{chitchat.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit bigvisit;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QButtons, QComCtrls, QExtCtrls;

type
  TfBigVisit = class(TForm)
    ListBox_Visit: TListBox;
    CancelButton: TBitBtn;
    helpbutton: TBitBtn;
    BitBtn_OK: TBitBtn;
    BitBtn_Delete: TBitBtn;
    CheckBox_DeleteLevel: TCheckBox;
    SpinEdit_DeleteLevel: TSpinEdit;
    Label1: TLabel;
    BitBtn_Copy: TBitBtn;
    BitBtn_PurgeNonLocal: TBitBtn;
    Timer_purge_nonlocals: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CancelButtonClick(Sender: TObject);
    procedure BitBtn_OKClick(Sender: TObject);
    procedure BitBtn_DeleteClick(Sender: TObject);
    procedure helpbuttonClick(Sender: TObject);
    procedure ListBox_VisitDblClick(Sender: TObject);
    procedure ListBox_VisitMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpinEdit_DeleteLevelChanged(Sender: TObject;
      NewValue: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox_DeleteLevelClick(Sender: TObject);
    procedure BitBtn_CopyClick(Sender: TObject);
    procedure BitBtn_PurgeNonLocalClick(Sender: TObject);
    procedure Timer_purge_nonlocalsTimer(Sender: TObject);
  private
    { Private declarations }
    stupidinit : boolean;
    delete_me : Tlist;
    formshown : boolean;
    procedure maybe_deleteTvisited(index:integer);
    procedure delete_maybedelete(deleteTvisited:boolean);
    procedure deletestuff;
    procedure moveselect(amount:integer; setit:boolean = false);
    procedure xhelp;
    procedure recaption;
    procedure DeleteLevel;
    procedure copyselected;
  public
    { Public declarations }
  end;

var
  fBigVisit: TfBigVisit;

type

  Tbigvisit_result =
  (bigvisit_nada, bigvisit_dir, bigvisit_enter, bigvisit_control_enter);

var

bigvisit_result : Tbigvisit_result;

Gpurge_nonlocals : boolean;

implementation

{$R *.xfm}

uses main, sbrs, qt,
weirdo
, fontfun, code, options, QClipbrd, dir;

var
mouseshift: TShiftState;
wasselected:integer;

procedure TfBigVisit.FormCreate(Sender: TObject);
begin
  autoscroll := true;
end;

procedure TfBigVisit.FormShow(Sender: TObject);
begin
  fixfonts(fBigVisit);
  formguard(fBigVisit);

  delete_me := Tlist.create;;

  wasselected := -1;

  with form1.visiteddirs do begin
    ListBox_Visit.items.assign(items);
    ListBox_Visit.itemindex := itemindex;
  end;

//  caption := form1.captionstuff;
  bigvisit_result := bigvisit_nada;
  spinedit_deleteLevel.value := Goptions.visited_delete_level;
  stupidinit := true; //focused doesn't work on spin control.
  //and elsewhere.
  //so I WANT the associated code to exec for this.
  CheckBox_deleteLevel.checked := false;
  recaption;

  if Gpurge_nonlocals then begin
    Gpurge_nonlocals := false;
    Timer_purge_nonlocals.enabled := true;
  end;
  formshown := true;

end;

procedure TfBigVisit.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

  procedure fakeck(movement:integer);
  begin
//I can't fake the key, because I can't remove the control from the shift,
//because Shift is a value, not var.
    moveselect(movement);
    key := 0;   //however I can get rid of the beep.
  end;

begin

  case key of
    ord('X'): fakeck(1);

    ord('E'): fakeck(-1);

    key_return, key_enter: begin
      if ssctrl in shift then
      bigvisit_result := bigvisit_control_enter
      else
      bigvisit_result := bigvisit_enter;
      modalresult := mrOK;
      if ListBox_Visit.itemindex<0 then
      ListBox_Visit.itemindex := wasselected;
      exit;
//      close;
    end;

//    key_F1, key_help: xhelp;

    key_Delete: deletestuff;

    key_Insert: copyselected;

    ord('C'): if ssctrl in shift then copyselected;

  end;


end;

procedure TfBigVisit.CancelButtonClick(Sender: TObject);
begin
  bigvisit_result := bigvisit_nada;
  modalresult := mrCancel;
end;

procedure TfBigVisit.BitBtn_OKClick(Sender: TObject);
begin
  bigvisit_result := bigvisit_dir;
  modalresult := mrOK;
end;

procedure TfBigVisit.deletestuff;
var
theitemindex,
i : integer;
begin
  with ListBox_visit do begin

    theitemindex := itemindex;

    for i := items.count-1 downto 0 do begin
      if selected[i] then begin
        maybe_deleteTvisited(i);
//        items.delete(i);
      end;
    end;

    if itemindex<0 then begin
      if theitemindex>=items.count then
      theitemindex := items.count-1;
      itemindex := theitemindex
    end;

  end;
end;


procedure TfBigVisit.BitBtn_DeleteClick(Sender: TObject);
begin
  if CheckBox_DeleteLevel.checked then
  deletelevel
  else
  deletestuff;
end;

{****************************************************************************
I THINK I've done everything I have to do to emulate key movement. These GUI
environments are so EZ no?
****************************************************************************}
procedure TfBigVisit.moveselect(amount:integer; setit:boolean = false);
var
i:integer;
oldms:boolean;
begin
  with ListBox_visit do begin

    oldms := multiselect;

    multiselect := false;

    if not setit then
    inc(amount,itemindex);

    for i := 0 to items.count-1 do
    selected[i] := false;

    if amount<0 then
    amount := 0;

    if amount >= items.count then
    amount := items.count-1;

    itemindex := amount;

    multiselect := oldms;

  end;

end;

procedure TfBigVisit.xhelp;
begin
  oshelp('Etc_Visited_Directories');
  fBigVisit.setfocus;
end;

procedure TfBigVisit.helpbuttonClick(Sender: TObject);
begin
  xhelp;
end;

//procedure TfBigVisit.FormKeyDown(Sender: TObject; var Key: Word;
//  Shift: TShiftState);

procedure TfBigVisit.ListBox_VisitDblClick(Sender: TObject);
var
dummykey:Word;
begin
  dummykey := key_Enter;
  formkeydown(nil,dummykey,mouseshift);
end;

procedure TfBigVisit.ListBox_VisitMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  mouseshift := shift;
  wasselected := ListBox_Visit.ItemAtPos(Point(x,y),true);
  //fix another amusing CLX idiosyncrasy.
end;

procedure TfBigVisit.recaption;
begin
  CheckBox_DeleteLevel.caption :=
  safe_format('Delete > le&vel %d',
  [SpinEdit_DeleteLevel.value]);

  if CheckBox_DeleteLevel.checked then
  BitBtn_Delete.caption := '&Delete level'
  else
  BitBtn_Delete.caption := '&Delete'
  ;

  caption := osversion;

end;

procedure TfBigVisit.SpinEdit_DeleteLevelChanged(Sender: TObject;
  NewValue: Integer);
begin
  if not stupidinit then
  exit;

  Goptions.visited_delete_level :=
  spinedit_deleteLevel.value;
  if not CheckBox_DeleteLevel.checked then
  CheckBox_DeleteLevel.checked := true
  else
  recaption;
end;

procedure TfBigVisit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  stupidinit := false;

  delete_maybedelete(modalresult = mrOK);

  formshown := false;

end;

procedure TfBigVisit.CheckBox_DeleteLevelClick(Sender: TObject);
begin
  if not stupidinit then
  exit;

  if CheckBox_DeleteLevel.checked then begin
    working_multioff(ListBox_Visit);
  end else
  ListBox_visit.multiselect := true;

  recaption;

end;

procedure TfBigVisit.DeleteLevel;
var
i:integer;
begin

  for i := ListBox_Visit.items.count-1 downto 0 do begin

    if slashlevel(
//    VisitedDirs.items[i]
    ListBox_Visit.items[i]
    //the marker shouldn't be a slash....
    ) >
    Goptions.visited_delete_level

    then begin
      maybe_deleteTvisited(i);
//      ListBox_Visit.items.delete(i);
    end;

  end;

end;

procedure TfBigVisit.BitBtn_CopyClick(Sender: TObject);
begin
  copyselected;
  close;
end;

procedure TfBigVisit.copyselected;
var
s:string;
count,
i:integer;
begin
  s := '';
  count := 0;
  with ListBox_Visit do
  for i := 0 to items.count-1 do
  if selected[i] then begin
    inc(count);
    if (s<>'') then
    s := s+LNEND;
    s := s+visited_dir(i,ListBox_Visit);
  end;

  if length(s) < 1 then
  errorf('No selections!')
  else begin

    if count>1 then
    s := s+LNEND;

    clipboard.astext := s;

  end;

end;

{****************************************************************************
Wed 5/31/2006 1:00 pm. So I was musing around trying to implement the purge
non-locals function -- get rid of CD network drives etc -- when I realized I
had been leaving the Tvisited objects all over the place! Bad bad....

So anyone who deletes an item should called this function, which'll add the
Tvisited object to the delete_me list. Then, if we exit with OK, it'll delete
those objects.
****************************************************************************}

procedure TfBigVisit.maybe_deleteTvisited(index:integer);
begin
  if ListBox_Visit.items.objects[index] is Tvisited then
  delete_me.add(ListBox_Visit.items.objects[index]);

//and also do the delete.
  ListBox_Visit.items.delete(index);
end;

{****************************************************************************
****************************************************************************}

procedure TfBigVisit.delete_maybedelete(deleteTvisited:boolean);
var
i:integer;
begin

  if deleteTvisited then begin
//if he's clicked OK or whatever.
    for i := 0 to delete_me.count-1 do begin
      if (Tvisited(delete_me[i]) is Tvisited) then
      Tvisited(delete_me[i]).free;
    end;

  end;

  freeandnil(delete_me);

end;


{****************************************************************************
****************************************************************************}

procedure TfBigVisit.BitBtn_PurgeNonLocalClick(Sender: TObject);
var
i:integer;
begin

  for i := ListBox_Visit.items.count-1 downto 0 do begin
    if (ListBox_Visit.items.objects[i] is Tvisited)
    and (not (ListBox_Visit.items.objects[i] as Tvisited).tree.local) then
    maybe_deleteTvisited(i);
  end;

end;

{****************************************************************************
****************************************************************************}


procedure TfBigVisit.Timer_purge_nonlocalsTimer(Sender: TObject);
begin
  if not formshown then
  exit;

  Timer_purge_nonlocals.enabled := false;

  BitBtn_PurgeNonLocalClick(nil);

  BitBtn_OKClick(nil);

end;

end.
