{clip.pas

See the bottom of main.pas for the BSD-style license.

The list boxes in here are populated by "addafile" in main.pas.
Which it just took me 10 minutes to figure-out.

}

{$I osops.i}

unit clip;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, QTypes, QExtCtrls, publics;

type
  TClipForm = class(TForm)
    BitBtn1: TBitBtn;
    YesButton: TBitBtn;
    Timer: TTimer;
    Panel: TPanel;
    ListBoxFull: TListBox;
    Splitter1: TSplitter;
    ListBoxName: TListBox;
    Splitter2: TSplitter;
    ListBoxShort: TListBox;
    LabelFull: TLabel;
    LabelName: TLabel;
    LabelShort: TLabel;
    Label_thoughts: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    CheckBox_quotes: TCheckBox;
    CheckBox_slash: TCheckBox;
    ListBoxData: TListBox;
    CheckBox_data: TCheckBox;
    CheckBox_Cute: TCheckBox;
    CheckBoxKeep: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure YesButtonClick(Sender: TObject);
{   procedure FormPaint(Sender: TObject);  }
    procedure FormShow(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ListBoxFullEnter(Sender: TObject);
    procedure LabelFullClick(Sender: TObject);
    procedure LabelNameClick(Sender: TObject);
    procedure LabelShortClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure CheckBox_quotesClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    oldpanel,
    whichform : integer;
    inited,
    badclip,      {flag of clipem failure; show sets it false}
    oldslash,oldquotes, olddata, oldcute : boolean;
    procedure clipoid(usefile:boolean = false);
    procedure fixpanels;
    procedure fixlabels;
    procedure selectall;
    procedure xinit;
    procedure xoptions;
    procedure xform;
    procedure clipem;
    procedure clipdata;
    procedure whichListBox;
  public
    { Public declarations }
    directory,
    unmark,
    plzquick : boolean;
    {means called by short-cut key, so form just flashes momentarily.}
    plzsuper : Rquick_copy;

  end;

var
  ClipForm: TClipForm;

implementation

{$R *.xfm}

uses qclipbrd, options, sbrs, code, main, files,
fontfun,
weirdo;

const

lopanel : integer = 1;
hipanel : integer = 3;

var

thisfv : Tfv;   {copy of form1's thisfv.}

{****************************************************************************
these globals are set by whichListBox.
****************************************************************************}

whichListB : TlistBox;
whichLabel : Tlabel;

procedure TClipForm.whichListBox;
begin
  case whichform of
    1: begin
      whichLabel := LabelFull;
      if checkbox_data.checked and (not directory) then begin
        ListBoxData.visible := true;
        ListBoxFull.visible := false;
        whichListB := ListBoxData;
      end else begin
        ListBoxData.visible := false;
        ListBoxFull.visible := true;
        whichListB := ListBoxFull;
      end;
    end;

    2: begin
      whichListB := ListBoxName;
      whichLabel := LabelName;
    end;
{$ifdef MSWINDOWS}
    3: begin
      whichListB := ListBoxShort;
      whichLabel := LabelShort;
    end;
{$endif}
  end;
end;

procedure TClipForm.fixpanels;

  procedure showwhich(lb:TlistBox; nm:Tlabel; turnon:boolean);
  begin
    if turnon then begin
      lb.color := selcolor;
      nm.color := selcolor;
    end else begin
      lb.color := unselcolor;
      nm.color := unselcolor;
    end;

  end;

begin

  if not inited then
  exit;

  splitter2.cursor := crHSplit;
  splitter1.cursor := crHSplit;
{****************************************************************************
Mon 1/03/2005 1:59 pm. apparently CLX likes to be reminded....
****************************************************************************}

  intrange(lopanel,hipanel,whichform);

  whichlistbox;
  //set some evil globals.

  showwhich(ListBoxFull,LabelFull,false);
  showwhich(ListBoxName,LabelName,false);
{$ifdef MSWINDOWS}
  showwhich(ListBoxShort,LabelShort,false);
{$endif}
  showwhich(ListBoxData,LabelFull,false);

  showwhich(WhichListB,WhichLabel,true);

  YesButton.setfocus;

end;

procedure TClipForm.FormCreate(Sender: TObject);
{$ifdef LINUX}
{Well *of course* it won't in another Linux....}
  procedure labeloid(lb:Tlabel);
  const
  fix = 3;
  begin
    lb.height := lb.height - fix;
    lb.top := lb.top + fix;
  end;
{$endif}
begin
  autoscroll:=true;

{$ifdef LINUX}
  labeloid(LabelFull);
  labeloid(LabelName);

  ListBoxShort.visible := false;
  LabelShort.visible := false;
  Splitter1.visible := false;
  ListBoxFull.width := (width div 3) * 2;
  ListBoxData.width := ListBoxFull.width;
  ListBoxName.width := width div 3;
{$endif}

{$ifdef MSWINDOWS}
  hipanel := 3;
  ListBoxData.font.name := 'terminal';
{$endif}

{$ifdef LINUX}
  hipanel := 2;
  ListBoxData.font.name := 'courier';
{$endif}
{we want to make the dubious data info mono-spaced.}

  lopanel := 1;

  plzquick := false;
{****************************************************************************
Fri 3/12/2010 11:19 am. *sometimes* it does a quick clip even when I asked for
the menu. No doubt another little delphi twitch.
****************************************************************************}

end;


const
ClipFileName : string = 'fnames~';

procedure TClipForm.clipoid(usefile:boolean = false);
var
lb : Tlistbox;
count, i:integer;
line_end, s:string;
cn:Tclip_number;
fileoid_OK:boolean;

  function fileoid:boolean;
  var
  h:integer;
  begin
    result := false;

    thisdirectory;

    if not inputQuery(
    'Specify destination file',
    safe_format('Append %d file names to file',[count]),
    ClipFileName) then
    exit;

    if FileExists_unq(ClipFileName) then begin
      h := FileOpen(ClipFileName,fmOpenReadWrite);
      if h>=0 then
      FileSeek(h,0,2);
    end else
    h := StupidNewFile(ClipFileName);

    if h<0 then begin
      errorf('Couldn''t open "%s"; sorry',[ClipFileName]);
      exit;
    end;

    hprintf(h,'%s'+LNEND,[s]);  {want terminating line end for file, but
    traditionally not for copy.}

    FileClose(h);

    result := true;

  end;


begin

  try

    case whichform of
  {   1: lb := ListBoxFull;  }
      2: lb := ListBoxName;
{$ifdef MSWINDOWS}
      3: lb := ListBoxShort;
{$endif}
    else
      lb := ListBoxFull;
      if checkBox_data.checked and (not directory) then
      lb := ListBoxData;
    end;

    s := '';
    line_end := '';
    count := 0;

    for i := 0 to lb.items.count-1 do begin
      if not lb.selected[i] then
      continue;

      inc(count);
      s := s + line_end + lb.items[i];
      line_end := LNEND;
    end;

    fileoid_OK := true;
{if user chose to send file names to a file, then that might fail or cancel,
in which case we *shouldn't* unmark the things; so if file, fileoid sets/
clears fileoid_OK.}

    if length(s)>0 then begin
      if usefile then
      fileoid_OK := fileoid
      else
      clipboard.astext := s;
    end;

  {the objects in the LIstBoxName list contain the indices of marked
  files, which we would like to unmark now.}

    if unmark then
    for i := 0 to ListBoxName.items.count-1 do begin

      cn := ListBoxName.items.objects[i] as Tclip_number;

      if cn=nil then
      continue;   {oh well let's be sloppy}

      if lb.selected[i] and fileoid_OK then
      file_check(form1.thisfv,cn.index);

      cn.free;

    end;

{has to happen *after* the checking. If File -- user requested file
operation -- and Fileoid_OK -- user didn't back out, or other error --
then we'll do this stuff now.}
    if usefile and fileoid_OK then begin

      file_oldnew_begin;
      file_oldnew('',ExpandFileName(ClipFileName));
      file_oldnew_finish;

      form1.files_find_select(ClipFileName,0,search_EXACT);

    end;

  except
    on exception
    do;
  end;


  close;
end;


procedure TClipForm.YesButtonClick(Sender: TObject);
begin
  clipoid;
end;

{****************************************************************************
Didn't work. The problem is, how to close a form when it opens. The Great
Masters of Delphi didn't think anybody'd ever want to do that, so it's not EZ.
In my childish innocence in winders I could do it with the paint thingey,
which'd always show-up after the form was settled down. But not, apparently,
in CLX! Or XP! Or on Tuesdays or whatever. Anyway so I use a timer.... I mean,
it's just windows.....

procedure TClipForm.FormPaint(Sender: TObject);
begin
  exit;

  if not plzquick then
  exit;

  plzquick := false;

  YesButtonClick(nil);

end;

****************************************************************************}

{implement trailingslash and quotes options.}
procedure TClipForm.xform;
type
Tsfunc = function(s:string):string;
var
x:Tsfunc;

  procedure lb_f(lb:TListBox; f:Tsfunc);
  var
  i:integer;
  begin
    for i := 0 to lb.items.count-1 do
    lb.items[i] := f(lb.items[i]);
  end;

begin

  CheckBox_slash.visible := directory;
  CheckBox_data.visible := not directory;

{first unquote everything, so the slash nonsense works.}
  lb_f(ListBoxFull,unquote);
  lb_f(ListBoxName,unquote);
{the MSWINDOWS short form is never quoted.}

{ListBoxData never gets quoted, unquoted, or slashed/unslashed.}

  if directory then begin

    if CheckBox_slash.checked then
    x := fslash
    else
    x := fdeslash;
  {there should be only a single directory}
    lb_f(ListBoxFull,x);
{$ifdef MSWINDOWS}
    lb_f(ListboxShort,x);
{$endif}
  end else begin
    clipem;
    if badclip then
    exit;
  end;

{now do quotes for everybody.}
  if CheckBox_quotes.checked then begin
    lb_f(ListBoxFull,quoteoid);
    lb_f(ListBoxName,quoteoid);
{$ifdef MSWINDOWS}
    lb_f(ListBoxShort,quoteoid);
{$endif}
  end;

  ListBoxData.visible := (not directory) and
  CheckBox_data.checked;

  ListBoxFull.visible := not ListBoxData.visible;

  CheckBox_quotes.visible := not listBoxData.visible;
  CheckBox_cute.visible := listBoxData.visible;

  selectall;

end;

{implement the OS.INI options. Called by xinit, and also by formshow if
quickcopy.}
procedure TClipForm.xoptions;
const
done : boolean = false;
begin
  if CheckBoxKeep.checked and done then
  exit;

  done := true;


  whichform := 1;

  if not Goptions.fullpath then
  whichform := 2;
{$ifdef MSWINDOWS}
  if Goptions.short then
  whichform := 3;
{$endif}
  CheckBox_quotes.checked := Goptions.quotes;
  CheckBox_slash.checked  := Goptions.trailingslash;
  CheckBox_data.checked := Goptions.data;
  Checkbox_cute.checked := Goptions.cute;

end;

procedure TClipForm.FormShow(Sender: TObject);
const
panel_dif = 5;
o_labelheight = 13;
var
dif : integer;
begin
  fixfonts(clipform);
  formguard(clipform);

  xinit;

  badclip := false;

  clipem;       {load up list boxes.}
  if badclip then
  exit;

{make behavior predictable.}
  if plzquick then begin
{save his behavior.}
    oldpanel := whichform;
    oldslash := CheckBox_slash.checked;
    oldquotes := CheckBox_quotes.checked;
    olddata := CheckBox_data.checked;
    oldcute := CheckBox_cute.checked;

    xoptions; {set default behavior as per options}

    if quick_valid in plzsuper then begin
      CheckBox_quotes.checked := quick_quotes in plzsuper;
      CheckBox_slash.checked := quick_slash in plzsuper;

      if quick_name in plzsuper then
      whichform := 2
      else if quick_cute in plzsuper then begin
        CheckBox_data.checked := true;
        CheckBox_cute.checked := true;
      end;

    end;

  end;

  fixpanels;
  fixlabels;
  xform;
{  selectall;  }  {xform does it.}

  YesButton.setfocus;

  labelFull.height := o_labelheight + Gtabdif;
  labelName.height := o_labelheight + Gtabdif;
  labelShort.height := o_labelheight + Gtabdif;

  dif := panel.top - labelFull.height;

  if dif<>panel_dif then begin
    dif := panel_dif - dif;
//    panel.anchors := [];
    panel.height := panel.height-dif;
    panel.top := panel.top + dif;
//    panel.anchors := [akLeft,akTop,akRight,akBottom];
  end;

  if not plzquick then
  exit;



{$ifdef LINUX}
{has to be here -- as opposed to create -- to see the option. Don't know
why I thought it was only in Linux.... Oh I see because it has to take
more time, and that's how we do it. In windows the default 20 ms is ok.
Hmmm... Yes it's even in the help.}
  Timer.interval := Goptions.enabledelay;
{$endif}

{  plzquick := false;  }

  Timer.enabled := true;

end;

{this only happens if plzquick, i.e. user pressed quickcopy shortcut. When
he does that, (1.) always uses full-path, (2.) always copies to clipboard,
(3.) resets style back to whatever it was before. }
procedure TClipForm.TimerTimer(Sender: TObject);
begin
  Timer.enabled := false;

  if badclip then begin
    close;
    exit;
  end;

  if not plzquick then
  exit;

  clipoid;
  whichform := oldpanel;       {restore user's old style}
  CheckBox_quotes.checked := oldquotes;
  CheckBox_slash.checked := oldslash;
  CheckBox_data.checked := olddata;
  CheckBox_cute.checked := oldcute;
end;

procedure TClipForm.fixlabels;
begin
  if ListBoxData.visible then
  ListBoxFull.width := ListBoxData.width;

  LabelFull.width := ListBoxFull.width - 2;
  LabelFull.left := ListBoxFull.left;

  LabelName.width := ListBoxName.width - 2;
  LabelName.left := ListBoxName.left;

{$ifdef MSWINDOWS}
  LabelShort.width := ListBoxShort.width - 2;
  LabelShort.left := ListBoxShort.left;
{$endif}

end;

procedure TClipForm.FormResize(Sender: TObject);
begin
  fixlabels;
end;

procedure TClipForm.ListBoxFullEnter(Sender: TObject);
begin
  whichform := (sender as TlistBox).tag;
  fixpanels;
end;

procedure TClipForm.selectall;

  procedure sa(lb:TlistBox);
  var
  i:integer;
  begin
    with lb do for i := 0 to items.count-1 do begin
      selected[i] := true
    end;
  end;

begin
  sa(ListBoxFull);
  sa(ListBoxName);
  sa(ListBoxData);
{$ifdef MSWINDOWS}
  sa(ListBoxShort);
{$endif}

end;


procedure TClipForm.LabelFullClick(Sender: TObject);
begin
  whichform := 1;
  fixpanels;
  exit;

  if (not directory) and (CheckBox_data.checked) then
  ListBoxData.setfocus
  else
  ListBoxFull.setfocus;
end;

procedure TClipForm.LabelNameClick(Sender: TObject);
begin
  whichform := 2;
  fixpanels;
  exit;

  ListBoxName.setfocus;
end;

procedure TClipForm.LabelShortClick(Sender: TObject);
begin
  whichform := 3;
  fixpanels;
  exit;

  ListBoxShort.setfocus;
end;

procedure TClipForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ListBoxFull.clear;
  ListBoxName.clear;
  ListBoxShort.clear;
  ListBoxData.clear;
  plzquick := false;
  plzsuper := [];
end;

procedure TClipForm.BitBtn2Click(Sender: TObject);
begin
  oshelp('Etc Copy File Names');
  setfocus;
end;

procedure TClipForm.BitBtn3Click(Sender: TObject);
begin
  clipoid(true);
end;

procedure TClipForm.xinit;
var
s:string;
begin
  if inited then
  exit;

  inited := true;

  s := '(Click the titles to avoid changing selection; ^A selects all again';

  if Goptions.quickcopy.key<>0 then begin
    s := s + safe_format(' ... quickcopy shortcut is %s',
    [Goptions.quickcopy.show]);
    CheckBoxKeep.caption := '&Make '+Goptions.quickcopy.show + ' options';
  end else begin
    CheckBoxKeep.visible := false;
  end;

  s := s + ')';

  Label_thoughts.caption := s;

  xoptions;

end;

procedure TClipForm.CheckBox_quotesClick(Sender: TObject);
begin
  if (Sender as TCheckBox).focused then begin
    xform;
    fixpanels;
  end;
end;

{****************************************************************************
****************************************************************************}


procedure TClipForm.clipem;
var
idx, acount : integer;
cn : Tclip_number;

  procedure addafile(index:integer);
{$ifdef Im_Stupid}
  overload;
{$endif}
  var
  apath,aname:string;
  begin
    aname := Tos_f(thisfv.fls.objects[index]).name;

    apath := thisfv.status.caption + aname;

    ListBoxFull.items.add(apath);

    if cn=nil then
    ListBoxName.items.add(aname)
    else
    ListBoxName.items.addobject(aname,cn);

{$ifdef MSWINDOWS}
    ListBoxShort.items.add(shortify(apath));
{$endif}

  end;

{$ifdef Im_Stupid}
{I wrote two of these because I stupidly used "[i]" (//now "idx" after I did
this same stupid mistake again!) above instead of "[index]" moron idiot....
And *left no comment* Guess I was ashamed....}
  procedure addafile(aname:string); overload;
  var
  apath:string;
  begin
    apath := thisfv.status.caption + aname;

    ListBoxFull.items.add(apath);
    ListBoxName.items.add(aname);

{$ifdef MSWINDOWS}
    ListBoxShort.items.add(apath);
{$endif}

  end;
{$endif}


begin

  if badclip then
  exit;
  {been here done that}

  directory := form1.thepanel=d;

  thisfv := form1.thisfv;

  try

    unmark := false;
    cn := nil;

    ListBoxFull.clear;
    ListBoxName.clear;
    ListBoxShort.clear;

    case form1.thepanel of
      d: begin
        ListBoxFull.items.add(thetree.selectedPath);
        ListBoxName.items.add(xFileName(thetree.selectedPath));
{$ifdef MSWINDOWS}
        ListBoxShort.items.add(shortify(thetree.selectedPath));
{$endif}
        {*********Nothing for Listboxdata if directory**********}
      end;

      f1,f2: begin
{****************************************************************************
So this is correct. If there are directories in the file panel, the filecount
will be >0, and we *can* paste those names if we want.
****************************************************************************}

        if thisfv.filecount<1 then begin
          badclip := true;
          if Goptions.error_clip then
          errorf('No file names to copy!');
          timer.enabled := true;
          exit;
        end;

        acount := 0;
        for idx := 0 to thisfv.filecount-1 do begin
          if file_dir_ismarked( Tos_f(thisfv.fls.objects[idx]) )
          then begin
            cn := TClip_number.create;  {clipform should off them.}
            cn.index := idx;
            addafile(idx);
            inc(acount);
          end;
        end;

        if acount=0 then begin
//          addafile(file_selected_name);
          addafile(file_selected_index);
        end else
        unmark := true;

        clipdata;   {do the data box please.}

      end;
    end;
  except
    on E: exception do
    Errorf('Clipform error: %s',[E.Message]);
  end;

end;

procedure TClipForm.clipdata;
var
namewidth, sizewidth, timewidth,
pass, idx, acount : integer;

  procedure addafile(index:integer);
  var
  namelength, sizelength, timelength : integer;
  apath,aname:string;
  begin
    aname := Tos_f(thisfv.fls.objects[index]) .name;

    apath := thisfv.status.caption + aname;

    namelength := length(aname);

    with thisfv.view.items[index] do begin
      sizelength := length(subitems[sizecolumn-1]);
      timelength := length(subitems[timecolumn-1]);
    end;

    if pass=1 then begin

      if namelength > namewidth then
      namewidth := namelength;

      if sizelength > sizewidth then
      sizewidth := sizelength;

      if timelength > timewidth then
      timewidth := timelength;

    end else begin

      with thisfv.view.items[index] do
      if checkbox_cute.checked then
{****************************************************************************
cute should look like

log          308,877 12/2/03 10:43:14a a
os_vers           23 12/2/03 10:54:38a a
ov_to_tre      1,576 10/9/02 09:37:48a
pdsortx       26,967 12/9/02 03:30:28p
T~               344 12/2/03 01:08:32p a
ver150select      50 9/18/02 04:56:12p a r

****************************************************************************}
      ListBoxData.items.add(
      safe_format('%s%s %s%s %s%s %s',
      [
      aname,
      spaces(namewidth-namelength),
      spaces(sizewidth-sizelength),
      subitems[sizecolumn-1],
      spaces(timewidth-timelength),
      subitems[timecolumn-1],
      subitems[attscolumn-1]
      {the constants are for the TListView.columns thingey; for *subitems*
      of course we need -1.}
      ]))

      else

      ListBoxData.items.add(
      safe_format('"%s", "%s", "%s", "%s"',
      [
      apath,
      subitems[sizecolumn-1],
      subitems[timecolumn-1],
      despace(subitems[attscolumn-1])
      {the constants are for the TListView.columns thingey; for *subitems*
      of course we need -1.}
      ]));
    end;

  end;

begin

  ListBoxData.Clear;

  try
    namewidth := 0;
    sizewidth := 0;
    timewidth := 0;
    {we're doing two passes so we can cuteify the data, i.e. to get the
    maximum widths first, then etc. }

    for pass := 1 to 2 do begin
      acount := 0;

      for idx := 0 to thisfv.filecount-1 do begin
        if file_dir_ismarked( Tos_f(thisfv.fls.objects[idx]) )
        then begin
          addafile(idx);
          inc(acount);
        end;
      end;

      if acount=0 then begin
        addafile(file_selected_index);
      end;
    end;
  except
    on E: exception do
    Errorf('Clipdata error: %s',[E.Message]);
  end;

end;


procedure TClipForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
keywas : Word;

begin

  if (Shift = [ssctrl]) and (key=ord('A')) then begin
    selectListBoxAll(whichListb);
    key := 0;
    exit;
  end;

  keywas := Key;
  Key := 0;

  if not (ssalt in Shift) then
  exit;

  case keywas of
    ord('L'): LabelFullClick(nil);
    ord('N'): LabelNameClick(nil);
    ord('O'): LabelShortClick(nil);
  else
    key := keywas;
  end;

end;

end.
