unit clips;

{ See the bottom of main.pas for the BSD-style license. }

interface

{$I osops.i}

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QButtons;

type
  TfClips = class(TForm)
    ListBox: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
    procedure ListBoxDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure clips_help;
    procedure refo;
  public
    { Public declarations }
  end;

var
  fClips: TfClips;

implementation

{$R *.xfm}

uses options, code, fontfun, qclipbrd, sbrs,
weirdo
;

procedure TfClips.FormShow(Sender: TObject);
var
i:integer;
begin
  fixfonts(fclips);
  formguard(fclips);

  if Goptions.clips.count < 1 then
  exit;
  //shouldn't happen but hey....

  Listbox.clear;
  for i := 0 to Goptions.clips.count-1 do
  listbox.items.add(evarize(Goptions.clips[i]));

  listbox.selected[0] := true;

end;

procedure TfClips.FormClose(Sender: TObject; var Action: TCloseAction);
var
ln,
s:string;
i:integer;
begin
  if modalresult <> mrOK then
  exit;

  ln := '';
  s := '';

  for i := 0 to Listbox.items.count-1 do begin
    if Listbox.selected[i] then begin
      s := s + ln + Listbox.items[i];
      ln := LNEND;
    end;
  end;

  clipboard.astext := s;

end;

procedure TfClips.BitBtn3Click(Sender: TObject);
begin
  clips_help;
end;

procedure TfClips.clips_help;
begin
  oshelp('Etc Clips');
  setfocus;
  refo;
end;

procedure TfClips.refo;
begin
  Listbox.setfocus;
end;


procedure TfClips.ListBoxDblClick(Sender: TObject);
begin
  modalresult := mrOK;
end;

procedure TfClips.FormCreate(Sender: TObject);
begin
  autoscroll := true;
end;

end.
