{execp.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}
{.$define STUPID_CHECKQUOTES}

unit execp;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons;

type
  Texecprompt = class(TForm)
    Memo: TMemo;
    OKButton: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtnClear: TBitBtn;
    BitBtn_Insert: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtnClearClick(Sender: TObject);
    procedure MemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MemoClick(Sender: TObject);
    procedure MemoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn_InsertClick(Sender: TObject);
  private
    { Private declarations }
{$ifdef STUPID_CHECKQUOTES}
    procedure checkquotes;
{$endif}
  public
    { Public declarations }
    isexec : boolean;
{****************************************************************************
Thu 2/19/04 6:55 pm. The idea is the caller which I believe is always
something exec.pas will set this if an executable has been specified, which is
most of the time, except for "exec=*" specs. But if there is no exec, the guy
probably wants to execute a program he types in with no muss/fuss, so if not
exec, then a key_Return executes; otherwise have to use @Y for Yes. Then just
to be more confusing, if he uses the CLR button, isexec is cleared also --
since it obviously just got cleared.

Fri 8/08/2008 12:21 pm. I think this is a bad idea; let's just get rid of
isexec, and make it *always* default to the OK button -- which is almost
always what I want.
****************************************************************************}


    changed : boolean;


  end;

var
  execprompt: Texecprompt;

implementation

{$R *.xfm}

uses qt, sbrs, fontfun, code, options, exec, main;

procedure Texecprompt.FormCreate(Sender: TObject);
begin
  autoscroll := true;
end;

{****************************************************************************
Fri 8/08/2008 12:58 pm. On faster machines, the memo keeps reselecting itself;
some clx/delphi race silliness no doubt.
****************************************************************************}

procedure Texecprompt.FormShow(Sender: TObject);
begin

  fixfonts(execprompt);
  formguard(execprompt);

  changed := false;
{$ifdef STUPID_CHECKQUOTES}
  checkquotes;
{$endif}

  if Goptions.inserts<>nil then begin
    BitBtn_insert.caption := Goptions.inserts.r.name;
    BitBtn_insert.visible := true;
  end;

  if isexec then
  Okbutton.setfocus
  else
  memo.setfocus;
end;

procedure Texecprompt.BitBtnClearClick(Sender: TObject);
begin
  Memo.text := '';
  isexec := false;
  Memo.setfocus;
end;

procedure Texecprompt.MemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  changed := true;

{****************************************************************************
Fri 8/08/2008 12:25 pm. Force him to always use the OK button. He can always
edit it?
****************************************************************************}
  if (key=key_Return) and (not isexec) then begin
//    key := 0;
    modalresult := mrOK;
  end;

end;


{****************************************************************************
Fri 8/08/2008 1:25 pm. This happens spontaneously on some machines on
odd-numbered Tuesdays! Kuel eh?
****************************************************************************}

procedure Texecprompt.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if xlatewordstar(key,shift) or (not (ssalt in shift)) then begin
    Memo.setfocus;
  end;
end;

{$ifdef STUPID_CHECKQUOTES}
{****************************************************************************
(ctext -p)

There are quotes! You may have to adjust the form width so the lines come out
right!

Thu 11/02/2006 11:42 am. I grovel in shame! This was rily stupid; all I had to
do was get rid of word wrap on the memo -- and enable auto scroll -- and it
all takes care of itself! ... Dumb dumb dumb....

****************************************************************************}

procedure Texecprompt.checkquotes;
var
i:integer;
begin
  Label_quotewarning.visible := false;

  for i := 0 to memo.lines.count-1 do begin
    if pos('"',memo.lines[i]) >0 then begin
      Label_quotewarning.caption :=

'There are quotes! You may have to adjust the form width so the lines come out'
+' right!'


      ;

      Label_quotewarning.visible := true;

    end;

  end;

end;
{$endif}


procedure Texecprompt.MemoClick(Sender: TObject);
begin
  changed := true;
end;

procedure Texecprompt.MemoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  changed := true;
end;

procedure Texecprompt.BitBtn_InsertClick(Sender: TObject);
var
args:TStringList;
i:integer;
begin

  args := jgo_slist;

  changed := true;

  execform.exec_args(args,Goptions.inserts);

  for i := 0 to args.count-1 do
  memo.lines.insert(i,args[i]);

  memo.lines.insert(0,Goptions.inserts.r.exec);
  BitBtn_insert.visible := false;

  args.free;

end;

end.
