{fasttree.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit fasttree;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, QTypes, QExtCtrls;

type
  TFastTreef = class(TForm)
    ListBox1: TListBox;
    OKButton: TBitBtn;
    BitBtn2: TBitBtn;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    autotree : boolean;
    //true if user shouldn't do anything. I was going to fix something
    //with this, but wasn't necessary.
  public
    { Public declarations }
    selected : integer;
    key_error : boolean; //pressed a key not in list; it happens.
  end;

var
  FastTreef: TFastTreef;

  ft_what : string;       {if not '', try to find it and do it.}
  {i.e. for wretched macros automation junk.}

implementation

{$R *.xfm}
uses main, sbrs, fontfun, code;


procedure TFastTreef.FormCreate(Sender: TObject);
begin
  autoscroll := true;
end;

procedure TFastTreef.FormShow(Sender: TObject);
begin
  key_error := false;
  autotree := length(ft_what)>0;

  fixfonts(fasttreef);
  formguard(fasttreef);


{  OKButton.setfocus;  }
  ListBox1.items.assign(form1.drivelist.items);
  if form1.drivelist.itemindex>=0 then
  ListBox1.itemindex := form1.drivelist.itemindex;
  selected := -1;
  ListBox1.setfocus;
  if autotree then
  timer1.enabled := true;
end;

procedure TFastTreef.FormKeyPress(Sender: TObject; var Key: Char);
var
i:integer;

  function checkit:boolean;
  begin
    result :=
    (length(Listbox1.items[i])>0) and
    (tolower(listbox1.items[i][1])=key);
    if result then begin
      selected := i;
      ListBox1.itemindex := i;
      close;
    end;
  end;

begin
  if autotree then
  exit;

  key := tolower(key);
  with ListBox1 do begin
    if itemindex<0 then
    close;

    for i := 0 to items.count-1 do begin
      if checkit then begin
        exit;
        key_error := false;
      end;
    end;

    key_error := true;

  end;
  close;
end;

procedure TFastTreef.ListBox1DblClick(Sender: TObject);
begin
  selected := ListBox1.itemindex;
  close;
end;

procedure TFastTreef.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if
  autotree or
  (Shift<>[ssCtrl]) then
  exit;

  with ListBox1 do
  case key of
    ord('X'): begin
      ItemIndex := ItemIndex+1;
    end;
    ord ('E'): begin
      if Itemindex>0 then
      ItemIndex := ItemIndex-1;
    end;

  else
    exit;
  end;

  key := 0;

end;

procedure TFastTreef.Timer1Timer(Sender: TObject);
var
alen, i:integer;
label
ENDNESS;
begin
  alen := length(ft_what);
  if alen>0 then
//do the mechanical tree select. i.e. os_instructions or something.
  for i := 0 to ListBox1.items.count-1 do begin
    if copy(ListBox1.items[i],1,alen)=ft_what then begin
      if ListBox1.items.objects[i]=thetree then begin
        selected := -1;
        modalresult := mrCancel;
        goto ENDNESS;
      end;
      ListBox1.itemindex := i;
      selected := i;
      goto ENDNESS;
    end;
  end;

  ListBox1.itemindex := -1;
  selected := -1;
  {no selection found}

  ENDNESS:
  timer1.enabled := false;
  ft_what := '';        {remove the trap}
  close;

end;

end.
