{files.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

{****************************************************************************
files.pas  Fri 5/10/02 3:00 pm
Fri 5/10/02 3:00 pm creation.
Wednesday, May 22, 2002 12:46 pm. Created from dirfiles.pas. A separate
section for the file junk.
Thu 11/07/02 11:44 am. Tidying-up scurrilous slanders in comments....
****************************************************************************}

unit files;

interface

uses sysutils, classes, QComCtrls, main, publics, dir, Qgraphics, sbrs;

{$ifdef LINUX}
function file_lxstat(reset : boolean = false):boolean;
{$endif}

function file_scan(t:Ttree; scanall:boolean; panel:Tfv; directory:string;
casesort:boolean):boolean;

procedure flipsort(v:Tfv; column:integer);
//procedure directoid(v:Tfv);
function file_ismarked(t:Tos_f):boolean;
function file_dir_ismarked(t:Tos_f):boolean;

function file_isstar(t:Tos_f):boolean;
function file_isunmarked(t:Tos_f):boolean;

procedure file_mark(fv:Tfv; i:integer);
procedure file_only_mark(fv:Tfv; i:integer);
procedure file_unmark(fv:Tfv; i:integer);
procedure file_check(fv:Tfv; i:integer);
procedure file_skip(fv:Tfv; i:integer);

procedure file_checkifmarked(fv:Tfv; i:integer);
procedure file_dir_checkifmarked(fv:Tfv; i:integer);

procedure file_skipifmarked(fv:Tfv; i:integer);

procedure file_markchecked(which:Tfv = nil; alist:TStringList=nil);

procedure file_oldnew_begin;
function file_oldnew(oldpath,newpath:string):boolean;
procedure file_oldnew_finish;

procedure file_off(path:string);

//procedure file_select(v:Tfv; which:integer);
//turns-out I didn't use it!
function isdir(t:Tos_f):boolean;

function os_delete(name:string
{$ifdef LINUX}
; filesize : int64 = -1
{$endif}
):boolean;

function OverwriteOK(s,d:string):resultAction;
function samefile(s,d:string):resultAction;
function newerOK(s,d:string):resultAction;

{note that this *always* worked for directories, i.e. in file display.}
function file_selected_index(which:Tfv = nil):integer;
function file_selected(which:Tfv = nil):Tos_f;
function file_selected_name(which:Tfv = nil):string;
function file_selected_info(which:Tfv = nil):string;
function file_selected_item(which:Tfv = nil):Tlistitem;

function file_thiscount_complain
(var onefile:string; var marked:boolean):integer;

procedure saveselect(panel:Tfv);

procedure sortNameKey;
procedure sortExtKey;
procedure sortSizeKey;
procedure SortDatekey;

procedure selectedmark(mark:boolean = true);
procedure fixcomparefunc(casesort:boolean);

procedure file_fiddlesort(fv:Tfv = nil);

procedure file_renamedir(old,new:string);
procedure file_showext(v:Tfv; which:integer = -1);

procedure file_top(saveit:boolean; which:Tfv = nil);

procedure fix_ext_field;

function file_findname(panel:Tfv; name:string):integer;

function sameSizeTime(s,d:string):boolean;

procedure file_show;

const

files_progress = $10;
{$ifdef MSWINDOWS}
files_abortmask = $1ff;
files_sortmask = $7fff;
{$endif}
{$ifdef LINUX}
files_abortmask = $3Ff;
files_sortmask = $3FFF;
{$endif}

{var
excount : integer; }


var
ST_sort_start, ST_sort_done:os_ticks;

implementation

uses code, qforms, qstdctrls, options, fileutil, chitchat
{qcontrols, qgraphics }
{$ifdef LINUX}
,Libc
{$endif}
{$ifdef MSWINDOWS}
,weirdo
{$endif}
,osinfo
;

{I'm guessing FileExists'll do it but hoo knows? nope}
{function direxists(s:string):boolean;
begin
  result := FileExists_unq(s);
end;}
{I am such a fool; directoryexists is in library of course....}


{works by figgering the size field which here gets to be \ or something.}
function isdir(t:Tos_f):boolean;
begin
  result := t.dir;
end;

{****************************************************************************
****************************************************************************}

function file_findname(panel:Tfv; name:string):integer;
begin

  for result := 0 to panel.filecount-1 do begin
    if
  {$ifdef MSWINDOWS}
    CompareText
  {$endif}
  {$ifdef LINUX}
    CompareStr
  {$endif}
    (name, Tos_f(panel.fls.objects[result]) .name)=0
    then
    exit;
  end;

  result := -1;

end;

{****************************************************************************
Tue 3/28/2006 5:43 pm. The idea is -- I think -- is when we enter a directory
from the tree display, it'll retain the old sort  it won't reset it to the
default sort, even if resort=1?
****************************************************************************}

procedure savesort(panel:Tfv = nil);
begin

  if panel=nil then
  panel := form1.thisfv;

  try
    panel.old_tree := panel.file_tree;
    panel.old_ns := panel.namesort;
    panel.old_s  := panel.sort;
    panel.sortdir :=
    panel.status.caption;
  except
    on exception do
    ;
  end;

end;

procedure restoresort(panel:Tfv; var thesort:FileSortKind);
begin
  if
  (
{$ifdef MSWINDOWS}
  CompareText
{$endif}
{$ifdef LINUX}
  CompareStr
{$endif}
  (panel.status.caption,panel.sortdir)=0)
  and (panel.old_tree = panel.file_tree)
{this is almost never going to make a difference, but theoretically.}
  and (panel.old_s<>nada_sort) then with panel do begin
    namesort := old_ns;
    thesort := old_s;
    old_s := nada_sort;
  end;
end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
ho ho ho Thursday, June 6, 2002 5:04 pm if you don't do that topitem thingey
[i.e. assigning to topitem], the select won't "take". // Yes I just had to do
the x thing; if you don't assign the top item, apparently the select won't
"take".... Because of course normally it's done with a human being and a
mouse, and nobody finished the code....//

Well no Friday, June 28, 2002 10:38 am it's worse than that. It just won't
assign 'cause it feels like it.... oh oh I see in the help occasionally it
suggests that topitem is *read-only*. Whaddya know? Apparently there was some
dispute... Yeah same in VCL.... Incomptent idiots.... In TTreeView, topitem is
*not* marked read-only.

So the idea here is we'll set it in this proc; which probably won't work but
mebbe we can figger out a cool way to do it.

So apparently not only is it *read-only*, it's *noacess*. After I set select,
it disappears. So basically not only can't you *write* it, you can't *read*
it. Kuel....

Hmmm.... Seems to work ok if you don't think about it much. And of course trap
the exceptions. Note also apparently the view.scroll thing would've done it
too.

//There is much pain here, much sorrow. So at least Mon 8/05/02 6:15 pm --
I'll probably regret this on Tuesday -- all's I have to do is group them in a
do-dothing exception thingey, and then I can assign to the topitem without
fear or favor. Or something. Or who knows.....

//Monday, August 18, 2003 4:05 pm. I dumped much code here didn't make
sense.

****************************************************************************}

{skip the directories at the top of the file view. }

procedure directoid(v:Tfv);
var
i, sel, top : integer;
begin

  if notinited>0 then
  exit;

  for i := 0 to v.filecount-1 do begin
    if not isdir( Tos_f(v.fls.objects[i]) )
    then begin
      sel := i;
      top := i;

      if top>1 then
      dec(top);

      v.view.topitem := v.view.items[top];

      v.view.selected := v.view.items[sel];
      exit;

    end;
  end;

  {only come here if there are no files in the view.}

  if (v.view.items.count>0) then begin
    v.view.selected := v.view.items[0];
  end;

{  PlzFView(true); }

end;


procedure saveselect(panel:Tfv);
var
t:Tlistitem;
begin

  try

    t := file_selected_item(panel);

    if t=nil then
    exit;
    {I keep adding these as I'm debugging an objectionable exception and
    stumble on these when I enable "stop on delphi exceptions". I figger
    good plan to kill exceptions, even if I use "try" on practically everything.}

    panel.selectname := t.subitems[filesub]; {this is ok usage; no point in
      gettings the files array opinion of it, since we'd just have to set it
      first. // whatever....}

    panel.selectindex := t.index;

    panel.selectdir :=
    panel.status.caption;

  except
    on exception
    do;
  end;

end;

{so now it restoreselect if it can, or otherwise does a directoid
thingey.}
function restoreselect(panel:Tfv):boolean;
var
index:integer;
t:Tlistitem;
begin
  result := false;

  if panel.view=nil then
  exit;

  if (length(panel.selectname)<1) or
  (
{$ifdef MSWINDOWS}
  CompareText
{$endif}
{$ifdef LINUX}
  CompareStr
{$endif}
  (panel.status.caption,panel.selectdir)<>0)
  then begin
    directoid(panel);
    panel.selectname := '';
    exit;
  end;

{strew the directories at the top.}
//  directoid(panel);

  index := file_findname(panel,panel.selectname);

  if index<0 then
  index := panel.selectindex;

  intrange(0,panel.filecount-1,index);

  if index>=0 then begin
    t := panel.view.items[index];

    if t<>nil then begin
      panel.view.selected := t;

//      plzFview(true);
{****************************************************************************
Thu 8/17/2006 2:44 pm. This shouldn't be here. plzFview adjusts *both*
dislpays. Whoever calls restoreselect or whoever calls it should do this or
something. Or maybe do this: ?
****************************************************************************}
//      form1.Fcute(panel);    //nah THIS
      plzFview(true,panel);


      result := true;
    end;
  end;

  if not result then
  panel.selectname := '';

end;

{****************************************************************************
****************************************************************************}

type
sortbehavior = (SortDont, SortMaybe, SortMust);

function namecap(fv:Tfv):string;
begin
  case fv.namesort of
    name_ascend, name_descend:  result := namecaption;
    ext_ascend, ext_descend:    result := extcaption;
  end;
end;

type
file_size_style = (fs_number,fs_commas,fs_short);


function file_size(f:Tos_f; style:file_size_style = fs_commas):string;
begin
  if f.dir then
  result := slashchar
  else case style of
    fs_number: result := IntToStr(f.size);
    fs_commas: result := numbercommas(f.size);
    fs_short:  result := abbreviated_number(f.size);
  end;

//  if commas then
//  result := numbercommas(f.size)
//  else
//  result := IntToStr(f.size);
end;

function file_datetime(f:Tos_f):string;
var
timespace : integer;
begin
  try

    datetimetoString(result,
    'm/dd/yy hh:nn:ssa/p',
    filedatetodatetime(f.time)
    );

    if goptions.zerotime then
    exit;

  {make 1/01/01 01:01:01 ==> 1/01/01  1:01:01}
    timespace := pos(' 0',result);

    if timespace>0 then
    result[timespace+1] := ' ';
  except
{****************************************************************************
    on e: exception do begin
      result := safe_format('?:%s',[e.message]);
    end;
that was boring; just bad argument. Here's how owenview shows it

 bsgrep   b    3-03-00  1:17p          46 a
 bs       bak  3-12-07 12:47p         327 a
 jgf      bat  3-02-00  1:32p          21 a
 bs       c    3-03-00  2:07p       7,344 a
 hssym    c    3-03-00  2:15p       3,062 a
 jgioer   c    3-02-00  3:26p       7,285 a
 jgmerge  c    3-02-00  3:26p       5,602 a
 jgopen   c    3-02-00  3:30p      15,358 a
 jgsplit  c    3-02-00  3:27p      15,946 a
 jgwin95  c    3-02-00  6:40p      15,548 a
 jgwin95b c    3-02-00  4:23p       6,463 a
 bs       exe  3-12-07 12:55p      29,343 a
 jgw9     h    1-17-01  4:02p       1,777 a
 jgwin95  h    3-02-00  4:23p      15,622 a
 bs       obj  3-12-07 12:55p       4,924 a
 hssym    obj  3-12-07 12:55p       1,042 a
 jgioer   obj  0-00-80              1,266 a
 jgmerge  obj  0-00-80              1,679 a
 jgopen   obj  0-00-80              4,284 a
 jgsplit  obj  0-00-80              3,679 a
 jgwin95  obj  0-00-80              3,864 a
 jgwin95b obj  0-00-80                968 a
 jg       p    3-12-07 12:54p       2,132 a
 bs       prj  3-12-07 12:53p         237 a
 bs       tc   3-03-00  1:50p       1,690 a

but really we can include better info // of course let's do it in the owenshow
format!

BS.EXE       29,343 3/12/07 12:55:08p    a
JGW9.H        1,777 1/17/01  4:02:34p    a
jgWIN95.H    15,622 3/02/00  4:23:18p    a
BS.OBJ        4,924 3/12/07 12:55:06p    a
HSSYM.OBJ     1,042 3/12/07 12:55:06p    a
JGIOER.OBJ    1,266    ?-??-?? ??:???    a
JGMERGE.OBJ   1,679    ?-??-?? ??:???    a
JGOPEN.OBJ    4,284    ?-??-?? ??:???    a
JGSPLIT.OBJ   3,679    ?-??-?? ??:???    a
JGWIN95.OBJ   3,864    ?-??-?? ??:???    a
JGWIN95B.OBJ    968    ?-??-?? ??:???    a
jg.p          2,132 3/12/07 12:54:52p    a
bs.prj          237 3/12/07 12:53:12p    a
BS.TC         1,690 3/03/00  1:50:58p    a

****************************************************************************}

    on exception do begin
      result := '??/??/?? ??:??:???';
    end;
  end;


end;

{****************************************************************************
****************************************************************************}
const
ex_f : string = '%s%-04s%s';
//               12345

procedure fix_ext_field;
var
x:string;
i:integer;
begin
  x := safe_format('%2d',[Goptions.ext_field mod 100]);
  for i := 1 to length(x) do begin
    if x[i]=' ' then
    x[i] := '0';    //stupid format.
  end;

  ex_f := safe_format('%%s%%-%ss%%s',[x]);

//[5] := chr(Goptions.ext_field mod 10 + ord('0'));
end;


{****************************************************************************
Wed 10/12/2005 2:30 pm. We come here with panel.fls == TStringList of assorted
random files. We have to

1. Assign to the string component of the string list the appropriate item from
the Tos_f in the object.

2. While we're at it, try and add a chr(0) to the beginning of each directory
entry, eh? // nah using sort letters see "c_dir" etc.

3. Sort the whole thing.

4. I think it might be fun to throw away the strings but maybe not. //There's
an info function that shows them. + It'd just take more time....

Thu 10/13/2005 4:11 pm. And then we have to custom sort them to stop Linux
from being extremely stupid. Along with all the golden locales and unicodes
and every silly thing....

****************************************************************************}

function tssort(panel:Tfv; sort:FileSortKind):boolean;
var
reverse : boolean;
one, two:os_ticks;
c_dir, c_fil:string;

procedure namestrings;
var
i:integer;
begin
  for i := 0 to panel.fls.count-1 do
  with panel.fls.objects[i] as Tos_f do begin

    if (dir) then
    panel.fls[i] := c_dir+name
    else
    panel.fls[i] := c_fil+name;
  end;

end;

procedure extstrings;
var
i:integer;
begin
  if not Goptions.dir_ext then begin
    for i := 0 to panel.fls.count-1 do
    with panel.fls.objects[i] as Tos_f do begin

      if (dir) then
      panel.fls[i] := c_dir+name
      else
      panel.fls[i] :=
      format(ex_f,[c_fil, ext ,nameroot])
      ;

    end;

    exit;

  end;

  for i := 0 to panel.fls.count-1 do
  with panel.fls.objects[i] as Tos_f do begin

    if (dir) then
    panel.fls[i] :=
    format(ex_f,[c_dir, ext ,nameroot])
    else
    panel.fls[i] :=
    format(ex_f,[c_fil, ext ,nameroot])
    ;

  end;
end;

procedure sizestrings;
var
i:integer;
s:string;
begin
  for i := 0 to panel.fls.count-1 do
  with panel.fls.objects[i] as Tos_f do begin
{$ifdef LINUX_maybe}
    s :=
    StringReplace(format('%10u',[size]),
    ' ','0',[rfReplaceAll,rfIgnoreCase])+name;
{$else}
    s := format('%10u%s',[size ,name]);
{$endif}

    if (dir) then
    panel.fls[i] := c_dir+s
    else
    panel.fls[i] := c_fil+s;

  end;

end;

procedure timestrings;
var
i:integer;
s:string;
begin
  for i := 0 to panel.fls.count-1 do
  with panel.fls.objects[i] as Tos_f do begin

{$ifdef LINUX_maybe}
    s :=
    StringReplace(format('%10u',[time]),
    ' ','0',[rfReplaceAll,rfIgnoreCase])+name;
//    s := format('%10u%s',[Cardinal(time)+Cardinal($80000000),name]);

{****************************************************************************
I think Linux has a plus/minus scheme or something; anyway adding the magic
$8000,0000 seemed to make time sorts work -- actually it worked in XP too, but
why push things?. Note that the time is Filetime; so it's os-dependent and who
knows. You understand we sort the resulting *string* -- so I can use the
built-in TStringList sort -- so it's all trickery..... // Nope nope none of
that; it was all just the zeros! Ha ha ha....
****************************************************************************}

{$else}

    s := format('%10u%s',[time,name]);

{$endif}

    if (dir) then
    panel.fls[i] := c_dir+s
    else
    panel.fls[i] := c_fil+s;
  end;

end;



procedure attsstrings;
var
i:integer;
begin
  for i := 0 to panel.fls.count-1 do
  with panel.fls.objects[i] as Tos_f do begin

    if (dir) then
    panel.fls[i] := c_dir+atpix+name
    else
    panel.fls[i] := c_fil+atpix+name;
  end;

end;

procedure rev;

begin
  reverse := true;
  c_dir := 'b';
  c_fil := 'a';
end;

begin
  one := Get_ms;

  result := true;
  //there's no way out anyway.

  panel.fls.sorted := false;

  reverse := false;

  c_dir := 'a';
  c_fil := 'b';

{****************************************************************************
Thu 9/27/2007 2:29 pm. So you see the plot is we concoct a sortable list of
the files involving the c_dir / c_fil thingey there and various other magic,
and then we sort it with the stupid_string_sort below. I believe the actual
file records are kept in the TStringList fls.objects[].
****************************************************************************}

  case sort of
    name_ascend: begin
      namestrings;
    end;

    name_descend: begin
      rev;
      namestrings;
    end;

    ext_ascend: begin
      extstrings;
    end;

    ext_descend: begin
      rev;
      extstrings;
    end;

    size_ascend: begin
      sizestrings;
    end;

    size_descend: begin
      rev;
      sizestrings;
    end;

    time_ascend: begin
      timestrings;
    end;

    time_descend: begin
      rev;
      timestrings;
    end;

    atts_ascend: begin
      attsstrings;
    end;

    atts_descend: begin
      rev;
      attsstrings;
    end;

  end;

  stupid_string_sort(panel.fls,reverse);

  two := Get_ms;

  if (two-one)<1 then
  exit;
//don't log fast sorts i.e. two files or something.

  ST_sort_start := one;
  ST_sort_done  := two;

end;


{****************************************************************************
this also apparently actually shows the files.
****************************************************************************}

procedure sortfiles(panel:Tfv; sort:FileSortKind; behavior:sortbehavior);
var
n,s,t,a : string; {name size time attribute column headings}
pix : Tlistitem;
{dt : string; }
theview : Tlistview;
i:integer;
name_alignment:Talignment;
unsorted : string;
TheFv: Tfv;

{$ifdef LINUX}

  function dontcontrol(s:string):string;
  var
  i:integer;
  const
  xchr = '?';
  begin
    result := s;
    for i := 1 to length(s) do begin
      if s[i]<' ' then
      result[i] := '?';
    end;
  end;
{$endif}

begin

  saveselect(panel);

  restoresort(panel,sort);

  TheFv := panel;
  TheFv.sorted := false;

  theview := panel.view;
  Theview.sorted := false; {this is very hard to kill}
  name_alignment := taLeftJustify;

  Theview.columns[namecolumn].caption := '';
  Theview.columns[sizecolumn].caption := '';
  Theview.columns[timecolumn].caption := '';
  Theview.columns[attscolumn].caption := '';

  if (TheFv.filecount<1) then begin
    Theview.items.clear; {yes must clear it}
    Theview.columns[namecolumn].caption := 'no files';
    TheFv.sorted := behavior<>SortDont;
    {don't flag unsorted unless it's already broke.}
    exit;
  end;

  case sort of

    all_unsorted: begin
      n := 'unsorted';
      s := sizecaption;
      t := timecaption;
      a := attscaption;
    end;

    name_ascend: begin
      n := uppercase(namecaption + ascending);
      s := sizecaption;
      t := timecaption;
      a := attscaption;
    end;

    name_descend: begin
      n := uppercase(namecaption + descending);
      s := sizecaption;
      t := timecaption;
      a := attscaption;
    end;

    ext_ascend: begin
      n := uppercase(extcaption + ascending);
      s := sizecaption;
      t := timecaption;
      a := attscaption;
      name_alignment := taRightJustify;
    end;

    ext_descend: begin
      n := uppercase(extcaption + descending);
      s := sizecaption;
      t := timecaption;
      a := attscaption;
      name_alignment := taRightJustify;
    end;

    size_ascend: begin
      n := namecap(panel);
      s := uppercase(sizecaption+ascending);
      t := timecaption;
      a := attscaption;
    end;

    size_descend: begin
      n := namecap(panel);
      s := uppercase(sizecaption+descending);
      t := timecaption;
      a := attscaption;
    end;

    time_ascend: begin
      n := namecap(panel);
      s := sizecaption;
      t := uppercase(timecaption+ascending);
      a := attscaption;
    end;

    time_descend: begin
      n := namecap(panel);
      s := sizecaption;
      t := uppercase(timecaption+descending);
      a := attscaption;
    end;

    atts_ascend: begin
      n := namecap(panel);
      s := sizecaption;
      t := timecaption;
      a := uppercase(attscaption+ascending);
    end;

    atts_descend: begin
      n := namecap(panel);
      s := sizecaption;
      t := timecaption;
      a := uppercase(attscaption+descending);
    end;

  else
    exit;
  end;

  if sort=all_unsorted then
  TheFv.sorted := true
  else

  if
  ((Goptions.sortmax=0) or
  (TheFv.filecount<=Goptions.sortmax) or
  (behavior=SortMust)) and
  (behavior<>SortDont)
  then begin
    TheFv.Sorted :=
    tssort(TheFv,sort);
  end;

  if TheFv.sorted then
  unsorted := ''
  else
  unsorted := '?';

  panel.sort := sort;
  {leave the sort categories intact so he can sort if he wants to.}

  savesort(panel);

  TheFv.namecaption := unsorted+n;
  Theview.columns[namecolumn].caption := TheFv.namecaption;
  Theview.columns[namecolumn].Alignment := name_alignment;
  {u know as far as I can tell, this alignment thingey has no effect.... //
  oh excuse me, this is the alignment for the *contents*, not the
  heading....}

  Theview.columns[sizecolumn].caption := unsorted+s;
  Theview.columns[timecolumn].caption := unsorted+t;
  Theview.columns[attscolumn].caption := unsorted+a;

  Theview.items.clear;

//  if not thefv.dont_fixupdate then
  thefv.view.items.BeginUpdate; {It was there all the time!}

{this is where the actual assignment to the listview occurs. // I have to do
this even if the sort was aborted because things'll've been moved around by
now -- the files array must match the listview. But anyway the sort is what
takes all the time, apparently.}

  for i:=0 to TheFv.filecount-1 do begin

    pix := TheFv.view.items.add;
    pix.caption := Tos_f(TheFv.fls.objects[i]).mark;

{$ifdef LINUX}

{****************************************************************************
Supposedly linux filenames can contain *any* character -- like MSDOS now that
I think of it; the *things* you could so with Microsoft basic!.... Anyway,
this won't fix it, but it might make a little more visible. // actually worked
too.
****************************************************************************}
    pix.SubItems.Add(dontcontrol(

    Tos_f(TheFv.fls.objects[i]).name));

{$else}
    pix.SubItems.Add(
    Tos_f(TheFv.fls.objects[i]).name);
{$endif}

    if goptions.short_size then
    pix.subitems.add(file_size(
    Tos_f(TheFv.fls.objects[i]),fs_short))
    else
    pix.subitems.add(file_size(
    Tos_f(TheFv.fls.objects[i]) ));
    pix.subitems.add(file_datetime(
    Tos_f(TheFv.fls.objects[i]) ));

    pix.SubItems.add( Tos_f(TheFv.fls.objects[i]).atpix);

    if ((i and Gloadlv_n)=0) and
    Gcheck('listview load') then begin
      thefv.scanshort := true;
      thefv.sorted := false; {might not be true but I want it to turn
      yellow.}
      TheFv.filecount := i+1;
      {fake the filecount?}
      break;
    end;

  end;

//  if not thefv.dont_fixUpdate then
  thefv.view.items.endUpdate; {It was there all the time!}

  restoreselect(panel);

  file_showext(panel);
  {this should be here so that the initial display of files show the
  the appropriate little extension cue on the top. It may be stupid, but
  at least it'll be consistent....}

end;

{$ifdef MSWINDOWS}
{
aReadOnly
faHidden
faSysFile
faVolumeID
faDirectory
faArchive  arhs
faAnyFile
}
function showatts(atts:integer):string;
  procedure a(att:integer;letter:char);
  begin
    if (atts and att)<>0 then
    result := result + letter
    else
    result := result + ' ';
  end;

begin
  result := '';
{$WARNINGS OFF}
  a(faSysfile,'s');
  a(faHidden,'h');
  a(faReadonly,'r');
  a(faArchive,'a');
{$WARNINGS ON}

end;
{$endif}


{$ifdef LINUX}
function showatts(atts:integer; Mode: mode_t):string;

  procedure a(att:integer;letter:char);
  begin
    if (atts and att)<>0 then
    result := result + letter
    else
    result := result + ' ';
  end;

  procedure b(att:integer; letter:char);
  begin
    if (mode and att)<>0 then
    result := result + letter
    else
    result := result + ' ';
  end;

begin
  result := '';
{$WARNINGS OFF}
  if Goptions.numeric_atts then begin
//    a(faSymlink,'s');
//    result := result + OctalStr(mode and $1ff);
    result := OctalStr(mode and $FFFF);
    exit;
  end;

  if (atts and faDirectory)=0 then
  b(S_IXOTH or S_IXGRP or S_IXUSR,'x')
  else
  result := result + ' ';
  a(faSymlink,'s');
  a(faReadonly,'r');
{  a(faHidden,'h');  {in Linux it's just any dot file apparently.}
{a waste of time, since they're obvious.}
  result := result + ' '; {I guess make it four characters. One's
  left over!}


{$WARNINGS ON}

end;
{$endif}


{****************************************************************************
****************************************************************************}
type
oldtag = class
  s : string;
end;

function getoldnames(panel:Tfv; directory:string):TstringList;
var
oldt : oldtag;
index : integer;
begin

  result := nil;

  if
  (
{$ifdef MSWINDOWS}
  CompareText
{$endif}
{$ifdef LINUX}
  CompareStr
{$endif}
  (directory,panel.status.caption)=0
  )
  then begin

{save the old tags}
    result := TstringList.Create;
    result.sorted := false;

    for index := 0 to panel.filecount-1 do begin
      if not file_isunmarked( Tos_f(panel.fls.objects[index]) )
      then begin
        oldt := oldtag.Create;
        oldt.s := Tos_f(panel.fls.objects[index]).mark;
        result.addobject( Tos_f(panel.fls.objects[index]) .name,oldt);
      end;
    end;

{$ifdef LINUX}
    result.casesensitive := true;
{$endif}
{$ifdef MSWINDOWS}
    result.casesensitive := false;
{$endif}

    result.sorted := true;  //so we can use .find.

  end;

end;


{****************************************************************************
http://groups.google.com/group/borland.public.delphi.objectpascal/browse_thread/thread/37f69b493ccb4bae/10d38652c2c9f2ad%2310d38652c2c9f2ad

Mike Williams
View profile
   More options Jan 22 1999, 4:00 am
Newsgroups: borland.public.delphi.objectpascal
From: mike @aps-soft.com (Mike Williams)
Date: 1999/01/22
Subject: Re: Filesize > 2 Gig under NT
Reply to author | Forward | Print | Individual message | Show original | Report this message | Find messages by this author

>Q: Is there (or can there be) a Int64 implementation for 'size' in
>TSearchRec that can be used for WinNT? Is the WinNT NTFS return size being
>recast from 64 to 32 bits?
>Q: Is there a NT specific API call that returns the correct file size?

Don't use SR.Size.  Instead, use

  SR.FindData.nFileSizeHigh and SR.FindData.nFileSizeLow

These represent the hi and low 32-bit values of the 64-bit file size.

-Mike
****************************************************************************}

function add1file(panel:Tfv; f:Tsearchrec; rescan:boolean;
oldnames:Tstringlist):Tos_f;
var
index:integer;
//fl : Tos_f;

begin

  result := Tos_f.create;

  result.dir       := (f.attr and faDirectory)<>0;
  result.name      := f.name;
  result.ext       := ExtractFileExt(f.name);
  result.nameroot  := ExtractFname(f.name);
{$ifdef MSWINDOWS}
  result.time      := if_dirtime_int(result.dir,f);
{$endif}

{$ifdef LINUX}
  result.time      := f.time;
{$endif}

  if result.dir then
  result.size := 0
  else begin
{$ifdef MSWINDOWS}
{$WARNINGS OFF}
    result.size      := f.finddata.nFileSizeLow
    or (f.finddata.nFileSizeHigh shl 32)
    ;
{$WARNINGS ON}
{$endif}

{$ifdef LINUX}
    if Goptions.little_files then
    result.size := f.size
    else
    result.size := os_fsize(panel.status.caption + f.name);
{$endif}

  end;  //else result.dir.

  result.attr      := f.attr;

{$ifdef LINUX}
{$WARNINGS OFF}
  result.atpix     := showatts(f.attr,f.mode);
{$WARNINGS ON}
{$endif}

{$ifdef MSWINDOWS}
  result.atpix     := showatts(f.attr);
{$endif}

  inc(panel.bytecount,result.size);

  result.mark := ftagNOTHING;

  if rescan and
  oldnames.find(result.name,index) then
  with result do begin
    mark := es((oldnames.objects[index] as oldtag).s,1);
    if (mark=ftagCK) then begin
      inc(panel.checked);
      panel.check_counted := true;
    end;
  end;

  panel.fls.addobject('' {result.ext},result);
  inc(panel.filecount); {next}
  if result.dir then
  inc(panel.dircount);

end;

{****************************************************************************

****************************************************************************}

function file_scan(t:Ttree; scanall:boolean; panel:Tfv; directory:string;
casesort:boolean):boolean;

var
fileview : TListView;
r : integer;
f : Tsearchrec;

oldnames : TstringList;
index:integer;
broke,
rescan:boolean;

oldlength : integer;

const
here : boolean = false;

label
ENDNESS;

begin

  result := false;    {assume failure}

  if here then
  exit;

  panel.panel.color := panel.view.color;
  panel.view.hide;

  if t<>nil then
  panel.file_tree := t;   {*this* should be the only place file_tree
  gets assigned! ... Yes your right if it was a class I could've
  engineered it ez.}

  form1.progress(files_progress);

{$ifdef LINUX}
  file_lxstat(true);
{$endif}

  panel.checked := 0;
  panel.check_counted := true;

  fileview := panel.view;

  broke := false;
  panel.scanshort := false;

  saveselect(panel);  //changes panel.selectdir for some reason.

  oldnames := getoldnames(panel,directory);
  rescan := oldnames<>nil;

  form1.stopness(howNoWay,'(listview clear)');
  fileview.items.clear;  {it is finished.}
  form1.stopness(howClick);

  oldlength := -1;

  while (not directoryexists(directory))
  do begin

    if (length(directory)=oldlength) then begin

      //make fail for broken paths.
      panel.selectdir := directory;
      fileview.columns[namecolumn].caption := xFileName(directory);
      fileview.columns[sizecolumn].caption := 'doesn''t';
      fileview.columns[timecolumn].caption := 'exist';
      panel.nonexistent := true;
      goto ENDNESS;

    end;

    oldlength := length(directory);
    deslash(directory);
    directory := extractFilePath(directory);
  end;

  panel.status.Caption := directory;

  if Goptions.clickscan then
  panel.status.Hint := 'click to rescan '+directory
  else
  panel.status.Hint := 'double-click to rescan '+directory;

  panel.nonexistent := false;

  directory := directory+'*';
  r := findfirst(directory,faAnyFile
{$WARN SYMBOL_PLATFORM OFF} {because the stupid thing is conditionalized}
  or faHidden
  or faReadOnly
  or faSysFile
{$WARN SYMBOL_PLATFORM ON}
  ,f);

{  panel.files := nil;  } {we don't have to do that, and we shouldn't!}
  panel.emptyfs;    //but we *should* do this for ts_sort.

  panel.bytecount := 0;
  panel.filecount := 0;
  panel.dircount  := 0;

  while(r=0) do begin

    if not indecentdirectory(f) then
    add1file(panel,f,rescan,oldnames);

    if
    (Goptions.scanmax<>0) and
    (panel.filecount>=Goptions.scanmax) and
    (not scanall) then
    panel.scanshort := true;

    inc(Gcheck_count);
    if panel.scanshort or
    (
    ((Gcheck_count and Gcheck_n)=0)
    and Gcheck('scan '+f.name)
    )
    then begin
      broke := true;
      rescan := false;
      panel.scanshort := true;
      break;
    end;

    r := findnext(f);

  end;

  findclose(f);

  fixcomparefunc(casesort);

  if broke then
  sortfiles(panel,panel.sort,sortDont)
  else
  sortfiles(panel,panel.sort,sortMaybe);
  {sortfiles is in charge of displaying the contents of the file array in the
  Tlistview whatever it is.}

  if rescan then begin

    for index := 0 to oldnames.count-1 do begin
      (oldnames.objects[index] as oldtag).free
    end;

    oldnames.free;

  end;

  form1.fileshintoid;

  form1.progress(0);

  panel.view.show;

  ENDNESS:
  here := false;

end;

procedure sortheem(v:Tfv; k:FileSortkind);
begin
  v.old_s := nada_sort; {kill old sort.}

  form1.progress(files_progress);

  v.view.sorted := false; {it's hard to kill}

  sortfiles(v,k,SortMust);

  form1.progress(0);

  file_showext(v);

//  v.sorted := true;

{  form1.plzrefocus_panel; }
  plzfview(true);

end;


procedure flipsort(v:Tfv; column:integer);
var
k : FileSortKind;

begin
  k := v.sort {defaultsort};
  {set it to the current sort, so if he clicks that empty button
  it'll sort however its supposed to currently. I.e. after a sort
  abort.}

  case column of
    {cycle through them.}
    namecolumn: begin

      if v.sort=all_unsorted then begin
        k := Goptions.sort; //put in the default specified, eh?
        //ext_ascend;
        v.namesort := k;
      end else

      if Goptions.click_upsort then
      case v.sort of
        ext_ascend, ext_descend: begin
          k := name_ascend;
          v.namesort := k;
//this I think got left out of a version by accident Wed 3/29/2006 5:58 pm.
        end;

        name_ascend, name_descend: begin
          k := ext_ascend;
          v.namesort := k;
        end;

      else
        k := v.namesort;
      end
      else
      case v.sort of
        ext_ascend: begin
          k := ext_descend;
          v.namesort := ext_ascend;
        end;

        ext_descend: begin
          k := name_ascend;
          v.namesort := name_ascend;
        end;

        name_ascend: begin
          k := name_descend;
          v.namesort := name_ascend;
        end;

        name_descend: begin
          k := ext_ascend;
          v.namesort := ext_ascend;
        end;

      else
        k := v.namesort;
      end;
{Tue 1/14/03 3:46 pm. The plan here is to honor the convention I was
apparently already honoring, which is to default to the ascending sort when
switching columns. Because the name column has four kinds of sort it's more
complicated.}

    end;

    sizecolumn: begin
      if Goptions.click_upsort then
      k := size_ascend
      else
      if v.sort = size_ascend then
      k := size_descend
      else
      k := size_ascend;
    end;

    timecolumn: begin
      if Goptions.click_upsort then
      k := time_ascend
      else
      if v.sort = time_ascend then
      k := time_descend
      else
      k := time_ascend;
    end;

    attscolumn: begin
      if Goptions.click_upsort then
      k := atts_ascend
      else
      if v.sort = atts_ascend then
      k := atts_descend
      else
      k := atts_ascend;
    end;
{  else
    goto ENDNESS;  }
  end;

  sortheem(v,k);

end;

{****************************************************************************
****************************************************************************}
procedure sortWhatKey(ascend, descend:FileSortKind);
var
k:FileSortKind;
begin

  if form1.thisfv.sort = ascend then
  k := descend
  else
  k := ascend;

  if Goptions.upsort then
  k := ascend;

  sortheem(form1.thisfv,k);

end;

procedure sortNameKey;
begin
  sortWhatKey(name_ascend,name_descend);
end;

procedure sortExtKey;
begin
  sortWhatKey(ext_ascend,ext_descend);
end;

procedure sortSizeKey;
begin
  sortWhatKey(size_ascend,size_descend);
end;

procedure SortDatekey;
begin
  sortWhatKey(time_ascend,time_descend);
end;

{****************************************************************************
****************************************************************************}

function file_ismarked(t:Tos_f):boolean;
begin
  result :=
  (t.mark = ftagCK)
  and (not t.dir)
  ;
end;

function file_dir_ismarked(t:Tos_f):boolean;
begin
  result :=
  (t.mark = ftagCK);
end;

function file_isstar(t:Tos_f):boolean;
begin
//we change the syntax of "isstar" to mean "is star or skipped"
  result :=
  (t.mark = ftagCKED) or
  (t.mark = ftagSKIPPED);
end;

function file_isunmarked(t:Tos_f):boolean;
begin
  result :=
  t.mark = ftagNOTHING;
end;

procedure f_m(fv:Tfv; i:integer; what:char; dontdir : boolean = false);
begin
  if ( Tos_f(fv.fls.objects[i]) .dir)
  and
  (
  (
  (what=ftagCK) and
  (not Goptions.dirmark)
  )
  or
  dontdir
  )
  then
  exit;

  if what=ftagCK then begin
    if Tos_f(fv.fls.objects[i]) .mark <> ftagCK
    then begin
      inc(fv.checked);
      fv.check_counted := true;
    end;
  end else begin
    if Tos_f(fv.fls.objects[i]) .mark = ftagCK
    then begin
      dec(fv.checked);
      fv.check_counted := true;
    end;
  end;

  Tos_f(fv.fls.objects[i]) .mark := what;
  fv.view.items[i].caption := what;

end;

procedure file_check(fv:Tfv; i:integer);
begin
  f_m(fv,i,ftagCKED);
end;

procedure file_skip(fv:Tfv; i:integer);
begin
  f_m(fv,i,ftagSKIPPED);
end;

procedure file_checkifmarked(fv:Tfv; i:integer);
begin
  if file_ismarked( Tos_f(fv.fls.objects[i]) )
  then
  file_check(fv,i);
end;

procedure file_dir_checkifmarked(fv:Tfv; i:integer);
begin
  if file_dir_ismarked( Tos_f(fv.fls.objects[i]) )
  then
  file_check(fv,i);
end;

procedure file_skipifmarked(fv:Tfv; i:integer);
begin
  if file_ismarked( Tos_f(fv.fls.objects[i]) )
  then
  file_skip(fv,i);
end;

procedure file_markchecked(which:Tfv = nil; alist:TStringList=nil);
var
x, i:integer;
slist:TStringList;
begin
  if which=nil then
  which := form1.thisfv;

  if alist<>nil then begin
{this is really code for drag 'n' drop atrocities -- but then it has to be
somewhere, and here isn't bad, might be useful for something else someday.}
    slist := TStringList.create;
    slist.assign(alist);
    slist.sorted := false;

    for i := 0 to slist.count-1 do
    slist[i] := ExtractFileName(slist[i]);

{$ifdef LINUX}
    slist.casesensitive := true;
{$endif}
{$ifdef MSWINDOWS}
    slist.casesensitive := false;
{$endif}

    slist.sorted := true;
    //because we want to use find on it.

    for i := 0 to which.filecount-1 do begin
      if (file_isstar( Tos_f(which.fls.objects[i]) )) and (slist.find(
      Tos_f(which.fls.objects[i]) .name,x))
      then begin
        file_mark(which,i);
        slist.delete(x);
      end;
    end;

    slist.free;

    exit;

  end;

  for i := 0 to which.filecount-1 do begin
    if file_isstar( Tos_f(which.fls.objects[i]) )
    then begin
      file_mark(which,i);
    end;
  end;
end;


procedure file_mark(fv:Tfv; i:integer);
begin
  f_m(fv,i,ftagCK);
end;

procedure file_only_mark(fv:Tfv; i:integer);
begin
  f_m(fv,i,ftagCK,true );
end;


procedure file_unmark(fv:Tfv; i:integer);
begin
  f_m(fv,i,ftagNOTHING);
end;



procedure file_showext(v:Tfv; which:integer = -1);
var
ext:string;
begin

  try
    if which<0 then
    which := file_selected_index(v);

    ext := Tos_f(v.fls.objects[which]) .ext;

    if length(ext)>0 then
    v.view.columns[namecolumn].caption :=
    safe_format('%s (%s)',[v.namecaption,ext])
    else
    v.view.columns[namecolumn].caption := v.namecaption;

  except
    on exception
    do ;
  end;

end;



{$ifdef DIDNT_USE_IT}
procedure file_select(v:Tfv; which:integer);
begin
  if which < v.view.items.count then begin
    v.view.selected := v.view.items[which];
    PlzFView;
  end;
end;
{$endif}

procedure selectedmark(mark:boolean = true);
var
t:Tlistitem;
begin

  t := file_selected_item {form1.thisfv.view.selected};

  if t=nil then
  exit;

  if mark then
  file_mark(form1.thisfv,t.index)
  else
  file_unmark(form1.thisfv,t.index);

end;



{****************************************************************************
This is a protected version of delete; it won't happen if the constant below
is set, or if a few other options aren't right.
****************************************************************************}

const
osdel_OK = true;

{.$define DBG_OS_DELETE}

function os_delete(name:string
{$ifdef LINUX}
; filesize : int64 = -1
{$endif}
):boolean;

var
xname:string;
begin
  result := false;


  if osdel_OK then begin

    if os_readonly(name) then begin
      exit;
    end;

    xname := Goptions.del_dir+ExtractFileName(name);

    if (
{$ifdef RECYCLE}
    (not thetree.recycle) and
{$endif}
    (isdel_dir) and
    (not Gos_delete_dontsave) and
    (DirectoryExists(Goptions.del_dir)) and
    (not samedir(ExtractFilePath(name),Goptions.del_dir))
    )
    then begin

{$ifdef DBG_OS_DELETE}
      dbg('os_d del_dir:%s',[name]);
{$endif}

      if (not DeleteFile(xname)) and FileExists_unq(xname) then
      errorf('During move-don''t-delete (in %s, deletedir=%s), '+
      'couldn''t delete %s',
      [ininame,Goptions.del_dir,xname]);

      {if it fails, can't rename.}
{$ifdef LINUX}
      result := os_fMove(name,xname,filesize,true);
{****************************************************************************
Fri 4/29/2005 12:36 pm. The OwenShow scheme, borrowed from OwenView, relies on
having a delete directory destination on every drive. But there *are* no
drives in Linux. So we use the os_fMove function which'll copy/delete if it
can't move. The -2 stops it from calling us back! ... Ok it's a little
sickening... // so I changed it to a Linux-only flag Mon 5/16/2005 11:04 am.
****************************************************************************}
{$endif}
{$ifdef MSWINDOWS}
      result := RenameFile(name,xname);
{$endif}
    end else begin
{$ifdef RECYCLE}
{$ifdef DBG_OS_DELETE}
      dbg('os_d recycle?:%s',[name]);
{$endif}
      result :=
      (not Gos_delete_dontsave)
      and thetree.recycle and recycle_file(name);
      if not result then
{$endif}
      result := DeleteFile(name);
    end;

  end else begin
    osinfof('files:osdel_OK is false; would''ve deleted file "%s"',[name]);
    result := true;
  end;

end;

function sameSizeTime(s,d:string):boolean;
var
s_age, d_age,
s_size, d_size:integer;
begin
  s_age := FileAge(s);
  d_age := FileAge(d);

  s_size := os_fSize(s);
  d_size := os_fSize(d);

  result :=
  (s_age = d_age)
  and
  (s_size = d_size);

end;

function depictfile(s:string):string;
var
dt:string;
begin

  result := s+' ???';
    try

    datetimetoString(
    dt,
    'm/d/yy hh:nn:ss a/p',
    filedatetodatetime(FileAge(s))
    );

    result :=
    safe_format('%s: %s bytes; %s',
    [
    s,
    numbercommas(os_fSize(s)),
    dt
    ]);
  except
    on E: exception do
    errorf('depictfile: %s',[e.message]);
  end;
end;

{true if ok to write. No actually returns raNA if no overwrite, else
raOK. or perhaps raABORT.}
function OverwriteOK(s,d:string):resultAction;
var
same:string;
begin
  result := raNA;

  if not FileExists_unq(d) then
  exit;

  if sameSizeTime(s,d) then
  same := '(they appear to be the same size, date)'
  else
  same := '';

  chit.wreck.visible := Goptions.wreck;
  chit.Caption := safe_format('Overwrite %s?',[d]);
  chit.AbortBut.caption := '&Abort';
  chit.SkipBut.caption := '&Skip';
  chit.OkBut.caption := '&Yes, overwrite';

  chit.chat.Text :=
  safe_format(
  'overwrite'+LNEND+
  '%s'+LNEND+
  'onto'+LNEND+
  '%s?'+LNEND+
  '%s',
  [depictfile(s),depictfile(d),same]
  );

  chit.showmodal;

  result := chit.chit_result;

end;

const

{Blue Green Red}
clGreenish = $005500;
clRedish =   $000055;

{type Rsamefile = (sfIS, sfISNT, sfABORT);}


{true if same file}
function samefile(s,d:string):ResultAction;
var
Sstory,Dstory:string;

begin
  result := raNA;

{  a := depictfile(longify(s));
  b := depictfile(longify(d));  }
{we don't really want to check their times; the same name is bad
enough. ... Thursday, October 31, 2002 6:19 pm *WHAT* is he babbling
about!? Good grief that's all I care about}

{$ifdef MSWINDOWS}
  v_longify(s);
  v_longify(d);
{$endif}

  if
  (not sameSizeTime(s,d))
  or
  (
{$ifdef MSWINDOWS}
  CompareText
{$endif}
{$ifdef LINUX}
  CompareStr
{$endif}
  (xfilename(s),xfilename(d))<>0
  )
  then
  exit;

  Sstory := depictfile(s);
  Dstory := depictfile(d);

  chit.Caption := safe_format('Same file?',[0]);

  chit.chat.font.color := clGreenish;

  chit.chat.text :=
  safe_format(
  '%s'+LNEND+
  'and'+LNEND+
  '%s'+LNEND+
  'appear to be the same file. Skip, or abort?',
  [Sstory,Dstory]);

  chit.wreck.visible := Goptions.wreck;
  chit.Abortbut.caption := '&Abort';
  chit.SkipBut.caption := '&Skip';
  chit.OkBut.caption := '&Yes, do it anyway!';

  chit.showmodal;

  result := chit.chit_result;

  if result=raOK then
  result := ra_Same_Overwrite_OK;

end;

{true if ok to write}
function newerOK(s,d:string):resultAction;
var
sd:string;
begin
  result := raNA;

  if not FileExists_unq(d) then
  exit;

  if FileAge(d) <= FileAge(s) then
  exit;

  chit.wreck.visible := Goptions.wreck;
  chit.Caption := safe_format('Newer %s?',[d]);
  chit.AbortBut.caption := '&Abort';
  chit.SkipBut.caption := '&Skip';
  chit.OkBut.caption := '&Yes, Clobber it';

  sd := depictfile(d);

  chit.chat.font.color := clRedish;

  chit.chat.Text :=
  safe_format(
  'ovewrite older'+LNEND+
  '%s'+LNEND+
  'onto'+LNEND+
  '%s?',
  [depictfile(s),sd]
  );

  chit.showmodal;

  result := chit.chit_result;

  if
  (result=raWRECK)
  or
  (
  (result=raOK)
  and usuref('Really totally obliterate newer'+LNEND+
  '%s?',
  [sd])
  ) then
  exit;

{****************************************************************************
Fri 5/20/2005 1:43 pm. This is bad; it obliterates raABORT at least. I have no
idea why it's here, but now I'm removing it.
****************************************************************************}
//  result :=raNFG;


end;


{****************************************************************************
the caller is in charge of making sure it's the same Tfv.
****************************************************************************}

procedure file_top(saveit:boolean; which:Tfv = nil);
const
oldindex : integer = -1;
begin

  with form1 do begin

    if which=nil then
    which := thisfv;

    with which.view do begin
      if saveit then begin
        oldindex := which.view.topitem.index;
      end else begin
        try
          if (oldindex>=0)
          and (oldindex<items.count) then
          topitem := items[oldindex];
        except
          on exception do;
        end;

        oldindex := -1;

      end;

    end;

  end;

end;


{****************************************************************************
****************************************************************************}
function file_selected_item(which:Tfv = nil):Tlistitem;
begin
  with form1 do begin
    if which=nil then
    which := thisfv;

    result := which.view.selected;

    if result=nil then begin
      result := which.view.itemfocused;
      try
        if result<>nil then
        which.view.selected := result;
        {fix the stupid thing?}
      except
        on exception
        do;
      end;
    end;

  end;
end;


function file_selected_index(which:Tfv = nil):integer;
var
t:Tlistitem;
begin
  with form1 do begin
    if which=nil then
    which := thisfv;

    t := file_selected_item(which);

    if t<>nil then
    result := t.index
    else
    result := -1;
  end;
end;

{****************************************************************************
****************************************************************************}
var
empty_Tos_f : Tos_f;

function file_selected(which:Tfv = nil):Tos_f;
var
index : integer;
begin
  result := empty_Tos_f; {an empty one I guess. So callers don't have to check or
  exception or other boring etc.}
  with form1 do begin

    if which=nil then
    which := thisfv;

    index := file_selected_index(which);

    if index>=0 then result := Tos_f(which.fls.objects[index])

  end;
end;

function file_selected_name(which:Tfv = nil):string;
begin
  result := file_selected(which).name;
end;

{****************************************************************************
Tos_f = record
  dir:boolean;
  mark : char;
  name,ext:string;
  time,size,attr:integer;
  atpix : string[4];
$ifdef LINUX
  Mode: mode_t;
$endif
end;

bingo.bop 123,456 date time ar

****************************************************************************}

function file_selected_info(which:Tfv = nil):string;
var
f:Tos_f;
begin
  f := file_selected(which);

{$ifdef MSWINDOWS}
  result := safe_format(
  '%s %s %s %s',
  [f.name,file_size(f),file_datetime(f),despace(f.atpix)]);
{$endif}

{$ifdef LINUX}
  result := safe_format(
  '%s %s %s %s %s',
  [f.name,file_size(f),file_datetime(f),despace(f.atpix)
  ,OctalStr(f.mode)
  ]);
{$endif}

end;


{****************************************************************************
Fri 9/16/2005 3:32 pm. Changed to "Ansi" version versus 'jes
CompareStr/CompareText to match TStringLIst, which I'm now using to sort the
directories....
****************************************************************************}

procedure fixcomparefunc(casesort:boolean);
begin
  if casesort then
  comparefunc := CompareStr
  else
  comparefunc := CompareText;

end;

{****************************************************************************
****************************************************************************}

procedure deletefile_entry(panel:Tfv; index:integer; free_file:boolean =
true);
begin
  if Tos_f(panel.fls.objects[index]).dir then
  dec(panel.dircount);

  if free_file then
  panel.fls.objects[index].free; //dump the tos_f.

  panel.fls.delete(index);
  dec(panel.filecount);
end;

{****************************************************************************
go through the two file thingeys, and if it's the directory, the fiddle the
files somehow. Returns true if anything is deleted or added.
****************************************************************************}

procedure file_oldnew_begin;
begin
  with form1 do begin
    fv1.needs_sort := false;
    fv2.needs_sort := false;
  end;
end;

procedure file_oldnew_finish;
  procedure fof(p:Tfv);
  begin
    if p=nil then
    exit;
    with p do if needs_sort then begin
      needs_sort := false;
      fixcomparefunc(Goptions.casesort);
      sortfiles(p,sort,SortMaybe);
    end;
  end;
begin

{$ifdef LINUX}
  file_lxstat(true);
{$endif}

  fof(form1.fv1);
  fof(form1.fv2);

end;

function file_oldnew(oldpath,newpath:string):boolean;
var
olddirectory, newdirectory,
oldname, newname:string;

  procedure fsn(panel:Tfv);
  var
  index:integer;
  os_f:Tos_f;     //the file record for the old thing.
  f:Tsearchrec;
  begin

    result := false;

    os_f := nil;

{check the old guy.}
    if
    (
  {$ifdef MSWINDOWS}
    CompareText
  {$endif}
  {$ifdef LINUX}
    CompareStr
  {$endif}
    (olddirectory,panel.status.caption)=0
    )
{    and
    (panel.files<>nil) }
{and this seems a little touchy too; it won't find the name if the filecount
is zero, which occurs at the beginning of the program. Indeed, nobody should
be looking at panel.files really..... Oh if I had only made a class....}
    then begin
      index := file_findname(panel,oldname);
      if index>=0 then begin

        os_f := Tos_f(panel.fls.objects[index]);

        deletefile_entry(panel,index,false);  //DON'T free the file.

        result := true;
        panel.needs_sort := true;  {it needs it because that's the way I
        display everything.}

        dec(panel.bytecount,os_f.size);

      end;
    end;

{check the new guy.}
    if
    (
  {$ifdef MSWINDOWS}
    CompareText
  {$endif}
  {$ifdef LINUX}
    CompareStr
  {$endif}
    (newdirectory,panel.status.caption)=0
    )
    and (
{$ifdef LINUX}
    LXFindOne
{$else}
    findfirst
{$endif}
    (newdirectory+newname,
    faAnyFile
    {$WARN SYMBOL_PLATFORM OFF}
    or faHidden
    or faReadOnly
    or faSysFile
    {$WARN SYMBOL_PLATFORM ON}
    ,f)=0) then begin
      if
      (not indecentdirectory(f)) then begin
        {first dump the *old* name. }
        index := file_findname(panel,newname);
        if (index>=0)
        then
        deletefile_entry(panel,index);

//then add the the new file,
        add1file(panel,f,false,nil);

        if (os_f<>nil) then
        Tos_f(panel.fls.objects[panel.filecount-1]) .mark := os_f.mark;

        panel.needs_sort := true;
        result := true;
      end;

      findclose(f);
    end;

    freeandnil(os_f);

  end;

  procedure xjunk(src:string; var dstdir, dstname:string);
  begin
    if src='' then begin
      dstdir := '';
      dstname := '';
    end else begin
      dstdir    := extractFilePath(src);
      dstname   := ExtractFileName(src);
    end;

    if (length(dstdir)<1) and (length(dstname)>0) then
    dstdir := getcurrentdir;
    {you understand, if whoever is calling us doesn't have a directory on the
    argument, it is presumably using the current directory. I certainly hope
    so.}

    if length(dstdir)>0 then
    slash(dstdir);

  end;

  function fnexists(s:string):boolean;
  begin
    result :=
    FileExists_unq(s) or
    DirectoryExists(s)
    ;
  end;

begin

  deslash(oldpath); //make it work with directories too.
  deslash(newpath);

  xjunk(oldpath,olddirectory,oldname);
  xjunk(newpath,newdirectory,newname);

  result := false;

{****************************************************************************
//added Thursday, January 27, 2005 12:22 pm.
Tuesday, April 5, 2005 3:53 pm. but seems richly stupid. This for instance
won't update a file if it's been appended-to. Hmmmph. But of course that
doesn't happen in normal OwenShow ops; but sometimes, like when I'm saving a
picture of the directories, I want it to happen; so I introduced the anyway
argument. // But then again, this would fail in a normal Owenshow operation
when I was copying a new version of a file over an existing version of the
same file. So to hoo with it. I wish I remember why I put this stuff in.
****************************************************************************}
  fsn(form1.fv1);
  fsn(form1.fv2);
end;

procedure file_off(path:string);
begin
  file_oldnew_begin;
  file_oldnew(path,'');
  file_oldnew_finish;
end;

{****************************************************************************
****************************************************************************}

procedure file_fiddlesort(fv:Tfv = nil);
const
sort_inited : boolean = false;
var
sk : filesortkind;
begin

  with form1 do begin

    if not sort_inited then begin
      sort_inited := true;

      fv1.sort := Goptions.sort;
      fv2.sort := Goptions.sort;
      case Goptions.sort of
        name_ascend,name_descend,ext_ascend,ext_descend:
        sk := Goptions.sort;
      else
        sk := ext_ascend;
      end;

      fv1.namesort := sk;
      fv2.namesort := sk;

      exit;
    end;

    if not Goptions.resort then
    exit;

    if fv=nil then
    fv := thisfv;

    fv.sort := Goptions.sort;

  end;
end;



{You could short-circuit it for multiple files, just to indicate whether there
was 1 or 2 -- but still it would take forever for a single file, so what the
heck might as well provide a count... So while we're at it we'll provide the
name of a single file, if it is a single file.... // and then Mon 12/02/02
2:20 pm added the obvious marked result too; which is actually
length(onefile)<1 but whatever. So I can short-circuit the idiotic file-list
scan I was doing in various cpyfiles operations. }

function file_thiscount_complain
(var onefile:string; var marked:boolean):integer;
var
dircount,
i:integer;
onetos : Tos_f;

  procedure dircheck(const x:Tos_f);
  begin
    if x.dir then
    inc(dircount);
  end;

begin
  onefile := '';
  onetos := nil;
  result := 0;
  marked := false;
  dircount := 0;

  with form1 do
  for i := 0 to thisfv.filecount-1 do begin

    if file_dir_ismarked( Tos_f(thisfv.fls.objects[i]) )
    then begin
      marked := true;
      inc(result);
      if onetos=nil then
      onetos := Tos_f(thisfv.fls.objects[i]) ;

      dircheck( Tos_f(thisfv.fls.objects[i]) );
    end;

  end;

  if onetos=nil then begin
    onetos := file_selected;
    if onetos.name<>'' then
    result := 1;
    dircheck(onetos);
  end;

  if dircount>0 then begin
    errorf(
    'You can''t copy/move directories with OwenShow! '+
    'Or rename/delete them in the files display.');
    result := -1;
    exit;
  end;

  if result<1 then begin
    errorf('No files to copy!');
    result := -1;
    exit;
  end;

  onefile := onetos.name;

{  if onetos.dir then begin
    errorf('Can''t do that with directory "%s" in file panel',
    [onefile]);
    result := -1;
  end;  }

end;

procedure file_renamedir(old,new:string);
  procedure f_r(fv:Tfv;old,new:string);
  begin
    if old=fv.status.caption then begin
      fv.status.caption := new;
    end;
  end;
begin
  slash(old);
  slash(new);
  f_r(form1.thisfv,old,new);
  f_r(form1.elsefv,old,new);
end;

{****************************************************************************
TSTATBUF DEFINTION!!!!

type
  _stat = record
    st_dev: __dev_t;                     Device.
    __pad1: Word;
    st_ino: __ino_t;                     File serial number.
    st_mode: __mode_t;                   File mode.
    st_nlink: __nlink_t;                 Link count.
    st_uid: __uid_t;                     User ID of the file's owner.
    st_gid: __gid_t;                     Group ID of the file's group.
    st_rdev: __dev_t;                    Device number, if device.
    __pad2: Word;
    st_size: __off_t;                    Size of file, in bytes.
    st_blksize: __blksize_t;             Optimal block size for I/O.
    st_blocks: __blkcnt_t;               Number 512-byte blocks allocated.
    st_atime: __time_t;                  Time of last access.
    __unused1: LongWord;
    st_mtime: __time_t;                  Time of last modification.
    __unused2: LongWord;
    st_ctime: __time_t;                  Time of last status change.
    __unused3: LongWord;
    __unused4: LongWord;
    __unused5: LongWord;
  end;
  |.$EXTERNALSYM stat| // Renamed due to conflict with stat function
  TStatBuf = _stat;
  PStatBuf = ^TStatBuf;
****************************************************************************}

{$ifdef LINUX}

function file_lxstat(reset : boolean = false):boolean;
const
olditem : Tos_f = nil;

atts : array [0..2] of char = 'xwr';
atts2 : array[0..2] of char = 'sgu';  //these are backwards.
var
thisitem : Tos_f;
//buf : TstatBuf;
o:To_statresult;
lbl : Tlabel;
ids,s:string;
j,i : integer;

label
GOTORESET;

begin
  result := false;

  lbl := form1.Label_LXstat;

  if reset then begin
    GOTORESET:
    olditem := nil;
    if length(lbl.caption)>0 then
    lbl.caption := '';
    exit;
  end;

  thisitem := file_selected;

  if thisitem=empty_Tos_f then
  goto GOTORESET;

  if thisitem=olditem then
  exit;

  olditem := thisitem;

  try
    o := os_Getstat(thisdir_string+thisitem.name);
  except
    on e: exception do begin
      lbl.caption := e.message;
      exit;
    end;
  end;

  result := true;

//  if thisitem.dir then
//  s := 'd'
//  else
//  s := '-';

  form1.link_name := '';

  s := '?';
  case (o.buf.st_mode and S_IFMT) of
    S_IFSOCK: s := 'sock';
    S_IFLNK:  begin
      s := os_readlink(thisdir_string+thisitem.name);

      if s<>'' then
      form1.link_name := '"' + s + '"'
      else
      form1.link_name := '';

      s := 'link';
    end;

    S_IFREG:  s := 'file';
    S_IFBLK:  s := 'blk';
    S_IFDIR:  s := 'dir';
    S_IFCHR:  s := 'char';
    S_IFIFO:  s := 'fifo';
  end;

  s := s + ' ';

//  if o.errno=0 then
//  o.errno := 76543;

  if o.errno<>0 then
  s := safe_format('%d? ',[o.errno])+s;

  for i := 11 downto 0 do begin
    if i=8 then
    s := s+' ';

    if (o.buf.st_mode and (1 shl i)) = 0 then
    s := s + '-'
    else begin
      j := i mod 3;
      if i<=8 then
      s := s + atts[j]
      else
      s := s + atts2[j];
    end;
  end;

  try
    ids :=
    ' '+getpwuid(o.buf.st_uid)^.pw_name
    +
    ' '+getgrgid(o.buf.st_gid).gr_name
    ;
  except on e: exception do
//    lbl.caption := e.message;
//all I knows if midnight commander does this....
    ids := safe_format(' %d %d',[o.buf.st_uid,o.buf.st_gid]);
  end;

  s := s + ids;

  lbl.caption := s;

  form1.statmemoid;


end;
{$endif}

{****************************************************************************
****************************************************************************}

function verboseatts(f:Tos_f):string;
var
i:integer;
space:string;
begin
  result := '';
  space := '';

  for i := 1 to length(f.atpix) do begin
    case f.atpix[i] of
{$ifdef LINUX}
      'x':
      begin
        result := result + space + 'exec';
        space := ' ';
      end;
{$endif}
      's':
      begin
        result := result + space +
{$ifdef LINUX}
        'symlink'
{$endif}
{$ifdef MSWINDOWS}
        'system'
{$endif}
        ;
        space := ' ';
      end;

      'r':
      begin
        result := result + space + 'read-only';
        space := ' ';
      end;

{$ifdef MSWINDOWS}
      'h':
      begin
        result := result + space + 'hidden';
        space := ' ';
      end;

      'a':
      begin
        result := result + space + 'archive';
        space := ' ';
      end;
{$endif}

      end;
  end;

  if result<>'' then
  result := LNEND + result;

end;


procedure file_show;
var
f:Tos_f;
q,
{$ifdef MSWINDOWS}
short,
{$endif}
atpix:string;
begin
//  infof('%s',[file_selected_info]);
//  exit;

  f := file_selected;
  if (f<>nil) then begin

    if pos(' ',f.name)>0 then
    q := '"'
    else
    q := '';

    atpix := verboseatts(f);
{$ifdef MSWINDOWS}
    short := shortify(f.name);
    if CompareText(short,f.name)<>0 then begin
      short := LNEND+short;
      if f.dir then
      short := short + slashchar;
    end
    else
    short := '';

{$endif}
    if f.dir then
    osinfof(
    q+'%s'+slashchar+q+
{$ifdef MSWINDOWS}
    '%s'+
{$endif}
    LNEND+
    '%s%s'

    ,
    [f.name,
{$ifdef MSWINDOWS}
    short,
{$endif}
    file_datetime(f),
    atpix]
    )

    else

    osinfof(
    q+'%s'+q+
{$ifdef MSWINDOWS}
    '%s'+
{$endif}
    LNEND+
    '%s%s'+LNEND+
    '%s bytes'
    ,
    [f.name,
{$ifdef MSWINDOWS}
    short,
{$endif}
    file_datetime(f),
    atpix,
    numbercommas(f.size)
    ]
    );
  end;
end;


{****************************************************************************
****************************************************************************}

initialization

empty_Tos_f := Tos_f.create;

finalization

empty_Tos_f.free;



end.
