{fontfun.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

{****************************************************************************
Fri 9/09/2005 5:24 pm. I should say the notes in here are far far south by
now; this is undoubtedly the oddest part of OwenShow, which has *many* odd
parts.

----------------------------------------
----------------------------------------


so this got too complicated. These things should be true:

  1. Whenever a control gets its font modified, the control should be added to
  a list associated with the font, and used *instead* of the original font for
  subsequent changes.

But that still wouldn't work. Say I change a font; main fiddles *its* stuff,
but other forms don't do that until they're shown, at which point they may
well have-overlapping fonts. // No no that'd be ok; the first time, *they're*
controls wouldn't be in the list, so they'd use the *original* font, eh?

Yeah, yeah. So when you're fiddling fonts on a form, it's like

  if control in list for font, change its font to the new font
  else if control font == original font, then changes its font to the new
  font, and store its control in the list.

//no no there'd have to be a little more logic. There'd have to be a list of
forms, too, so the form'd know it *hadn't* been there before. It it *hasn't*
been there, then it'll change fonts according to the original font; otherwise
it'll use the control storage.

No, no, it's like there'll be a list of forms, with each item in the form list
having a list of controls that *have been seen*.


//Wait. Start again:

1. For each font category, we keep the original font, and a change-to font,
and a list of changed controls.

2. When a control is submitted for change, *if* it's in the changed control
list, *or* if its font== the original font, *then* it gets changed. It of
course gets its control saved at that point.

3. There's a "done" list of forms, which gets cleared whenever a font is
changed.

//Oops gotta make the main array a list, because two fonts may be the same!
So, leave the font labels I've got there, and just check that each one
is unique while we dance the dance.

Wednesday, June 9, 2004 10:32 am. Or something....

****************************************************************************}


unit fontfun;


interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QButtons, QExtCtrls, QComCtrls;

type
  TfFontfun = class(TForm)
    CancelButton: TBitBtn;
    helpbutton: TBitBtn;
    BitBtn_OK: TBitBtn;
    GroupBox1: TGroupBox;
    Panel_Original: TPanel;
    Splitter1: TSplitter;
    Panel_Changed: TPanel;
    Label_treemono: TLabel;
    Label_small: TLabel;
    Label_dialog: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label_tm_changed: TLabel;
    Label_small_changed: TLabel;
    Label_dialog_changed: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    BitBtn_reset: TBitBtn;
    SpinEdit_THadjust: TSpinEdit;
    Label17: TLabel;
    SpinEdit_header: TSpinEdit;
    Label18: TLabel;
    SpinEdit_tabDif: TSpinEdit;
    Label19: TLabel;
    SpinEdit_Line: TSpinEdit;
    Label20: TLabel;
    CheckBox_Short: TCheckBox;
    Label21: TLabel;
    CheckBox_Debug: TCheckBox;
    ListView_FontTest: TListView;
    SpinEdit_Scroll: TSpinEdit;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label_treemonoClick(Sender: TObject);
    procedure BitBtn_OKClick(Sender: TObject);
    procedure BitBtn_resetClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure helpbuttonClick(Sender: TObject);
    procedure SpinEdit_THadjustChanged(Sender: TObject; NewValue: Integer);
    procedure SpinEdit_headerChanged(Sender: TObject;
      NewValue: Integer);
    procedure SpinEdit_tabDifChanged(Sender: TObject;
      NewValue: Integer);
    procedure FormResize(Sender: TObject);
    procedure SpinEdit_LineChanged(Sender: TObject; NewValue: Integer);
    procedure CheckBox_ShortClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox_DebugClick(Sender: TObject);
    procedure SpinEdit_ScrollChanged(Sender: TObject; NewValue: Integer);
  private
    { Private declarations }
    changed : boolean;
    function getfonts:boolean;
    function putfonts:boolean;
    procedure clickfont(which:integer);
    procedure fontfunhelp;
    procedure figgerFileFonts;
  public
    { Public declarations }
    function xinit:boolean;  {probably called by main?}
  end;

var
  fFontfun: TfFontfun;

//Gtabheight,
Gtabdif,      //adjustment for various thingeys.
Gislineadjust,  //set by jdisplay code.
Gtreelineadjust : integer;

show_line_count : boolean;
//NOT saved restored.

const
{$ifdef MSWINDOWS}
scrollguess = 16;
headerPlusLineguess = 14;
{$endif}
{$ifdef LINUX}
scrollguess = 18;
headerPlusLineguess = 15;
{****************************************************************************
changed to 8 Wed 10/19/2005 11:29 am when I had to fudge 2 on 3 linux
systems. Wed 11/02/2005 1:58 pm. So I have to keep adjusting them -3, for 18;
so, 15.
****************************************************************************}
{$endif}

files_PixPerLine : integer = 10;
files_header:integer = 19;
files_scroll:integer = scrollguess;

var
line_fudge,
header_fudge,
scroll_fudge : integer;


function fixfonts(f:Tform):boolean;

function needlineadjust:boolean;

procedure undebugfudge;

implementation

{$R *.xfm}

uses
weirdo
, sbrs, code, inifiles, options, main, exec, qt, log, qmenus,
publics, fileutil;

var
isfontfun : boolean;

const
treelineadjust_name = 'treelineadjust';


tabdif_name = 'tabdif';
short_name = 'short_menu';

header_name = 'header_fudge';
line_name   = 'line_fudge';
scroll_name = 'scroll_fudge';


{$ifdef LINUX}
MS_dialog_name = 'MS Shell Dlg';
{$endif}


type

Tfontthing = class
  story    : string;
  linux_label,
  origlabl,           {the original font.}
  newlabl : Tlabel;   {a new font after it's changed by user, or reading
                      osfonts.ini.}

{$ifdef LINUX}
  original_name : string;
{****************************************************************************
in Linux, some things that are named "MS Shell Dlg" aren't. Something randomly
changes their names.... So I will explicitly encode them. Note that I don't
have to save and restore this to the font ini file; this is ALWAYS inited to
whatever it is for the dialog font. Or something.
****************************************************************************}
{$endif}


  dialog_ptr : TFontDialog;
//  original: Tfont;
{ I was going to save the font in this created Tfont -- but that's
stupid; save it in the labl. }

  control_list:Tlist;
{a list of controls that had their fonts changed *already*. }

  anysize:boolean;

  savefont: Tfont;
  fontsaved : boolean;

  constructor Create(s:string;l,n:Tlabel;f:Tfont;a:boolean = true);
  destructor Destroy; override;

end;

constructor Tfontthing.Create(s:string;l,n:Tlabel;f:Tfont;a:boolean = true);
begin
  inherited Create;

  origlabl := l;

  linux_label := Tlabel.create(fFontFun);
  with linux_label do begin
    parent :=   l.parent;
    left :=     l.left;
    top :=      l.top;
    width :=    l.width;
    height :=   l.height;
    wordwrap := l.wordwrap;
    onclick :=  n.onclick;
  end;

  if Goptions.show_original_fonts then begin
    {q.v. in help}
    origlabl.visible := true;
    linux_label.visible := false;
  end else begin
    origlabl.visible := false;
    linux_label.visible := true;
  end;

  newlabl := n;
  newlabl.visible := true;

  origlabl.font.assign(f);
  newlabl.font.assign(origlabl.font);

  {argument L is the font I assign in the IDE -- which presumably gets
  transmogrified by Kylix when OS starts in Linux-of-the-week or whatever.}

  dialog_ptr := TfontDialog.create(fFontFun);
//dialogue.assign(original);  //no compile error!

//  dialog_ptr.height := {ffontfun.height} screen.height -10;
  //try to make font list visible; although I think this only works in Linux
  //-- but of course that's where I need it.... but doesn't work there either.

  dialog_ptr.font.assign(newlabl.font);
{so the original, the new lablel,  and the dialogue get the font of the label
-- which of course I set in the IDE to my heart's desire. }

  control_list := Tlist.create;

  story := s; {the story }

  savefont := Tfont.create;
  fontsaved := false;

  anysize := a;
{****************************************************************************
THE STORY OF ANYSIZE                                  Thu 6/10/2004 9:40 am.

I started by comparing name and size, which seemed pretty simple-minded, but
then an even more simple-minded assumption: just compare names. This "works",
inasmuch as the fontlog (Goptions.osfontfun) showed no assignments ("got")
when I made everything anysize in Windows. Already I had determined everything
had to be anysize in Linux -- where the precise font is less interesting,
since there is no reliable set of Linux fonts anyway.

So the idea now is one explicitly decides if the font will be anysize compared
in .xinit, defaulting to true. If for some reason one wanted to, say, check
all the 5-point Small fonts separately, one would make sure that font came
*first* in the .xinit creation list, with an anysize false argument. But I
didn't test that.

So the business of checking only the names isn't as stupid as it sounds, but
certainly would cause more trouble in more elaborate programs. But still, the
size version first, anysize version next, strategy would probably fix that
kind of thing OK. Whatever. This everyone-anysize thing works today -- and a
lot better than at least two other silly approaches, in Linux of course which
is where the fonts are really ugly otherwise. You understand, it wouldn't
improve things to develop the fonts in Linux and then fix them in Windows:
since Linux has the unstandardized font mengarie, it would just make Windows
like another Linux, while doing them in Windows at least guarantees a mild
compatibility with other Windows systems.

****************************************************************************}


end;

destructor Tfontthing.Destroy;
begin
  origlabl.visible := false;
  newlabl.visible := false;
  linux_label.visible := false;
  freeandnil(control_list);
  freeandnil(savefont);
  inherited destroy;
end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
ff17_list should wind-up as a stringlist of forms:

  the object associated with each form is a stringlist of objects.

    the object associated with objects is the integer number of the desired
    font.

The correspondence between the font number drivelled in OwenShowFonts there
and local numbers is arbitrary.

****************************************************************************}
var
ff17_list:TstringList;
isff17 : boolean; //if true, don't use old mechanism.

function getff17(form_name,component_name:string):integer;
var
index :integer;
begin
  result := -1;

  if not ff17_list.find(form_name,index) then
  exit;

  try
    with ff17_list.objects[index] as TStringList do begin
      if find(component_name,index) then
  //    result := index;
      result := integer(objects[index])-1;  //it's 1-based.
    end;
  except on
    exception do;
  end;

end;

procedure xff17;
var
object_name,
s : string;
h : integer;

thisform : TStringList;

  procedure finish_thisform;
  begin
    if thisform<>nil then begin
      thisform.casesensitive := false;
      stupid_string_sort(thisform);
    end;
  end;

begin
  ff17_list := TStringList.create;

  if length(Goptions.fontfun17)<1 then
  exit;

  h := FileOpen(Goptions.fontfun17,fmOpenRead);
  if h<0 then exit;

  thisform := nil;

  while hgets(h,s) do begin
    if es(s,1)=';' then
    continue;

    tokenate(s);
    if tokens<>2 then
    continue;

    if tokenarray[1]='form' then begin
      finish_thisform;

      thisform := TStringList.Create;
      ff17_list.addobject(tokenarray[2],thisform);
    end else
    if tokenarray[1]='object' then begin
      object_name := tokenarray[2];
    end else
    if tokenarray[1]='font' then begin
      if thisform=nil then
      continue;

      thisform.addobject(object_name,Tobject(JgoStrToInt(tokenarray[2])));

    end;

  end;

  finish_thisform;

  ff17_list.casesensitive := false;

  ff17_list.sorted := true; //so we can use find.

  FileClose(h);

  isff17 := ff17_list.count > 5;
//I mean, there must've been *something*.

end;

procedure freeff17;
var
i:integer;
begin
  for i := 0 to ff17_list.count-1 do begin
    if ff17_list.objects[i] is TStringlist then
    ff17_list.objects[i].free;
  end;

  freeandnil(ff17_list);
end;

{****************************************************************************
****************************************************************************}


type

Rfontname = record
  fname, dname:string;
end;

const
MAX_FONTS = 8;    {i.e. just the number of labels I have on this stupid
form.}

{****************************************************************************
the name in the font when the program runs is different from the one in the
font dialogue now and then.
****************************************************************************}

var

fonts : TList;

wasform:Tlist;

IniFile: Tinifile;

form_name : string;

{****************************************************************************
****************************************************************************}
procedure logit(const TheFormat:string; const Args: array of
const);
begin
  if Goptions.fontfun then
  lg('ffun',TheFormat,Args);
end;

procedure logfonttable;
var
i:integer;
begin
  for i := 0 to fonts.count-1 do
  with Tfontthing(fonts[i]) do begin
    logit('  %d:%s:%d %s:%d',
    [i+1,
    origlabl.font.name,origlabl.font.size,
    newlabl.font.name,newlabl.font.size
    ]);

  end;
end;

{****************************************************************************
****************************************************************************}
function ischanged(which:integer):boolean;
begin
  with Tfontthing(fonts[which]) do
  result :=
  (dialog_ptr.font.name <> newlabl.font.name) or
  (dialog_ptr.font.size <> newlabl.font.size) or
  (dialog_ptr.font.height <> newlabl.font.height)
  ;
{some fonts wouldn't change unless I added height -- but they don't appear
to change anyway, so it's more trickery in the heart of darkness
somewhere.... Whatever.}
end;

{****************************************************************************
Kylix elevates sizes of fonts on odd-numbered Tuesdays.

terminal:6 to terminal:7
small fonts:6 to small fonts:7
small fonts:6 to small fonts:8

****************************************************************************}

{$ifdef LINUX}
function fonts_eq(oo_name:string; target,our_font:Tfont; anysize : boolean = false):boolean;
begin

  result :=
  (
  SameText(target.name,oo_name) or
  SameText(target.name,our_font.name)
  )
  and
  (
  anysize
  or
  (target.size = our_font.size)
  )
  ;
end;

{$else}
function fonts_eq(first,second:Tfont; anysize : boolean = false):boolean;
begin
  result :=
  (first.name = second.name) and
  (
  anysize
  or
  (first.size = second.size)
  )
  ;
  {we have a limited notion of equals.}
end;
{$endif}

procedure labelize(which:Tfontthing);
begin

  if which.anysize then begin

    which.origlabl.caption :=
    safe_format('&%d. %s: %s',
    [which.origlabl.tag+1,
    which.story, which.origlabl.font.name]);

    which.newlabl.caption :=
    safe_format('=> %s',
    [which.newlabl.font.name]);

  end else begin

    which.origlabl.caption :=
    safe_format('&%d. %s: %s/%d',
    [which.origlabl.tag+1,
    which.story, which.origlabl.font.name ,which.origlabl.font.size]);

    which.newlabl.caption :=
    safe_format('=> %s/%d',
    [which.newlabl.font.name,which.newlabl.font.size]);

  end;

  which.linux_label.caption :=
  which.origlabl.caption;

  which.dialog_ptr.font.assign(which.newlabl.font);

//  which.newlabl.caption := which.newlabl.caption + ' ' + which.newlabl.name;

end;

procedure unxinit;
var
i:integer;
begin
  freeandnil(wasform);

  if fonts=nil then
  exit;

  for i := 0 to fonts.count-1 do begin
    freeandnil(Tfontthing(fonts[i]).control_list);
  end;

  freeandnil(fonts);

  freeff17;

end;


{$ifdef LINUX}
{****************************************************************************
Mon 11/20/2006 3:23 pm. These various TRYs were delved in honor of the
CrossKylix (http://crosskylix.untergrund.net) version: the Linux distribution
is compiled on a Windows machine, although for I still must use an ancient
Linux machine to debug the thing. This created a sort-of regularity for the
fonts -- I don't really know what Mr. CrossKylix does there, but it's probably
always the same -- and so I tried some tricks. But the first post-CrossKylix
try2 seemed to work best.
****************************************************************************}

{$define LX_TRY2}
{.$define LX_TRY3}
{****************************************************************************
Mon 11/20/2006 1:52 pm. In careful scientific tests, this worked better once
on a Suse10 something system. // But worse on ancient Mandrake8, and
acceptably on Suse10 so etc. Hmmm.... So I'll include osfontslx.ini ... Hmmmm
// well TRY4 didn't really work out. I think TRY2 was better than what was
before so what the heck....
****************************************************************************}
{.$define LX_TRY4}
{$endif}

function TfFontfun.xinit:boolean;
const
done : boolean = false;
var
thistop,
heightfix,
bottomfix,
i:integer;
{$ifdef LINUX}
dfontthing : Tfontthing;
{$if defined(LX_TRY3) or defined(LX_TRY4) }
s:string;
{$ifend}
{$endif}

begin

  result := false;

  if done then begin
    exit;
  end;

  done := true;

  wasform := Tlist.create;
  fonts := Tlist.create;
  //fonts.sorted := false;    {no such adjustment}

  fonts.add(Tfontthing.create('file/tree mono-spaced',
  label_treemono,label_tm_changed,form1.FilesView1.font));

  fonts.add(Tfontthing.create('small',
  label_small,label_small_changed,form1.PageControl1.font));

{$ifdef LINUX}
  dfontthing := Tfontthing.create('dialog',
  label_dialog,label_dialog_changed,ffontfun.font);

  dfontthing.original_name := MS_dialog_name;

  fonts.add(dfontthing);

//  dbg('%s, %s',[ffontfun.font.name,MS_dialog_name]);

{$else}
  fonts.add(Tfontthing.create('dialog',
  label_dialog,label_dialog_changed,ffontfun.font));
{$endif}


{$ifdef ENOUGH_FONTS}
  fonts.add(Tfontthing.create('(alt 8)',
  label4,label12,form1.font));
{****************************************************************************
Tue 6/08/2004 6:37 pm. That was the treacherous MS SANS SERIF, beloved but
betraying. Kylix WANTS the default "MS Shell Dlg". Of course, it isn't in the
font list, but that's EZ: just edit the XFM file (i.e. as ASCII), and for any
font that says "MS SANS SERIF", *delete* the name entry, and the charset just
for good luck. Outward and onward, eh?
****************************************************************************}

  fonts.add(Tfontthing.create(label5,label13));
  fonts.add(Tfontthing.create(label6,label14));
  fonts.add(Tfontthing.create(label7,label15));
  fonts.add(Tfontthing.create(label8,label16));

{$endif}

  if not FileExists_unq(Goptions.osfonts) then begin
    case Goptions.os of
      w9x: header_fudge := 0;
      xp:  header_fudge := 0;
    end;

{$ifdef LX_TRY4}
    s := dir_inize('osfontslx.ini');

    if FileExists(s)

{****************************************************************************
Font file `%s is not present. Click YES to use `%s (maybe works better on
recent Linuxes)? Or click "NO" to use an older algorithm that works OK on
Mandrake 8 and maybe other older systems. When it doesn't work, you can
(1.) exit OwenShow, (2.) delete osfonts.ini, and (3.) try again. Or just
suffer, and go through the etc / fontfun menu item.

****************************************************************************}

    and usuref(


'Font file %s is not present. Click YES to use %s (maybe works better on'
+' recent Linuxes)? Or click "NO" to use an older algorithm that works OK on'
+' Mandrake 8 and maybe other older systems. When it doesn''t work, you can'
+' (1.) exit OwenShow, (2.) delete osfonts.ini, and (3.) try again. Or just'
+' suffer, and go through the etc / fontfun menu item.'



    ,[Goptions.osfonts,s]
    )

    then

    os_fCopy(s,Goptions.osfonts)
//    RenameFile(s,Goptions.osfonts)
//leave the original strewn around....
    else begin
      with Tfontthing(fonts[0]) do begin
        newlabl.font.name := 'misc-fixed';
        newlabl.font.size := 10;
      end;

      with Tfontthing(fonts[1]) do begin
        newlabl.font.name := 'misc-fixed';
        newlabl.font.size := 8;
      end;

      with Tfontthing(fonts[2]) do begin
        newlabl.font.name :=
        'helvetica';
        newlabl.font.size := 10;
      end;

    end;
{$endif}

{$ifdef LX_TRY3}
    s := dir_inize('osfontslx.ini');
    if FileExists(s) then
    RenameFile(s,Goptions.osfonts)
    else begin
      with Tfontthing(fonts[0]) do begin
        newlabl.font.name := 'misc-fixed';
        newlabl.font.size := 10;
      end;

      with Tfontthing(fonts[1]) do begin
        newlabl.font.name := 'misc-fixed';
        newlabl.font.size := 8;
      end;

      with Tfontthing(fonts[2]) do begin
        newlabl.font.name :=
        'helvetica';
        newlabl.font.size := 10;
      end;

    end;
{$endif}

{$ifdef LX_TRY2}

    with Tfontthing(fonts[0]) do begin
      newlabl.font.name := 'misc-fixed';
      newlabl.font.size := 10;
    end;

    with Tfontthing(fonts[1]) do begin
      newlabl.font.name := 'misc-fixed';
      newlabl.font.size := 8;
    end;

    with Tfontthing(fonts[2]) do begin
      newlabl.font.name :=
      'helvetica';
      newlabl.font.size := 10;
    end;

{$endif}

{$ifdef LX_TRY1}
{****************************************************************************
setup some phony defaults *in here*. Before we attempted to write junk to a
phoney ini file -- which confused things, at least, because I'd have to decide
on what the *original* name was, and that changes now and then as I hack this
thing to pieces....
****************************************************************************}
    with Tfontthing(fonts[0]) do begin
      newlabl.font.name := 'misc-fixed';
      newlabl.font.size := 8;
    end;

    with Tfontthing(fonts[1]) do begin
      newlabl.font.name := 'misc-fixed';
      newlabl.font.size := 7;
    end;

    with Tfontthing(fonts[2]) do begin
      newlabl.font.name :=
//      'adobe-helvetica'
      'helvetica'
{****************************************************************************
Fri 9/09/2005 5:20 pm. Cool; it works in Mandrake *and* Fedora! Ad Astra!
****************************************************************************}

      ;

      newlabl.font.size := 9;


    end;
{$endif}

  end;

  thistop := label_treemono.top;

  heightfix := (label_small.top - label_treemono.top);

  bottomfix := ClientHeight - (GroupBox1.height + GroupBox1.top);

  i := 0;
  while i<fonts.count do begin


    with Tfontthing(fonts[i]) do
    begin

      origlabl.top := thistop;
      origlabl.tag := i;

      newlabl.top  := thistop;
      newlabl.tag  := i;

      linux_label.top := thistop;
      linux_label.tag := i;

      inc(thistop,heightfix);

      labelize(fonts[i]);

      inc(i);

    end;

  end;

  height := thistop+heightfix+bottomfix;

  if FileExists_unq(Goptions.osfonts) then begin
    result := getfonts;
    if result then
    wasform.clear;
  end else begin
    getfonts;   //get the defaults!
    putfonts;
    {make-up an initial record.}
  end;

  logfonttable;

  if (Goptions.fontfun and (length(Goptions.oslog)>0)) then begin
    caption := safe_format('Font fun (log: %s)',
    [Goptions.oslog]);
  end;

  xff17;
  if isff17 then
  caption := safe_format('%s (ff17)',[caption]);

  figgerFileFonts;

end;

procedure TfFontfun.FormShow(Sender: TObject);
begin
  changed := false;
//  xinit;
  fixfonts(fFontfun);    {why not?}
  formguard(fFontfun);
end;

procedure TfFontfun.FormCreate(Sender: TObject);
begin
  autoscroll := true;
end;

const
secname = 'font';

{returns true if font is changed via osfonts.ini file.}
function TfFontfun.getfonts:boolean;
var
x, section_number:integer;
sname : string;

o_name, n_name:string;
o_size, n_size:integer;

  function findold(n:string; s:integer):integer;
  var
  i:integer;
  begin
    result := -1;

    for i := 0 to fonts.count-1 do
    with Tfontthing(fonts[i]) do begin
      if (origlabl.font.name = n)
      and (origlabl.font.size = s) then begin
        result := i;
        exit;
      end;
    end;
  end;



begin
  result := false;

  try
    IniFile := Tinifile.create(Goptions.osfonts);

    changed := false;

    Gtreelineadjust :=
    IniFile.ReadInteger(treelineadjust_name,treelineadjust_name,
    Gtreelineadjust);

    SpinEdit_THadjust.value := Gtreelineadjust;

    header_fudge :=
    IniFile.ReadInteger(header_name,header_name,
    header_fudge);
    SpinEdit_header.value := header_fudge;

    line_fudge :=
    IniFile.ReadInteger(line_name,line_name,
    line_fudge);
    SpinEdit_line.value := line_fudge;

    scroll_fudge :=
    IniFile.ReadInteger(scroll_name,scroll_name,
    scroll_fudge);
    SpinEdit_scroll.value := scroll_fudge;

    result := Gtreelineadjust <> 0;

    Gtabdif :=
    IniFile.ReadInteger(tabdif_name,tabdif_name,
    0);

    Spinedit_tabdif.value := Gtabdif;

    Goptions.short_menu :=
    IniFile.ReadBool(short_name,short_name,false);

    CheckBox_short.checked := Goptions.short_menu;

    for section_number := 1 to MAX_FONTS-1 do begin
      sname := secname+IntToStr(section_number);

      o_name :=
      IniFile.ReadString(sname,'o_name','');

      o_size :=
      IniFile.ReadInteger(sname,'o_size',0);

      n_name :=
      IniFile.ReadString(sname,'n_name','');

      n_size :=
      IniFile.ReadInteger(sname,'n_size',0);

      x := findold(o_name,o_size);

      try

        if (x>=0)
{
        and (
        (o_name <> n_name) or
        (o_size <> n_size)
        )
}

        then with Tfontthing(fonts[x]) do begin
          newlabl.font.name:= n_name;
          newlabl.font.size := n_size;

          labelize(fonts[x]);
          {which does the dialogue I believe.}
        end;

        result := true;

      except
        on exception
        do; //nada.
      end;


    end;
//    iniFile.UpdateFile; //not needed here. we're reading.
    IniFile.free;
  except
    on exception
    do;   //nada.
  end;
end;

function TfFontfun.putfonts:boolean;
var
i, section_number:integer;
sname : string;

begin
  result := false;

  try
    IniFile := Tinifile.create(Goptions.osfonts);

    IniFile.WriteInteger(treelineadjust_name,treelineadjust_name,
    Gtreelineadjust);

    IniFile.WriteInteger(header_name,header_name,
    header_fudge);

    IniFile.WriteInteger(line_name,line_name,
    line_fudge);

    IniFile.WriteInteger(scroll_name,scroll_name,
    scroll_fudge);

    IniFile.WriteInteger(tabdif_name,tabdif_name,
    Gtabdif);

    IniFile.WriteBool(short_name,short_name,Goptions.short_menu);

    for section_number := 1 to MAX_FONTS do
    inifile.erasesection(secname+IntToStr(section_number));

    for i := 0 to fonts.count-1 do
    with Tfontthing(fonts[i]) do begin
      sname := secname+IntToStr(i+1);
      IniFile.WriteString(sname,'o_name',origlabl.font.name);
      IniFile.WriteInteger(sname,'o_size',origlabl.font.size);

      IniFile.WriteString(sname,'n_name',newlabl.font.name);
      IniFIle.WriteInteger(sname,'n_size',newlabl.font.size);
    end;

    inifile.updatefile;

    inifile.free;

  except
    on exception
    do;   //nada.
  end;
end;


procedure TfFontfun.Label_treemonoClick(Sender: TObject);
begin
  with sender as Tlabel do
  clickfont(tag);
end;


procedure TfFontFun.clickfont(which:integer);
var
oldcolor : Tcolor;
begin
  if (which < fonts.count) then
  with Tfontthing(fonts[which]) do begin
    savefont.assign(dialog_ptr.font);

    oldcolor := newlabl.color;
    newlabl.color := clSilver;

    if dialog_ptr.execute then begin

  //    changeto.name := dialogue.font.name;
  //    changeto.size := dialogue.font.size;
  // no see the dialogue *is* the change.
      changed := ischanged(which) or changed;
      newlabl.font.assign(dialog_ptr.font);
      newlabl.font.color := clBlack;
      {it just gets confusing otherwise, although
      it was kind of fun....}

      labelize(fonts[which]);
    end;

    newlabl.color := oldcolor;

  end;
end;

{****************************************************************************
****************************************************************************}
function isff_label(lbl:Tlabel):boolean;
var
i:integer;
begin
  result := false;
  if not isfontfun then
  exit;

  for i := 0 to fonts.count-1 do
  with TFontthing(fonts[i]) do begin
    result :=
    (lbl = linux_label) or
    (lbl = origlabl)
    or (lbl = newlabl)
    ;
    if result then
    exit;
  end;
end;


{****************************************************************************
****************************************************************************}
function fiddle_a_font(x:Tcomponent):boolean;
var
ifont,icontrol : integer;
fptr:Tfont;
//islabel:boolean;
fcolor : Tcolor;

begin
//  fptr := nil;
  {get rid of stupid warning.}

  result := false;

//    islabel := false;


  try
{****************************************************************************
Wed 11/05/2008 6:45 pm. Hoo-whee, do we have fun! ... In version ujd, I
"fixed" the "extraneous F1 problem" -- where pressing the sacred help F1 key
on forms that hadn't been jiggered to do something with an F1 keypress would
produce an annoying error -- by laboriously going through every form and
changing the default "helptype" from "htKeyWord" to "htContext", which made
windows happy.

But then the *same problem* showed-up in Linux. Which, as I discovered in more
laborious experiments, is because it's attitude is *exactly the opposite*: it
*wants* the default htKeyWord! ... Ha ha ha ha! ... Hey Borland guys, just
whack 'em out....

However I *did* just notice that if I press enough F1s, it'll hang-up for a
long time on the offending forms; I guess it's doing a broken help for each F1
keypress. ... That's probably hopeless; so don't do that....

Anyway, here we are sticking this totally unfont code in here, since I happen
to be going through all the forms anyway....

//Well I should mention that the Kylix "Application.Onhelp" is totally broken,
bogus, doesn't work. Of course, this little difficulty isn't documented, and
is left for an exercise for the programmer, presumably after he's encountered
this stupid bogus help problem....

****************************************************************************}
    if x is Tcontrol then
{$ifdef MSWINDOWS}
    (x as Tcontrol).helptype := htContext;
{$endif}
{$ifdef LINUX}
    (x as Tcontrol).helptype := htKeyWord;
{$endif}

  except on exception do
    ;
  end;





  if (x is Tlabel) then begin
    if isff_label(Tlabel(x)) then
    exit;

    fptr := Tlabel(x).font;
//      islabel := true;
  end
  else if (x is TListView) then
  fptr := TlistView(x).font
  else if (x is Tmemo) then
  fptr := Tmemo(x).font
  else if (x is TPageControl) then
  fptr := TPageControl(x).font
  else if (x is Tedit) then
  fptr := Tedit(x).font
  else if (x is TComboBox) then
  fptr := TComboBox(x).font
  else if (x is TButton) then
  fptr := TButton(x).font
//    else if (x is Tcanvas) then
//    fptr := Tcanvas(x).font
//can't do that apparently.
  else if (x is TListBox) then
  fptr := TListBox(x).font
  else if (x is TCheckBox) then
  fptr := TCheckBox(x).font
//  else if (x is ThelpDialog) then
//  fptr := THelpDialog(x).font
//oh stupid that's a form.

  else if (x is TForm) then
  fptr := TForm(x).font
//  else if (x is TPopupMenu) then
//  fptr := TPopupMenu(x).font
// no font.

//    else if (x is TBitBtn) then
//    fptr := TBitBtn(x).font
//Tbutton does it.
  else if (x is TGroupBox) then
  fptr := TGroupBox(x).font
  else
  exit;   {Not a font control I care about anyway. I can
  always add to the stupid list above. Note that I couldn't figger
  some clever comp sci way to do it just to the ancestor of these
  things; apparently fonts are pasted-on later....}

  logit('is: %s.%s: %s:%d',
  [form_name,x.name,fptr.name,fptr.size]);

{go through our font list, and check if the target font, a reference to
which is stored in fptr, is a target font.}

  if isff17 then begin
    ifont := getff17(form_name,x.name);
    if (ifont>=0)
    and (ifont<fonts.count)
    then begin
      fcolor := fptr.color;
      with Tfontthing(fonts[ifont]) do begin
        fptr.assign(newlabl.font);
        logit(' FF17: %s:%s:%d',[x.name,newlabl.font.name,newlabl.font.size]);
        fptr.color := fcolor;
        result := true;
      end;
    end;

    exit;
{****************************************************************************
The idea is IF ff17, then we SHOULDN'T use the other mechanism; it'll just
confuse things.
****************************************************************************}
  end;

  for ifont := 0 to fonts.count-1 do
  with Tfontthing(fonts[ifont]) do begin

{

Tfontthing is the type of the storage in fonts[i]. fonts[i].control_list
is a list of *controls* we've looked at before. You can tell one of them
from another because they have different addresses. So first I checked
if if it's already in the list the "indexof" thing. If it *isn't* in the
list, then it hasn't been changed by this code yet, so we check if the
font in fptr matches the *original* font we want to change.

That is, the *first* time we hit a target font, we check if it's the
same the original target font in our table -- which font was presumably
jiggered by Kylix Delphi when the program started, so it's something at
least that will work in the environment.

If it *is* an original font, then we replace it with the new font, and
add the control to the contrl_list.

So the *second* time we encounter the same control things'll work
because we can still identify the control, even 'though we've already
changed the font in it, so we *can't* identify via the original font.

Note also my "fonts_eq" is a selective equal thingey, on the theory that
they'll all be slightly different in incomprehensible ways. I can always
tinker with that.

}

    icontrol := control_list.indexof(x);
    if (icontrol>=0) or
    (fonts_eq(
{$ifdef LINUX}
    original_name,
{$endif}
    fptr,origlabl.font,anysize))
    then begin
      if (not fonts_eq(
{$ifdef LINUX}
      original_name,
{$endif}
      fptr,newlabl.font))
//        and (not (islabel and isfontfun))
      then begin
        fcolor := fptr.color;
        fptr.assign(newlabl.font);    {it gets the new font!}

        logit(' GOT: %s:%d',[newlabl.font.name,newlabl.font.size]);
        if fcolor<>clBlack then begin
          fptr.color := fcolor;
          logit(' (color saved)',[0]);
        end;
        result := true;
      end;
      if (icontrol<0) then
      control_list.add(x);

      if result then
      break; {the for loop dolt; we're finished....}
    end;
  end;

end;


{****************************************************************************
used like "fiddlefonts(form1)";
****************************************************************************}
{.$define DBG_FIDDLE}

function fiddlefonts(c:Tcomponent):boolean;
var
i: integer;

begin
  result := false;

{$ifdef DBG_FIDDLE}
  infof('fiddleconts(%s)',[c.name]);
{$endif}

  for i := 0 to c.Componentcount-1 do begin
    if fiddle_a_font(c.Components[i]) then
    result := true;
  end;

end;

{****************************************************************************
****************************************************************************}


function fixfonts(f:Tform):boolean;
var
i:integer;
begin
  ffontfun.xinit;
  result := false;

  i := wasform.indexof(f);

  isfontfun := f=fFontFun;

  if i<0 then begin
    form_name := f.name;
    fiddle_a_font(f);   //do the form itself!? yes....
    result := fiddlefonts(f) or result;
    wasform.add(f);
  end;

end;

procedure TfFontfun.BitBtn_OKClick(Sender: TObject);
begin

  if changed then begin
    if usuref('Save / change fonts?') then begin
      Gtabdif := SpinEdit_tabdif.value;
      putfonts;
      {main might look at this. Other forms will look at it when they show.
      Or something. // no, it's something; see fixfonts.}
      wasform.clear;
      figgerFileFonts;
      logfonttable;
      modalresult := mrOK; {apparently I have to do this.}
      changed := false;
      exit;
    end;

//can't do this on formclose. It crashes in Linux. I suppose this'll screw-up
//something when we exit by clicking the "x" but that's show biz....
    modalresult := mrCancel;


{
    else begin
      getfonts;
      modalresult := mrCancel;
    end
}
  end;

end;

procedure TfFontfun.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if changed and (modalresult <> mrOK) then
  getfonts else
  figgerFileFonts;
end;

procedure TfFontfun.BitBtn_resetClick(Sender: TObject);
begin
  if not usuref(
  'Try and reset everything back to the way it started ' +
  'by deleting %s and ' +
  'and restarting OS?',[Goptions.osfonts]) then
  exit;

  changed := false;

  DeleteFile(Goptions.osfonts);
//  xinit(true);
  modalresult := mrRetry;

end;

procedure TfFontFun.fontfunhelp;
begin
  oshelp('Etc Font Fun');
  setfocus;
end;


procedure TfFontfun.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if (is_key(Goptions.help,key,shift)) or (key=key_F1) then begin
    fontfunhelp;
    key := 0;
  end;

  if (not (ssALT in Shift)) then
  exit;

  if (key>=ord('1'))
  and (key<=ord('9')) then begin
    clickfont(key-ord('1'));
    key := 0;
  end;

end;


procedure TfFontfun.helpbuttonClick(Sender: TObject);
begin
  fontfunhelp;
end;

procedure TfFontfun.SpinEdit_THadjustChanged(Sender: TObject; NewValue: Integer);
begin
  Gtreelineadjust := SpinEdit_THadjust.value;
  changed := true;
end;

function needlineadjust:boolean;
begin
  result :=
  Gislineadjust<>Gtreelineadjust;
  if result then
  logit('needlineadjust: Gtreelinadjust should be %d; Gislineadjust: %d',
  [Gtreelineadjust,Gislineadjust]);
end;

procedure TfFontfun.SpinEdit_tabDifChanged(Sender: TObject;
  NewValue: Integer);
begin
  changed := true;
end;

procedure TfFontfun.FormResize(Sender: TObject);
begin
//  width := (GroupBox1.width - margin) div 2;
  Panel_Original.width := GroupBox1.width div 2;
//  Panel_Changed.width := width;
// The other panel is alClient so it resizes itself or something.
end;

procedure TfFontfun.CheckBox_ShortClick(Sender: TObject);
begin
  Goptions.short_menu := CheckBox_short.checked;
  changed := true;
end;

procedure TfFontfun.CheckBox_DebugClick(Sender: TObject);
begin
  show_line_count := CheckBox_Debug.checked;
end;


{****************************************************************************
****************************************************************************}

procedure TfFontfun.figgerFileFonts;
var
one,two:integer;
begin
  ListView_FontTest.font.assign(Label_tm_changed.font);

{****************************************************************************
Tue 11/08/2005 1:58 pm. Oops need stronger mumbo jumbo.
//  ListView_FontTest.height = ListView_FontTest.height + 20;
//  Listview_FontTest.height = ListView_FontTest.height - 20;
This (below) seemed to do it. At least once. At least on the XP. I haven't
discovered any way to derive the header and scroll bar size with this.

So, listview.ondrawitem didn't work; the things passed to it all have an
index of zero, and a top of zero. Kool, eh?
****************************************************************************}

  ListView_FontTest.visible := true;
  ListView_FontTest.update;

  one := ListView_FontTest.items[0].DisplayRect.Top;
  two := ListView_FontTest.items[1].DisplayRect.Top;

//AND this (see "mumbo jumbo" above.
  ListView_FontTest.visible := false;

  files_PixPerLine := two-one + line_fudge;

  if (files_PixPerLine = 0) then
  files_PixPerLine := 1;

  files_header :=
  headerPlusLineguess + ListView_FontTest.font.height + header_fudge;
//  one + header_fudge;
//nope this doesn't work. displayrect.top for first item is "1" or so.


  files_scroll := scrollguess + scroll_fudge;

end;

procedure TfFontfun.SpinEdit_headerChanged(Sender: TObject;
  NewValue: Integer);
begin
  header_fudge := SpinEdit_header.value;
  changed := true;
end;

procedure TfFontfun.SpinEdit_LineChanged(Sender: TObject;
  NewValue: Integer);
begin
  line_fudge := SpinEdit_Line.value;
  changed := true;
end;

procedure TfFontfun.SpinEdit_ScrollChanged(Sender: TObject;
  NewValue: Integer);
begin
  scroll_fudge := Spinedit_Scroll.value;
  changed := true;
end;

procedure undebugfudge;
begin
  with fFontfun do begin
    CheckBox_Debug.checked := false;
    CheckBox_DebugClick(nil);
    form1.unfudgedebug;
  end;

end;
{****************************************************************************
****************************************************************************}


initialization

finalization

unxinit;


end.
