/* hyperx.c     Wed 10-13-1993
Wed 10-13-1993  creation.
7/25/05: Linux version. Note the #ifdef MSWINDOWS is more-or-less anecdotal;
it's doubtful it'd compile OK under windows anymore.

*/

#ifdef MSWINDOWS
#include <windows.h>
#include <winbase.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef MSWINDOWS
#include <dir.h>
#include <dos.h>
#include <process.h>
#endif
#include <stdarg.h>

#ifdef MSWINDOWS
#ifdef __FLAT__
#include <conio.h>
#endif
#endif

#include "hyperx.h"
#include "winkey.h"

#define YES (1)
#define NO (0)

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


#ifndef BYTE
  #define BYTE char
#endif

#ifndef sBYTE
  #define sBYTE signed char
#endif

#ifndef WORD
//  typedef unsigned int WORD;
#endif

#ifndef BIG
  typedef unsigned long BIG;
#endif

#define ARRAYSIZE(x) (sizeof(x) / sizeof(x[0]))

#define BIT0 (1)
#define BIT1 (2)
#define BIT2 (4)
#define BIT3 (8)
#define BIT4 (16)
#define BIT5 (32)
#define BIT6 (64)
#define BIT7 (128)
#define BIT8 (256)
#define BIT9 (512)
#define BIT10 (1024)
#define BIT11 (2048)
#define BIT12 (4096)
#define BIT13 (8192)
#define BIT14 (16384)
#define BIT15 (32768)
#define BIT16 (65536)
#define BIT17 (131072)
#define BIT18 (262144)
#define BIT19 (524288)
#define BIT20 (1048576)
#define BIT21 (2097152)
#define BIT22 (4194304)
#define BIT23 (8388608)
#define BIT24 (16777216)
#define BIT25 (33554432)
#define BIT26 (67108864)
#define BIT27 (134217728)
#define BIT28 (268435456)
#define BIT29 (536870912)
#define BIT30 (1073741824)
#define BIT31 (2147483648)

#define nBIT(x) (1 << x)                          /*  */
#define lo(one,two) ( ((one) < (two)) ? (one) : (two))    /*  */
#define hi(one,two) ( ((one) > (two)) ? (one) : (two))    /* not tested. */

#define LOW(x) ((x) & 255)
#define HIGH(x) ((x) >> 8)

#define LOCALK enum       /* that's what I learned in c--. LOCALK { bingo=1 }
                          etc. */

/****************************************************************************
****************************************************************************/

#define EFIX YES
#define ENAME "EOP"
#define QUOTEOID YES
#define DONTWAIT defined(MSWINDOWS) /* is it possible it won't leave the command window open
forever in XP? */

#define LETWAIT YES

/****************************************************************************
****************************************************************************/
char *hyperhistory=
#ifdef MSWINDOWS
"c:\\hyperx~"
#else
"/home/gregor/jgotemp/hyperx~"
#endif
;

char *xinstead;

int noagain;

/****************************************************************************
****************************************************************************/

#if LETWAIT
int nwait;
void letwait(void) {
  int waitoid;

  waitoid = nwait * 1000;

  if ((!noagain) || (nwait<1) )
  return;

  while (waitoid>0) {
    Sleep(100);   //this is the winders millisecond wait.
    if (kbhit()) {
      x_getch();
      return;
    }
    waitoid -= 100;
  }
}
#endif

/* scan off of spaces in s; stop at any non-blank, including \0, \n. Return
1 if end of line -- \n \0, else 0. Mon 05-15-1995 version.*/
_f int scans(char **s) {
  while (**s && (**s<=' ') && (**s != '\n') )
  ++(*s);

  return **s=='\n' || **s=='\0';
}


#ifdef MSWINDOWS

/****************************************************************************
****************************************************************************/

/****************************************************************************

function os_isw9x:boolean;
var
OSVersionInfo: TOSVersionInfo;
begin
  result := true;   {assume w9x.}

  OSVersionInfo.szCSDVersion[0] := chr(0);
  OSVersionInfo.dwOSVersionInfoSize := SizeOf(OSVersionInfo);
  if (not GetVersionEx(OSVersionInfo)) then
  exit;

  {
  osinfof('Windows version %d.%d',
  [OSVersionInfo.dwMajorVersion,OSVersionInfo.dwMinorversion]);
  }

  if OSVersionInfo.dwMajorVersion>=5 then
  result := false;


end;

can't do that stars up in the sky etc.

//so I have to searchpath somehow.


****************************************************************************/
#if DONTWAIT

int hyperx_kill95(char *who);
_f void Sleepy(
    BIG dwMilliseconds  // sleep time in milliseconds
   );

/* strstr but ignore case. */
_f char *stristr(char *target, char *what) {
#ifndef MSWINDOWS
  return strcasestr(target,what);
#else
  int length;
  if (length=strlen(what)) {
    while (*target) {
      if (!(strnicmp(target,what,length))) return target;
      ++target;
    }
  }
  return NULL;
#endif
}

#define ISIBMGRAF(x) (x > ' ')
/* if u use  et al, scanchar'll fail without this. isgraf() is compatible. */
/* scan off of characters in s; stop at any blank, including \0, \n. Return 1
if end of line -- \n \0, else 0. */
_f int scanchar(char **s) {
  while(ISIBMGRAF(**s)) ++(*s);
  return **s=='\n' || **s=='\0';
}

_f void *mustalloc(unsigned size) {      /* clears block to zero. */
  void *p;
  if ((p=calloc(size,1)) != NULL)
  return p;
  fprintf(stderr,"ran out of memory.");
  exeunt(7);
}


/****************************************************************************
****************************************************************************/


#define NTOKENS (80)

char *tokens[NTOKENS+2];
int tokencount, original_length;


_f int tokenate0(char *s) {
  char *p;
  original_length = strlen(s);


  tokencount=0;
  while(1) {
    if (tokencount>=NTOKENS)
    return original_length;

    if (!*s)
    return original_length;

    if (scans(&s))
    return original_length;

    tokens[tokencount++]=s;

    if (*s=='\"') {
      p = strchr(s+1,'\"');
      if (!p)
      return original_length;
      /* 'cause that's the string. unbalanced quote. */

      s = ++p;    /* character after quote. */
    }
    else
    scanchar(&s);

    if (*s)
    *s++ = '\0';

    if (!*s)
    return original_length;

  }
}

_f int tokenate(char *s) {
  int x=tokenate0(s);
  tokens[tokencount]=NULL;
  return x;
}

void untoken(int original_length, char *s) {
  int i;
  for (i=0; i<original_length; ++i) {
    if (!s[i])
    s[i] = ' ';   /* replace it with a space. */
  }
}

#if 0
char *extensionize(char *what, char *ext) {
  char *x;
  x = mustalloc(strlen(what)+strlen(ext)+4);

  strcpy(x,what);
  strcat(x,ext);
  return x;
}
#endif

/****************************************************************************
****************************************************************************/

#if 0
int has_extension(char *s) {
  return
  fnsplit(s,NULL,NULL,NULL,NULL) & EXTENSION;
}
#endif

int previous_esystem(char *wha) {
  char *e, *c;
  if (
  (e=getenv(ENAME)) && (c=getenv("COMSPEC"))
  ) {
    spawnl(
    P_WAIT
    ,c,c,e,"/C",wha,NULL);
  }
  else
  system(wha);

}

static
char
drive[MAXDRIVE],
dir[MAXDIR],
file[MAXFILE],
ext[MAXEXT],
newpath[MAXPATH];

/* isinpath assumes drive, dir, file, ext have been set-up correctly; it
tries the passed extension and sees if that's found in the path. */
char *isinpath(char *ext) {
  fnmerge(newpath,drive,dir,file,ext);
  return searchpath(newpath);
}

int redir(char *s) {
  return
  strchr(s,'<') ||
  strchr(s,'>') ||
  strchr(s,'|');
}

#define DOXP NO //YES    //test on w98.

esystem(char *wha) {
  char
  *spath,
  *c,
  *oldtoken0,
  *pathoid;
  int i, isext;

  int tokenoid;

  if (
#if DOXP
  DOXP
#else
  (!redir(wha)) &&
  (noagain) &&       /* he doesn't want to wait . */
  (c=getenv("COMSPEC")) &&
  stristr(c,"cmd.exe")
#endif
  ) {
    /* i.e. it's XP */

#ifdef WORKED_WITH_ONE_ARGUMENT_RESOLVED_TO_EXE
    spawnl(
    P_OVERLAY
    ,c,c,
    "/C","start",
    /* "\"usux\"", */ /* sometimes this juju is good*/
    wha,NULL);
  /* *THAT* did it. This XP is so EZ once you know how....*/
    return;
#endif

    tokenoid=tokenate(wha);

    isext =
    fnsplit(tokens[0],drive,dir,file,ext) & EXTENSION;

    pathoid = NULL;

    if (isext)
    pathoid = tokens[0];
    else {

/****************************************************************************
MS-DOS searches for a file by using default filename extensions in the
following order of precedence: .COM, .EXE, and .BAT. To run ACCNT.BAT
when ACCNT.COM exists in the same directory, you must include the .BAT
extension on the command line. // SO there's *NO WAY* to do this right.
Unless you do exactly what cmd does, go through *each* directory, and
check *each* thing.

My problem was, when I type "help" in a directory with a "help.bat", I
was executing XP's stupid console help first. *Because* I tried to do
things in order.

Now, the reason I *want* to do all this, is because XP is so exceedingly
stupid that it won't close the windows of various programs. So I'm just
changing the rules, and doing the batch first.

Note that XP *still* leaves window open for DOS programs -- which is
usually what one wants anyway, because they usually spit some stuff out.
Or who knows....

****************************************************************************/

      if (
      (spath=isinpath(".bat")) ||
      (spath=isinpath(".com")) ||
      (spath=isinpath(".cmd"))
      ) {
        untoken(tokenoid,wha);
        previous_esystem(wha);
        return;
      }
      else
      if (
      (spath=isinpath(".exe"))
      )
      pathoid=spath;
    }

/* see we do batch files different. But we did the search in the correct
order. */

    if (pathoid)
//    if
    (spawnvp(
//    P_DETACH,
      P_OVERLAY,    //this is what makes stupid XP close window.
//    P_WAIT,
    pathoid,
    tokens))
    ;

#if 0
     != -1)
//there is no way to fool it.
      fnsplit(pathoid,NULL,NULL,file,ext);
      fnmerge(newpath,NULL,NULL,file,ext);
        for (i=0; i<200; ++i)
        Sleepy(100);
        if (!hyperx_kill95(newpath))
        break;

      return;
#endif

//if failure fall through to
    untoken(tokenoid,wha);
  }

  previous_esystem(wha);
  return;

}

#elif EFIX
esystem(char *wha) {
  char *e, *c;
  if (
  (e=getenv(ENAME)) && (c=getenv("COMSPEC"))
  ) {
    spawnl(
    P_WAIT
    ,c,c,e,"/C",wha,NULL);
  }
  else
  system(wha);
}

#endif

#define system esystem

#endif

/****************************************************************************
****************************************************************************/
deblr(char *s) {
  while(1) {
    switch(*s) {
      case '_': *s=' '; break;

      case 0:
      return;
    }
    ++s;
  }
}



int systemf(char *format, ...) {
  va_list argptr;
  char acommand[200];
  va_start(argptr, format);
  vsprintf(acommand,format,argptr);
  va_end(argptr);
  return system(acommand);
}


/****************************************************************************
sadly I haven't written ctext for Linux, so this EZ text is out of date.

hyperx args              `" __DATE__ `"
lets u edit and then execs, or esc. An argument of a single period invokes the
program without arguments. Up-/down-arrows might move through history.
 -hHistory_path          Specify that.
 -n                      Must be before non-options; no "again?" option.
 -n2                     etc., but wait 2 seconds at end.
 -xpgm_options[,file]    Executes buffer with pgm_options prepended (_s ==>
        ' '). In such case, "." starts with previous history, if any. If
        ,file, uses that instead of default `%s. MUST BE FIRST.
`a#ifdef MSWINDOWS 
If `" ENAME `" is defined in environment to something like /E:30000, it
might be used as an argument to command using comspec to run the thing. If
XP, might run exe programs without honoring -n because XP is so smart....
`a#endif
If single argument double-period "..", like "." but no "again?" just exits
(i.e. ".." == -n). Entering ^A will defeat a "no again" option. 
`a#if __FLAT__ && defined(MSWINDOWS)
`a "(w32) "
`a#endif
`a#if DONTWAIT
`a "(XP dontwait) "
`a#endif
`a ,hyperhistory


****************************************************************************/
depart() {
  fprintf(stderr,





"hyperx args              " __DATE__ "\n"
"lets u edit and then execs, or esc. An argument of a single period invokes the\n"
"program without arguments. Up-/down-arrows might move through history.\n"
" -hHistory_path          Specify that.\n"
" -n                      Must be before non-options; no \"again?\" option.\n"
" -n2                     etc., but wait 2 seconds at end.\n"
" -xpgm_options[,file]    Executes buffer with pgm_options prepended (_s ==>\n"
"        ' '). In such case, \".\" starts with previous history, if any. If\n"
"        ,file, uses that instead of default %s. MUST BE FIRST.\n"
#ifdef MSWINDOWS
"If " ENAME " is defined in environment to something like /E:30000, it\n"
"might be used as an argument to command using comspec to run the thing. If\n"
"XP, might run exe programs without honoring -n because XP is so smart....\n"
#endif
"If single argument double-period \"..\", like \".\" but no \"again?\" just exits\n"
"(i.e. \"..\" == -n). Entering ^A will defeat a \"no again\" option.\n" 
#if __FLAT__ && defined(MSWINDOWS)
 "(w32) "
#endif
#if DONTWAIT
 "(XP dontwait) "
#endif
 ,hyperhistory



   );

  exit(1);
}

#define BSIZE (100)

_f int strplus(char *dst, char *src, int max) {
  int index;
  --max;
  index=strlen(dst);
  while(*src && (index < max))
  dst[(index)++]=*src++;
  dst[index]='\0';
  return index;
}


#ifdef MSWINDOWS
#define PAGE0BIOSX (*( (BYTE far *) (MK_FP(0x40,0x50))))

void ifline(void) {
#if !__FLAT__
  if (PAGE0BIOSX)
  fputc('\n',stderr);
#endif
}

#endif

mustopen(FILE **f, char *name, char *mode) {
  if (!(*f=fopen(name,mode))) {
    fprintf(stderr,"couldn't open %s for %s.",name,mode);
    exeunt(3);
  }
}

/* return nz if file name exists. */
int exist(char *name) {
  return !access(name,0);
}

/* leaves stream rewound. */
long filesize(FILE *stream) {
  long length;
  fseek(stream,0L,SEEK_END);
  length = ftell(stream);
  rewind(stream);
  return(length);
}

#define SAFEMARJ (15)
#define POSITION() (dst-d)
void detab(char *d, char *src, int max) {
  char *dst;
  unsigned newposition;
  dst=d;
  if (max<=SAFEMARJ) {
    *d='\0';
    return;
  }
  max -= SAFEMARJ;
  while(*src && (POSITION()<max) ) {
    if (*src=='\t') {
      newposition= (POSITION() & 0xfff8) +8;
      while(POSITION() < newposition) *dst++=' ';
      ++src;
    }
    else *dst++=*src++;
  }
  *dst='\0';
}

#undef POSITION
#undef SAFEMARJ

/* open the file in RB, and then use bfgets() to get 0-termed lines from weird
files. */
char *bfgets(char *s, int n, FILE *fp) {
  LOCALK { BBUF = 200 };
  char buf[BBUF+2];
  int c, index=0;
  while(1) {
    switch(c=getc(fp)) {
      case 'Z'-CTL:
      case EOF:
      if (!index) return NULL;
      case LF:
      case CR:
      buf[index++]='\0';
      if ((c=getc(fp)) >= ' ')
      ungetc(c,fp);

      if (n>BBUF) 
      n=BBUF;
      detab(s,buf,n);
      return s;

      default:
      if (c<' ') continue;

      case '\t':
      break;
    }

    if (index < BBUF)
    buf[index++]=c;
  }
}

/****************************************************************************
****************************************************************************/
#if QUOTEOID
char *quoteoid(char *s) {

  static char b[BSIZE];

  if ( (strchr(s,' ')) &&
  (*s!='"')
  ) {
    b[0]='"';
    b[1]='\0';
    strplus(b,s,BSIZE);
    strplus(b,"\"",BSIZE);
    return
    b;
  }

  return s;

}
#endif





/****************************************************************************
****************************************************************************/
int hypernumber=0;
long fileindex;

/* return the character BEFORE the fileindex. Leave the file index
AT the character. */
int getbackward(FILE *ifile) {
  int c;
  if (fileindex<=0)
  return -1;
  fseek(ifile,--fileindex,SEEK_SET);
  c=getc(ifile);
  fseek(ifile,fileindex,SEEK_SET);
  return c;
}

/* return the character AT the fileindex. The fileindex at the *next*
character. */
int getforward(FILE *ifile) {
  fseek(ifile,fileindex++,SEEK_SET);
  return getc(ifile);
}

int gobacktochar(FILE *ifile, int what) {
  int c;
  while(((c=getbackward(ifile))!=what)) {
    if (c==-1)
    return -1;
  }
  return 0;
}

/* leaves file pointer at character after LF. */
int gobacktoLF(FILE *ifile) {
  if (gobacktochar(ifile,LF))
  return -1;
}

int gobackline(FILE *ifile) {
  if (gobacktoLF(ifile)) return -1;
  if (!gobacktoLF(ifile)) {   /* EOF's OK. */
    getforward(ifile);   /* dump the line feed. */
  }
  else {
    rewind(ifile);
    fileindex=0;
  }
/* reset the pointer to the beginning of the file. */
  return 0;
}

int sign(int what) {
  if (what<0)
  return -1;
  if (what>0)
  return 1;
  return 0;
}

/* -1'll get the next line back. */
int hyperget(char *dst, int size, int signedindex) {
  FILE *hyperfile=NULL;
  int i;
  static int baddirection;

  if (hypernumber<0)
  hypernumber=0;

  if (signedindex && (baddirection==sign(signedindex)))
  goto BADNESS;

  baddirection=0;       /* if he goes the other direction, please! */

  if (exist(hyperhistory)) {
    mustopen(&hyperfile,hyperhistory,"rb");
    fileindex=filesize(hyperfile);
    if ( (hypernumber -= signedindex)>0) {
      for (i=1; i<hypernumber; ++i) {
        if (gobackline(hyperfile))
        goto BADNESS;
      }
      if (fileindex) {
        gobackline(hyperfile);
/* the last one should *always* be bad. */
        bfgets(dst,size,hyperfile);
        fclose(hyperfile);
        return 0;
      }
    }
  }

  BADNESS:
  baddirection=sign(signedindex);
  if (hyperfile)
  fclose(hyperfile);
  *dst='\0';
  return
  -1;
}

hypersave(char *b) {
  FILE *hyperfile;
  if (scans(&b))
  return;       /* but don't save empty. */
  mustopen(&hyperfile,hyperhistory,"a");
#ifdef MSWINDOWS
  fprintf(hyperfile,"%s\n",b);
#else
//winders is less likely stick in escape characters etc.
  while(*b) {
    if (*b>=' ')
    fputc(*b,hyperfile);
    ++b;
  }
  fputc('\n',hyperfile);
#endif  
  fclose(hyperfile);
}

/****************************************************************************
****************************************************************************/

#define MYINSERT (WINSERT|WINOCLR|CR0OK)

#define STUPID1 YES
/****************************************************************************
Wed 1/18/2006 4:23 pm. If I used options arguments with this wretched thing, 
then the little "." or ".." would appear in the buffer, moron....
****************************************************************************/

int main(int argc, char *argv[]) {
  int i, index=0, insert=MYINSERT, c, result, achar=0;
  char b[BSIZE], *p, bb[BSIZE],
  *space=" "
  ;
  WORD op='-';

  b[0]='\0';

  if (argc<2)
  depart();

#if !STUPID1
  if ((argc==2) && !strcmp(argv[1],"."))
  argc=1;

  if ((argc==2) && (!strcmp(argv[1],".."))) {
    argc=1;
    noagain=YES;
  }
#endif

  for (i=1; i<argc; ++i) {
    if (argv[i][0]==op) {
      switch(argv[i][1]) {
	case 'h':
	hyperhistory = argv[i]+2;
	break;

        case 'n':
        noagain= YES;
#if LETWAIT
        if (argv[i][2])
        nwait = atoi(argv[i]+2);
#endif
        break;

        case 'x':
        xinstead=p=argv[i]+2;
        if (p=strchr(p,',')) {
          *p++ = '\0';
          hyperhistory=p;
        }
        deblr(xinstead);
        space="";
        break;

        default:
        depart();
      }
    }
    else {
      op=0xffff;      /* disable further options. */
      strplus(b,space,BSIZE);

#if STUPID1
      if (!strcmp(argv[i],"."))
      argv[i]="";
      
      if (!strcmp(argv[i],"..")) {
        noagain=YES;
        argv[i]="";
      }
#endif

#if QUOTEOID
      strplus(b,quoteoid(argv[i]),BSIZE);
#else
      strplus(b,argv[i],BSIZE);
#endif
      space=" ";

    }
  }

  termstart();
/* note that it is impossible to go back to console mode after endwin() (the 
supposed inverse of termstart(). So we don't. Oddly, "system()"  works anyway.
*/

  if (xinstead) {
    if (strcmp(b,"."))
    hypersave(b);           /* always save at least one if command. */
    else {
      achar=UPARROW;
      b[0]='\0';
    }
  }
  else
  strplus(b," ",BSIZE);

  while(1) {


    strcpy(bb,b);
    
    

#ifdef MSWINDOWS
    if (hypernumber)
    printf("%d:",hypernumber);
    else
    putchar(173); //make an ibm pc graf character prompt.
#else    
    gotoxy(0,0);
    if (hypernumber)
    printw("%d:",hypernumber);
    else
    x_putch('!');
#endif

    if (achar) {
      c=achar;
      achar=0;
    }
    else {
      c=wwwgets(b, BSIZE, NO, 0, &insert, &index, 0, 0);
#ifdef MSWINDOWS
      putchar('\n');
//in Linux everything's erased or something.
#endif
      if (strcmp(bb,b) ) {
        hypersave(b);
        ++hypernumber;
      }
    }

    switch (c) {
      case 0:

      while(1) {
#ifndef MSWINDOWS
	clear();	//ncurses.
	refresh();
#endif

#if CHECK_CTLA
        if (Gwas_ctla)
        noagain = NO;
#endif

        if (xinstead) {
#ifndef MSWINDOWS
	  printw(":%s %s\n",xinstead,b);
	  refresh();
#endif
          systemf("%s %s",xinstead,b);
#if LETWAIT
          letwait();
#endif
          exeunt(0);
        }
#ifndef MSWINDOWS
	printw(":%s\n",b);
	refresh();
#endif
        result=system(b);

        if (noagain) {
#if LETWAIT
          letwait();
#endif
          exeunt(result);
        }

#ifdef MSWINDOWS
        ifline();
#endif        
#ifdef MSWINDOWS
        printf("Again?: N\b");
        c=bioscharacter();
        x_putch(c);
        printf(LNEND);
#else
        printw("\nAgain?: ");
        c=x_getch();
        x_putch(c);
        printw("\n");
#endif
        if (toupper(c)!='Y')
        exeunt(result);
      }

      case 'E'-CTL:
      case UPARROW:
      hyperget(b,BSIZE,-1);
      continue;

      case 'X'-CTL:
      case DOWNARROW:
      hyperget(b,BSIZE,1);
      continue;
    }

    exeunt(1);
  }

}


