{log.pas        Thu 12/30/2004 6:35 pm
Thu 12/30/2004 6:35 pm  creation.

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit log;

interface

procedure lg(kind:string; const TheFormat:string; const Args: array of const);

procedure checklog_toobig;

implementation

uses SysUtils, options, sbrs, code
{$ifdef LINUX}
, Libc
{$endif}
,main
;
{****************************************************************************
****************************************************************************}


const
loghandle:integer = -1;

BIGGIE = 800000;

log_opened_once : boolean = false;

log_done : boolean = false;
log_success : boolean = false;

var
biggieflag : boolean;
biggiesize : integer;


procedure logclose;
begin

  if loghandle<0 then
  exit;

  FileClose(loghandle);
  loghandle := -1;

  log_done := false;  //trigger another open.

end;

procedure maybeclose;
begin
  if Goptions.logclose then
  logclose;
end;

function logopen:boolean;
begin

  result := false;

{****************************************************************************
//if a log event occurs before we getoptions -- don't stop the thing forever.
The oslog test is just in case I WANT to see an event before getoptions.
****************************************************************************}
  if
//  (notinited<>0) and      //not needed. So i can debug with notinited.
  (Goptions.oslog='') then
  exit;

  if (log_done) then begin
    result := log_success;
    exit;
  end;

  log_done := true;

  if Goptions.oslog='' then
  exit;

  if FileExists_unq(Goptions.oslog) then begin
    //append to it.
    loghandle := FileOpen(Goptions.oslog,fmOpenReadWrite);
    if loghandle>=0 then begin
      biggiesize := fileseek(loghandle,0,2);  // goto the end.
      biggieflag := biggiesize>BIGGIE;    //flag if it's too big.
    end;
  end else
  loghandle := StupidNewFile(Goptions.oslog);

  log_success := (loghandle>=0);

  if log_success and (not log_opened_once) then begin
    hprintf(loghandle,'-----------------------------------'+LNEND);
    log_opened_once := true;
  end;

  result := log_success;

end;



procedure lg(kind:string; const TheFormat:string; const Args: array of
const);
var
s,
stamp:string;

begin
  if (not logopen)
  or (length(TheFormat)<1)  //don't log empties; dbg does them sometimes.
  then
  exit;

  DateTimeToString(stamp,' (mm/dd/yy hh:mm:ss:zzz): ',now);

{****************************************************************************
oops turns-out some of my messages had trailing LNENDs -- unimportant on the
screen, but annoying in log file. So I'll get the formatted string, and then
dump any and ALL control characters, including CR LF....
****************************************************************************}

  s := kind+stamp+safe_format(TheFormat,Args);
  uncontrol(s);

  hprintf(loghandle,'%s'+LNEND,[s]);

  maybeclose;

end;

{****************************************************************************
****************************************************************************}

procedure checklog_toobig;
begin
  if logopen then
  maybeclose;     //in case it SHOULD be closed.

  if (not biggieflag) then
  exit;

  Goptions.logclose := true;    //so we can delete it.
  maybeclose;                   //close it now please.

  errorf('Wowsers! oslog "%s" is %s bytes!',[
  Goptions.oslog,
  numbercommas(biggiesize)
  ]);

  biggieflag := false;          //only do error once.
end;

{****************************************************************************
****************************************************************************}


initialization

finalization

logclose;

end.
