{options.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}



{$define ALT_F6_SUX_IN_W98}

{$define ALWAYS_HALT}

unit options;

interface

uses classes, sbrs, qt, publics, qgraphics{, code}
{$ifdef LINUX}
,Libc
{$endif}
;

{****************************************************************************
$I TLA.I    Thu 5/20/2010 3:18 pm. So sad. This is upper-case because the tla
file used to be produced by charming 16-bit antideluvian programs that made
caps output. But recent it's been changed and degraded and enhanced, and is
now produced by a Delphi program itself, and of course I unthinkingly made the
output chic and lower-case. So the linux source got wacko!
****************************************************************************}
{$I tla.i}

{$ifdef MSWINDOWS}
const
MAX_FILES = 6000;
{$endif}

{$ifdef LINUX}
const
MAX_FILES = 3000;
{$endif}

{$ifdef PGMDIRIZE_HELPDIR}
helpdir : string = 'helphtm';
{$else}
helpdir = 'helphtm';
{$endif}

type


Tdeletes = (OSother, OSmkdir, OSrendir, OSdeletedir, OSCopyFile, OSMoveFile,
OSrenamefile, OSdeletefile);

Tsdeletes = set of Tdeletes;


OS_OP = record
  name:string;        {caption contents}
//  ospref,
  layout_main,
  ossize:string;      {name of size/position storage}
  osfonts:string;     {name of fonts storage}

  oslog:string;       {name of log.}
  logclose : boolean;

  fontfun:boolean;    {name of font fun log.}
  fontfun17:string;

{$ifdef LOG_SCAN}
  scanlog:boolean;   {name of scan log.}
{$endif}

{these are the path clipboard options; what happens at quickcopy.}
  fullpath,           {the default copy to clipboard form}
  trailingslash,      {the default trailing slash copy}
  quotes,             {the default quoting}
  short,              {the default shortness for windows}
  data,
  cute : boolean;

//  whichtree : string; {which tree to start-up with}
// isn't used except to get ....; see figger_whichtree now.
  whichtreeindex : integer;   {set by code}
  scantalk : boolean;  {whine more maybe?}
  casesort : boolean; {sort by case; otherwise ignore case}
  spacebreak: boolean;

{  width, height:integer; }

  wreck, xlate, debugscan:boolean;

  recall_save_layout, recall_main_layout,

  stuff,
  stufftop,
  flip,
  markon, markoff,
  nextkey,
  delete,
  move,
  create,
  rename,
  copy,
  describe,
  scan,
  help,
  markall,
  unmarkall,
  markstars,
  unmarkstars,
  marktop,
  markbottom,
  gotodir,
  literal,
  exec,
  execform,
  fixfiles,
  TreeKey,
  sortName,
  sortExt,
  sortSize,
  sortDate,
  sortNot,
  quickcopy,
  super_quickcopy,
  list,
  cuteify,
  mark,
  etc,
  file_rescan,
//  dir_exact,
  bigvisit,
  exact

  : Tos_key;

  sortmax : integer;
  scanmax : integer;

  del_dir:string;

  allowdelete : boolean;
  deletes : Tsdeletes;
  scanlevels : integer;
  currentdir:boolean;
{  splash:boolean; }

  os : osystem;

  trees : TStringList; {of TTrees probably. There's supposed to be
  a Ttree in the object.}

  execs : TStringList; {of Texecs I assume.}
{****************************************************************************
in the ini file under the headings [trees] list all the desired trees; in DOS
this normally drives. Like

  [os]
  whichtree=c:testtree

  [trees]
  c:testtree=1
  d:d_tree=1

and then for each item with =1, there should be a section like

  [c:testtree]
  ;file=c_tree.tst
  ;file=c_tree
  file=NoneSuch
  exclude=c_tree_exclude
  drive=c

  [c_tree_exclude]
  \ati=1

And there might be a list of directories to exclude....

****************************************************************************}

{  files, bottom : integer;  }

  disablenot : boolean;

  sort : FileSortKind;
  resort : boolean;

{  keymult : integer; }

  ontop : integer;
  {force OwenShow back on top after ontop milliseconds, if not 0.}

  enabledelay : integer;

{  left, top:integer;  }

  driveinfo : string;
  hintdelay : integer;

  control_stop, alt_stop: boolean;

{$ifdef CHECK_TREE_DRIVE}
  check_tree_drive : boolean;
{$endif}

  control_enter_flip : boolean; {what happens @ ^enter}

  halt : boolean;

  alwayshome : integer;                 {let's have a global version!}

  dir_leftselect : boolean;
  dir_creationtime : boolean;

  dir_fix : boolean;
  dir_fix_time : integer;
  dir_fix_more : boolean;
  dir_fix_scroll : integer;

  dir_page : integer;

  drivelist : boolean;

  throttle_wait : integer;

  os_instructions : string;

  click_upsort,
  upsort : boolean;

{$ifdef LINUX}
  nop_name : string;
//  show_cancel : boolean;
{$endif}

  dirmark : boolean;

  clickscan : boolean;
  keepclip : boolean;

  checkspeed : integer;
  checkmod : integer;
  fixtoolong : integer;

  visited_delete_level : integer;

  enter_top : boolean;

  short_menu : boolean;

  zerotime : boolean;

//  permissions : string;

  dont_kill_offsets : boolean;

  dbytes : boolean;

{$ifdef LINUX}
  renamestarqmark: boolean;
{$endif}

  inversionmessage: boolean;

  grafinfo : boolean;   //show "C:" thingey in save dir graphic. default off.
  grafselect : boolean;

  getsizes_anyway: boolean;

  visitDirs : TStringList;

  copy_error_stop : boolean;

  formguard : boolean;

  dontfixcheck : boolean;

  keyabort : boolean;

  show_original_fonts : boolean;

  mkdirsearch : boolean;

//  dir_exact_anyway : boolean;

  cumulative_time : integer;
  cumulative_dir_delay : integer;

{$ifdef MSWINDOWS}
  gates_sux,
  owenshow_drive,
{$endif}
  owenshow_code,
  owenshow_path: string;

{$ifdef MSWINDOWS}
  add_gates_exec : boolean;
{$endif}

  add_path:string;

//  layout_position : boolean;

{$ifdef LINUX}
  dontfix_kylix_positions : boolean;
  kylixleft,kylixtop,kylixcount:integer;
{$endif}

  otherdir : boolean;

  edir_bak,
  edir_name,
  edir_tag,
  edir_midtag,
  edir_endtag,
  edir_skip_chars,
  edir_seedot,
  edir_skips : string;
  edir_selectanyway,
  edir_see,
  edir_ext,
  edir_dot : boolean;
  edir_skip_list : TStringList;
  edir_key : Tos_key;

  edir_exec:Texec;

  edir_scan:integer;

  edir_exclude:TStringList;

  clips : TStringList;
  clips_key : Tos_key;

{$ifdef LINUX}
  numeric_atts : boolean;
  numeric_key : Tos_key;
{$endif}

  xinfo,
  xinfo_skip : integer;
  xinfo_big : integer;  //default for Ttree.xinfo_big.

  debug : boolean;

  tricky_inhibit_timer : integer;

  ext_field : integer;

{$if defined(LINUX)}
  LinuxExecWait : integer;
{$ifend}

  minutesversion : boolean;

  linux_time : boolean;   //turn the linux timer on and off in main for
                          //osidle.
  linux_timer : integer;  //for this interval.

  reread_enable : boolean;
  non_modaldelay,
  execkey_delay,
  reread, rereadwait:integer;

  treeifo : string;
  local_trees:boolean;
  //set by gettrees.

  stupid_yes:boolean;

  antiskid_time,
  antiskid : integer;

  startup : Texec;

  alert : string;

  retry_wait : integer;

{$ifdef MSWINDOWS}
  delete_destination : boolean;
{$endif}

  short_size : boolean;

  execute_error : boolean;

  execute_check : boolean;

  execute_nil : boolean;

  insert : string;
  inserts : Texec;

  dont_save_ok:boolean;

  jcopy_setting:JCOPY;
  jcopy_file:string;

  update_delay : integer;

{$ifdef MSWINDOWS}
  dont_uncolor : boolean;
{$endif}

  autodir : boolean;

  keepright : boolean;

  resize_rate : integer;

  dir_ext : boolean;

  edit_ini : Texec;
  edit_ini_key : Tos_key;

{$if defined(LINUX)}
  little_files : boolean;
{$ifend}

  helphtm : string;
  helpexecute : string;
  helpok : boolean;
  helpjs : string;

  logexec : boolean;

  pathpurge : TStringList;

  bewarned : boolean;

  error_clip : boolean;

end;

const
CHECK_N_DEFAULT = $1FFF;

Gcheck_n : integer = CHECK_N_DEFAULT;
//file_scan.

Gddir_n  : integer = CHECK_N_DEFAULT;
//dir: recursive_ddir. (delete dir)

{And then we'll just concoct various other values now and then.}

Gscan_n : integer = CHECK_N_DEFAULT;
//dir:tree_start et al, i.e. scan dirs.

Gscan_n_4:integer = CHECK_N_DEFAULT;

Gdescribe_n : integer = CHECK_N_DEFAULT;
//dir:r_dir_describe. describe dir.

Gcumu_n : integer = CHECK_N_DEFAULT;
//Ttree.find.

Gfcumu_n : integer = CHECK_N_DEFAULT;

{****************************************************************************
some new additions.
****************************************************************************}
Gloadlv_n : integer = CHECK_N_DEFAULT;
//files sortfiles; i.e. loads listview after sorting. Or something.

{****************************************************************************
****************************************************************************}

edir_scan_both = -1;
edir_scan_before = -2;
edir_scan_after = -3;
edir_scan_never = -4;

none = 'none';

var

Gcheck_count : integer;

//Gcheck_file_rescan_in_dir : boolean;

{$ifdef LINUX}
Gdel_id:uint64;
{$endif}


const


dir_fix_default = 150;
dir_page_default = 80;

throttle_wait_default = 1000; //500;

os_instructions_default = '';
{defaults to none}

LXTIMER_DEFAULT = 500;

reread_enable_DEFAULT = true;


Goptions: OS_OP = (

//  name : 'OwenShow';
//  ospref : 'layout_main.ini';  {a preferred main set-up.}
  layout_main : 'main';
  ossize : 'ossize.ini';  {where we save restore size position etc.}
  osfonts: 'osfonts.ini';

  fontfun17: 'OwenShowFonts';

  fullpath : true;
  trailingslash : true;
  quotes : QUOTES_DEFAULT; {quote thingeys. default in publics}
  short : false;
  data : false;
  cute : false;

  wreck : true;
  xlate : true;

  recall_save_layout:   (show:'@F9'; key : key_F9;   shift : [ssalt ] );
  recall_main_layout:   (show:'@F8'; key : key_F8;   shift : [ssalt ] );

  stuff :         (show:'@ -'; key : ord('-'); shift : [ssalt  ] );
  stufftop :      (show:'^ -'; key : ord('-'); shift : [ssctrl ]);
  flip :          (show:'@+';  key : ord('='); shift : [ssalt  ] );

{  markon :        (show: '+/='; key : ord('=') );  {aka +}
  markon :        (show: eq_pl_string; key : jgok_eq_pl );  {i.e. either = or +.}
  markoff :       (show: '-';   key : ord('-'));
  nextkey :       (key : ord(';'));

  delete :        (show:'F2';  key : key_F2);
  move :          (show:'F3';  key : key_F3);
  create :        (show:'F3';  key : key_F3); {move create different panels}
  rename :        (show:'F4';  key : key_F4);
  copy :          (show:'F1';  key : key_F1);
  describe :      (show:'|F9';  key : key_F9; shift : [ssShift]);
  scan :          (show:'F8';  key : key_F8);

  help :          (show:'@H'; key : ord('H'); shift : [ssalt]);

  markall :       (show:'F5';  key : key_F5);
  unmarkall :     (show:'F6';  key : key_F6);

{$ifdef MSWINDOWS}
  markstars :     (show:'@F5'; key : key_F5; shift : [ssalt]);
  {$ifndef ALT_F6_SUX_IN_W98}}
    unmarkstars :   (show:'@F6'; key : key_F6; shift : [ssalt]);
{****************************************************************************
leave it as nothing; it doesn't work in w98 -- because Microsoft wanted it
that way! See THE DARKNESS OF @F6 in help.
****************************************************************************}
  {$endif}
{$endif}

{$ifdef LINUX}
  markstars :     (show:'|F5'; key : key_F5; shift : [ssshift]);
  {$ifndef ALT_F6_SUX_IN_W98}}
    unmarkstars :   (show:'|F6'; key : key_F6; shift : [ssshift]);
    //make it empty to be consistent with winders.
  {$endif}
{$endif}

  gotodir :       (key : key_Escape);

  literal :       (key : ord('*'); shift : [ssShift]);

  exec :          (show:'@G'; key : ord('G'); shift : [ssalt]);

  execform :      (show:'|@G'; key : ord('G'); shift : [ssalt,ssshift]);

{$ifdef MSWINDOWS}
  fixfiles :      (show: '@F'; key : ord('F'); shift : [ssalt]);
{$endif}

  TreeKey :       (show:'@F10';key: key_F10; shift : [ssalt]);

  sortName :      (show:'F7';       key: key_F7);
  sortExt :       (show:'F8';       key: key_F8);
  sortSize :      (show:'F9';       key: key_F9);
  sortDate :      (show:'F10';      key: key_F10);
  sortNot :       (show:'^F7';      key: key_F7;        shift: [ssctrl]);
  quickcopy :     (show: '^Insert'; key: key_Insert;    shift : [ssctrl]);
  super_quickcopy: (show: '@Insert'; key: key_Insert;    shift : [ssalt]);
  cuteify:        (show: '^J';      key: ord('J')-CTL;  shift : [ssctrl]);
  mark:           (show: '|F7';     key: key_F7;        shift : [ssShift]);
  etc:            (show: '|F8';     key: key_F8;        shift : [ssShift]);
  file_rescan:    (show:'Insert';   key: Key_Insert);
//  dir_exact:      (show:'Insert';   key: Key_Insert);

  exact:          (show:'||';       key : ord('|');     shift : [ssShift]);

{****************************************************************************
So note here how to specify a control key *in this source*: you have to add
the "-CTL" thingey after the ord of the character. This is because

1. *I* fiddle with the alphabetic control characters in the key-handling code
in main.pas that way.

2. Delphi or somebody gives you, for instance, 1F for ^_.

So you see I was really trying to make things consistent.

As nearly as I can guess, ^@G (control alt g) should be encoded with that -CTL
also.

So "cuteify" is specifiable because I just Mon 4/21/03 3:27 pm made it "work"
for files as well as directory, and it *isn't* one of the WordStar control
characters I blithely added to the motion control nonsense. (I mean actually
it is, WordStar help I think....) So I figured it should be specifiable.

Note that in OS.INI, the set_key code will deal with control characters like
that, q.v.
****************************************************************************}

  sortmax : MAX_FILES;
  scanmax : MAX_FILES;

  allowdelete : false;  {default to safe}
  deletes : [];         {default to none}

  scanlevels : 1;

{  splash : false; }

{$ifdef ohnoLINUX}
  files : 80;
  bottom : 12;
{$endif}

  sort : ext_ascend;
  resort : true;

{$ifdef MSWINDOWS}
  enabledelay : 100 {500 {250 {1000};
{$endif}

{$ifdef LINUX}
  enabledelay : 500 {250 {1000};
{$endif}

  hintdelay : 10000 {2500};

  control_stop : true;
  alt_stop : true;

  control_enter_flip : true; {what happens @ ^enter}

{$ifdef ALWAYS_HALT}
  halt : true;
{$endif}

  alwayshome : 2;               {global version; default for trees.}

  dir_creationtime : true;      {Show directory creation time if I can.}

  dir_fix_time : 1;   {default it to on Thu 3/18/04 6:23 pm.}

  dir_page : dir_page_default;

  drivelist :
{$ifdef LINUX}
  false
{$endif}
{$ifdef MSWINDOWS}
  true
{$endif}
  ;

  throttle_wait : throttle_wait_default;

  os_instructions : os_instructions_default;

{$ifdef LINUX}
  nop_name : 'nop';
{$endif}

  dirmark : true;

  checkspeed : 0; //CHECK_N_DEFAULT; let os figure it out.
  fixtoolong : 2500 ;//3000;

  visited_delete_level : 5;

  enter_top : true;

  dbytes : true;

  formguard : true;

{$ifdef MSWINDOWS}
  show_original_fonts : true;
{$endif}

  mkdirsearch : true;

  cumulative_time : 1500;
  cumulative_dir_delay : 500;

{$ifdef MSWINDOWS}
  owenshow_drive : 'os_d';
{$endif}
  owenshow_code : 'os_c';
  owenshow_path : 'os_p';

//  layout_position : true;

{$ifdef LINUX}
  kylixleft: 4;
  kylixtop: 20;
  kylixcount: 2;
{$endif}

  otherdir : true;

  edir_bak      : 'bak';
  edir_name     : 'edir.os';
  edir_tag      : '|';
  edir_midtag   : '|';
  edir_endtag   : '|';

  edir_skip_chars : '~';

  edir_seedot   : 'seedot.os';

  edir_see      : false;

  edir_ext      : true;

{$ifdef LINUX}
  edir_dot      : true;
{$endif}

  edir_key      : (show:'@R'; key : ord('R'); shift : [ssalt ] );

//default for Ttree.xinfo.
  xinfo :
{$ifdef MSWINDOWS}
      1
{$endif}
{$ifdef LINUX}
      0
{$endif}
  ;

//xinfo_skip defaults to zero....

//default for Ttree.xinfo_big.
{$ifdef MSWINDOWS}
  xinfo_big : 1;
{$endif}
{$ifdef LINUX}
  xinfo_big : 0;
{$endif}

  tricky_inhibit_timer :
{$ifdef MSWINDOWS}
  600
{$endif}
{$ifdef LINUX}
  600 //1500
{$endif}
  ;

  ext_field : 4;

{$if defined(LINUX)}
  LinuxExecWait : 100;
{$ifend}

  linux_time : true;
  linux_timer : LXTIMER_DEFAULT;

  reread_enable : reread_enable_DEFAULT;

//provide modifiable defaults.
  reread : MAX_FILES;

  treeifo : 'treeifo';

  stupid_yes: true;

  antiskid_time : 500;

//  alert : 'alert';
//leave default blank. That looks cool

{$ifdef MSWINDOWS}
  delete_destination : true;
{$endif}

  execute_error : true;

  execute_check : true;

  execute_nil : true;

  update_delay : 50;

  autodir : true;

  keepright : true;

  resize_rate : 0;

  edit_ini_key : (show:'I'; key:ord('I'); shift : [ssalt]);

{$ifdef LINUX}
{$ifndef PGMDIRIZE_HELPDIR}
  helphtm :
//  'file:///'+ //special firefox wednesday mumbo jumbo?
  helpdir + slashchar + 'ohelpfrm.htm';
  helpjs : helpdir + slashchar + 'owenshow.js';
{$endif}
  helpexecute : 'firefox' ;


  helpok : false;   //whine about help 'cause it won't work.

{$endif}
{$ifdef MSWINDOWS}
{$ifndef PGMDIRIZE_HELPDIR}
  helpexecute : '"c:\Program Files\Mozilla Firefox\firefox.exe"';
//else leave it blank, see? So shellexec'll work.
  helphtm :
  'file:///'+ //special firefox wednesday mumbo jumbo?
//didn't help. Firefox sick today. // oh it's probably a good idea.
//so now I'm going to try and programdirize the helpdir.
  helpdir + slashchar + 'ohelpfrm.htm';
//  helpjs : helpdir + slashchar + 'owenshow.js';
{$endif}

  helpok : true;

{$endif}

  bewarned : true;

  )
;

const
mainname = 'os';
visitdirname = 'favorites';

ininame :    string = mainname+'.ini';

ex_ininame : string = mainname+'ex.ini';


var

markset : set of char;

ostag,

originaldir : string;
{$ifdef MSWINDOWS}
datadrive : char;
{$endif}

datadir : string;     {the slashed copy of where the data goes.}

Gexitnow : boolean;   {this should be the general-purpose get-out-of-town
notice.}

Gos_args : TStringList;
//a record of the command-line arguments -- for restarting I believe.

need_speed_fix : boolean;
//i.e. Goptions.checkspeed == 0.


procedure getoptions;
{$ifdef dontbother}
procedure putoptions;
{$endif}
procedure datadirize(var s:string);
function fdatadirize(s:string):string;
function osversion:string;
function clx_delphi_effheadgetTLA:string;
procedure set_key(var what:Tos_key; s:string );
function is_key(const what:Tos_key; key:Word; shift:Tshiftstate):boolean;
function same_key(const one,two:Tos_key):boolean;
procedure fix_control(var Key: Word; Shift: TShiftState);
procedure unfix_control(var Key: Word; Shift: TShiftState);

function cantdelete(what:Tdeletes = OSother):boolean;
function skipextension(ext:string):boolean;

function isdel_dir(checkdisk:boolean = false):boolean;

function dir_inize(s:string):string;

procedure refix_again(anyway : boolean = false);


{****************************************************************************
****************************************************************************}

implementation

uses code, inifiles, sysutils, main, fileutil, {cpyfiles,} dir, {jdisplay,}
osinfo,
strutils
,weirdo
,files
;

const

treename = 'trees';
execname = 'execs';
skipname = 'skip';

var

IniFile : TIniFile  ;

{$ifdef LINUX}
  procedure checknop; forward;
{$endif}

{$ifdef MSWINDOWS}
  procedure gates_sux; forward;
{$endif}

function wasset(section,name:string):boolean;
var
s:string;
begin
  result := false;

  try
    s := IniFile.ReadString(section,name,'');
    result := s<>'';
  except
    on exception do;
  end;
end;

procedure fixcheckspeed;

//  function shiftize_r(what, howmuch:integer):integer;
//  begin
//    result := what shr howmuch;
//    if result = 0 then
//    result := 1;
//  end;
// I don't have to do this because maskize checks for zero, stupid.

  function maskize(what:integer):integer;
  var
  i:integer;
  bitgothi:boolean;

  begin
    i := sizeof(integer) * 8;

    bitgothi := false;

    if (what<0) then
    what := 1 shl (i-2);
{if it's negative, because I might pass unchecked nonsense here, then pick the
biggest positive number, which is probably that.}

    if (what=0) then
    what := 1;

    while(i>0) do begin
      dec(i);

      if (what and (1 shl i))<>0 then
      bitgothi := true;

      if bitgothi then
      what :=
      what or (1 shl i);
    end;

    result := what;

  end;

{$HINTS OFF}    {so it won't complain about dummy.}
  procedure figgercheckspeed;
  var
  dummy,
  count : CARDINAL;

  ticks : os_ticks;

  begin

    ticks := get_ms;

    for count := 0 to $100000 do begin
      dummy := count div 7;
    end;

    ticks := get_ms - ticks;

    if ticks = 0 then
    ticks := 1;

    Goptions.checkspeed :=
    500000
//    288768
    div ticks;

{****************************************************************************
I was going to "tune" it to Linux -- but what the heck this is as good a guess
as any. I did it like

    x
 ------      =   $1800
   47

"47" being the tick count on the XP I develop it on, and $1800 being a number
nicely between $1000 and $1FFF -- i.e. a mask of $1FFF, which is what
experiment suggested was OK over the years. As the tick gets larger -- slower
machine, it took longer to do code junk -- checkspeed should get smaller, and
the user check will occur more often. Ifits real fast, then checkspeed gets
real big -- but fortunately all OwenShow operations will occur
instantaneously.... See discussion of checkspeed in the help for what this all
might mean. // And then of course I adjusted the number, because its wildly
different when OwenShow is actually running as opposed to breaking right
around here. Whatever. ....

****************************************************************************}


  end;
{$HINTS ON}

begin
  need_speed_fix := Goptions.checkspeed = 0;

  if need_speed_fix then
  figgercheckspeed;


  if Goptions.checkmod>0 then
  Goptions.checkspeed := Goptions.checkspeed shr Goptions.checkmod
    //if it's positive, make check faster.
  else if Goptions.checkmod<0 then
  Goptions.checkspeed :=
  Goptions.checkspeed shl -Goptions.checkmod;
    //if it's negative, make check slower.

{OK now we make it into a mask.}
  Gcheck_n := maskize(Goptions.checkspeed);
  Gddir_n  := maskize(Goptions.checkspeed);

  Gloadlv_n := maskize(Goptions.checkspeed shr 0);

{$ifdef MSWINDOWS}
  Gscan_n:= maskize(Goptions.Checkspeed shr 8);
  {make it check *more*.}
//  Gscan_n := $7FF;  //this worked on 2000 xp machine
//  Wednesday, April 30, 2008 3:36 pm. So changed maksize from 2 to 8.

  Gscan_n_4 := maskize(Goptions.Checkspeed);
{$endif}

{$ifdef LINUX}
  Gscan_n:= maskize(Goptions.Checkspeed shr 2);

  Gscan_n_4 := maskize(Goptions.Checkspeed shl 1);
{$endif}

  Gdescribe_n := maskize(Goptions.Checkspeed shr 3);
{****************************************************************************
Because it counts the size of everything it actually takes longer than scan.
// this was "right" for LRA's monstrous averatec gigabyte "documents and
settings"
****************************************************************************}


{****************************************************************************
Gfcumu_n is the *fast* version; it'll check more often, during cumulative
searches. Gcumu_n is the slow version. // Is *real slow* in giant w7a
directory tree Tuesday, May 4, 2010 2:18 pm.
****************************************************************************}
{$ifdef MSWINDOWS}
  if os_isw7 then
  Gcumu_n := maskize(Goptions.Checkspeed
  shr
//  12  //at last too fast.
//  10
  11  //just right?
  )


  else
{$endif}

  Gcumu_n := maskize(Goptions.Checkspeed
//  shl 1
  shr 3
//  shr 6
//  shr 8
  );

//  Gcumu_n := 1; //that "worked" in w7.

  Gfcumu_n := 1   //just as fast as possible ;

end;

{****************************************************************************
Thu 7/16/2009 5:47 pm. So I think refix without true is just a lazy calc, so
it would only calc when it had to, later.
****************************************************************************}


procedure refix_again(anyway : boolean = false);
const
figured : boolean = false;
begin
  if (anyway and need_speed_fix) then
  figured := false;

  if figured then
  exit;

  figured := true;

  if need_speed_fix then begin   //jigger it so it figgers again.
    Goptions.checkspeed := 0;
    fixcheckspeed;
  end;

end;

function deplus(var s:string):boolean;
begin
  result := es(s,1)='+';
  if result then
  s := copy(s,2,10000);
end;

function fdatadirize(s:string):string;
begin
  datadirize(s);
  result := s;
end;

procedure datadirize(var s:string);
begin

  if deplus(s) then
  exit;


{$ifdef DONTUSEDIRECTORIZE}
    if (length(s)>0) and (pos(slashchar,s)=0)
  {$ifdef MSWINDOWS}
    and (pos(':',s)=0)
  {$endif}
{$endif}

  if not haspath(s) //directoried(s)
  then
  s := datadir+s;

end;

{$ifdef THIS_WAS_STUPID}
{****************************************************************************
Tue 11/15/2005 10:18 am. Yes C has __DATE__ and __TIME__ I believe, but not in
Delphi. So then a kindly German suggested this approach: checking the
date/time of the exe file, which would normally be equivalent to the compile
time. And so it would be -- but then I realized that's *not what I want*. The
whole *point* is to be able to tell if I've got the right version as I hack
away fixing things, and for that it has to be the *same* minutes code in
Windows and Linux -- but of course in Linux I'll inevitably be recompiling
again! Silly silly; so now I enhanced my date-constant making process -- the
thing that shows-up in the source as tla.i -- with the minutes code sJGO_XMN.
****************************************************************************}

function osminutes:string;
const
done : boolean = false;
datestring : string = '';
var
minutes : integer;
begin
  if not done then begin
    done := true;
    if FileExists_unq(paramstr(0)) then begin
      datestring := '';
      minutes :=
      MinuteoftheDay(
      FileDatetoDateTime(FileAge(paramstr(0)))
      );
      while minutes <> 0 do begin
        datestring :=

        chr(minutes mod 26 + ord('a'))
        +
        datestring
        ;

        minutes := minutes div 26;
      end;
    end else
    datestring := sJGO_XMN;
  end;

  result := datestring;

end;
{$endif}

function osversion:string;
begin
  if (Goptions.minutesversion) then
  result :=
  safe_format('%s (%s:%s)',
  [Goptions.name,sTLA,sJGO_XMN])
  else
  result :=
  Goptions.name + ' (' + sTLA + ')';
end;

function clx_delphi_effheadgetTLA:string;
begin
  result := sTLA;
end;

{$ifdef LINUX}

{****************************************************************************
Fri 12/08/2006 11:43 am. Tried it again, and OwenShow'll still obliterate
comments in the ini file if I don't do this -- I assume a Kylix failing....
****************************************************************************}

var
oldinimode : __mode_t;  //used by unreadonlyinifile, in case it was only
                        //r/o.
gotmode : boolean;

procedure readonlyinifile;
{var
newmode : __mode_t;  }
begin
  gotmode := false;
  If FileExists_unq(ininame) then begin
    try
      oldinimode := OS_getmode(ininame);
{      newmode := oldinimode and
      (not (S_IWUSR or S_IWGRP or S_IWOTH));  }

      if chmod(Pchar(ininame),
{      newmode  }
      oldinimode and
      (not (S_IWUSR or S_IWGRP or S_IWOTH))
      )=0 then
      gotmode := true;
    except
      on exception do;
    end;
  end;
end;

procedure unreadonlyinifile;
begin
  if not gotmode then
  exit;

  if FileExists_unq(ininame) then begin
    chmod(Pchar(ininame),oldinimode);
    gotmode := false;
  end;
end;


{$endif}

function dir_inize(s:string):string;
begin
  result := directorize(ininame,s);
end;

procedure openinifile(name:string = '');
begin
  if IniFile <> Nil
  then exit;

  if length(name)>0 then
  ininame := name;

  datadirize(ininame);

  ex_ininame := dir_inize(ex_ininame);

{Friday, June 6, 2003 1:54 pm. If there isn't any os.ini, and there *is*
osex.ini, then use the latter.}
  if (not FileExists_unq(ininame))
  and FileExists_unq(ex_ininame) then
  RenameFile(ex_ininame,ininame);

{$ifdef LINUX}
  readonlyinifile;
{$endif}

  try
    IniFile := Tinifile.Create(ininame);
  except
    on e: exception do
    errorf('Inifile complaint: %s',[e.message]);
  end;

end;

procedure closeinifile;
begin

  try
{   inifile.UpdateFile }
{we don't do this here, because we depend on never writing anything to the
main ini file, to avoid Linux mysteries of life....}

    IniFile.Free;
  except
//    on e: efcreateerror do ;
    on e: exception do {nothing} ;

{in Linux this always generate an error, at least if my readonlyinifile dodge
is working ok. If I don't protect the ini file, the cranky CLX or someone
throws away all the comments, which I dislike.}

  end;

{$ifdef LINUX}
  unreadonlyinifile;
{$endif}

  IniFile := Nil;
end;

{****************************************************************************
The grand section scheme. The idea is you specify a section like
[os]
section=Linux

Getoptions reads that first, then uses the sec() function to read all
things. So it'd be

[os]
section=Linux

then it'd look for junk in

[Linux:os]
[Linux:trees]

etc. I like it.

****************************************************************************}

var
section:string; {might be used by putoptions someday.}

function sec(name:string):string;
begin
  if length(section)>0 then
  result := section + ':' + name
  else
  result := name;
end;


{****************************************************************************
****************************************************************************}
{$ifdef RECYCLE}
var
recycling : boolean;  //set if any recycle=1.

{$endif}

{$define GETX_SORT_LATER}

procedure gettrees;
var
i : integer;
exclude, name : string;
t : Ttree;
dummy:TStringList;


  procedure getxlist(var sl:Tstringlist; section:string);
  var
  value,
  j:integer;
  begin
    sl := TstringList.create;

    if length(section)>0 then begin
      IniFile.ReadSection(section,sl);

{$ifdef MSWINDOWS}
      sl.casesensitive := false;  {make it any case.}
{$endif}
{$ifdef LINUX}
      sl.casesensitive := true;
{$endif}
{$ifndef GETX_SORT_LATER}
  {sort at the start, because otherwise the objects disappear even 'though
  they shouldn't. // Nope; or at least if "sorted" property is false. Which
  it should be. And the objects *shouldn't* disappear.}
      stupid_string_sort(sl);
{$endif}

      j := 0;
      while j < sl.Count do begin
        value := IniFile.ReadInteger(section,sl[j],-2);

        if value<-1 then
        sl.delete(j)
        else begin

{$ifdef MSWINDOWS}
          sl[j] :=
          fdeslash(fdedrive(sl[j]));
{$else}
          sl[j] := fdeslash(sl[j]);
{$endif}

          sl.objects[j] := Tobject(value);  //log level, eh?

          inc(j);
        end;
      end;
{$ifdef GETX_SORT_LATER}
      stupid_string_sort(sl);   //we CHANGED it!?!?
{$endif}
    end;

  end;

  procedure pathoid_etc;
  begin

{Thursday, February 13, 2003 1:48 pm. This is NOT the place to put
default inits; this is called to fix-up directory names. OS produces
a default tree if none is specified, but it must do all the init it
wants there. This is called by normal code and the default code.}

    if length(t.pathsFile.name)<1 then
    exit;   {leave errors for others.}

    datadirize(t.pathsFile.Name);

    t.pathsFile.Name     := extensionize(t.pathsFile.Name,extPATHS);
    t.picturesFile :=
    Ttreefile.create(extensionize(t.pathsFile.Name,extPIX));

    t.offsetsFile  :=
    Ttreefile.create(extensionize(t.pathsFile.Name,extOFFSETS));

    t.infoFile     :=
    Ttreefile.create(extensionize(t.pathsFile.Name,extINFO),true);

{$ifdef MSWINDOWS}
    t.homedir := fslash(fredrive(t.homedir,t.drive[1]));
{we were doing "fdedrive" but that's inconsistent with what's
saved when homedir isn't honored -- in which case I save the path
with the stupid drive.}

    t.otherdir := fslash(fredrive(t.otherdir,t.drive[1]));
{$endif}

{$ifdef LINUX}
    t.homedir := fslash(t.homedir);
    t.otherdir := fslash(t.otherdir);
{$endif}

  end;

//if the specified tree doesn't exist, make one up.
//this is probably a bad idea but what it's been this way a while....
  function make_imaginary:boolean;
  begin
    result := false;
    IniFile.ReadSection(name,dummy);
    //NOT t.name; the section is named NAME....
    if dummy.count>0 then
    exit;   //there was something; hence don't make it up.


//    t.xinfo := 0;
{****************************************************************************
Fri 2/10/2006 4:03 pm. don't put a stupid letter up there if you don't know
what it is. I'm not sure this is meaningful -- but it's still stupid... // no
no the only reason for this nonsense is so in Windows you can have

  [trees]
  a:floppy drive=1
  b:tree=0
  c:hard drive=1
  d:tree=1
  e:tree=1
  f:tree=1

without any corresponding sections, and it'll create a nice set of trees with
*no human intervention* -- for which of course you'll want nice xinfo
letters....

****************************************************************************}


    result := true;
  end;

begin
  Goptions.trees := TStringList.create;
  Goptions.trees.sorted := false;
  {apparently I was just hoping this'd work.}

  dummy := TStringList.create;
  //for checking existence of tree section q.v.

//read the entire section of [trees] into .trees.
  IniFile.ReadSection(sec(treename),Goptions.trees);

  i := 0;

  while i < Goptions.trees.Count do begin
    name := Goptions.trees[i];

    if not IniFile.ReadBool(sec(treename),name,false) then begin
      Goptions.trees.Delete(i);
      continue;
    end;      {just skip that one; it was =0.}

    t := TTree.create
    (name)
    ; //this does some defaults from Goptions.globals.

//let user change name from section, particularly to use e vars.
    t.name := evarize(IniFile.ReadString(name,'name',name));
//    t.name := name; {error msg info, at least....}
    Goptions.trees[i] := t.name;

    if not make_imaginary then
    begin

      t.autodirscan := IniFile.ReadBool(name,'autodir',t.autodirscan);

{$ifdef MSWINDOWS}
      t.drive     := lowercase(
      evarize(IniFile.ReadString(name,'drive',t.drive)));

{$endif}

      t.retry_wait := IniFile.ReadInteger(name,'retry_wait',t.retry_wait);

{$ifdef RECYCLE}
      t.recycle := IniFile.ReadBool(name,'recycle',t.recycle);
      recycling := t.recycle or recycling;
{$endif}

      t.pathsFile.name :=
      evarize(IniFile.ReadString(name,'file',t.pathsFile.name));

      t.homedir := evarize(IniFile.ReadString(name,'homedir',t.homedir));

      t.otherdir := evarize(IniFile.ReadString(name,'otherdir',t.otherdir));

      t.rootwarning := IniFile.ReadBool(name,'rootwarning',t.rootwarning);

      t.decode_alwayshome(
      IniFile.ReadInteger(name,'alwayshome',Goptions.alwayshome));

      t.local := IniFile.ReadBool(name,'local',false); //he must specify it.
      t.local_wasset := wasset(name,'local');

      exclude := IniFIle.ReadString(name,'exclude','');

      t.xinfo :=
      IniFile.ReadInteger(name,'xinfo',Goptions.xinfo);

      t.xinfo_skip :=
      IniFile.ReadInteger(name,'xinfo_skip',Goptions.xinfo_skip);

      t.xinfo_big :=
      IniFile.ReadInteger(name,'xinfo_big', Goptions.xinfo_big);

      if t.xinfo<2 then
      t.xinfo_skip := 0;

    end;

    if
    (length(t.pathsFile.Name
    )<1)
{$ifdef MSWINDOWS}
    or (length(t.drive)<>1)
    or (t.drive<'a')
    or (t.drive>'z')
{$endif}
    then begin
{$ifdef MSWINDOWS}
      errorf('something''s wrong in tree "%s": filename:"%s"; '
      +'drive:"%s"; deleting...',
      [t.name,t.pathsFile.Name,t.drive]);
{$endif}
{$ifdef LINUX}
      errorf('something''s wrong in tree "%s": filename:"%s"; '
      +'deleting...',
      [t.name,t.pathsFile.Name]);
{$endif}
      t.free;
      Goptions.trees.delete(i);
      continue;
    end;

    pathoid_etc;

    getxlist(t.exclude,exclude);

    Goptions.trees.objects[i] := t;

    Goptions.local_trees :=
    Goptions.local_trees or
    t.local;

    t.index := i; //an obvious dodge.Tuesday, March 28, 2006 11:06 am.

    inc(i);

  end;

  if Goptions.trees.count < 1 then begin

{****************************************************************************
****************************************************************************}

    t := TTree.create(
{$ifdef MSWINDOWS}
    datadrive +
    ':tree'
{$endif}
{$ifdef LINUX}
    'LX_tree'
{$endif}
    );

{$ifdef MSWINDOWS}
    t.drive     := datadrive;
{$endif}


    t.pathsFile.name :=
{$ifdef MSWINDOWS}
    datadrive+
    '_tree'
{$endif}
{$ifdef LINUX}
    'LX_tree'
{$endif}
    ;

    t.exclude := TStringList.create;

{$ifdef RECYCLE}
    if Goptions.os=XP then begin
      t.recycle := true;
      recycling := true;
    end;
//for naked OS, try and recycle. but NOT FOR W98 slow SLOW....
{$endif}

    pathoid_etc;

    Goptions.trees.addobject(t.name,t);

{****************************************************************************
****************************************************************************}

  end;

  for i:=0 to Goptions.trees.count-1 do begin
    (Goptions.trees.objects[i] as Ttree).option_tree_index := i;
  end;

  freeandnil(dummy);

end;

{****************************************************************************
****************************************************************************}
procedure figger_whichtree;
var
{$ifdef MSWINDOWS}
i:integer;
{$endif}
whichtree : string;
h:integer;
begin

  h := FileOpen(Goptions.treeifo,fmOpenRead);
  if h >- 0 then begin
    hgets(h,whichtree);
  end;
  FileClose(h);
  DeleteFile(Goptions.treeifo);
  //get rid of the thing, so we won't do this twice.

  if whichtree = '' then

  whichtree :=
  IniFile.ReadString(sec(mainname),'whichtree','');

  Goptions.whichtreeindex :=
  Goptions.trees.IndexOf(whichtree);

{$ifdef MSWINDOWS}
  if Goptions.whichtreeindex < 0 then
  for i := 0 to Goptions.trees.count-1 do begin
    if ((Goptions.trees.objects[i] as Ttree).drive=datadrive)
    //if the drive equals the original drive, let's guess that's it.
    then begin
      Goptions.whichtreeindex := i;   //voila.
      break; //the for.
    end;
  end;
{$endif}

  if Goptions.whichtreeindex < 0 then
  Goptions.whichtreeindex := 0;     // pick the first.

  if (not Goptions.local_trees)
  then with Goptions.trees.objects[Goptions.whichtreeindex] as Ttree do begin
    if (not local_wasset) then begin
      local_wasset := true; //shouldn't make any difference.
      local := true;
      Goptions.local_trees := true;
  {****************************************************************************
  if no locals (not local_trees) and user didn't specify this one already,
  either local or not, THEN set the whichtree to local.
  ****************************************************************************}
    end;
  end;

end;

{****************************************************************************
****************************************************************************}
procedure os_ize(var s:string);
begin

  case Goptions.os of
    xp: begin
      s := StringReplace(s,
      'command.com',
      'cmd.exe',
      [rfReplaceAll,rfIgnoreCase]);
    end;

    w9x: begin
      s := StringReplace(s,
      'cmd.exe',
      'command.com',
      [rfReplaceAll,rfIgnoreCase]);

      s := StringReplace(s,
      '.cmd',
      '.bat',
      [rfReplaceAll,rfIgnoreCase]);

    end;
  end;

end;

{****************************************************************************
****************************************************************************}
//fill-in the stuff that should be filled-in.
function fakeanexec:Texec;
begin
  result := Texec.create;
  with result do begin
    xops := TStringList.create;
//well that seems to be it.
  end;
end;

function exec_rereads(dst:TStringlist; section:string):boolean;
var
i:integer;
begin
  result := false;    //assume failure.

  IniFile.ReadSection(section,dst);
  if dst.count<1 then
  exit;

  for i := 0 to dst.count-1 do begin
    dst.objects[i] :=
    TObject(
    IniFile.ReadInteger(section,dst[i],0));
    //store the reread parameter in the object.
  end;

  result := true;

end;

function getanexec(name:string):Texec;
var
s,opname:string;
x:integer;
const
allx = 'all';
dirx = 'dir';
filex = 'files';
begin

  result := nil;

  if name='' then
  exit;

  result := Texec.create;
  result.r.name := name;     {the identification.}
  result.r.exec := IniFile.ReadString(name,'exec',result.r.exec);
  deslash(result.r.exec);
  os_ize(result.r.exec);
  datadirize(result.r.exec);

  if
  (result.r.name='') or
  (result.r.exec='')
  then begin
    freeandnil(result);
    exit;
  end;

  if (xfilename(result.r.exec)[1]='*') then
  result.r.exec := '';

  {get options and what not that should appear with the exec. They get stuck
  on as arguments I hope. They should appear in the form xop1=an arg, up to
  xop20. }

  result.xops := TStringList.create; {just always make one}

  opname := IniFile.ReadString(name,'options','');

  if length(opname)>0 then begin  //overrides the old "xops1" etc.
    IniFile.readsection(opname,result.xops);
    x := 0;
    while x<result.xops.count do begin
      if IniFile.ReadBool(opname,result.xops[x],false) then
      inc(x)
      else
      result.xops.delete(x);   //it has to say ==1.
    end;
  end
  else
  for x := 0 to 20 do begin
    s := Inifile.ReadString(name,'xop'+IntToStr(x),'');
    if length(s)>0 then
    result.xops.add(s);
  end;

  {pass arguments in named file (one per line) instead of cmd-line.}
  result.r.argfile :=
  IniFile.ReadString(name,'argfile',result.r.argfile);
  datadirize(result.r.argfile);

  {notice the defaults here for boolean thingeys; these are they; well
  actually Tue 4/15/03 6:29 pm now I'm going to have the constructor do it
  q.v. publics}

  s := IniFile.ReadString(name,'xin','all');

  {default to both}
  {    result.in_dir := true;
      result.in_files := true;  }

  if CompareText(s,dirx)=0 then
  result.r.in_files := false;
  if CompareText(s,filex)=0 then
  result.r.in_dir := false;

  if IniFile.ReadString(name,'prompt','')='no'
  then begin
    result.r.prompt := false;
    //don't even show prompt menu execution.
    result.r.showing_prompt := false;
  end else
  {make a little inputbox before executing.}
  result.r.prompt :=
  IniFile.ReadBool(name,'prompt',result.r.prompt {true});

  {use short names}
  result.r.short :=
  IniFile.ReadBool(name,'short',result.r.short {false} );

  {use full path for names}
  result.r.full :=
  IniFile.ReadBool(name,'fullpath',result.r.full {false} );

  {quotify if necessary}
  result.r.quotes :=
  IniFile.ReadBool(name,'quotes',result.r.quotes {true} );

  {wait for execution to be over}
  result.r.modal :=
  IniFile.ReadBool(name,'modal',result.r.modal {true} );

  result.r.reread_enable :=
  IniFile.ReadBool(name,'reread_enable',result.r.reread_enable);

  {reread files after execution (if files)}
  s :=
  IniFile.ReadString(name,'reread',IntToStr(result.r.all_reread));

{****************************************************************************
Mon 4/30/2007 11:29 am. The idea apparently is he could specify a *section*
instead of a number, and then we'd look in the section for strings matching
the tree (windows) or the beginning of the current direcotry (Linux) and use
the attached object for the all_reread value -- which is, approximately, what
reread used to be when it was just numeric.
****************************************************************************}

  if (sbrs.isdigit(es(s,1))) then begin
    result.r.all_reread := JgoStrToInt(s);
    freeandnil(result.reread);
  end else begin
    if not exec_rereads(result.reread,s) then
    freeandnil(result.reread);
  end;

  if not result.r.reread_enable then
  result.r.all_reread := 0;
{****************************************************************************
Mon 4/30/2007 11:31 am. crush rereading! I got bored with it. ... Unless
you've set treread_enable OR specified a section thingey for the reread value,
in which case presumably you want that instead.
****************************************************************************}

  result.r.rereadwait :=
  IniFile.ReadInteger(name,'rereadwait',result.r.rereadwait);

  result.r.doubleclick :=
  IniFile.ReadBool(name,'doubleclick',result.r.doubleclick);

  result.r.args :=
  IniFile.ReadBool(name,'args',result.r.args);

  result.r.select :=
  IniFile.ReadBool(name,'select',result.r.select {false} );

  result.r.marked :=
  IniFile.ReadBool(name,'marked',result.r.marked);

  result.r.non_modaldelay :=
  IniFile.ReadInteger(name,'non_modaldelay',result.r.non_modaldelay);

  result.r.directory :=
  IniFile.ReadString(name,'directory',result.r.directory);

  result.r.log :=
  IniFile.ReadBool(name,'log',result.r.log);

  result.r.invisible :=
  IniFile.ReadBool(name,'invisible',result.r.invisible);

  if result.r.directory='*' then
  result.r.directory := datadir;

  deslash(result.r.directory);
  {chdir seems to like that now and then.}

  {    result.throttling :=
  IniFile.ReadBool(name,'throttling',result.throttling);  }

  set_key(result.r.key,
  IniFile.ReadString(name,'key',''));

  if result.r.key.key = osRETURN then begin
    result.r.in_dir := false;
    result.r.is_enter := true;
    result.r.in_files := true;
  end else if result.r.key.shift=[] then
  result.r.key.key := 0; {must be alt or control I guess.}

end;

function get_edit_exec(name,to_edit:string; def:Texec = nil):Texec;
begin
  result := nil;

  if (name=none) then
  exit;

  result := getanexec(name);

  if result = nil then begin

    result := fakeanexec;

    if def<>nil then begin
      result.assign(def);
    end else
    result.r.exec :=
{$ifdef LINUX}
    'emacs'
{$endif}

{$ifdef MSWINDOWS}
    'notepad.exe'
{$endif}
    ;

  end;

  result.r.ignore_reread := true;
//because osedir makes other arrangements or something.

  result.fixed_arglist :=  TStringList.create;
  result.fixed_arglist.add(to_edit);

end;


{****************************************************************************
****************************************************************************}
procedure getinserts;
begin
  Goptions.insert := IniFile.ReadString(sec(mainname),'insert','');

  if Goptions.insert='' then
  exit;

  Goptions.inserts := Getanexec(Goptions.insert);
  Goptions.inserts.r.args := false;

end;

{****************************************************************************
  if what=nil then
  exit;


//I'm getting this from Texecform.exec_args.... well actually I'm just doing
//it.
  Texecform.exec(args(Goptions.inserts,what);


  Goptions.inserts.insert(0,anexec.exec);






  Goptions.inserts.AddStrings(what.xops);

  if what.fixed_arglist<>nil then
  Goptions.inserts.addStrings(what.fixed_arglist);




//  IniFile.ReadSection(Goptions.insert,Goptions.inserts);

****************************************************************************}


{****************************************************************************
****************************************************************************}
{$define EVAR_EXEC_DEF}   {make like bingo=%bongo% work?}

procedure getexecs;
var
i:integer;
{$ifdef EVAR_EXEC_DEF}
s,
{$endif}
name:string;
t : Texec;
begin
  Goptions.execs := TStringList.create;
  Goptions.execs.sorted := false;
  IniFile.ReadSection(sec(execname),Goptions.execs);

  i := 0;

  while i <= Goptions.execs.Count-1 do begin
    name := Goptions.execs[i];

{$ifdef EVAR_EXEC_DEF}
    s := evarize(Inifile.ReadString(sec(execname),name,''));
    if (s='')
    or (s='0') then begin
      Goptions.execs.Delete(i);
      continue;
    end;      {just skip that one}
//i.e., any enviro value other than '0' or nothing will enable the feature.

{$else}
    if not IniFile.ReadBool(sec(execname),name,false) then begin
      Goptions.execs.Delete(i);
      continue;
    end;      {just skip that one}
{$endif}

    t := getanexec(name);
    if (t=nil) then begin
      Goptions.execs.delete(i);
      continue;
    end;

    Goptions.execs.objects[i] := t;

    inc(i);

  end;

end;

{****************************************************************************
****************************************************************************}

var
skips : TStringList;

procedure getskips;
var
i:integer;
s:string;
begin
  skips := jgo_slist;
  IniFile.ReadSection(sec(skipname),skips);

{throw away comments and =0}
  i := 0;
  while i < skips.count do begin
    s := skips[i];
    if (es(s,1)=';')
    or (not IniFile.ReadBool(sec(skipname),s,false)) then begin
      skips.delete(i);
      continue;   {while}
    end;
    inc(i);
  end;
  skips.CaseSensitive :=
{$ifdef MSWINDOWS}
  false
{$endif}
{$ifdef LINUX}
  true
{$endif}
  ;
  stupid_string_sort(skips);

end;

{****************************************************************************
the custom_sort INHERENTLY must use indexof, since the list ISN'T sorted the
way the thing expects. And we MUST avoid the idiotic default )(*&(*&) UTF-8 in
Linux, since punctuation can be part of extensions.
****************************************************************************}
function skipextension(ext:string):boolean;
begin
  result :=
  skips.indexof(ext) >= 0;
end;

{****************************************************************************
Ooops, `%s command-line error.`%s
os `%sdPath   specify path for data dir (`%s et al).
   `%sd       use current directory for data.
   Otherwise OS uses program directory for data storage.
   `%siIniname use that ini file.
   `%sc       start showing current directory (currentdir=1)
   `%sf       allow main form disable anyway
   `%svFName  use file with Fname for favorite dirs.
   `%sr       recall main layout
`a$ifdef LINUX
   `%srut     allow to run as root bad bad....
`a$endif




//no this didn't work out.
`a$ifdef MSWINDOWS
   `%sxXO.BAT (windows) Restart OS with some 16-bit environment variables.
    using that batch file. See help. "-x" alone: don't.
`a$endif

(use ctext -x)
****************************************************************************}

procedure getcmdline;
var
op,s:string;
var
i : integer;
  procedure explanations(why:string = '');
  begin

    if (length(why)>0) then
    why := safe_format(' ("%s")',[why]);

    osinfof(






'Ooops, %s command-line error.%s'
+LNEND+'os %sdPath   specify path for data dir (%s et al).'
+LNEND+'   %sd       use current directory for data.'
+LNEND+'   Otherwise OS uses program directory for data storage.'
+LNEND+'   %siIniname use that ini file.'
+LNEND+'   %sc       start showing current directory (currentdir=1)'
+LNEND+'   %sf       allow main form disable anyway'
+LNEND+'   %svFName  use file with Fname for favorite dirs.'
+LNEND+'   %sr       recall main layout'
{$ifdef LINUX}
+LNEND+'   %srut     allow to run as root bad bad....'
{$endif}




    ,
    [ParamStr(0),
    why,
    opchar,
    ininame,
    opchar,
    opchar,
    opchar,
    opchar,
    opchar,opchar,opchar,opchar] // leave a few extra.
    );
    form1.pleaseclose := true;
    Gexitnow := true;
  end;

  function goodname(what:string):boolean;
  begin
    result :=
    length(what)>0;
    if not result
    then explanations(
    safe_format(LNEND+'("%s" uses bad name)',[ParamStr(i)]));
  end;

begin

  for i := 1 to Paramcount do begin
    Gos_args.add(ParamStr(i));
    s  := copy(ParamStr(i),3,10000);
    op := copy(ParamStr(i),2,10000);

    if
    (ParamStr(i)[1]=opchar)
    or (ParamStr(i)[1]=otheropchar)
    then
    case es(ParamStr(i),2) of
      'd': begin

        if length(s)<1 then
        s := originaldir;

        if not goodname(s) then
        exit;

        if DirectoryExists(fdeslash(s)) then
        datadir := fslash(s)
        else begin
          explanations(
          safe_format(LNEND+'(directory "%s" doesn''t exist)',[s]));
          exit;
        end;
      end;

      'c': Goptions.currentdir := true;

      'f': Goptions.disablenot := es(ParamStr(i),3)<>'-';

      'i': begin
        if not goodname(s) then
        exit;
        ininame := s;

      end;

      'r': begin
        plz_restore_layout := true;
      end;

      'v': begin
        if not goodname(s) then
        exit;
        Goptions.visitdirs.add(s);
      end;

    else
      explanations(ParamStr(i));
      exit;
    end
    else begin
      explanations(ParamStr(i));
      exit;
    end;
  end;
end;

procedure getsort;
var
i:integer;
s:string;
type
Rsorting = record
  what : FileSortKind;
  name : string;
end;

const
st : array[1..10] of Rsorting = (
  (what:name_ascend;   name:'+name'   ),
  (what:name_descend;  name:'-name'   ),
  (what:ext_ascend;    name:'+ext'    ),
  (what:ext_descend;   name:'-ext'    ),
  (what:size_ascend;   name:'+size'   ),
  (what:size_descend;  name:'-size'   ),
  (what:time_ascend;   name:'+date'   ),
  (what:time_descend;  name:'-date'   ),
  (what:atts_ascend;   name:'+atts'   ),
  (what:atts_descend;  name:'-atts'   )
);

begin
  s :=
  IniFile.ReadString(sec(mainname),'sort','');

  for i := low(st) to high(st) do begin
    if CompareText(st[i].name,s)=0 then
    Goptions.sort := st[i].what;
  end;

  Goptions.resort := IniFile.ReadBool(sec(mainname),'resort',
  Goptions.resort);

end;

procedure fixmarkset;
begin
  if is_key(Goptions.markon,{key_equal}jgok_eq_pl,[]) then
  markset := markset + ['=', '+'];

  if is_key(Goptions.markoff,ord('-'),[]) then
  markset := markset + ['-'];
end;

function isdel_dir(checkdisk:boolean = false):boolean;
begin
  result :=
  length(Goptions.del_dir)>0;
  if result and checkdisk then
  result := DirectoryExists(Goptions.del_dir);
end;

{****************************************************************************
the assumption is that the Goptions.visitDirs may already *have* some names
from command line args. So this list is a list of *files* which contain paths
we want stuffed into visited dirs -- permanently.
****************************************************************************}

procedure getvisitdirs;
var
sl:TStringList;
j:integer;
section:string;
begin
  sl := TStringList.create;
  section := sec(visitdirname);
  IniFile.ReadSection(section,sl);
  j := 0;
  while j < sl.Count do begin
    if not Inifile.ReadBool(section,sl[j],false) then
    sl.delete(j)
    else
    inc(j);
  end;

  Goptions.VisitDirs.AddStrings(sl);
  sl.free;

  for j := 0 to Goptions.VisitDirs.count-1 do begin
//section is just a var here for datadirize.
    section := Goptions.VisitDirs[j];
    datadirize(section);
    Goptions.VisitDirs[j] := section;
  end;

end;

procedure get_edir_skips;
var
i:integer;

  function addstar(s:string):string;
  begin
    if (es(s,1)='.')
    and (pos('?',s)<1)
    and (pos('*',s)<1)
    and (pos('[',s)<1)
    then
    result := '*'+s
    else
    result := s;
  end;

begin

  if length(Goptions.edir_skips)>0 then begin

    IniFile.ReadSection(Goptions.edir_skips,Goptions.edir_skip_list);

    i := 0;

    while i < Goptions.edir_skip_list.count do begin
      if not
      IniFile.ReadBool(Goptions.edir_skips,Goptions.edir_skip_list[i],false)
      then
      Goptions.edir_skip_list.delete(i)
      else
      begin
        Goptions.edir_skip_list[i] :=
        addstar(Goptions.edir_skip_list[i]);
        inc(i);
      end;
    end;
  end;

//ok let's do some more with this nonsense. First,
  if not Goptions.edir_see then begin

    //add the name.
    Goptions.edir_skip_list.add(Goptions.edir_name);

    //add the backup.
    Goptions.edir_skip_list.add(
    ExtractFName(Goptions.edir_name)
    + '.'
    + Goptions.edir_bak
    );

  end;

{$ifdef DO_IT_in_osedir}
  if Goptions.edir_dot then
  Goptions.edir_skip_list.add('.*');
  //this will require interpretation in the osedir.pas file q.v.
{$endif}


end;



{****************************************************************************
****************************************************************************}
procedure getclips;
var
i:integer;
s:string;

equals : char;

const
clipname = 'clips';

//            1234567
equalsname = 'EqualS:';
equalssize = 7;

begin
  Goptions.clips.sorted := false;
//we leave 'em the way he wants 'em.
  IniFile.ReadSection(sec(clipname),Goptions.clips);

  i := 0;
  equals := #0;

  while i < Goptions.clips.count do begin
    s := Goptions.clips[i];



    if (es(s,1)=';')
    or (not IniFile.ReadBool(sec(clipname),s,false)) then begin
      Goptions.clips.delete(i);
      continue; //while.
    end;

    if copy(s,1,equalssize)=equalsname then begin
      equals := es(s,equalssize+1);
      Goptions.clips.delete(i);
      continue;
    end;

    if Goptions.clips[i]='_' then
    Goptions.clips[i] := ' ';
    Goptions.clips[i] :=
    AnsiReplaceStr(Goptions.clips[i],equals,'=');

    inc(i);
  end;

end;


{****************************************************************************
****************************************************************************}
{$ifdef MSWINDOWS}

function vista_dir:boolean;
const
INSTALL_KEY = 'win_install';
INSTALL_NOT = INSTALL_KEY + '.not';
V_DIR = 'os_data';

var
help_src, help_dst,
appdata:string;

//x_copy : boolean;

  procedure c_i(who:string);
  begin
    if FileAge(pgmdir+who) > FileAge(datadir+who) then
    //update only!
    os_fcopy(pgmdir+who,datadir+who);
  end;

  procedure copyhelp(kind:string);
  var
  f:TSearchRec;
  r:integer;

  begin

    r := FindFirst(help_src+kind,faAnyFile,f);
    while (r=0) do begin
      if FileAge(help_src+f.name) > FileAge(help_dst+f.name) then
//forgot to do that until Wed 5/19/2010 7:14 pm.
      os_fcopy(help_src+f.name,help_dst+f.name);
      r := FindNext(f);
    end;

  end;

begin

  result := false;  //assume failure.

  if FileExists(pgmdir+INSTALL_NOT) then
  exit;   //no vista for me please....
{****************************************************************************
Wed 12/03/2008 3:03 pm. The code below copies the files *if they're newer*
everytime OwenShow starts if the file WIN_INSTALL exists. This is wasteful,
but probably not much, and who cares? It's vista. ... Anyway, this is a way to
still use the wonderful Windows install mechanism but *not* use a data
directory even %APPDATA% exists: by making sure a  file WIN_INSTALL.NOT exists
in "\program files\OwenShow".
****************************************************************************}


  appdata:=GetEnvironmentVariable('APPDATA');

//  x_copy := false;

  if FileExists(pgmdir+INSTALL_KEY)
{****************************************************************************
Thu 8/02/2007 1:36 pm. in the Official Winders Install version of OwenShow, I
deliberately include this empty file INSTALL_KEY = "win_install" (probably).
So this code can tell it's being Officially Winders Installed. The other
methods of install, like exploding it in the directory, copying it from your
thumb drive, etc., presumably won't have this file. If it does, however, it'll
try to do this data directory dance.
****************************************************************************}

  and (appdata<>'') then begin
    appdata := fslash(appdata) + V_DIR;
    if not DirectoryExists(appdata) then begin
      mkdir(appdata);
//      x_copy := true;
    end;

//now set-up for copyhelp.
    help_dst := fslash(appdata) + helpdir;
    help_src := pgmdir(true) + fslash(helpdir);
//    x_copy := true;   //always. we'll udpate.

    if not DirectoryExists(help_dst) then
    mkdir(help_dst);

    if not
    DirectoryExists(help_dst)
    then
    exit;   //with failure. That is, use files in "program files\owenshow"
            //etc.

{****************************************************************************
Thu 6/21/2007 5:44 pm. vista didn't like me storing all the data in the
program directory, bad bad program....
****************************************************************************}

    result := true;   //vickery!

    datadir := fslash(appdata);   //set the global datadir.

    slash(help_dst);    //remember to put on the slash.


    c_i('faq'               );
    copyhelp('*.htm');
    copyhelp('*.png');
    copyhelp('*.jpg');
    copyhelp('*.gif');
    c_i('JGO_SMAL.FON'      );
    c_i('layout_big.ini'    );
    c_i('osex.ini'          );
    c_i('os_src.zip'        );
    c_i('OwenShowFonts'     );
    c_i('readme.txt'        );
    c_i('splash.png'        );
    c_i('version.txt'       );
    c_i('win_install'       );


  end;


end;

{$endif}

{****************************************************************************
****************************************************************************}

procedure getpathpurge;
var
i:integer;
section:string;

begin

  section := IniFile.ReadString(sec(mainname),'pathpurge','');
  if section='' then
  exit;

  IniFile.ReadSection(section,Goptions.pathpurge);

  i := 0;
  while i < Goptions.pathpurge.count do begin
    if not IniFile.ReadBool(section,Goptions.pathpurge[i],false) then
    Goptions.pathpurge.delete(i)  //off =0 etc.
    else
    inc(i);
  end;

end;

{****************************************************************************
****************************************************************************}

procedure getoptions;
var
s:string;

{$ifdef LINUX}
const
os_evar:string = '';
os_code:string = '';
os_path:string = '';
{$endif}

begin


  originaldir := getcurrentdir;

  getcmdline;

  if Gexitnow then
  exit;

  if length(datadir)<1 then begin
    {i.e., not specified on command-line.}
{$ifdef MSWINDOWS}
    if (not vista_dir) then
{$endif}
    datadir := fslash(pgmdir);
  end;

{$ifdef PGMDIRIZE_HELPDIR}
//perform runtime initialization *before* we try getting user spec.
//should be ok therefore. Hmmph hmmph.

//  pgmdirize(helpdir);
  datadirize(helpdir);
//for vista! for vista!

  Goptions.helphtm :=
//  'file:///'+ //special firefox wednesday mumbo jumbo?
//didn't help. Firefox sick today. // oh it's probably a good idea.
//so now I'm going to try and programdirize the helpdir.
// chrome works. To hoo with it. We shellexec with a full path.

  helpdir + slashchar + 'ohelpfrm.htm';
  Goptions.helpjs := helpdir + slashchar + 'owenshow.js';

{$ifdef DONT_BOTHER}  //didn't help anyway, with ff.
  Goptions.helphtm :=
  StringReplace(Goptions.helphtm,'\','/',[rfReplaceAll]);

  Goptions.helpjs :=
  StringReplace(Goptions.helpjs,'\','/',[rfReplaceAll]);
{$endif}

{$endif}



  chdir(datadir);

  openinifile;




  if IniFile <> Nil then begin

{****************************************************************************
DON'T PUT THINGS HERE!!!! PUT THEM AFTER "LINUX" and "section"
****************************************************************************}
{****************************************************************************
****************************************************************************}

{$ifdef LINUX}
{provides the same functionality as "section=" except it isn't compile except
in the acheral Linux version. So I can just leave the thing in there.}

    s :=
    IniFile.ReadString(sec(mainname),'LINUX','');
    if length(s)>0 then
    section := s;

{$endif}

{first, get the desired section, if any. // no no do this AFTER the linux
trick; so they can use it *in* the Linux section if desired.}
    section :=
    IniFile.ReadString(sec(mainname),'section',section);

{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
PUT NEW THINGS HERE!!!
****************************************************************************}

    getpathpurge;

    Goptions.autodir :=
    IniFile.ReadBool(sec(mainname),'autodir',
    Goptions.autodir);

    Goptions.name :=
    IniFile.ReadString(sec(mainname),'name',
//    Goptions.name
    OwenShowID
    );

    Goptions.ossize :=
    IniFile.ReadString(sec(mainname),'ossize',Goptions.ossize);

    Goptions.osfonts :=
    IniFile.ReadString(sec(mainname),'osfonts',Goptions.osfonts);

    Goptions.oslog :=
    IniFile.ReadString(sec(mainname),'oslog',Goptions.oslog);

    Goptions.logclose :=
    IniFile.ReadBool(sec(mainname),'logclose',Goptions.logclose);

    Goptions.fontfun :=
    IniFile.ReadBool(sec(mainname),'fontfun',Goptions.fontfun);

    Goptions.fontfun17 :=
    IniFile.ReadString(sec(mainname),'fontfun17',Goptions.fontfun17);

{$ifdef LOG_SCAN}
    Goptions.scanlog :=
    IniFile.ReadBool(sec(mainname),'scanlog',Goptions.scanlog);
{$endif}

{quickcopy options}
    Goptions.fullpath :=
    IniFile.ReadBool(sec(mainname),'fullpath',Goptions.fullpath);

    Goptions.trailingslash :=
    IniFile.ReadBool(sec(mainname),'trailingslash',Goptions.trailingslash);

    Goptions.short :=
    IniFile.ReadBool(sec(mainname),'short',Goptions.short);

    Goptions.quotes :=
    IniFile.ReadBool(sec(mainname),'quotes',Goptions.quotes);

    Goptions.data :=
    IniFile.ReadBool(sec(mainname),'data',Goptions.data);

    Goptions.cute :=
    IniFile.ReadBool(sec(mainname),'cute',Goptions.cute);


{-----------------}

    Goptions.alwayshome :=
    IniFIle.ReadInteger(sec(mainname),'alwayshome',Goptions.alwayshome);
    intrange(0,2,Goptions.alwayshome);

{****************************************************************************
I want this here so various other weird parts of the system can know these
things.
****************************************************************************}
    Goptions.os := NoOS;

    s :=
    IniFile.ReadString(sec(mainname),'osystem','');

    ostag := s;

    if CompareText(copy(s,1,2),'w9')=0 then
    Goptions.os := w9x
    else if CompareText(s,'xp')=0 then
    Goptions.os := xp
    else if CompareText(s,'linux')=0 then
    Goptions.os := linux
    else if CompareText(s,none)=0 then begin
    end
{$ifdef MSWINDOWS}
    else begin
//      ostag := 'unknown';
      if os_isw9x then begin
        Goptions.os := w9x;
        ostag := 'w9x';
      end else begin
        Goptions.os := xp;
        ostag := 'xp';
      end
    end
{$endif}
{$ifdef LINUX}
    else begin
      ostag := 'linux';
      Goptions.os := linux;
    end
{$endif}
    ;

{****************************************************************************
let's gather together all these things here
****************************************************************************}
    case Goptions.os of
      w9x: Goptions.dir_fix_scroll := 2;

{$ifndef ALWAYS_HALT}
      XP, Linux: Goptions.halt := true;
{$endif}

    end;

{****************************************************************************
this nonsense has to be BEFORE gettrees, because gettrees uses it. Well some
of it, anyway.
****************************************************************************}
{$ifdef MSWINDOWS}
    Goptions.owenshow_drive :=
    IniFile.ReadString(sec(mainname),'owenshow_drive',
    Goptions.owenshow_drive);

    Goptions.gates_sux :=
    IniFile.ReadString(sec(mainname),'gates_sux',
    Goptions.gates_sux);

    Goptions.add_gates_exec :=
    IniFile.ReadBool(sec(mainname),'add_gates_exec',
    Goptions.add_gates_exec);

{$endif}

    Goptions.owenshow_path :=
    IniFile.ReadString(sec(mainname),'owenshow_path',
    Goptions.owenshow_path);

    Goptions.add_path :=
    IniFile.ReadString(sec(mainname),'add_path',
    Goptions.add_path);

{$ifdef MSWINDOWS}
    datadrive := tolower(datadir[1]);
    files_rut[1] := datadrive;
  //init the thing in main.

    if length(Goptions.owenshow_drive)>0 then
    win_putenv(Goptions.owenshow_drive,datadrive);

    if length(Goptions.owenshow_code)>0 then
    win_putenv(Goptions.owenshow_code,pgmdir(false));

    if length(Goptions.owenshow_path)>0 then
    win_putenv(Goptions.owenshow_path,fdeslash(datadir));

    if length(Goptions.add_path)>0 then begin
      Goptions.add_path := evarize(Goptions.add_path);
      //so he can use os_p mebbe.

      s := getenvironmentvariable('PATH');
      if length(s)>0 then
      s := s + ';';

      if length(Goptions.add_path)>0 then
      s := s + Goptions.add_path;

      win_putenv('PATH',s);

    end;

{$endif}

{$ifdef LINUX}
{****************************************************************************
the os_evar is because, apparently, putenv actually sticks the string
itself into the environment, so I had to concoct a Delphi const up there --
and that fixed it! That *is* dumb.... Anyway with just the local variable -- I
was just passing the output of the safe_format function -- "echo $os_p"
echoed nothing, but with it, it properly echoed the owenshow dir path. Ad
astra, eh?
****************************************************************************}
    if length(Goptions.owenshow_path)>0 then begin
      os_evar := safe_format('%s=%s',[Goptions.owenshow_path,
      fdeslash(datadir)]);
      putenv(pchar(os_evar));
    end;

    if length(Goptions.owenshow_code)>0 then begin
      os_code := safe_format('%s=%s',
      [Goptions.owenshow_code,pgmdir(false)]);
      putenv(pchar(os_code));
    end;

    if length(Goptions.add_path)>0 then begin
      Goptions.add_path := evarize(Goptions.add_path);
      //so he can use os_p mebbe.

      os_path := getenv('PATH');
      if length(os_path)>0 then
      os_path := os_path + ':';
      //deal with a completely empty path neatly.

      os_path := os_path+Goptions.add_path;

      os_path := safe_format('PATH=%s',
      [os_path]);

      putenv(pchar(os_path));
    end;

{$endif}

    Goptions.otherdir :=
    IniFile.ReadBool(sec(mainname),'otherdir',
    Goptions.otherdir);

    Goptions.xinfo :=
    IniFile.ReadInteger(sec(mainname),'xinfo',Goptions.xinfo);

    Goptions.xinfo_skip :=
    IniFile.ReadInteger(sec(mainname),'xinfo_skip',Goptions.xinfo_skip);

    Goptions.xinfo_big :=
    IniFile.ReadInteger(sec(mainname),'xinfo_big',Goptions.xinfo_big);

    case Goptions.os of
      w9x: Goptions.retry_wait := 2000;
      xp:  Goptions.retry_wait := -1;
    end;

    Goptions.retry_wait := IniFile.ReadInteger(sec(mainname),'retry_wait',
    Goptions.retry_wait);

    gettrees;

    Goptions.treeifo :=
    IniFile.ReadString(sec(mainname),'readifo',Goptions.treeifo);
    Goptions.treeifo := evarize(Goptions.treeifo);
    datadirize(Goptions.treeifo);

    figger_whichtree;

    Goptions.scantalk :=
    IniFile.ReadBool(sec(mainname),'scantalk',Goptions.scantalk);

    Goptions.casesort :=
    IniFile.ReadBool(sec(mainname),'casesort',Goptions.casesort);

{    Goptions.filestart :=
    IniFIle.Readbool(sec(mainname),'filestart',Goptions.filestart);  }

    Goptions.spacebreak:=
    IniFIle.Readbool(sec(mainname),'spacebreak',Goptions.spacebreak);

{    Goptions.width :=
    IniFile.ReadInteger(sec(mainname),'width',Goptions.width);

    Goptions.height :=
    IniFile.ReadInteger(sec(mainname),'height',Goptions.height);  }

    set_key(Goptions.recall_save_layout,
    Inifile.ReadString(sec(mainname),'recall_save_layout','')
    );

    set_key(Goptions.recall_main_layout,
    IniFile.ReadString(sec(mainname),'recall_main_layout','')
    );

    set_key(Goptions.nextkey,
    Inifile.ReadString(sec(mainname),'nextkey','')
    );

    set_key(Goptions.markon,
    Inifile.ReadString(sec(mainname),'markon','')
    );

    set_key(Goptions.markoff,
    Inifile.ReadString(sec(mainname),'markoff','')
    );

    set_key(Goptions.delete,
    IniFile.ReadString(sec(mainname),'delete',''));

    set_key(Goptions.move,
    IniFile.ReadString(sec(mainname),'move',''));

    set_key(Goptions.rename,
    IniFile.ReadString(sec(mainname),'rename',''));

    set_key(Goptions.copy,
    IniFile.ReadString(sec(mainname),'copy',''));

    set_key(Goptions.describe,
    IniFile.ReadString(sec(mainname),'describe',''));

    set_key(Goptions.scan,
    IniFIle.ReadString(sec(mainname),'scan',''));

    set_key(Goptions.help,
    IniFile.ReadString(sec(mainname),'help',''));

    set_key(Goptions.create,
    IniFile.ReadString(sec(mainname),'create',''));

    set_key(Goptions.markall,
    IniFile.ReadString(sec(mainname),'markall',''));

    set_key(Goptions.unmarkall,
    IniFile.ReadString(sec(mainname),'unmarkall',''));

    set_key(Goptions.markstars,
    IniFile.ReadString(sec(mainname),'markstars',''));

    set_key(Goptions.marktop,
    IniFile.ReadString(sec(mainname),'marktop',''));

    set_key(Goptions.markbottom,
    IniFile.ReadString(sec(mainname),'markbottom',''));

    set_key(Goptions.unmarkstars,
    IniFile.ReadString(sec(mainname),'unmarkstars',''));

    set_key(Goptions.stuff,
    IniFile.ReadString(sec(mainname),'stuff',''));

    set_key(Goptions.stufftop,
    IniFile.ReadString(sec(mainname),'stufftop',''));

    set_key(Goptions.flip,
    IniFile.ReadString(sec(mainname),'flip',''));

    set_key(Goptions.gotodir,
    IniFile.ReadString(sec(mainname),'gotodir',''));

    set_key(Goptions.literal,
    IniFile.ReadString(sec(mainname),'literal',''));

    set_key(Goptions.exec,
    IniFile.ReadString(sec(mainname),'exec',''));

    set_key(Goptions.execform,
    IniFile.ReadString(sec(mainname),'execform',''));

    set_key(Goptions.TreeKey,
    IniFIle.ReadString(sec(mainname),'tree',''));

    set_key(Goptions.fixfiles,
    IniFile.ReadString(sec(mainname),'fixfiles',''));

    set_key(Goptions.sortName,
    IniFile.ReadString(sec(mainname),'sortname',''));

    set_key(Goptions.sortExt,
    IniFile.ReadString(sec(mainname),'sortext',''));

    set_key(Goptions.sortSize,
    IniFile.ReadString(sec(mainname),'sortsize',''));

    set_key(Goptions.sortDate,
    IniFile.ReadString(sec(mainname),'sortdate',''));

    set_key(Goptions.sortNot,
    IniFile.ReadString(sec(mainname),'sortnot',''));

    set_key(Goptions.quickcopy,
    IniFile.ReadString(sec(mainname),'quickcopy',''));

    set_key(Goptions.quickcopy,
    IniFile.ReadString(sec(mainname),'super_quickcopy',''));

    set_key(Goptions.cuteify,
    IniFile.ReadString(sec(mainname),'cuteify',''));

    set_key(Goptions.etc,
    IniFile.ReadString(sec(mainname),'etc',''));

    set_key(Goptions.mark,
    IniFile.ReadString(sec(mainname),'mark',''));

{****************************************************************************
****************************************************************************}

    set_key(Goptions.file_rescan,
    IniFIle.ReadString(sec(mainname),'file_rescan',''));

{$ifdef EXACT_STUPID_STUPID}
    set_key(Goptions.dir_exact,
    IniFile.ReadString(sec(mainname),'dir_exact',''));

    if same_key(Goptions.file_rescan,Goptions.dir_exact) then begin
    //check dir_exact_anyway only if they're the same key.
      Goptions.dir_exact_anyway :=
      IniFile.ReadBool(sec(mainname),'dir_exact_anyway',
      Goptions.dir_exact_anyway);
    end

    else

    Goptions.dir_exact_anyway := true;

    Gcheck_file_rescan_in_dir :=
    same_key(Goptions.file_rescan,Goptions.dir_exact) or
    (not Goptions.dir_exact_anyway);

{$endif}

    set_key(Goptions.exact,
    IniFile.ReadString(sec(mainname),'exact',''));

{****************************************************************************
****************************************************************************}

    set_key(Goptions.bigvisit,
    IniFile.ReadString(sec(mainname),'bigvisit',''));

    Goptions.del_dir :=
    IniFile.ReadString(sec(mainname),'del_dir','');


    slash(Goptions.del_dir);
{$ifdef MSWINDOWS}
    Goptions.del_dir := fdedrive(Goptions.del_dir);
{$endif}

{$ifdef LINUX}
    if isdel_dir then begin
      if (not DirectoryExists(Goptions.del_dir)) then begin
        errorf('deletedir "%s" doesn''t exist; removing',[Goptions.del_dir]);
        Goptions.del_dir := '';
      end
      else
      Gdel_id := disk_id(fdeslash(Goptions.del_dir))
    end;
{$endif}
{$ifdef MSWINDOWS}
    if isdel_dir and (not DirectoryExists(Goptions.del_dir)) then begin
      errorf('deletedir "%s" doesn''t exist; removing',[Goptions.del_dir]);
      Goptions.del_dir := '';
    end;
{$endif}

    Goptions.sortmax :=
    IniFile.ReadInteger(sec(mainname),'sortmax',Goptions.sortmax);

    Goptions.scanmax :=
    IniFile.ReadInteger(sec(mainname),'scanmax',Goptions.scanmax);

    Goptions.allowdelete :=
    IniFile.ReadBool(sec(mainname),'allowdelete',Goptions.allowdelete);

    if IniFile.ReadBool(sec(mainname),'mkdir',       false) then
    Goptions.deletes := Goptions.deletes + [OSmkdir         ];

    if IniFile.ReadBool(sec(mainname),'rendir'      ,false) then
    Goptions.deletes := Goptions.deletes + [OSrendir        ];

    if IniFile.ReadBool(sec(mainname),'deletedir'   ,false) then
    Goptions.deletes := Goptions.deletes + [OSdeletedir     ];

    if IniFile.ReadBool(sec(mainname),'os_fCopy'    ,false) then
    Goptions.deletes := Goptions.deletes + [OSCopyFile      ];

    if IniFile.ReadBool(sec(mainname),'os_fMove'    ,false) then
    Goptions.deletes := Goptions.deletes + [OSMoveFile      ];

    if IniFile.ReadBool(sec(mainname),'renamefile'  ,false) then
    Goptions.deletes := Goptions.deletes + [OSrenamefile    ];

    if IniFile.ReadBool(sec(mainname),'deletefile' ,false) then
    Goptions.deletes := Goptions.deletes + [OSdeletefile    ];

    Goptions.wreck :=
    IniFile.ReadBool(sec(mainname),'wreck',Goptions.wreck);

{    Goptions.xlate :=
    IniFile.ReadBool(sec(mainname),'xlate',Goptions.xlate);  }
    //Wednesday, August 18, 2004 6:53 pm. i'm not sure why I commented
    //this out. // it's in help.a.

    Goptions.debugscan :=
    IniFile.ReadBool(sec(mainname),'debugscan',Goptions.debugscan);

    Goptions.scanlevels :=
    IniFile.ReadInteger(sec(mainname),'scanlevels',Goptions.scanlevels);

    Goptions.currentdir :=
    IniFile.ReadBool(sec(mainname),'currentdir',Goptions.currentdir);

    Goptions.halt :=
    IniFile.ReadBool(sec(mainname),'halt',Goptions.halt);

    if Goptions.os=w9x then
    Goptions.non_modaldelay := 1000;
    //default it to 1 second if w98....

    Goptions.non_modaldelay :=
    IniFile.ReadInteger(sec(mainname),'non_modaldelay',
    Goptions.non_modaldelay);

    Goptions.execkey_delay :=
    IniFile.ReadInteger(sec(mainname),'execkey_delay',
    Goptions.execkey_delay);

    Goptions.reread_enable :=
    IniFile.ReadBool(sec(mainname),'reread_enable',Goptions.reread_enable);

    Goptions.reread :=
    IniFile.ReadInteger(sec(mainname),'reread',Goptions.reread);

    Goptions.rereadwait :=
    IniFile.ReadInteger(sec(mainname),'rereadwait',Goptions.rereadwait);

    getexecs;

    getinserts;

    getskips;

    Goptions.stupid_yes :=
    IniFile.ReadBool(sec(mainname),'stupid_yes',Goptions.stupid_yes);

    Goptions.antiskid_time :=
    IniFile.ReadInteger(sec(mainname),'antiskid_time',
    Goptions.antiskid_time);

    Goptions.antiskid :=
    IniFile.ReadInteger(sec(mainname),'antiskid',Goptions.antiskid);

    Goptions.disablenot :=
    IniFile.ReadBool(sec(mainname),'disablenot',Goptions.disablenot);

{    Goptions.keymult :=
    IniFile.ReadInteger(sec(mainname),'keymult',Goptions.keymult); }

    Goptions.ontop :=
    IniFile.ReadInteger(sec(mainname),'ontop',Goptions.ontop);

    getsort;

    Goptions.enabledelay :=
    IniFile.ReadInteger(sec(mainname),'enabledelay',
    Goptions.enabledelay);

{    Goptions.top :=
    IniFile.ReadInteger(sec(mainname),'top',
    Goptions.top);

    Goptions.left :=
    IniFile.ReadInteger(sec(mainname),'left',
    Goptions.left);  }

    Goptions.hintdelay :=
    IniFile.ReadInteger(sec(mainname),'hintdelay',
    Goptions.hintdelay);

    s :=
    lowercase(IniFile.ReadString(sec(mainname),'cumulativestop','alt_control'));

    with Goptions do
    if s='off' then begin
      control_stop := false;
      alt_stop := false;
    end else if s='alt' then begin
      control_stop := false;
      alt_stop := true;
    end else if s='control' then begin
      control_stop := true;
      alt_stop := false;
    end else begin
      control_stop := true;
      alt_stop := true;
    end;

    Goptions.driveinfo :=
    IniFile.ReadString(sec(mainname),'driveinfo',Goptions.driveinfo);

{$ifdef CHECK_TREE_DRIVE}
    Goptions.check_tree_drive :=
    IniFile.ReadBool(sec(mainname),'check_tree_drive',
    Goptions.check_tree_drive);
{enables peculiar bug-checking for a bug which may no longer exist.}
{$endif}

    Goptions.control_enter_flip :=
    IniFile.ReadBool(sec(mainname),'control_enter_flip',
    Goptions.control_enter_flip);

{$ifdef MSWINDOWS_NO_doit_in_layout}
    Goptions.dir_creationtime :=
    IniFile.ReadBool(sec(mainname),'dir_creationtime',
    Goptions.dir_creationtime);
{$endif}

    Goptions.dir_fix_time :=
    IniFile.ReadInteger(sec(mainname),'dir_fix',
    Goptions.dir_fix_time);

    Goptions.dir_fix := Goptions.dir_fix_time>0;

    if Goptions.dir_fix_time=1 then
    Goptions.dir_fix_time := dir_fix_default;

    Goptions.dir_fix_more :=
    IniFile.ReadBool(sec(mainname),'dir_fix_more',
    Goptions.dir_fix_more);

    Goptions.dir_fix_scroll :=
    IniFile.ReadInteger(sec(mainname),'dir_fix_scroll',
    Goptions.dir_fix_scroll);

    Goptions.dir_page :=
    IniFile.ReadInteger(sec(mainname),'dir_page',
    Goptions.dir_page);

    Goptions.drivelist :=
    IniFile.ReadBool(sec(mainname),'drivelist',
    Goptions.drivelist);

    Goptions.throttle_wait :=
    IniFile.ReadInteger(sec(mainname),'throttle_wait',
    Goptions.throttle_wait);

    intrange(1,99,Goptions.dir_page);

    Goptions.os_instructions :=
    IniFile.ReadString(sec(mainname),'os_instructions',
    Goptions.os_instructions);

    Goptions.upsort :=
    IniFile.ReadBool(sec(mainname),'upsort',Goptions.upsort);

    Goptions.click_upsort :=
    IniFile.ReadBool(sec(mainname),'click_upsort',Goptions.click_upsort);

    datadirize(Goptions.os_instructions);

{$ifdef LINUX}
    Goptions.nop_name :=
    IniFile.ReadString(sec(mainname),'nop',Goptions.nop_name);

    pgmdirize(Goptions.nop_name);
//    datadirize(Goptions.nop_name);
{****************************************************************************
No no; *datadirize* the nop we MAKE up (in checknop below somewhere); not the
old-fashioned *distributed* program; that one's installed with the OwenShow
executable in the program directory.
****************************************************************************}

//    Goptions.show_cancel :=
//    IniFile.ReadBool(sec(mainname),'show_cancel',Goptions.show_cancel);
{$endif}

    Goptions.dirmark :=
    IniFile.ReadBool(sec(mainname),'dirmark',Goptions.dirmark);

    Goptions.clickscan :=
    IniFile.ReadBool(sec(mainname),'clickscan',Goptions.clickscan);

    Goptions.checkspeed :=
    IniFile.ReadInteger(sec(mainname),'checkspeed',Goptions.checkspeed);

    Goptions.fixtoolong :=
    IniFile.ReadInteger(sec(mainname),'fixtoolong',Goptions.fixtoolong);

{$ifdef MSWINDOWS}
//gotta be before checkmod/resize_rate, *after* os_ize call.
    if Goptions.os = w9x then begin
      Goptions.checkmod := -2;  //make it slower for w98.
//      Goptions.rereadwait := 700; //etc.
      Goptions.resize_rate := 333;  //default for w98.
    end;
{$endif}

    Goptions.checkmod := IniFile.ReadInteger
    (sec(mainname),'checkmod',Goptions.checkmod);

    Goptions.dontfixcheck :=
    IniFile.ReadBool(sec(mainname),'dontfixcheck',Goptions.dontfixcheck);

    Goptions.visited_delete_level :=
    IniFile.ReadInteger(sec(mainname),'visited_delete_level',
    Goptions.visited_delete_level);

    Goptions.enter_top :=
    IniFile.ReadBool(sec(mainname),'enter_top',
    Goptions.enter_top);

//    Goptions.short_menu :=
//    IniFile.ReadBool(sec(mainname),'short_menu',
//    Goptions.short_menu);
//it's done in font fun now Thursday, August 11, 2005 4:18 pm.

    Goptions.zerotime :=
    Inifile.ReadBool(sec(mainname),'zerotime',
    Goptions.zerotime);

//    Goptions.permissions :=
//    IniFile.ReadString(sec(mainname),'permissions',
//    Goptions.permissions);

//    Goptions.treelineadjust :=
//    IniFile.ReadInteger(sec(mainname),'treelineadjust',
//    Goptions.treelineadjust);


    Goptions.dbytes :=
    Inifile.ReadBool(sec(mainname),'dbytes',
    Goptions.dbytes);

{$ifdef LINUX}
    Goptions.renamestarqmark :=
    IniFile.ReadBool(sec(mainname),'rename*?',
    Goptions.renamestarqmark);
{$endif}

    Goptions.inversionmessage :=
    IniFile.ReadBool(sec(mainname),'inversionmessage',
    Goptions.inversionmessage);

    Goptions.grafinfo :=
    IniFile.ReadBool(sec(mainname),'grafinfo',
    Goptions.grafinfo);

    Goptions.grafselect :=
    IniFile.ReadBool(sec(mainname),'grafselect',
    Goptions.grafselect);

    Goptions.getsizes_anyway :=
    IniFile.ReadBool(sec(mainname),'getsizes_anyway',
    Goptions.getsizes_anyway);

    Goptions.copy_error_stop :=
    IniFile.ReadBool(sec(mainname),'copy_error_stop',
    Goptions.copy_error_stop);

    Goptions.formguard :=
    IniFile.ReadBool(sec(mainname),'formguard',
    Goptions.formguard);

    Goptions.keyabort :=
    IniFile.ReadBool(sec(mainname),'keyabort',
    Goptions.keyabort);

    Goptions.show_original_fonts :=
    IniFile.ReadBool(sec(mainname),'show_original_fonts',
    Goptions.show_original_fonts);

    Goptions.mkdirsearch :=
    IniFile.ReadBool(sec(mainname),'mkdirsearch',
    Goptions.mkdirsearch);

    Goptions.cumulative_time :=
    IniFile.ReadInteger(sec(mainname),'cumulative_time',
    Goptions.cumulative_time);

    Goptions.cumulative_dir_delay :=
    IniFile.ReadInteger(sec(mainname),'cumulative_dir_delay',
    Goptions.cumulative_dir_delay);

//    Goptions.layout_position :=
//    IniFile.ReadBool(sec(mainname),'layout_position',
//    Goptions.layout_position);
//it's a check etc menu now.

{$ifdef LINUX}
    Goptions.dontfix_kylix_positions :=
    IniFile.ReadBool(sec(mainname),'dontfix_kylix_positions',
    Goptions.dontfix_kylix_positions);

    Goptions.kylixleft :=
    IniFile.ReadInteger(sec(mainname),'kylixleft',
    Goptions.kylixleft);

    Goptions.kylixtop :=
    IniFile.ReadInteger(sec(mainname),'kylixtop',
    Goptions.kylixtop);

    Goptions.kylixcount :=
    IniFile.ReadInteger(sec(mainname),'kylixcount',
    Goptions.kylixcount);

{$endif}

    Goptions.edir_name :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_name',
    Goptions.edir_name)
    );

    Goptions.edir_tag :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_tag',
    Goptions.edir_tag)
    );

    Goptions.edir_midtag :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_midtag',
    Goptions.edir_midtag)
    );

    Goptions.edir_endtag :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_endtag',
    Goptions.edir_endtag)
    );

    Goptions.edir_skips :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_skips',
    Goptions.edir_skips)
    );

    Goptions.edir_skip_chars :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_skip_chars',
    Goptions.edir_skip_chars)
    );

    Goptions.edir_seedot :=
    evarize(
    IniFile.ReadString(sec(mainname),'edir_seedot',
    Goptions.edir_seedot)
    );

    Goptions.edir_ext :=
    IniFile.ReadBool(sec(mainname),'edir_ext',
    Goptions.edir_ext);

    Goptions.edir_selectanyway :=
    IniFile.ReadBool(sec(mainname),'edir_selectanyway',
    Goptions.edir_selectanyway);

    Goptions.edir_see :=
    IniFile.ReadBool(sec(mainname),'edir_see',
    Goptions.edir_see);

    Goptions.edir_dot :=
    IniFile.ReadBool(sec(mainname),'edir_dot',
    Goptions.edir_dot);


    set_key(Goptions.edir_key,
    IniFile.ReadString(sec(mainname),'edir_key','')
    );


    Goptions.edir_exec :=
    get_edit_exec(
    evarize(
    IniFile.ReadString(sec(mainname),'edir_exec','')),
    Goptions.edir_name
    );

    s := evarize(Inifile.ReadString(sec(mainname),'edir_scan',''));

    Goptions.edir_scan := edir_scan_both; //default.

         if s='both' then
    Goptions.edir_scan := edir_scan_both
    else if s='before' then
    Goptions.edir_scan := edir_scan_before
    else if s='after' then
    Goptions.edir_scan := edir_scan_after
    else if s='never' then
    Goptions.edir_scan := edir_scan_never
    else begin
      if sbrs.isdigit(es(s,1)) then
      Goptions.edir_scan := JgoStrToInt(s);
    end;

    get_edir_skips; //do it after the other edir options.

    getVisitDirs;

    getclips;
    set_key(Goptions.clips_key,
    IniFile.ReadString(sec(mainname),'clips_key',''));

{$ifdef LINUX}
//    Goptions.numeric_atts :=
//    IniFile.ReadBool(sec(mainname),'numeric_atts',Goptions.numeric_atts);
//save/restore with layout.

    set_key(Goptions.numeric_key,
    IniFile.ReadString(sec(mainname),'numeric_key',''));
{$endif}

    Goptions.debug := IniFile.ReadBool(sec(mainname),'debug',Goptions.debug);

    Goptions.tricky_inhibit_timer :=
    IniFile.ReadInteger(sec(mainname),'tricky_inhibit_timer',
    Goptions.tricky_inhibit_timer);

    Goptions.ext_field :=
    IniFile.ReadInteger(sec(mainname),'ext_field',
    Goptions.ext_field);

{$if defined(LINUX)}
    Goptions.LinuxExecWait :=
    IniFile.ReadInteger(sec(mainname),'LinuxExecWait',
    Goptions.LinuxExecWait);
{$ifend}

    Goptions.minutesversion :=
    IniFile.ReadBool(sec(mainname),'minutesversion',
    Goptions.minutesversion);

    Goptions.linux_time :=
    IniFile.ReadBool(sec(mainname),'linux_time',
    Goptions.linux_time);

    Goptions.linux_timer :=
    IniFile.ReadInteger(sec(mainname),'linux_timer',
    Goptions.linux_timer);

    if Goptions.linux_timer = 0 then
    Goptions.linux_time := false;

    s := evarize(IniFile.ReadString(sec(mainname),'startup',''));
    Goptions.startup := getanexec(s);

    Goptions.alert :=
    IniFile.ReadString(sec(mainname),'alert',
    Goptions.alert);

{$ifdef MSWINDOWS}
    Goptions.delete_destination :=
    IniFile.ReadBool(sec(mainname),'delete_destination',
    Goptions.delete_destination);
{$endif}

    Goptions.layout_main :=
    IniFile.ReadString(sec(mainname),'layout_main',
    Goptions.layout_main);

    Goptions.execute_error :=
    IniFile.ReadBool(sec(mainname),'execute_error',
    Goptions.execute_error);

    Goptions.execute_check :=
    IniFile.ReadBool(sec(mainname),'execute_check',
    Goptions.execute_check);

    Goptions.execute_nil :=
    IniFile.ReadBool(sec(mainname),'execute_nil',
    Goptions.execute_nil);

    Goptions.dont_save_ok :=
    IniFile.ReadBool(sec(mainname),'dont_save_ok',
    Goptions.dont_save_ok);

    Goptions.jcopy_setting :=
    jcopy_string_value(
    evarize(
    IniFile.ReadString(sec(mainname),'jcopy',
    '')
    )
    );

    Goptions.jcopy_file :=
    evarize(
    IniFile.ReadString(sec(mainname),'jcopy_file',
    Goptions.jcopy_file)
    );

    Goptions.update_delay :=
    IniFile.ReadInteger(sec(mainname),'update_delay',
    Goptions.update_delay);

{$ifdef MSWINDOWS}
    Goptions.dont_uncolor :=
    IniFile.ReadBool(sec(mainname),'dont_uncolor',
    Goptions.dont_uncolor);
{$endif}

    Goptions.keepright :=
    IniFile.ReadBool(sec(mainname),'keepright',
    Goptions.keepright);


    Goptions.resize_rate :=
    IniFile.ReadInteger(sec(mainname),'resize_rate',
    Goptions.resize_rate);

    Goptions.dir_ext :=
    IniFile.ReadBool(sec(mainname),'dir_ext',
    Goptions.dir_ext);

    Goptions.edit_ini :=
    get_edit_exec(
    evarize(
    IniFile.ReadString(sec(mainname),'edit_ini','')),
    ininame,
    Goptions.edir_exec
    )
    ;

    set_key(Goptions.edit_ini_key,
    IniFile.ReadString(sec(mainname),'edit_ini_key','')
    );


{$if defined(LINUX)}
    Goptions.little_files :=
    Inifile.ReadBool(sec(mainname),'little_files',Goptions.little_files);
{$ifend}

    Goptions.helphtm :=
    fdatadirize
    (
    IniFile.ReadString(sec(mainname),'helphtm',Goptions.helphtm)
    );

    Goptions.helpexecute :=
    IniFile.ReadString(sec(mainname),'helpexecute',
    Goptions.helpexecute);

    Goptions.helpok :=
    IniFile.ReadBool(sec(mainname),'helpok',
    Goptions.helpok);

//this isn't optional; just datadirized.
    datadirize(Goptions.helpjs);

    Goptions.logexec :=
    IniFile.ReadBool(sec(mainname),'logexec',
    Goptions.logexec);

    Goptions.bewarned :=
    IniFile.ReadBool(sec(mainname),'bewarned',
    Goptions.bewarned);

    Goptions.error_clip :=
    IniFile.ReadBool(sec(mainname),'error_clip',
    Goptions.error_clip);

    closeinifile;
  end;

  fix_ext_field;  //options.pas.


  pgmdirize(Goptions.fontfun17);

{$ifdef nuthin}
//Tue 9/04/2007 12:26 pm. Do these when you get them!
  Goptions.edir_name :=       evarize(Goptions.edir_name);
  Goptions.edir_tag :=        evarize(Goptions.edir_tag);
  Goptions.edir_midtag :=     evarize(Goptions.edir_midtag);
  Goptions.edir_endtag :=     evarize(Goptions.edir_endtag);
  Goptions.edir_skip_chars := evarize(Goptions.edir_skip_chars);
  Goptions.edir_seedot :=     evarize(Goptions.edir_seedot);
{$endif}

  fixcheckspeed;

  fixfilecaptions;

  fixmarkset;

  Goptions.ossize := dir_inize(Goptions.ossize);
//  Goptions.ospref := dir_inize(Goptions.ospref);
  Goptions.layout_main :=
  punc_blr(extractFName(Goptions.layout_main));

  Goptions.osfonts := dir_inize(Goptions.osfonts);

  Goptions.oslog := dir_inize(Goptions.oslog);

  if Goptions.upsort then case Goptions.sort of
    name_descend: Goptions.sort := name_ascend;
     ext_descend: Goptions.sort :=  ext_ascend;
    size_descend: Goptions.sort := size_ascend;
    time_descend: Goptions.sort := time_ascend;
    atts_descend: Goptions.sort := atts_ascend;
  end;

{$ifdef RECYCLE}
  if (Goptions.os=w9x)
  and recycling then
  Gddir_n := 1; //it's SLOW...
{$endif}

{
  if not FileExists_unq(Goptions.pdsortx) then
  errorf('Sort program %s missing; won''t be able to sort directories',
  [Goptions.pdsortx]);
}
//  if Goptions.execs.indexof(Goptions.permissions)<0 then
//  Goptions.permissions := '';

{$ifdef LINUX}
  checknop;
{$endif}

{$ifdef MSWINDOWS}
  gates_sux;
{$endif}

end;

{$ifdef dontbother}
procedure putoptions;
var
i:integer;
begin

  if
  Gexitnow or Goptions.dontput then
  exit;


  chdir(datadir);

  openinifile;

  if IniFile<>Nil then begin
{just save all the homedirs I don't care anymore.}
    for i := 0 to Goptions.trees.count-1 do begin
      with Goptions.trees.objects[i] as Ttree do begin
        Inifile.Writestring(Goptions.trees[i],'homedir',
        homedir);
        Inifile.WriteString(goptions.trees[i],'otherdir',
        otherdir);
      end;
    end;

    closeinifile;
  end;

end;
{$endif}

procedure xfinal;
var
i:integer;
begin

  if skips<> nil then begin
//    skips.free;
//    skips := nil;
    FreeAndNil(skips);
  end;

  if Goptions.trees<>nil then begin
    for i :=0 to Goptions.trees.count-1 do begin
//      (Goptions.trees.objects[i] as TTree).exclude.free;
//should of course be in the destructor...
      (Goptions.trees.objects[i] as TTree).free;
    end;
    Goptions.trees.free;
  end;

  if Goptions.execs<>nil then begin
    for i := 0 to Goptions.execs.count-1 do
    Goptions.execs.objects[i].free;
    Goptions.execs.free;
  end;

//  if Gos_args<>nil then
//  Gos_args.free;
  FreeAndNil(Gos_args);

  FreeAndNil(Goptions.visitDirs);

  FreeAndNil(Goptions.edir_skip_list);

  FreeAndNil(Goptions.clips);

  FreeAndNil(Goptions.inserts);


  FreeAndNil(Goptions.edir_exec);
  FreeAndNil(Goptions.edit_ini);

  FreeAndNil(Goptions.pathpurge);

end;

{****************************************************************************
decode a key into a Tos_key (key code, shift) with the syntax like

^F1   control F1.
@F1   alt F1.
^;    control semicolon.
^@F1  alt control F1.

I think we'll skip shift for now. If the thing doesn't understand, it just
skips it. // No no we need shift. But what to use what to use!

|     Vertical rule is shift.
\     Escape.

So apparently the way this works is it just over-writes the key *only if
something is in s". That's not really a good idea Friday, August 9, 2002
6:41 pm

Fri 11/29/02 1:12 pm. badmenu: my delphi 7 doesn't offer ALT-LETTER as
short-cut options for menu items. I.e. @X is forbidden. So for those we will
discriminate. ALT-backspace is legal, but we'll just forbid that too. //
Although the sensible thing to do is just intercept the key with os_key,
use the xinit fixmenu startup thing to write the cute thing but not do
the shortcut, and ignore the shortcut mechanism on the menu. Since
it doesn't work. // Oh I see you can't actually fire these stupid
TmenuItem. Of course got it.... So of course the answer, *don't* use
the submenu feature, but fire an event and open your own form. Which,
I've discovered, I've done for every single menu item except one which I
will now clobber. Sigh.... // Well apparently I can shortcut the menu keys
*only* if the menu doesn't have a submenu; if it has a menu -- the only
straggler being etc -- I can only shortcut the menu key by putting an
ampersand in the caption. Because I care so little about the etc menu, I'm
going to create a special mechanism to fix the little jerk. // but then
Tuesday, August 12, 2003 11:09 am later I believe they're all fixed so
none of them have submenus. Right. So I think this badmenu thing is
a little derelict this week. So let's OFF_BADMENU [a remove conditional Thu
11/03/2005 2:40 pm]. So I did that, and nobody complained so obviously the
badmenu thingey has stopped being used.

****************************************************************************}

procedure set_key(var what:Tos_key; s:string);
var
x : integer;
t : Tshiftstate;
show : string;

const
empty_key :Tos_key = ();

begin
  if length(s)<1 then
  exit; {Friday, August 9, 2002 6:41 pm just leave it be }

  what := empty_key;
  {but otherwise, whack the heck out of it.}

  if s='empty' then
  exit;
  {i.e. a way to blank-out default-defined keys.}

  show := s; {save the original}

  t := [];

  while true do begin
    case es(s,1) of
      '|': begin
        t := t+[ssShift];
        s := copy(s,2,10000);
      end;

      '^': begin
        t := t+[ssCtrl];
        s := copy(s,2,10000);
      end;

      '@': begin
        t := t+[ssAlt];
        s := copy(s,2,10000);
      end;

      '\': begin
        s := copy(s,2,10000);
        break; {exits while.}
      end;
    else
      break; {exits while.}
    end;
  end;

  x := keyname_code(s);
  {check for predefined codes like F10 etc. including some of my pre-defined
  codes.}

  {so it was one of them.}
  if x>=0 then begin
    what.key := x;
    what.shift := t;
    what.show := show;
    exit;
  end;


  {is it some gobble-dygook?}
  if (length(s)<>1) then
  exit; {yes, dump it.}

{it's a single character, let 'em do what they want?}
  makeupper(s[1]);

  what.key := ord(s[1]);
  what.shift := t;
  what.show := show;

  if  (ssctrl in what.shift)
  and (what.key >= ord('A'))
  and (what.key <= ord('Z'))
  then
  dec(what.key,CTL);
  {that's the way XP did it Thursday, June 13, 2002 4:27 pm... But apparently
  it only does it to non-alpha char. ? On Tuesdays? // Thu 12/05/02 11:34 am.
  Dolt it does it because I fiddled-it in form1.os_keys. And now I've
  determined that it leaves *other* control characters alone. So to summarize;
  *I* make the control characters into 'A'-CTL etc. because Kylix Linux Delphi
  doesn't; but it *does* control-ize the other guys, i.e. like ^_.}


end;

function is_key(const what:Tos_key; key:Word; shift:Tshiftstate):boolean;
begin
{do special processing for + key. Cause u see + is shift =, and we use
it to mark things. Or something.s.}
  if (what.key=jgok_eq_pl)
  and (
  (key = ord('=')) or
  (key = ord('+'))
  )
  and (
  (shift=[]) or (shift=[ssshift])
  )
  then begin
    result := true;
    exit;
  end;

{
  if (key=key_plus) then begin
    key := key_equal;
    shift := [];
  end;   }

  result :=
  (what.key = key) and
  (what.shift = shift);
end;

function same_key(const one,two:Tos_key):boolean;
begin
  result :=
  is_key(one,two.key,two.shift);
end;

procedure fix_control(var Key: Word; Shift: TShiftState);
begin
  if (key>=ord('A')) and (key<=ord('Z')) and
  (ssctrl in shift)
//  (shift = [ssctrl])  //DON'T do it for @^? Tuesday, September 1, 2009 5:03 pm
//well it really *should* be that way -- but I'm leaving it the old way 'cause
//it hasn't blown-up in *weeks*!
  then
  dec(key,ctl);  {make it control key please I don't understand why.... for
  the pitiful little wordstar keys. Thu 12/05/02 11:16 am. Ok apparently the
  way Delphi does it is: ^A..^Z appear as keys A..Z with control set. *Other*
  control characters appear as control characters, ^\ for instance. Is that
  clear? }
end;

procedure unfix_control(var Key: Word; Shift: TShiftState);
begin
  if (key>=(ord('A')-CTL)) and (key<=(ord('Z')-CTL)) and (ssctrl in shift) then
  inc(key,ctl);
end;

function cantdelete(what:Tdeletes = OSother):boolean;
begin
  result := false;  {CAN delete}

  if
  Goptions.allowdelete or (what in Goptions.deletes) then
  exit;

  result := true;

  if osinfof('You have to set "allowdelete=1" in %s for this feature '+
  'to work (or one of the mkdir=1 etc. specific enables); see help',[ininame],
  osinfo_help)=osinfo_help then
  oshelp('Owenshow Won''t Delete')
  ;

end;

{****************************************************************************
****************************************************************************}


{$ifdef LINUX}
const
Raiter_true : array [1..45] of byte = (

$7F, $45, $4C, $46, $01, $00, $00, $00,
$00, $00, $00, $00, $00, $00, $5F, $25,
$02, $00, $03, $00, $B5, $FF, $EB, $02,
$0E, $00, $5F, $25, $04, $00, $00, $00,
$F2, $AE, $40, $8A, $5F, $FB, $20, $C3,
$CD, $80, $20, $00, $01

);

rtname = 'raiter_true';

{ Yes this is a small program, specifically true.asm by Brian Raiter. }

procedure checknop;
var
newnop : string;
write_result,
h:integer;
label
BADNESS;
begin
  if executize(Goptions.nop_name) then
  exit; //well it's there and executable.

{****************************************************************************
Tue 8/02/2005 11:16 am. It's not there; so let's make our own.

So look, I'm not trying to create the Linux "nop" program; that was provided
as part of the OwenShow distribution oh, *months* ago --but no longer.

So if there's no distributed nop, I'm going to make my *own* version, or check
if I did that already. I'll use rtname aka "raiter_true" after the admirable
Brian Raiter. This is explained some more in README.SRC; search for RAITER.
****************************************************************************}

  newnop := rtname;
  datadirize(newnop);
  {data dir so we have a better chance of writing it. based on the fantasy
  that I figured-out how to run OwenShow with a read/only binary directory
  and a local data directory. // Tue 8/02/2005 11:18 am. I actually did this
  right *months* before I ever got around to running OwenShow with a directory
  argument.}

  if executize(newnop) then begin
    //probably already did this.
    Goptions.nop_name := newnop;
    exit;
  end;

  h := StupidNewFile(newnop);

  if h<0 then
  goto BADNESS;   //who knows...

  write_result := FileWrite(h,Raiter_true,high(Raiter_true));

  FileClose(h);

  if write_result<>high(Raiter_true) then
  goto BADNESS;

  if executize(newnop) then begin
    Goptions.nop_name := newnop;
    exit;
  end;


  BADNESS:
  errorf('The "%s" program didn''t exist; tried to create "%s" but '+
  'coulnd''t; '+
  'consequently execution of non-existent program from OwenShow will '+
  'abort OwenShow itself',[Goptions.nop_name,newnop]);

end;
{$endif}

{****************************************************************************
****************************************************************************}

{$ifdef MSWINDOWS}
procedure gates_sux;
var
h:integer;
begin
  if (length(Goptions.gates_sux)<1)
  or (
  (length(Goptions.owenshow_path+Goptions.owenshow_drive)<1)
  and (length(Goptions.add_path)<1)
  and (not Goptions.add_gates_exec)
  )
  then
  exit;

  datadirize(Goptions.gates_sux);

  h := StupidNewFile(Goptions.gates_sux);
  if (h<0) then
  exit;

  hprintf(h,'@echo off'+LNEND);

  if length(Goptions.owenshow_path)>0 then
  hprintf(h,'set %s=%s'+LNEND,[Goptions.owenshow_path,fdeslash(datadir)]);

  if length(Goptions.owenshow_drive)>0 then
  hprintf(h,'set %s=%s'+LNEND,[Goptions.owenshow_drive,datadrive]);

  if length(Goptions.add_path)>0 then
  hprintf(h,'set path=%s'+LNEND,
  [getenvironmentvariable('PATH')]);
  //by now I've added the path to OUR evar path.

  if Goptions.add_gates_exec then
  hprintf(h,

  'if %%1.==. goto done'                  +LNEND+
  '%%1 %%2 %%3 %%4 %%5 %%6 %%7 %%8 %%9'   +LNEND+
  ':done'                                 +LNEND

  );

  FileClose(h);

end;
{$endif}


{****************************************************************************
****************************************************************************}

initialization

Gos_args := TStringList.create;
Gos_args.sorted := false;

Goptions.visitDirs := TStringList.create;
Goptions.visitDirs.sorted := false;

Goptions.edir_skip_list := TStringList.create;

Goptions.clips := TStringList.create;

Goptions.pathpurge := TStringList.create;


finalization

xfinal;



end.



