{****************************************************************************
osidle.pas
Mon 1/09/2006 12:58 pm  creation from main.pas.

This is the ridiculously-large idle routine, which I've now isolated in a
separate file because it was just getting too awful. (It's included by
main.pas)

See the bottom of main.pas for the BSD-style license.

****************************************************************************}

procedure TForm1.os_idle(Sender: TObject; var Done: Boolean);
const
enabletimer : TICKTIME = ();
{oldpanel : whichpanel = none;}
wasinited : boolean = false;
here : boolean = false;
capdirtime : TICKTIME = ();

dummyword : word = 0;
throttle_letter : string = 'T';
sanity : char = 'a';

label ENDNESS;

{A number of little quirks with the components can be subdued during idle.}
  procedure fixFselect;
  const
  sdelay : Ticktime = ();
  CUTEMS = 100;
  update_delay : Ticktime = ();

  FIRSTCOUNT = 1;

  {Wednesday, October 16, 2002 5:46 pm. This combination of hacks made the
  files view keep its selection updated. Of course it doesn't happen
  naturally, at least in K3D7. Anyway search for plzupdateview to see the
  precise intricate arrangement.}

  begin
    if notinited>0 then
    exit;

    if (update_delay.waitfor<>0) then begin
      if delayed(update_delay) then begin
        plzupdateview := false;
        Fupdate;
        update_delay.waitfor := 0;
      end;
      exit;
    end;

    if plzupdateview then begin
      delayed(update_delay,Goptions.update_delay);
      exit;   //don't execute code below.
    end;

    if filemousedown then begin
      filemousedown := false;
      sdelay.waitfor := 0;
    end;

    if (thisfv.view.selected=nil)
    and (thisfv.view.itemFocused<>nil)
    then begin
      if (sdelay.waitfor=0) then
      delayed(sdelay,500 {2000})
      else if delayed(sdelay,0) then begin
        thisfv.view.selected := thisfv.view.ItemFocused;
        sdelay.waitfor := 0;
      end;
    end;

  end;

  procedure refo;
  begin

{****************************************************************************
Thu 10/31/02 11:51 am. So this mumbo-jumbo is required because after one
adjusts the columns on the file view, naturally the view is no longer selected
or something; the keys wander into space probably shooting over to a secret
Inprise cache.... Thu 11/07/02 10:39 am. And now when you adjust the columns,
they jump around a bit, no doubt due to this fixit.

Thu 3/09/2006 10:39 am. Well all very well, but my endless ingenuity included
automatically executing the selection logic for such occasions, so things
would fly around and be very unsatisfactory. So I stop everything in its track
with not inited, and do a tiny little select; it works so well....
****************************************************************************}

    if (notinited<>0)
    or (thepanel=d)
    or (not plzrefocuspanel) then
    exit;

    plzrefocuspanel := false;

    notinited := 1;   //stop selectpanel.
    elsefv.view.setfocus;
    thisfv.view.setfocus;
    notinited := 0;

  end;

{problem is clicking vertical scroll in blankety-blank Tlistview doesn't
trigger anything. So (1.) we'd like the view to get selected
(fix_file_select), and (2.) I'll fix the selection here so it stays in the
view.}


  procedure file_scroll_fix;
  var
  newtop, sindex, bottom_1:integer;
  const
  another_trick_time : ticktime = ();
  another_trick_wait = 400;

    procedure another_trick;
    begin
      if not os_scrolled then
      delay_z(another_trick_time,another_trick_wait);
    end;

    function select_panel_if_scroll(fv:Tfv):boolean;
    begin
      result := false;

      if (fv.which=thepanel) then
      exit;
  {the purpose of this code is to select a panel based on change in the
  top-item or something, because the user scrolled it.}

      try
  {BUG082803}
        if (fv.oldtop<0) then begin
          fv.oldtop := fv.view.topitem.index;
        end else begin
          result := fv.view.topitem.index <> fv.oldtop;
        end;
      except
        on exception
        do;
      end;
    end;

  begin

    if no_tricks
    or (not delay_z(tricky_wait))
    or plzupdateview  //shouldn't do this while waiting to do that.
    then begin
      FilesM_stat.caption := 'n';
      exit;
    end
    else
    FilesM_stat.caption := '';

    if select_panel_if_scroll(fv1) then begin
      selectpanel(fv1.which);
{Commenting-out the recursive call to xosidle revived BUG082803. So I put it
back again, and lengthened the set_tricky calls}
      exit;
    end else if select_panel_if_scroll(fv2) then begin
      selectpanel(fv2.which);
      exit;
    end;

    if (thepanel=d) or (thisfv.view.topitem=nil) then begin
      exit;
    end;

//    dbg_nolog('begin scroll_fix');

    try
      newtop := thisfv.view.topitem.index;
      bottom_1 := filepage(thisfv.view)+newtop;
      sindex := file_selected_index(thisfv);

      if sindex<0 then begin
        files_selectoid(thisfv.view.itemfocused.index);
        exit; {I think that makes sense eh?}
      end;

      if (delay_z(tricky_wait)) then begin
//        dbg_nolog('scroll_fix after trickY-wait');

        if sindex<newtop then begin
          {the select is above the window; move it.}
          files_selectoid(newtop);
          another_trick;
        end else begin
          if (sindex >= bottom_1) then begin
            files_selectoid(bottom_1-1);
            another_trick;
          end else
          if (delay_once(another_trick_time))
          and (
          (sindex = newtop) or (sindex >= (bottom_1-1))
          )
          then begin
            thisfv.view.update;
{This fixes when for various perverse reasons the selection is half-way or
sometimes even more out-of-the window. When the window is x+1/2 line high, for
instance, using the top or bottom scroll buttons when the item is the top or
the bottom will 'cause it to do that; that only gets fixed when the mouse
wanders into the TlistView-scroll area. We also set-up this trick when the
code above determines that scrolling has happened but there was no keyboard
scroll ("another_trick"). Note that we only treat items near the top and the
bottom of the screen in this way. This working is all dependent on the correct
linefudge value which today is 5 or 7 or something.}

          end;
        end;
      end;
    except
      on e: exception
      do
      ;
    end;
  end;

{$ifdef CHECK_TREE_DRIVE}
  procedure checkTD(fv:Tfv);
  type
  statekind = (start, bad, badness);

  var
  number:integer;
  stupidstring:string;
  bd : boolean;
  const
  state : statekind = start;
  t : TICKTIME = ();
  label
  BADNESSLABEL;
  begin

    if fv=fv1 then
    number := 1
    else
    number := 2;

    stupidstring := fv.status.caption[1];

    bd := not (fv.file_tree.drive=stupidstring);

    case state of

      start: begin
        if not bd then
        exit;

        delay_z(t,5000);
        state := bad;
        exit;
      end;

      bad: begin
        if not delay_z(t) then
        exit;

        if not bd then begin
          state := start;
          exit;
        end;

        state := badness;
        goto BADNESSLABEL;

      end;

      badness: begin
        BADNESSLABEL:

        state := start; {always start again.}

        if not bd then
        exit;

      end;

    end;

    dbg('(thetree:%s) fv%d.tree (%s):%s <> fv%d caption:%s (Gcheckcount: %d)',
    [thetree.name,
    number,fv.file_tree.name,fv.file_tree.drive,
    number,fv.status.caption,Gcheckcount]);

{$ifdef INFO_TREE_DRIVE}
    fv1_tsd('os_idle checkTD',[0]);
{$endif}

  end;
{$endif}

  procedure fixdraglist;
  var
  i : integer;
  begin
    if draglist<>nil then begin
      file_oldnew_begin;

      for i := 0 to draglist.count-1 do begin
        if not FileExists_unq(draglist[i]) then
        file_oldnew(draglist[i],'');
      end;

      file_oldnew_finish;

      draglist.Free;
      draglist := nil;
      unFilesM_stat;
    end;
  end;

  procedure ckc(fv:Tfv);
  begin
    if not fv.check_counted then
    exit;

    if fv.checked>0 then
    fv.checklabel.caption := safe_format('(%s) ',[numbercommas(fv.checked)])
    else
    fv.checklabel.caption := '';
  end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
MAIN OSIDLE ROUTINE. osidle local sbrs are *above*.
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}

begin

  if here
  then
  exit;

  here := true;

{****************************************************************************
Tue 12/10/02 11:41 am. The here trap prevents re-entry; I got into the habit
of using this to prevent unpleasantness in automatic events, i.e. button
clicks etc. In fact os_idle shouldn't be called by Delphi twice (this before
the introduction of the fabulous LinuxTimer), and one liability of the here
trap is forgetting to unset it, usually with a foolish exit -- which I've done
numerous times.
****************************************************************************}

{****************************************************************************
this moved here Wed 9/17/03 7:34 pm and goto ENDNESS added. I don't know why
it was stuck in the middle there all that time. Bad idea anyway; could've
'caused truly mysterious problems -- i.e. what happens if we lose the focus
just at the right moment while starting-up? I mean who knows anyway but
still...
****************************************************************************}

  if not wasinited then begin
    visible := false;
    xinit;
    wasinited := true;
    goto ENDNESS;
  end;

{****************************************************************************
Thu 1/19/2006 2:54 pm. Now we deal with turnin on and off owenshow.
****************************************************************************}

  if (not Application.active) then begin
    if FilesMiscSanity.caption = 'X' then
    FilesMiscSanity.caption := 'x'
    else
    FilesMiscSanity.caption := 'X';
    os_enabled := false;
    os_off := true;
    throttle(true);
    cursoid(crCross {HourGlass});
    cumulativestop; {Thursday, May 1, 2003 2:01 pm}
    enabletimer.waitfor := 0;

    Gos_idle_off;   //turn off this software.

    goto ENDNESS;
  end;

{****************************************************************************
Thu 1/19/2006 2:56 pm. application is active. But form1 isn't enabled, so
enabled it.
****************************************************************************}
  if (not os_enabled) then begin

    set_tricky;

    delayed(enabletimer,Goptions.enabledelay);
    os_enabled := true;

    goto ENDNESS;

  end else if modaling then begin
  //enabled and modaling.
    FilesMiscSanity.caption := 'M';
    goto ENDNESS;

  end else if enabletimer.waitfor<>0 then begin
  //enabled and enabletimer.waitfor.


{$if defined(LINUX)}
//    active_color;
{$ifend}

    set_tricky;
    if delayed(enabletimer) then begin
      enabletimer.waitfor := 0;

      inc(notinited);
      {mostly to prevent setfocus from firing TListView OnEnter?}

      FilesView1.setfocus;
      FilesView2.Setfocus;
      DirVScrollsetfocus;

{$if defined(LINUX)}
//      active_color;
{$ifend}

      if thepanel<>d then begin
        sortcolor;
        thisfv.view.setfocus;
      end;

      inited;

      cursoid(crDefault); {it forgot that once too. On w98.}

      os_off := false;

      fakeshiftoff;

    end;

    goto ENDNESS; {Tue 9/30/03 10:21 am should've been here. If the enabled
    timer isn't up, it shouldn't do anything; and probably if it is, it should
    wait until the next idle anyway just for fun.}
  end;

{****************************************************************************
Tue 9/30/03 10:15 am. Somehow sometimes it forgets it's enabled? Or at least
the cursor remains a +, and keys don't work.
****************************************************************************}
  if (os_off) then begin
//    Gos_idle_off;   //missing until Thursday, January 19, 2006 2:45 pm.
//didn't seem to help....
    os_enabled := false; {dangerously retrigger everything.}
    goto ENDNESS;
  end;

{****************************************************************************
the above is all involved in whether os is focused or not. The rest of this is
various things I tinker-with to make them work or work better.
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}

  if Gthrottling then begin
    if (not delay_z(throttle_time)) then begin
//      FilesMiscSanity.caption := 'T';

//      dbg('throttle_time.waitfor=%d, oldcount=%d; now=%d; dif:%d',
//      [throttle_time.waitfor,throttle_time.oldcount,Get_ms,
//      Get_ms - throttle_time.oldcount
//      ]);
      goto ENDNESS;
    end;

//this was in the fast loop until Wednesday, August 15, 2007 11:24 am.
    if throttle_letter='t' then
    throttle_letter := 'T'
    else
    throttle_letter := 't';

//    dbg_nolog('width: %d',[width]);

    delay_z(throttle_time,Goptions.throttle_wait);     {set it off again.}
//    dbg('re-throttling');

  end else begin
    throttle_letter := '';

    if delay_z(throttle_time) then begin
//      if not os_instructions then
      //hack to make responsive while throttled? somehow I did something
      //that made it less so...
      throttle(true);
      {wait a long time and turn it on anyway. // i.e., others are in charge
      of turning it off, like keypress. But fall thru and do some processing
      -- just not very often.}

    end;

  end;

//  dbg('unthrottled processing');

{FilesMiscSanity is a tiny label on the left of FilesMiscPanel. It flickers
while os_idle runs. The FilesMiscPanel is there for this and future expansion.}
  inc(sanity);
  if sanity>='z' then
  sanity := 'a';
  FilesMiscSanity.caption := throttle_letter+sanity;

  refo;

  fixFselect;

  dir_fix;  //this is the mechanism that updates the tree display now and
            //then.

{this is the mechanism that fixes the cumulative top-of-the-form caption.}
  if Gstartcumulative then begin
    delayed(capdirtime,Goptions.cumulative_time);
    Gstartcumulative := false;
  end else if (capdirtime.waitfor<>0) and
  (delayed(capdirtime,0) or (not Giscumulative)) then begin
    capdirtime.waitfor := 0;
    cumulativestop;
    fakeshiftoff;
  end;

{$ifdef LINUX}
  checkzombies;
{$endif}

{oh let's poke the queue. // Tue 7/29/03 11:13 am. Yes of course I *have* to
do this. The extra keys will get stuck on MyKeyQueue, but the only way they'll
get *unstuck* is if *somebody else* calls FormKeyDown. Delphi'll only call it
*when a key is pressed*. Ijit...}
  if (MyKeyQueue<>nil) and (MyKeyQueue.count>0) then begin
{$ifdef IDLE_KEY}
    dbg_nolog('osidle key');
{$endif}
    jgo_seekey(nil,dummyword,[]);
  end;

//  dbg_nolog('file_scroll_fix');
  file_scroll_fix;

{$ifdef CHECK_TREE_DRIVE}
  if Goptions.check_tree_drive then
  checkTD(thisfv); {checkTD(fv2);}
{$endif}

  fixdraglist;

  os_instructions;
  {check for instructions from wandering strangers?}

{****************************************************************************
Monday, March 7, 2005 6:37 pm. This probably shouldn't be here; it was here
without the "Giscumulative" condition, but even with it, it still could call
capdir_file while someone else is; guard capdir_file if I must.
****************************************************************************}

{$ifdef DEBUG_TREE_OPEN}
{****************************************************************************
Mon 1/10/2005 6:49 pm. I moved this from os_keys; sender=nil when this called
by the timer probably, so the idea is it'll only check at idle times, although
I'm still not sure that's right. Anyway I'm going to set DEBUG_TREE_OPEN to
undefed, until I need it again or throw it away entirely.
****************************************************************************}
  if sender <> nil then    //if not timer call of os_idle.
  checkopen(thetree);
{$endif}

{****************************************************************************
****************************************************************************}

  if dumpclick then begin
    emptyMyKeyQueue;
    cumulativestop;
    if delay_z(dumpclicktime) then
    dumpclick := false;
  end;

{$ifdef LINUX}
  if fixcount>0 then begin
    dec(fixcount);
    if fixcount=0 then begin
      left := got_left;
      top := got_top;
    end;
  end;
{$endif}

{$ifdef LINUX}
  lxstat;
{$else}
//to test in windows.
//  Label_LXstat.caption := 'hi ma are you my friend forever can see at least?';
//  dbg('And how about these apples hey babe let''s biggle eh?');
{$endif}

//  dbg('help font: %s',[HelpDialog.font.name]);

  ckc(fv1);
  ckc(fv2);

  fixthis;
  showcount;

  if plz_clear_debug
  and delay_z(clear_debug_time) then begin
    plz_clear_debug := false;
    clrdbg;
  end;

  if (
  pleaseSFF_flag and
  (Application.active)
  and delay_z(pleaseSFF_ticks)
  ) then begin
    pleaseSFF_flag := false;
    FilesM_Stat.caption := 'oi';
    seefiles(false,false);
  end;

  ENDNESS:

  here := false;

end;

