{resize.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit resize;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QButtons, QComCtrls;

type
  Tfresize = class(TForm)
    BitBtn_OK: TBitBtn;
    RadioButton_move: TRadioButton;
    RadioButton_Resize: TRadioButton;
    RadioButton_Borders: TRadioButton;
    RadioButton_namecol: TRadioButton;
    Memo1: TMemo;
    RadioButton_sizecol: TRadioButton;
    RadioButton_timecol: TRadioButton;
    RadioButton_attscol: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioButton_moveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure fixradiobuttons;
    procedure refocus;
    procedure remessage;
  public
    { Public declarations }
  end;

var
  fresize: Tfresize;

implementation

{$R *.xfm}

uses main,code,sbrs,publics,qt,fontfun, qextctrls, options;

var

button_table: array[1..7] of TRadioButton;

button_index : integer;

procedure Tfresize.fixradiobuttons;
var
i:integer;
begin
  button_table[1] := RadioButton_move;
  button_table[2] := RadioButton_Resize;
  button_table[3] := RadioButton_Borders;
  button_table[4] := radiobutton_namecol;
  button_table[5] := RadioButton_Sizecol;
  button_table[6] := RadioButton_Timecol;
  button_table[7] := RadioButton_Attscol;

  for i := low(button_table) to high(button_table) do
  button_table[i].tag := i;

  button_table[1].checked := true;
  button_index := 1;
end;

procedure Tfresize.refocus;
begin
  Memo1.setfocus;
end;

procedure Tfresize.remessage;
begin
  if RadioButton_resize.checked then
  memo1.text := 'PgUp / PgDn selects; then use arrow keys; '+
  'left, up: smaller'
  else
  memo1.text := 'PgUp / PgDn selects; then use arrow keys';

{$if false}
  if RadioButton_move.checked
  or RadioButton_borders.checked
  or radiobutton_filescol.checked then
  memo1.text := 'PgUp / PgDn selects; then use arrow keys'
  else
  memo1.text := 'PgUp / PgDn selects; then use arrow keys; '+
  'left, up: smaller';
{$ifend}

end;


{****************************************************************************
Tue 6/03/03 6:09 pm. If I want to see *arrow keys* in FormKeyDown, I have to
have this memo component. Stars up in the sky stormy weather.... Thu 6/05/03
12:26 pm. Actually this little form is a good demonstration of the
good/bad/ugly of these clever environments. It took me a *day* to write this
code so the user, presumably on a laptop, can change the size of the program
and other aspects of the program *without using the mouse*. Various cute
features fought me every inch: the above "must have memo" trick; the arrow
keys then would get swallowed by the radio buttons unless I refocus the memo;
the first time I did I use various control/alt combinations plus the arrow
keys, which worked in XP but shift+alt didn't work in Linux. The lesson is, to
write stuff quickly in Delphi, *do what Delphi wants*.
****************************************************************************}

procedure Tfresize.FormCreate(Sender: TObject);
begin
  autoscroll := true;
  fixradiobuttons;
  remessage;
  refocus;
end;

const
throms : integer = 0; //1000 div 3;    //i.e., per second
{this is intended for throwing away keys to accommodate slower machines,
since they're the ones that need the manual resize.... I.e. my toshiba
win98 test case. I could make it an option, but I'm too lazy....}

procedure Tfresize.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

const
here : boolean = false;
lastkey : integer = -1;

const
throtime : TICKTIME = ();

label
ENDNESS;

  procedure borderwidth(amount:integer);
  var
  horizontal_panel : Tpanel;

  begin

    if form1.thepanel=d then begin
      horizontal_panel := form1.filesPanel;
    end else begin
      horizontal_panel := form1.dirpanel;
      amount := amount * -1;
    end;

    horizontal_panel.width := horizontal_panel.width - amount;

  end;


  procedure namewidth(amount:integer);
  begin
    with form1 do begin
      topfv.view.Columns[namecolumn].Width :=
      topfv.view.Columns[namecolumn].Width+amount;

      bottomfv.view.Columns[namecolumn].Width :=
      topfv.view.Columns[namecolumn].Width;

    end;
  end;

  procedure sizewidth(amount:integer);
  begin
    with form1 do begin
      topfv.view.Columns[sizecolumn].Width :=
      topfv.view.Columns[sizecolumn].Width+amount;

      bottomfv.view.Columns[sizecolumn].Width :=
      topfv.view.Columns[sizecolumn].Width;

    end;
  end;

  procedure timewidth(amount:integer);
  begin
    with form1 do begin
      topfv.view.Columns[timecolumn].Width :=
      topfv.view.Columns[timecolumn].Width+amount;

      bottomfv.view.Columns[timecolumn].Width :=
      topfv.view.Columns[timecolumn].Width;

    end;
  end;

  procedure attswidth(amount:integer);
  begin
    with form1 do begin
      topfv.view.Columns[attscolumn].Width :=
      topfv.view.Columns[attscolumn].Width+amount;

      bottomfv.view.Columns[attscolumn].Width :=
      topfv.view.Columns[attscolumn].Width;

    end;
  end;

  procedure filesheight(amount:integer);
  begin
    caption := safe_format('filesheight(%d)',[amount]);
{    with form1 do begin }      {doesn't work this moon phase}
{    if (form1.topfv.panel.align=alclient) then  }
{    form1.topfv.panel.Height := form1.topfv.panel.height + amount; }
{    end; }

        {pretty much random....}

    form1.bottomfv.panel.height :=
    form1.bottomfv.panel.height - amount;
  end;

  procedure mode(whichway:integer);
  begin
    inc(button_index,whichway);
    if button_index<low(button_table) then
    button_index := high(button_table);

    if button_index>high(button_table) then
    button_index := low(button_table);

    button_table[button_index].checked := true;

    refocus;

  end;

begin

  if here then begin
    key := 0;
    exit;
  end;



  here := true;

{  infof('hi ma'); }
  case key of
    key_ALT,key_Shift,key_Control: goto ENDNESS;
    {really just so I can debug.}

    key_Return,
    key_Enter: begin
      key := 0;
      modalresult := mrOK;
      goto ENDNESS;
    end;

    key_left, key_right, key_up, key_down: begin

      if (throms<>0) then begin
        if
        (key=lastkey) and (not delay_z(throtime)) then
        goto ENDNESS;

        delay_z(throtime,throms);
      end;
    end
  else
    throtime.waitfor := 0;
  end;

  lastkey := key;

  try
    with form1 do
    case key of
      key_Prior: mode(-1);
      key_Next: mode(1);
      key_escape: fresize.close;
      key_tab: refocus;

      key_left: begin
        if RadioButton_move.checked then
        left := left-1
        else if RadioButton_Resize.checked then
        width := width-1
        else if RadioButton_Borders.checked then
        borderwidth(-1)
//        dirpanel.width := dirpanel.width - 1
        else if radiobutton_namecol.checked then
        namewidth(-1)
        else if RadioButton_sizecol.checked then
        sizewidth(-1)
        else if RadioButton_timecol.checked then
        timewidth(-1)
        else if RadioButton_attscol.checked then
        attswidth(-1)

        ;
      end;

      key_right: begin
        if RadioButton_move.checked then
        left := left+1
        else if RadioButton_Resize.checked then
        width := width+1
        else if RadioButton_Borders.checked then
        borderwidth(1)
//        dirpanel.width := dirpanel.width + 1
        else if radiobutton_namecol.checked then
        namewidth(1)
        else if RadioButton_sizecol.checked then
        sizewidth(1)
        else if RadioButton_timecol.checked then
        timewidth(1)
        else if RadioButton_attscol.checked then
        attswidth(-1)
        ;
      end;

      key_up: begin
        if RadioButton_move.checked then
        top := top-1
        else if RadioButton_Resize.checked then
        height := height-1
        else if RadioButton_Borders.checked then
        bottompanel.height := bottompanel.height+ 1
        else if radiobutton_namecol.checked then
        filesheight(-1)
        ;
      end;

      key_down: begin
        if RadioButton_move.checked then
        top := top+1
        else if RadioButton_Resize.checked then
        height := height+1
        else if RadioButton_Borders.checked then
        bottompanel.height := bottompanel.height-1
        else if radiobutton_namecol.checked then
        filesheight(1)
        ;
      end;

    end
  except
    on exception do;
  end;

  key := 0;

  ENDNESS:
  here := false;

end;

procedure Tfresize.RadioButton_moveClick(Sender: TObject);
begin
  button_index := (sender as TRadioButton).tag;
  remessage;
  refocus;
end;

procedure Tfresize.FormShow(Sender: TObject);
begin
  throms := Goptions.resize_rate;
  fixfonts(fresize);
  formguard(fresize);
  caption := 'move/resize';
end;

end.
