{sbrs.pas

See the bottom of main.pas for the BSD-style license.

}

{this is a sort-of CLX sbrs unlike my usual vanilla delphi-esque flavor. Note
incidentally not all these sbrs are used in OS -- or maybe any program on
earth....}

{$I osops.i}

unit sbrs;

interface

uses SysUtils, QGraphics, qForms,
qButtons, qStdCtrls, qExtCtrls, {qDialogs,}
QComCtrls
, qt
,classes
{$ifdef LINUX}
, Libc
{$endif}
,publics
;

const

{these characters should be defined in sbrs.pas because they're
general-purpose ASCII.}

Stx {: char} = chr(2);
Etx {: char} = chr(3);
Eot {: char} = chr(4);
Ack {: char} = chr(6);
Lf  {: char} = chr(10);
Cr  {: char} = chr(13);
{Ff  = chr(12); }
Del {: char} = #127;
ESC = #27;
TAB = #9;

CTL = $40; {ord('X')-CTL}

osRETURN = Key_return;

{$ifdef LINUX}
slashchar = '/';
sepchar = ':';  //i.e. in paths.
{$endif}

{$ifdef MSWINDOWS}
slashchar = '\';
sepchar = ';';  //i.e. in paths.
{$endif}


opchar =
{$ifdef LINUX}
'-'
{$endif}

{$ifdef MSWINDOWS}
'/'
{$endif}

;

otheropchar =
{$ifdef LINUX}
'/'
{$endif}

{$ifdef MSWINDOWS}
'-'
{$endif}

;




MAX_OSPATH = 400;

{$ifdef LINUX}
//LNEND : string = LF;
LNEND = LF;
{$endif}

{$ifdef MSWINDOWS}
//LNEND : string = CR+LF;
LNEND = CR+LF;
{$endif}

kilobyte = 1024;

  BIT0 =  (1) ;
  BIT1 =  (2) ;
  BIT2 =  (4) ;
  BIT3 =  (8) ;
  BIT4 =  (16) ;
  BIT5 =  (32) ;
  BIT6 =  (64) ;
  BIT7 =  (128) ;
  BIT8 =  (256) ;
  BIT9 =  (512) ;
  BIT10 =  (1024) ;
  BIT11 =  (2048) ;
  BIT12 =  (4096) ;
  BIT13 =  (8192) ;
  BIT14 =  (16384) ;
  BIT15 =  (32768) ;
  BIT16 =  (65536) ;
  BIT17 =  (131072) ;
  BIT18 =  (262144) ;
  BIT19 =  (524288) ;
  BIT20 =  (1048576) ;
  BIT21 =  (2097152) ;
  BIT22 =  (4194304) ;
  BIT23 =  (8388608) ;
  BIT24 =  (16777216) ;
  BIT25 =  (33554432) ;
  BIT26 =  (67108864) ;
  BIT27 =  (134217728) ;
  BIT28 =  (268435456) ;
  BIT29 =  (536870912) ;
  BIT30 =  (1073741824) ;


type

{$ifdef MSWINDOWS}
os_ticks = CARDINAL;
{$endif}
{$ifdef LINUX}
os_ticks = CARDINAL;
{$endif}
//well it might change.... It has before....

TICKTIME = record
  waitfor,oldcount: os_ticks;
end;

const
{a value to assign to a ticktime variable so that when
delayed is called with it, it will return as time-up.
see at least lcxcomm.}
dzero : TICKTIME = (
  waitfor:0;
  oldcount:0;
);

function samedir(dir1, dir2:string):boolean;

procedure cwdize(var s:string);
function pgmdir(slsh:boolean = true):string;
procedure pgmdirize(var s:string);
function fpgmdirize(s:string):string;

function deslash(var what:string):boolean;
function fdeslash(what:string):string;
{deslashes everyone but \ // but was miswritten; only worked in
Linux and if lucky.}
{function dirdeslash(dir:string):string; }
procedure slash(var what:string);
function fslash(what:string):string;

function formatint(value:longint; size:integer):string;
function formathex(value:longint; size:integer):string;
function isdigit(c:char):boolean;
function isspace(c:char):boolean;
function ischar(c:char):boolean;
function isprint(c:char):boolean;
function hextoint(s:string):longint;
function intrange(low, high:integer; var what:integer):boolean;
procedure wordrange(low, high:word; var what:word);
procedure longrange(low,high:longint; var what:longint);
function hprintf(handle:integer; const TheFormat:string; const Args: array of
const):integer; overload;
function hprintf(handle:integer; const TheFormat:string):integer; overload;

function hgets(handle:integer; var dst:string):boolean;
procedure tokenate(const s:string);
function tokenhget(handle:integer):boolean;
function boolstring(what:boolean):string;
function jgoStrToInt(const S: string): Longint;
function jgoi(const S: string; const start, count:integer):longint;
function spaces(count:integer):string;
procedure flip(var what:boolean);
function delineend(s:string; replace : string = ''):string;
function extractFname(const s:string):string;
function xfilename(const s:string):string;
function xfilepath(const s:string):string;
function despace(const s:string):string;
function position(index:integer; what,s:string):integer;
function posi(what,s:string):integer;
function revpos(what,s:string):integer;
procedure removecharacter(var s:string; where:integer);
procedure addcharacter(var s:string; where:integer; what:char);
function isreturnkey(k:integer):boolean;

{ if count<>0, then initialize hung count; if 0, then return true if
counted down.}
function hung(count:integer):boolean;

function lowest(one, two:integer):integer;
procedure switchint(var one, two: integer);
procedure makeupper(var key:char);
{ returns true if user answers yes. }



function es(s:string; i:integer):char;
{used to be emptyspace}


function commaoid(s:string):string;
procedure colonoid(var s:string; var x:longint);
function ualphan(s:string):string;
procedure replacechar(old,new:char; var dst:string);
function htell(handle:integer):longint;
function hrewind(handle:integer):boolean; {returns good if it worked.}
function isdefault(s:string):boolean;
function hexoid(s:string):longint;
function lastchar(s:string):string;
{returns value of first number in a string, i.e. "unit12" returns 12.}
function firstnumber(s:string):integer;

function uncontrol(var s:string):boolean; //removes controls.
function dontcontrol(s:string):string;    //returns controls replaced with ?.

function delayed(var t:TICKTIME; howlong: cardinal = 0):boolean;
function delay_z(var t:TICKTIME; howlong: cardinal = 0):boolean;
function delay_once(var t:TICKTIME):boolean;
{****************************************************************************
delayed(t,non-zero) sets t delay to milliseconds in howlong.
delayed(t) returns true if times-up. However it'll get confused someday as the
time turns-around or other things.

delay_z works the same, *except* if the TICKTIME is inited to zero, it returns
true. Results from delayed in such cases is undefined. Also, delay_z sets the
TICKTIME variable to zero, so it will CONTINUE to return true until the
variable is set again.

delay_once only returns true once, when the time is up; it uses a ticktime
inited by delayed or delay_z.

****************************************************************************}


procedure mswait(ms: cardinal; dontyield:boolean = true );

function Get_ms:os_ticks;

function getCDslash:string;

function unquote(s:string):string;
function quotate(s:string; onlyif:boolean=false):string;
function quoteword(s:string):string;

{remove lower case from string.}
function unlower(s:string):string;

function CompareStrN(const S1, S2: string; N:integer): Integer;
function CompareTextN(const S1, S2: string; N:integer): Integer;

{if spaces, double-quote it and return true.}
function quoteoid(s:string):string;

function tolower(c:char):char;

function numbercommas(x:int64):string;
function abbreviated_number(x:int64):string;
function BigIntToStr(x:int64):string;

function fdedrive(s:string):string;
function fredrive(s:string; drive:char):string;
function diskbytes(path:string):int64;

procedure adduniquething(thing_list:TStrings; s:string; o:Tobject=nil);

procedure ComboText0(combo:TComboBox);

function extensionize(s,ext:string):string;
function hasext(s:string):boolean;

procedure maybeclose(var h:integer);

{$ifdef LINUX}
function OctalStr(value:longint):string;
function disk_id(path:string):int64;
{$endif}

//function directoried(s:string):boolean;
function directorize(srcname,dstname:string):string;
function StupidNewFile(name:string; readwrite : boolean = false):integer;
{$ifdef LINUX}
function homeize(s:string):string;
{$endif}

function spaceadd(s1, s2:string):string;

function shortstring(s:string; max:integer; left:boolean = false):string;

function slashlevel(s:string):integer;

function notwild(s:string):boolean;
function iswild(s:string):boolean;
function GetFileSize(const FileName: string): LongInt;

function fixname(s:string):string;
function punc_blr(s:string):string;
procedure blrize(var s:string);

procedure selectListBoxAll(lb:TlistBox);

function safe_format(
const TheFormat: string;
const Args:array of const):string;

function scans(index:integer; s:string):integer;
function scanchar(index:integer; s:string):integer;
function field(index, count:integer; s:string):integer;
//function bakname(name:string):string;
function bakname(name:string; bakext : string = 'b~k'):string;
function pathlist_s:string;
function dir_begins_with(what,dir:string):boolean;
function shiftbits(shift:TShiftState):string;

function rename_er(const OldName, NewName: string; ifexists:boolean = false):
Boolean;

function jgo_slist:TStringList;
procedure stupid_string_sort(List:TStringList; reverse:boolean = false);

procedure fixslashquote(var s:string);

function FileExists_unq(const FileName: string): Boolean;

type
file_kind = ( BATCH_kind, OTHER_kind );

function pathlist(dontdot:boolean = false):TStringList;
function x_in_path(what:string; debug:boolean = false):string;
function haspath(s:string):boolean;

procedure headtail(s:string; var head,tail:string);

function Pos_nocase(Substr: string; S: string): Integer;

function makelineend(s:string):string;

{****************************************************************************
****************************************************************************}
type

Tkey_string = class
  private
  list : TStringList;

  procedure delete_key_string(i:integer);

  public
  constructor Create;
  destructor Destroy; override;
  function keystring(k:string):string;
  procedure set_keystring(k,s:string);
  //adds to list; replaces same key. if s='', deletes.
  function next(init:boolean = false):string;

end;

{****************************************************************************
****************************************************************************}

const
TOKENCOUNT = 30;
TokenSize = 20;

var
tokenarray : array[1..TOKENCOUNT] of string;
tokens : integer;
tokenstr:string;    { the original string. }

implementation

uses StrUtils, weirdo, code{, publics}
{$ifdef MSWINDOWS}
, windows
//, messages
//, sysutils
{$endif}
,main //for dbg.
;

{****************************************************************************
****************************************************************************}

{-----------------------------------------}
{returns true if slash NOT removed. It *shouldn't* be removed if it's
the root. Probably.}
function deslash(var what:string):boolean;
var i:integer;
begin
  result := true;

  i := length(what);

{$ifdef MSWINDOWS}
  if (i=3) and (what[2]=':') and (what[3]=slashchar)
  then
  exit;
{$endif}

{and then for both linux and windows}
  if what=slashchar then
  exit;

{thing ends with slash, and should}

{now thing will *not* end with slash, because we're about to remove it.}
  result := false;

  if
  es(what,i)=slashchar
  then begin
    setlength(what,i-1);
  end;
end;

function fdeslash(what:string):string;
begin
  deslash(what);
  result := what;
end;


procedure slash(var what:string);
begin
  if (not deslash(what))
  and (length(what)>0)    {don't slash nothing}
  then
  what := what + slashchar;
end;

function fslash(what:string):string;
begin
  slash(what);
  result := what;
end;


{
procedure eslash(var what:string);
begin
  if length(what)>0 then
  slash(what);
end;
}

function pgmdir(slsh:boolean = true):string;
const
pgmd : string = '';
begin

  if length(pgmd)<1 then begin
    pgmd := ExtractFilePath(ExpandFileName(ParamStr(0)));
{   osinfof('pgmd:"%s"',[pgmd]);  }
    slash(pgmd);
  end;

  if slsh then
  result := pgmd    //it's stored with trailing slash.
  else
  result := fdeslash(pgmd);

end;

{returns true if s includes directory info, or if s is '' -- i.e. it shouldn't
have directory info added.}
{$ifdef NAda_Use_haspath}
function directoried(s:string):boolean;
begin
  result :=
  (length(s)<1)       {an empty string shouldn't be fixed.}
  or (pos(slashchar,s)>0)
{$ifdef MSWINDOWS}
  or (pos(':',s)>0)
{$endif}
  ;
end;
{$endif}

function fpgmdirize(s:string):string;
begin
  pgmdirize(s);
  result := s;
end;

procedure pgmdirize(var s:string);
begin

{$ifdef USEDIRECTORIED_instead}
    if (length(s)>0) and (pos(slashchar,s)=0)
  {$ifdef MSWINDOWS}
    and (pos(':',s)=0)
  {$endif}
{$endif}

  if not haspath(s) //directoried(s)
  then
  s := pgmdir+s;

end;

{given srcname and dstname, if srcname has a path and
dstname doesn't, then return path+dstname, else dstname}
function directorize(srcname,dstname:string):string;
begin
  if haspath(dstname) //directoried(dstname)
  then
  result := dstname
  else
  result := extractFilePath(srcname)+dstname;
end;

{****************************************************************************
****************************************************************************}

function formatint(value:longint; size:integer):string;
var i:integer;
begin
  result := safe_format('%*d',[size,value]);
  for i := 1 to length(result) do begin
    if result[i]=' ' then
    result[i] := '0';
  end;
end;

function formathex(value:longint; size:integer):string;
var i:integer;
begin
  result := safe_format('%*x',[size,value]);
  for i := 1 to length(result) do begin
    if result[i]=' ' then
    result[i] := '0';
  end;
end;

{$ifdef LINUX}
function OctalStr(value:longint):string;
var
digit : integer;
begin
  result := '';
  while value<>0 do begin
    digit := value mod 8;
    value := value div 8;
    result := chr(ord(digit)+ord('0')) + result;
  end;

  while es(result,1)='0' do
  result := copy(result,2,60000);

  if result='' then
  result := '0';

end;
{$endif}

{---------------------------------------------------------------}
function isdigit(c:char):boolean;
begin
  result := false;
  case c of
    '0'..'9': result := true;
  end;
end;


{---------------------------------------------------------------}
function hextoint(s:string):longint;
var
i, anumber:integer;
begin
  result := 0;
  anumber := 0;

  for i:=1 to length(s) do begin
    case s[i] of
      '0'..'9': anumber := ord(s[i])-ord('0');
      'A'..'F': anumber := ord(s[i])-ord('A')+10;
      'a'..'f': anumber := ord(s[i])-ord('a')+10;
      else exit; {exit function at non-hex, i.e. like JgoStrToInt.}
    end;

    result := result*16;
    inc(result,anumber);
  end;
end;

{---------------------------------------------------------------}
function intrange(low, high:integer; var what:integer):boolean;
begin
  result := high >= low;
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

procedure wordrange(low, high:word; var what:word);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

procedure longrange(low,high:longint; var what:longint);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

{--------------------------------------------------------------}
function boolstring(what:boolean):string;
begin
  if (what) then
  result := 'true'
  else
  result := 'false';
end;

{--------------------------------------------------------------}
{$ifdef _BE_SMALL}
function hprintf(handle:integer;
const TheFormat:string;
const Args: array of const):integer;

const
ARSIZE = $200;

var
s:string;

count:integer;
p : array[0..ARSIZE+5] of char;

begin

{
function StrPCopy(Dest: PChar; Source: string): PChar;
}
  result := -1;

  try
    s := safe_format(Theformat,args);
    count := length(s);
    if count>ARSIZE then begin
      count := ARSIZE;
      setlength(s,count);
    end;

    StrPCopy(p,s);
    result := FileWrite(handle,p,count);
    if result<>count then
    result := -1;
  except
  end;

end;

function hprintf(handle:integer; const TheFormat:string):integer;
begin
  result := hprintf(handle,TheFormat,[0]);
end;

{$endif}

{****************************************************************************
this is the BIG version.
function StrPLCopy(Dest: PChar; const Source: string; MaxLen: Cardinal): PChar;
****************************************************************************}

type brokenprintf_exception = class(EStreamError);

function hprintf(handle:integer;
const TheFormat:string;
const Args: array of const):integer;

const
ARSIZE = $200;

var
s:string;
slength:integer;

count:integer;
p : array[0..ARSIZE+5] of char;

begin

{
function StrPCopy(Dest: PChar; Source: string): PChar;
}
  result := -1;

  try
    s := safe_format(Theformat,args);
    slength := length(s);

    while true do begin
      count := length(s);

      if count>ARSIZE then
      count := ARSIZE;

      if count=0 then
      break;

      StrPLCopy(p,s,count);
      s := copy(s,count+1,slength);

      result := FileWrite(handle,p,count);
      if result<>count then
      raise
      brokenprintf_exception.Create(
      format('%s:hprintf result<>count failure',
      [OwenShowID]));
    end;
    {this is the good end.}
    result := slength;
  except
    on e: exception do
    Errorf(e.message);
  end;

end;

function hprintf(handle:integer; const TheFormat:string):integer;
begin
  result := hprintf(handle,TheFormat,[0]);
end;

{--------------------------------------------------------------}
function isspace(c:char):boolean;
begin
  result := false;
  case c of
    ' ', chr(9), chr(10), chr(13): result := true;
  end;
end;

function ischar(c:char):boolean;
begin
  result := not isspace(c);
end;

function isprint(c:char):boolean;
begin
  if c < ' ' then
  result := false
  else
  result := ischar(c);
end;

function despace(const s:string):string;
var
i:integer;
begin
  result := '';
  for i:=1 to length(s) do begin
    if not isspace(s[i]) then
    result := result + s[i];
  end;
end;

function ualphan(s:string):string;
var
i:integer;
begin
  result := '';
  for i:=1 to length(s) do begin
    case s[i] of
      'a'..'z','A'..'Z','0'..'9':
      result := result + UpCase(s[i]);
    end;
  end;
end;




{--------------------------------------------------------------}
{function FileRead(Handle: Integer; var Buffer; Count: Longint): Longint;}

function hgets(handle:integer; var dst:string):boolean;
var
c:char;
begin
  result := true;

  dst := '';

  while true do begin
    if FileRead(handle,c,1)<>1 then begin
      result := false;
      dst := '';
      break;
    end;

    case c of
{      CR: break;  }
      LF: break;
    else
      if c>=' ' then {throw away control chars.}
      dst := dst+c;
      if (length(dst) >= 5000) then begin
        dst := '';
        break;
      end;
    end;
  end;
end;

function hrewind(handle:integer):boolean; {returns good if it worked.}
begin
  result :=
  (FileSeek(Handle, 0,0 )<> -1);
end;

function htell(handle:integer):longint;
begin
  result :=
  FileSeek(Handle,0,1);
end;

procedure tokenate(const s:string);
var
i:integer;
c:char;

state : (spaces, characters);

begin

  for i := low(tokenarray) to high(tokenarray) do
  tokenarray[i] := '';  //empty it.

  state := spaces;

  tokens := low(tokenarray)-1;  { pre decrement. }

  for i := 1 to length(s) do begin
    c := s[i];
    case state of
      spaces: begin
        if ischar(c) then begin
          state := characters;

          inc(tokens);
          tokenarray[tokens] := c;  {1st character.}

        end;
      end;

      characters: begin
        if isspace(c) then begin

          if tokens >= high(tokenarray) then
          break;

          state := spaces;

        end
        else
        tokenarray[tokens] := tokenarray[tokens]+c;
      end;
    end;
  end;

end;


{tries to get a string from the handle, and then tokenates it, leaving the
results in the tokenarray, and the tokencount in tokens. }

function tokenhget(handle:integer):boolean;
begin
  result := false;

  while true do begin

    if not hgets(handle,tokenstr) then
    exit;

    if (length(tokenstr)<1) or
    (tokenstr[1]=';') then
    continue;             { dump empty, comments }

    tokenate(tokenstr);
    break;
  end;

  result :=true;

end;

{-------------------------------------------------------------}

{same as StrToInt but doesn't crash at empty etc.}
function jgoStrToInt(const S: string): Longint;
var
i: integer;
minus : boolean;
r : longint;
begin
  r := 0;
  minus := false;

  for i := 1 to length(S) do begin
    case S[i] of
      ' ': ;  { throw away leading spaces }

      '0'..'9':
      r := (r * 10) + (ord(S[i])-ord('0'));

      '-':
      minus := true;

    else break;
    end
  end;

  result := r;

  if (minus) then
  result := -result;
end;


function jgoi(const S: string; const start, count:integer):longint;
begin
  result :=
  JgoStrToInt(copy(s,start,count));
end;


function spaces(count:integer):string;
begin
  result := '';
  while count>0 do begin
    result := result + ' ';
    dec(count);
  end;
end;

procedure flip(var what:boolean);
begin
  what := not what;
end;


{remove the last line end.}
function delineend(s:string; replace : string = ''):string;
var
index: integer;
begin

  while (true) do begin
    index := pos(LNEND,s);
    if (index<1) then
    break;

    s :=
    copy(s,1,index-1) +
    replace +
    copy(s,index+length(LNEND),5000);
  end;

  result := s;

end;

{working version of ExtractFileName. Actually that's not fair; borland honors
the stupid trailing slash correctly, but sometimes that's inconvenient.}
function xfilename(const s:string):string;
begin
  result :=
  ExtractFileName(fdeslash(s));
end;

{removes right-most directory from a path.}
function xfilepath(const s:string):string;
begin
  result :=
  ExtractFilePath(fdeslash(s));
end;


{used to be extractname, but there's a delphi function like that.}
function extractFname(const s:string):string;
var
i:integer;
begin
  result := xFileName(s) {extractFileName(s)};

//  i := pos('.',result);
//  if i>0 then
//  result := copy(result,1,i-1);
//bad bad. for bingo.bango.bop, returns wrong "bingo"; should
//return"bingo.bango". Saturday, August 2, 2003 12:31 pm.

  for i := length(result) downto 1 do
  if result[i]='.' then begin
    result := copy(result,1,i-1);
    exit;
  end;

end;


{--------------------------------------------------------------}
procedure removecharacter(var s:string; where:integer);
begin
  if where>1 then
  s := copy(s,1,where-1)+copy(s,where+1,255)
  else
  s := copy(s,2,255);
end;

function hung(count:integer):boolean;
const
hungcount : integer = 0;
begin
  result := false;

  if count > 0 then
  hungcount := count
  else if hungcount=0 then
  result := true
  else begin
    dec(hungcount);
    if hungcount=0 then
    result := true;
  end;
end;

function lowest(one, two:integer):integer;
begin
  if (one < two) then
  result := one
  else
  result := two;
end;

procedure switchint(var one, two: integer);
var t : integer;
begin
  t := one;
  one := two;
  two := t;
end;

procedure makeupper(var key:char);
var
x:integer;
begin
  x := ord(key);
  case key of
    'a'..'z': key := chr(x-$20);
  end;
end;


{ returns s[i], but if that's empty, returns chr$(0). }
function es(s:string; i:integer):char;
begin
  if (i<1) or (length(s)<i) then
  result := chr(0)
  else
  result := s[i];
end;

{advance the string to the next comma argument}
function commaoid(s:string):string;
var
i:integer;
begin
  i := pos(',',s);
  if i > 0 then
  result := copy(s,i+1,500)
  else
  result := '';
end;

{ a utility procedure that extracts a value after a colon. If
s is "1234:45:987", colonoid will change s to "45:987" and set
x to 45. }
procedure colonoid(var s:string; var x:longint);
var i:integer;
begin
  i := pos(':',s);
  if i > 0 then begin
    s := copy(s,i+1,500);
    x := jgoStrToInt(s);
  end;
end;

procedure replacechar(old,new:char; var dst:string);
var
i:integer;
begin
  for i:=1 to length(dst) do begin
    if dst[i]=old then
    dst[i] := new;
  end;
end;


function isdefault(s:string):boolean;
begin
  result :=
  (CompareText('DEFAULT',s)=0);
end;

function hexoid(s:string):longint;
begin
  if ( (length(s)>0) and (s[1]='$') ) then
  result := HexToInt(copy(s,2,500))
  else
  result := JgoStrToInt(s);
end;

{ called like
nfree(Tobject(bingo)); }
{I'm pretty sure this doesn't work good.// It's funnier than that Wed
6/02/2004 1:37 pm; Delphi 5 and onward, there's FreeAndNil what does it.}
{
procedure nfree(var what:Tobject);
begin
  what.free;
  what := nil;
end;
}

function lastchar(s:string):string;
var
len:integer;
begin
  len := length(s);
  if len > 0 then
  result := s[len]
  else
  result := Chr(0);
end;

function firstnumber(s:string):integer;
var
i:integer;
begin
  result := 0;
  for i:= 1 to length(s) do begin
    if isdigit(s[i]) then begin
      result := JgoStrToInt(copy(s,i,500));
      exit;
    end;
  end;
end;

{***********************************************************************
removes control characters from s. Returns true if any such.
***********************************************************************}
function uncontrol(var s:string):boolean;
var
i:integer;
begin
  i := 1;
  result := false;

  while i <= length(s) do
  if (ord(s[i])<32) or (ord(s[i])>126) then begin
    s := copy(s,1,i-1)+copy(s,i+1,10000);
    result := true;
  end else
  inc(i);

end;

function dontcontrol(s:string):string;
var
i:integer;
const
xchr = '?';
begin
  result := s;
  for i := 1 to length(s) do begin
    if s[i]<' ' then
    result[i] := '?';
  end;
end;

{****************************************************************************
if howlong, set wait to howlong. If 0, return YES if previous wait is
timed-out. Should be in ticks.// No u idiot in ms.
****************************************************************************}


{****************************************************************************
****************************************************************************}

{$ifdef MSWINDOWS}
function Get_ms:os_ticks;
begin
  result := GetTickCount;
end;
{$endif}

{****************************************************************************
****************************************************************************}
{****************************************************************************
Thu 4/20/2006 11:08 am. I see I haven't introduced the players!

function times:   Linux times().
function CLK_TCK (libc.pas):

  function CLK_TCK: __clock_t;
  begin
    Result := sysconf(_SC_CLK_TCK);
  end;

And now (also libc.pas)...

  function errno: error_t;

  function __errno_location: PInteger; cdecl;

Note incidentally that works because the thread/multitasking/whatever
environment contrives that you have your own private little errno
somewhere....

$define UNCRASH_SDJ     //in osops.i.

Thu 4/20/2006 11:12 am. So I decided, at an email from usual indignant linuxer
(my log smackdown_complaints.log; see web
http://home.att.net/~owen_labs/rant10.htm) that times() probably didn't ever
return -1; or at least not often. Anyway I still *check* for the error, and
offer a chance to do something stupid.

Thu 4/12/2007 1:02 pm. I'm removing the UNCRASH_SDJ conditional and code is
always true.

****************************************************************************}

{$OPTIMIZATION OFF} {enormous arithmetic works better. I hope.}
{$ifdef LINUX}
{.$define dbg_CRASHLX_SHOW}  // well it exited OK.

function Get_ms:os_ticks;
const
init : boolean = false;
divide : clock_t = 0;
mult : clock_t = 0;
{$ifdef dbg_CRASHLX_SHOW}
tickcrash: clock_t = 0;
{$endif}

lasttick : os_ticks = 0;
tick_no_fail_name = 'linux_tick_dont_fail';
tick_no_fail: string = tick_no_fail_name;    //a file name.
complained : boolean = false;

var
tick : clock_t;
buffo : Ttimes;
begin
  if divide = 0 then begin

    pgmdirize(tick_no_fail);

    divide := 1;
    mult := 1000 div CLK_TCK;

{****************************************************************************
apparently mult is usually 10, which is nice. So that's FFFF,FFFE * .010 s ==>
42,949,672.94 seconds ==> 715827 minutes, 11,930 hours, 497 days. Well there
you are, if you run it for years, you're out of luck. If, of course, mult is
10. // not really or suchi s the conclusion of UNCRASH_SDJ.
****************************************************************************}

{$ifdef dbg_CRASHLX_SHOW}
    tickcrash := times(buffo)+1000; //10 seconds.
{$endif}

    if mult = 0 then begin
      mult := 1; //GetTickCount()'s looking pretty good now, eh?
      divide := CLK_TCK div 1000; //say it was 10000. I mean who cares.
      if divide = 0 then
      divide := 1;  //to hoo with 'em.
    end;
  end;

  __errno_location^ := 0;   //clear errno Delphi way.

  tick := times(buffo);

{$ifdef dbg_CRASHLX_SHOW}
  if (tickcrash<>0)
  and (tick > tickcrash)
  then begin
    tick := -1;
    __errno_location^ := 12;  //fake an error?
    tickcrash := 0;           //make test only happen once?
  end;
{$endif}

  if (tick = -1) and (errno<>0) then begin

    result := lasttick + 100;   //fake something plausible?
    lasttick := result;

    if complained or FileExists_unq(tick_no_fail) then
    exit;   //leave with bogus result.

    complained := true;   //do this only once.

    if usuref(

{****************************************************************************
ctext -p

times() returned -1 and errno != 0. Linux has run too long? reboot the thing?
Should I give up? Or choose NO to continue with bogus ticks. To stop this
nonsense, create the empty file `%s in the program directory.
`a,[tick_no_fail]
****************************************************************************}

'times() returned -1 and errno != 0. Linux has run too long? reboot the thing?'
+' Should I give up? Or choose NO to continue with bogus ticks. To stop this'
+' nonsense, create the empty file %s in the program directory.'
,[tick_no_fail]


  ) then begin
      while true do
      halt(7);
    end else
    exit;
  end;


  result := (os_ticks(tick) * os_ticks(mult)) div os_ticks(divide);

  lasttick := result;

end;

{$endif}  //ifdef LINUX.

function delayed(var t:TICKTIME; howlong: cardinal = 0):boolean;
var
msnow : os_ticks;
begin
  msnow := Get_ms;

  if (howlong>0) then begin
    if (howlong < 60) then
    howlong := 60; {don't make it less than 55 i.e. xt tick ms.}
    t.oldcount := msnow;
    t.waitfor := howlong;
    result := false;
    exit;
  end;

  result :=
  (msnow-t.oldcount) >= t.waitfor;

end;
{$OPTIMIZATION ON} {enormous arithmetic works better}

{****************************************************************************
****************************************************************************}


function delay_z(var t:TICKTIME; howlong: cardinal = 0):boolean;
begin

  if howlong>0 then
  result := delayed(t,howlong)
  else if (t.waitfor=0) or (delayed(t)) then begin
    t.waitfor := 0;
    result := true;
  end else
  result := false;

end;

function delay_once(var t:TICKTIME):boolean;
begin
  result := false;

  if (t.waitfor<>0) and (delayed(t)) then begin
    t.waitfor := 0;
    result := true;
  end;

end;


{****************************************************************************
****************************************************************************}
procedure mswait(ms: cardinal; dontyield:boolean = true);
begin

  if ms > 10000 then
  ms := 10000;

  sleep(ms);

  if not dontyield then
  delphi_yield;

end;

{****************************************************************************
****************************************************************************}
{$ifdef Old_style_mswait_was_stupid}
{const
waiting:boolean = false; }
var
t : TICKTIME;
begin
  if {waiting or} (ms=0) then
  exit;

{  waiting := true; }
  if ms > 10000 then
  ms := 10000;

  delayed(t,ms);
  while not delayed(t,0) do
  begin
    if not dontyield then
    delphi_yield;
  end;
{  waiting := false; }

{I don't think there's any reason this isn't re-entrant....}
end;
{$endif}
{****************************************************************************
****************************************************************************}


function getCDslash:string;
begin
  result := getCurrentDir;
  slash(result); //it might be d:\.
end;



procedure cwdize(var s:string);

begin

  if (length(s)>0) and (pos(slashchar,s)=0)
  and (pos(':',s)=0) then
//  s := getCurrentDir+slashchar+s;
  s := getCDslash+s;

end;

procedure addcharacter(var s:string; where:integer; what:char);
begin
  s :=
  copy(s,1,where-1)+
  what+
  copy(s,where,10000);
end;



{remove enclosing quotes.}
function unquote(s:string):string;
var
i:integer;
begin
  result := trim(s);  //might as well remove leading/trailing spaces.
  if es(result,1)='"' then
  result := copy(result,2,10000);

  if lastchar(result)='"' then
  result := copy(result,1,length(result)-1);

  while true do begin
    i := pos('""',result);

    if i<1 then
    exit;

    removecharacter(result,i);
  end;

end;

{fix quotes and add enclosing quotes.}
function quotate(s:string; onlyif:boolean=false):string;
var
i:integer;
begin
  result := s;

  i := 1;

//only bother with things that have spaces and don't start with a quote
//already.
  if onlyif
  and (pos(' ',s)<1)
  and (es(s,1)<>'"')
  then
  exit;

  while i <= length(result) do begin
    if result[i]='"' then begin
      addcharacter(result,i,'"');
      inc(i,2);
    end else
    inc(i);
  end;

  result := '"' + result + '"';

end;

{****************************************************************************
*If* the first character is a ", return the string without the enclosing
quotes. Otherwise, if the character is a non-blank, return the initial word.
Else return empty string. Note that this is double-quote, for use probably
with ini files or who knows.
****************************************************************************}

function quoteword(s:string):string;
var
i:integer;
begin
  result := '';

  if es(s,1)='"' then begin
    i := 2;
    while i<=length(s) do begin
      if s[i]='"' then begin
        if es(s,i+1)='"' then begin
          inc(i);
        end else
        exit; {with result == string.}
      end;

      result := result + s[i];
      inc(i);
    end;
    exit; {unterminated quote. Whatever.}
  end;

  if isspace(es(s,1)) then
  exit; {with empty result.}

  i := 1;

  while i<=length(s) do begin
    if isspace(s[i]) then
    exit;

    result := result+s[i];
    inc(i);
  end;

  {no space at end of word. Fall thru with result==word.}

end;

function unlower(s:string):string;
var
i:integer;
begin
  result := '';
  for i := 1 to length(s) do
  case s[i] of
    'a'..'z': ;
  else
    result := result + s[i];
  end;

end;

{****************************************************************************
         10        20
12345678901234567890123456789
ABCDEFGHIJKLMNOPQRSTUVWXYZ
    5

    12345678901234567890123456789
    EFGHIJKLMNOPQRSTUVWXYZ
          7

****************************************************************************}
function position(index:integer; what,s:string):integer;
begin
  result := posi(what,copy(s,index,length(s)));
  if result>0 then
  inc(result,index-1);
end;

function posi(what,s:string):integer;
var
i_what,i_s:string;
begin
  i_what := lowercase(what);
  i_s := lowercase(s);
  result :=
  pos(i_what,i_s);
end;

{****************************************************************************
                length
what: abc          3
s:    xyzabcefg    9
      123456789

(case sensitive)

****************************************************************************}

function revpos(what,s:string):integer;
var
whatlen:integer;
begin
  whatlen := length(what);

  result := length(s) - whatlen + 1;

  while result >= 1 do begin

    if CompareStr(what,copy(s,result,whatlen))=0 then
    break; {the while}

    dec(result);

  end;

  {result = 0 if not found.}


end;



{****************************************************************************
****************************************************************************}
function CompareStrN(const S1, S2: string; N:integer): Integer;
begin
  result := CompareStr(copy(s1,1,n),copy(s2,1,n));
end;

function CompareTextN(const S1, S2: string; N:integer): Integer;
begin
  result := CompareText(copy(s1,1,n),copy(s2,1,n));
end;

{****************************************************************************
quote if spaces in body.
****************************************************************************}

function quoteoid(s:string):string;
begin
  if (es(s,1)<>'"') and (pos(' ',s)>0) then begin
    s := '"'+s+'"';
  end;
  result := s;
end;

{****************************************************************************
****************************************************************************}

function tolower(c:char):char;
var
s:string;
begin
  s := c;
  s := lowercase(s);
  result := s[1];
end;

{   $define BORLAND_REALLY_SUX_1}

{IntToStr doesn't work.}
function BigIntToStr(x:int64):string;
var
d:word;
begin
  result := '';
  while x<>0 do begin
    d := x mod 10;
    x := x div 10;
    result := IntToStr(d)+result;
  end;

  if length(result)<1 then
  result := '0';
end;

function numbercommas(x:int64):string;
var
s, three:string;

begin
  s := BigIntToStr(x);
  result := '';

  while true do begin

    three :=
    rightstr(s,3)
    ;

    s := leftstr(s, length(s)-3);

    if length(s)>0 then
    result := ','+three+result
    else begin
      result := three+result;
      break;
    end;

  end;

end;

function abbreviated_number(x:int64):string;
const
prefixes = '? kmGTPEZY';
var
i:integer;

begin

  i := 2;

  while x >= 1000 do begin
    x := (x + 499) div 1000;
    inc(i);
  end;

  if i > length(prefixes) then
  i := 1;

  result := IntToStr(x) + prefixes[i];

end;


{****************************************************************************
****************************************************************************}

procedure adduniquething(thing_list:TStrings; s:string; o:Tobject=nil);
var
indexof : integer;
begin
  indexof := thing_list.indexof(s);
  if indexof<0 then begin
    if o<>nil then
    thing_list.addobject(s,o)
    else
    thing_list.add(s);
  end;
end;

{amazing there's no way to just make it do this!?}
procedure ComboText0(combo:TComboBox);
begin
  if combo.items.count>0 then
  combo.text := combo.items[0]
  else
  combo.text := '';
end;

{****************************************************************************
****************************************************************************}
{$ifdef LINUX}
function fdedrive(s:string):string;
begin
  result := s;
end;

function fredrive(s:string; drive:char):string;
begin
  result := s;
end;

{$endif}

{$ifdef MSWINDOWS}
function fdedrive(s:string):string;
begin
  if es(s,2)=':' then
  result := copy(s,3,10000)
  else
  result := s;
end;

function fredrive(s:string; drive:char):string;
begin
  result := fdedrive(s);

  if length(result)>0 then
  result := drive+':'+ result;

end;

{$endif}

{$ifdef MSWINDOWS}

{$define NewGetFree}

{$ifdef NewGetFree}
//from jcopy something in sbrs.
  {return position in s of substr, but starting at index. 0 if not
  there.}

{$define EZ_WAY}

{$ifndef EZ_WAY}
  function ipos(substr:string; index:integer; s:string):integer;
  begin
    result := pos(substr,copy(s,index,255));
    if (result>0) then
    inc(result,index-1);
  end;


  {****************************************************************************
  if netdir, returns position of CONCLUDING \ i.e. in

   123456789
  "\\rose\d\gregor"

  returns 9.

  If *not* netdir, returns position of first \..

  ****************************************************************************}

  function netdir(dir:string):integer;
  begin

    if (copy(dir,1,2)='\\') then begin
  // like "\\rose\d\gregor". Let's try picking \\rose as an element.
      result := ipos('\',3,dir);
      result := ipos('\',result+1,dir); //no let's try \\rose\d\.
    end else begin
      result := pos('\',dir);
      if result<1 then
      result := length(dir);
    end;

  end;

  function net_rut(dir:string):string;
  var
  i:integer;
  begin
    i := netdir(dir);

    result := copy(dir,1,i);

  end;

  {****************************************************************************
  ****************************************************************************}
{$endif}

  function diskbytes(path:string):int64;

  var

  FreeBytes, TotalBytes: int64;
  begin

    if not GetDiskFreeSpaceEx(
{$ifdef EZ_WAY}
    pchar(ExtractFilePath(path))
{$else}
    pchar(net_rut(path))  //worked.
{$endif}
    ,
    FreeBytes,TotalBytes,nil
    ) then begin
      result := 0; //-1;
      exit;
    end;


    result := FreeBytes;

  end;

{$else}


  function diskbytes(path:string):int64;
  var
  x : integer;
  begin
    if
    ((length(path)>1) and (path[2]<>':'))
    or (length(path)<1)
    then begin
      result := 0;
      exit;
    end;

    case es(path,1) of
      'a'..'z', 'A'..'Z': x := ord(tolower(path[1]))-ord('a') + 1;
    else
      x := 0; {current}
    end;

    result := DiskFree(x);

  end;

{$endif}  //

{$endif}

{$ifdef LINUX}
{$OPTIMIZATION OFF} {enormous arithmetic works better}
function diskbytes(path:string):int64;
var
stat : Tstatfs64;

begin

  if (statfs64(pchar(path),stat)<>0)
//  and (statfs64(pchar(ExtractFilePath(path)),stat)<>0)
{diskbytes is frequently passed the path for a destination file that doesn't
exist, and stupid Linux just throws it away, so we give it a second chance on
that assumption. This will go wrong sometimes won't it? So nfg.... Onward. Of
course brilliant windows doesn't have these problems....}
  then
  result := 0
  else begin
    result :=
    stat.f_bavail * stat.f_bsize;
  end;

end;

{****************************************************************************
struct statfs
   long    f_type;     /* type of filesystem (see below) */
   long    f_bsize;    /* optimal transfer block size */
   long    f_blocks;   /* total data blocks in file system */
   long    f_bfree;    /* free blocks in fs */
   long    f_bavail;   /* free blocks avail to non-superuser */
   long    f_files;    /* total file nodes in file system */
   long    f_ffree;    /* free file nodes in fs */
   fsid_t  f_fsid;     /* file system id */
   long    f_namelen;  /* maximum length of filenames */
;

so I couldn't fine the def for statfs64 -- but what heck, the whole thing is
just a guess now anyway.
****************************************************************************}

function disk_id(path:string):int64;
var
stat : Tstatfs64;

begin

  if (statfs64(pchar(path),stat)<>0)
//  and (statfs64(pchar(ExtractFilePath(path)),stat)<>0)
{diskbytes is frequently passed the path for a destination file that doesn't
exist, and stupid Linux just throws it away, so we give it a second chance on
that assumption. This will go wrong sometimes won't it? So nfg.... Onward. Of
course brilliant windows doesn't have these problems....}
  then
  result := 0
  else begin
    result :=
//    stat.f_fsid.__val[0] +
//    (stat.f_fsid.__val[1] shl 32)
// sadly f_fsid is denied to non-root maybe. Anyway, it's zero. So we'll
//just pick thingeys
    stat.f_type +
    (stat.f_files shl 32)
    ;
  end;

end;

{OPTIMIZATION ON}
{$endif}


function isreturnkey(k:integer):boolean;
begin
  result :=
  (k=key_Enter) or
  (k=key_Return);

end;

function extensionize(s,ext:string):string;
begin
  if es(ext,1)<>'.' then
  ext := '.'+ext;
  result := extractFilePath(s) + extractFname(s)+ext;
end;

function hasext(s:string):boolean;
begin
  result :=
  pos('.',extractFileName(s))<>0;
end;


procedure maybeclose(var h:integer);
begin
  if h>=0 then
  FileClose(h);
  h := -1;
end;

{****************************************************************************
FileCreate only works if NO file, and FileOpen(name,fmOpenWrite) doesn't work
unless there IS an existing file. FileOpen(name,fmCreate) apparently just
doesn't work. ... So if readwrite, open it so you can do that.
****************************************************************************}
function StupidNewFile(name:string; readwrite : boolean = false):integer;
begin
  sysutils.DeleteFile(name);
  result := FileCreate(name);
  if not readwrite then
  exit;

  FileClose(result);

  result := FileOpen(name,fmOpenReadWrite);

end;

{****************************************************************************
****************************************************************************}


{
function dirdeslash(dir:string):string;
begin
  if dir=slashchar then
  result := slashchar
  else
  result := fdeslash(dir);
end;
}


function samedir(dir1, dir2:string):boolean;
begin
    result :=

{$ifdef MSWINDOWS}
  CompareText
{$endif}
{$ifdef LINUX}
  CompareStr
{$endif}


  (
  ExpandFileName(fdeslash(dir1)),
  ExpandFileName(fdeslash(dir2))
  )

  = 0;

end;

{$ifdef LINUX}
function homeize(s:string):string;
begin

{See it's simpler than I thought. ~\bongo should be translated to home
directory, but "\bingo~\bongo" -- you're on your own....}

  if es(s,1)='~' then
  result :=
  GetEnvironmentVariable('HOME')+
//  slashchar+
//no slash character dolt.
  copy(s,2,50000)
  else
  result := s;

end;
{$endif}


function shortstring(s:string; max:integer; left:boolean = false):string;
begin
  if max<5 then
  max := 5;

  if length(s)>max then begin
    if left then
    result := leftStr(s,max-3)+'...'
    else
    result := '...'+rightStr(s,max-3);
  end else
  result := s;
end;

{adds to s2 to end of s1, with a space if s1 and s2 both have length.}
function spaceadd(s1, s2:string):string;
begin
  if (length(s1)>0) and (length(s2)>0) then
  result := s1+' '+s2
  else
  result := s1+s2;
end;

function slashlevel(s:string):integer;
var
i:integer;
begin
  result := -1; {So root returns 0. If there *are* no slashes, then -1 is
  error I suppose.}

  for i := 1 to length(s) do begin
    if s[i]=slashchar then
    inc(result);
  end;
end;

function iswild(s:string):boolean;
begin
  result :=
  (pos('*',s)>0) or (pos('?',s)>0);
end;

function notwild(s:string):boolean;
begin
  result :=
  (pos('*',s)<1) and (pos('?',s)<1);
end;

function GetFileSize(const FileName: string): LongInt;
var
  SearchRec: TSearchRec;
begin
  if iswild(Filename) then
  result := -1
  else
  if FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec) = 0 then
    Result := SearchRec.Size
  else Result := -1;
  Sysutils.FindClose(SearchRec);  //there's a findclose(handle) somewhere.
end;

//dump spaces punctuation whatever. Leave single right-most period, if.
function fixname(s:string):string;
var
periodcount,
i:integer;
waspunc:boolean;
begin
  i := 1;
  periodcount := 0;
  waspunc := true;   //remove leading junk.

  while i <= length(s) do begin
    case (s[i]) of

      '.': begin
        inc(periodcount);
        inc(i);
      end;

      'a'..'z', 'A'..'Z', '0'..'9': begin
        inc(i);
        waspunc := false;
       end;

    else
      if waspunc
      then
      delete(s,i,1)
      else begin
        waspunc := true;
        s[i] := '_';
        inc(i);
      end;
    end;
  end;

  if AnsiRightStr(s,1)='_' then
  delete(s,length(s),1);

//handle periods.
  i := 1;
  while (i <= length(s)) and (periodcount>1) do begin
    if s[i]='.' then begin
      delete(s,i,1);
      dec(periodcount);
    end
    else
    inc(i);
  end;

//dump a trailing period. I.e. name.)(*&)
  if AnsiRightStr(s,1)='.' then
  delete(s,length(s),1);

//delete _ before a period.
  i := pos('.',s);
  if es(s,i-1)='_' then
  delete(s,i-1,1);

  result := s;

end;

//like fixname, except no period treatment.
function punc_blr(s:string):string;
var
i:integer;
waspunc:boolean;
begin
  i := 1;

  waspunc := true;   //remove leading junk.

  while i <= length(s) do begin
    case (s[i]) of
      'a'..'z', 'A'..'Z', '0'..'9': begin
        inc(i);
        waspunc := false;
       end;
    else
      if waspunc
      then
      delete(s,i,1)
      else begin
        waspunc := true;
        s[i] := '_';
        inc(i);
      end;
    end;
  end;

  if AnsiRightStr(s,1)='_' then
  delete(s,length(s),1);

  result := s;
end;

procedure blrize(var s:string);
var
i:integer;
begin
  for i := 1 to length(s) do begin
    if s[i]=' ' then
    s[i] := '_';
  end;
end;

procedure selectListBoxAll(lb:TlistBox);
var
i:integer;
begin
  if not lb.multiselect then
  exit;

  for i := 0 to lb.items.count-1 do begin
    lb.selected[i] := true;
  end;
end;

function safe_format(
const TheFormat: string;
const Args:array of const):string;
begin
  try
    result := format(Theformat,args);
  except
    on e: exception do
    result :=
    format('Format() error in program!'+LNEND+'Error:'+LNEND+'%s'+LNEND+
    'Format:'+LNEND+'%s',[e.message,TheFormat]);
  end;
end;

{****************************************************************************
starting at index in s, return index of first non-space. -1 if nonesuch.
Actually first <=' '.
****************************************************************************}

function scans(index:integer; s:string):integer;
begin

  for result := index to length(s) do begin
    if s[result] > ' ' then
    exit;
  end;

  result := 0;

end;

function scanchar(index:integer; s:string):integer;
begin

  for result := index to length(s) do begin
    if s[result] <= ' ' then
    exit;
  end;

  result := 0;

end;


//returns index of countth field starting at index.
function field(index, count:integer; s:string):integer;
begin
  result := 0;

  //remove any leading spaces.
  index := scans(index,s);
  if index<0 then
  exit;

//if count is 1, should stop now.
  dec(count);

  while (count>0) do begin
//get off of this one.
    index := scanchar(index,s);
    if index<0 then
    exit;

    //advance across trailing spaces to next thing.
    index := scans(index,s);
    if index<0 then
    exit;

    dec(count);
  end;

  result := index;


end;

function bakname(name:string; bakext : string = 'b~k'):string;
var
xlength : integer;
x : string;
//const
//bakext = '.b~k';
begin
  x := ExtractFileExt(name);
  xlength := length(x);

  if xlength>0 then
  result := copy(name,1,length(name)-xlength);

  result := result + '.' + bakext;
end;

{****************************************************************************
****************************************************************************}

function pathlist_s:string;
var
s:string;
i:integer;
c:string;
begin
  result := '';
  s := getenvironmentvariable('PATH');

  for i := 1 to length(s) do begin
    c := s[i];
    if c=sepchar then
    c := LNEND;
    result := result + c;
  end;


end;

{****************************************************************************
****************************************************************************}

function shiftbits(shift:TShiftState):string;
begin
  result := '';

  if ssalt in shift then
  result := '@';

  if ssctrl in shift then
  result := result + '^';

  if ssshift in shift then
  result := result + '|';


end;



{****************************************************************************
****************************************************************************}
function dir_begins_with(what,dir:string):boolean;
begin

  result :=
{$ifdef MSWINDOWS}
  sametext(what,copy(dir,1,length(what)))
{$endif}
{$ifdef LINUX}
  what=copy(dir,1,length(what))
{$endif}

end;

{****************************************************************************
****************************************************************************}
function rename_er(const OldName, NewName: string; ifexists:boolean = false):
Boolean;
begin

  if ifexists and
  (not FileExists_unq(OldName)) then begin
    result := true;
    exit;
  end;

  result := RenameFile(OldName,NewName);

  if not result then
  errorf('Couldn''t rename "%s" to "%s"',
  [OldName,NewName]);

end;

{****************************************************************************
****************************************************************************}

function jgo_slist:TStringList;
begin
  result := TStringList.create;
  result.sorted := false;
  result.casesensitive := false;
  result.duplicates := dupError {dupAccept};
end;


{****************************************************************************
****************************************************************************}

{****************************************************************************
The callback returns

a value less than 0 if the string identified by Index1 comes before the string
identified by Index2

0 if the two strings are equivalent

a value greater than 0 if the string with Index1 comes after the string
identified by Index2.

****************************************************************************}

function custom_compare(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareText(list[Index1],list[Index2]);
end;


function custom_case(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareStr(list[Index1],list[Index2])
end;


function r_custom_compare(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareText(list[Index2],list[Index1]);
end;


function r_custom_case(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareStr(list[Index2],list[Index1])
end;



//note caller might mark the thing *sorted*. If it thinks it is....
procedure stupid_string_sort(List:TStringList; reverse:boolean = false);
begin
//  List.sorted := false;
  //apparently it won't bother unless.
  //but then who knows if I rely on that?

  if reverse then begin

    if List.casesensitive then
    List.customsort(r_custom_case)
    else
    List.customsort(r_custom_compare);

  end else begin

    if List.casesensitive then
    List.customsort(custom_case)
    else
    List.customsort(custom_compare);

  end;

end;

{****************************************************************************
****************************************************************************}

type
Tobject_string = class

{****************************************************************************
I guess I can't store a naked string into a tstringlist object. // Yup I
thinks that's pretty certain. So I use this bogus class which I'm keeping
private.
****************************************************************************}

  s:string;

end;

constructor Tkey_string.Create;
begin
  inherited Create;       //their code.
//my code.
  list := jgo_slist;
end;

procedure Tkey_string.delete_key_string(i:integer);
begin
  try
    list.objects[i].free;
    list.delete(i);
  except
    on exception do; //too hoo with it.
  end;
end;


destructor Tkey_string.destroy;
begin

//my code.
  while list.count>0 do
  delete_key_string(0);

  freeandnil(list);

  inherited destroy;      //theirs.
end;

function Tkey_string.keystring(k:string):string;
var
index:integer;
begin

  result := '';

  index := list.indexof(k);

  if index>=0 then
  result := Tobject_string(list.objects[index]).s;

end;

procedure Tkey_string.set_keystring(k,s:string);
var
index : integer;
begin

  index := list.indexof(k);

  if index>=0 then begin

    if s='' then
    delete_key_string(index)
    else
    (list.objects[index] as Tobject_string).s := s

  end else begin    //not there already.

    if s<>'' then begin
      index := list.addobject(k,Tobject_string.create);
      (list.objects[index] as Tobject_string).s := s;
    end;

  end;

end;

function Tkey_string.next(init:boolean = false):string;
const
index : integer = 0;
begin
  if init then begin
    index := 0;
    exit;
  end;

  result := '';
  if index>=list.count then
  exit;

  result := (list.objects[index] as Tobject_string).s;

  inc(index);

end;


{****************************************************************************
change trailing \" to ".

12345678901234567890
"\bango\bongo\"

             slashquote

This is related to a bug so old I think it was in CP/M and I really have no
idea about the details. But somewhere in the bowels of Windows, I think a
sequence like the above can confuse the poor little thing, presumably because
of an inappropriate C-language treatment of the string -- or then again, who
knows.... All I know -- suspect -- is the backslashes in the front of the
string are passed correctly, but that \" upsets somebody. ... Whatever....

So I crudely destroy it; I don't dare replace it with \\" because that won't
work if there *is no* bug. Ah whatever....

****************************************************************************}

procedure fixslashquote(var s:string);
var
slashquote : integer;
begin
  slashquote := pos(slashchar+'"',s);
  if (slashquote>0)
  and (slashquote=length(s)-1)
  then
  s := copy(s,1,length(s)-2)+'"';

end;

{****************************************************************************
****************************************************************************}

function FileExists_unq(const FileName: string): Boolean;
begin
  result :=
  FileExists(unquote(FileName));
end;


{****************************************************************************
****************************************************************************}
{****************************************************************************
returns a stringlist of slash-terminated paths.
you gotta free the result.
****************************************************************************}
function pathlist(dontdot:boolean = false):TStringList;
var
s, thepath:string;
i : integer;

procedure addpath_if;
begin
  if s='' then
  exit;

  s := unquote(s);  //Tue 9/26/2006 1:03 pm. bad quotes.

  slash(s);
  result.add(s);

  s := '';

end;

begin
  result := jgo_slist;

  thepath := GetEnvironmentVariable('PATH');

  if not dontdot then begin
    s := '.';             //start with the local path.
    addpath_if;
//  result.add('');         //just use nothing instead.
//no that would wander in the path maybe.
  end;

  for i := 1 to length(thepath) do begin
    if thepath[i]=sepchar then begin
      addpath_if;
    end else begin
      s := s + thepath[i];
    end;
  end;

  addpath_if;      //trailing path?

end;


{****************************************************************************
        so according to exec in Turbo C library, the order is

     no search path for file as-is //don't do this one.

        search path for .com
                        .exe

      And according to my experiments, THEN we look for
                        .bat
                        .cmd

  Whatever.

Should return full path -- or if unfound, original string.

But let's look for them in each path directory in the above order; instead of
going through the whole thing in order, which is obviously wrong.

****************************************************************************}

{$ifdef MSWINDOWS}
function x_in_path(what:string; debug:boolean = false):string;
var
extensions,
paths : TStringList;
label
GOODNESS,
BADNESS;

  function pathoid:boolean;
  var
  i,j:integer;
  begin

    result := true;     //assume success.

    for i := 0 to paths.count-1 do
    for j := 0 to extensions.count-1 do begin
      if FileExists(paths[i]+what+extensions[j]) then begin
        x_in_path := quotate(paths[i]+what+extensions[j],true);
        //set enclosing result probably.

        if debug then
        infof('x_in_path: %s',[paths[i]+what+extensions[j]]);
        exit;
      end;

    end;

    result := false;    //failure.

  end;

begin

  if haspath(what)
  and fileexists(what) then begin
//already accessible. Or at least there's no point in sticking paths in front
//of it.
    result := what;
    exit;
  end;

  paths := pathlist;
  extensions := jgo_slist;
//already has an extension.
  if ExtractFileExt(what)<>'' then begin
    extensions.add('');
    if pathoid then
    goto GOODNESS;

    goto BADNESS;
  end;

  extensions.clear;
  extensions.add('.com');
  extensions.add('.exe');
  extensions.add('.bat');
  if not os_isw9x then
  extensions.add('.cmd');

  if pathoid then
  goto GOODNESS;

BADNESS:
  result := what;

GOODNESS:
  freeandnil(paths);
  freeandnil(extensions);
end;

{$endif}

{****************************************************************************
****************************************************************************}
{$ifdef LINUX}
function x_in_path(what:string; debug:boolean = false):string;
var
//extensions,
paths : TStringList;
label
GOODNESS,
BADNESS;

  function pathoid:boolean;
  var
  i
//  ,j
  :integer;
  begin

    result := true;     //assume success.

    for i := 0 to paths.count-1 do
//    for j := 0 to extensions.count-1 do
    begin
      if FileExists(paths[i]+what
//      +extensions[j]
      )
      then begin
        x_in_path := quotate(paths[i]+what,true);
        //set enclosing result probably.

        if debug then
        infof('x_in_path: %s',[paths[i]+what
//        +extensions[j]
        ]);
        exit;
      end;

    end;

    result := false;    //failure.

  end;

begin

  if haspath(what)
  and fileexists(what) then begin
//already accessible. Or at least there's no point in sticking paths in front
//of it.
    result := what;
    exit;
  end;

  paths := pathlist;
//  extensions := jgo_slist;

//already has an extension.
//  if ExtractFileExt(what)<>'' then begin
//    extensions.add('');
    if pathoid then
    goto GOODNESS;

//    goto BADNESS;
//  end;

//  extensions.clear;
//  extensions.add('.com');
//  extensions.add('.exe');
//  extensions.add('.bat');
//  extensions.add('.cmd');

//  if pathoid then
//  goto GOODNESS;

BADNESS:
  result := what;

GOODNESS:
  freeandnil(paths);
//  freeandnil(extensions);
end;

{$endif}


{****************************************************************************
****************************************************************************}

procedure headtail(s:string; var head,tail:string);
var
sl:TStringList;
begin
  sl := jgo_slist;

  sl.commatext := s;

  head := sl[0];

  tail := copy(s,length(head)+1,5000);

  freeandnil(sl);

end;

{****************************************************************************
****************************************************************************}
{$define ALLOW_SUBDIRS}

function haspath(s:string):boolean;
begin
  result :=
  (s='')    //if it's empty, don't add path.
  or
{$ifdef ALLOW_SUBDIRS}
  (pos(slashchar,s)=1) //make it a *leading* slash
{$else}
  (pos(slashchar,s)>0)
{$endif}
{$ifdef MSWINDOWS}
  or (pos(':',s)>0)
{$endif}

  ;
end;

{****************************************************************************
****************************************************************************}

function Pos_nocase(Substr: string; S: string): Integer;
begin
  result := pos(lowercase(substr),lowercase(s));
end;



//make it end with lineend, if not....
function makelineend(s:string):string;
begin

  result := s;

  if lastchar(result)=LF then
  exit;
//that's supposed to work with linux and winders.

  result := result + LNEND;

end;

{****************************************************************************
****************************************************************************}



end.
