{scan.pas

See the bottom of main.pas for the BSD-style license.

}

{this is the scan menu. }

{$I osops.i}

unit scan;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QButtons, QComCtrls, QExtCtrls;

type
Tscanresult = (ScanNada, Scanscan, ScanLevels, ScanForget,
ScanForgetDirectory,
ScanFilesEnter, ScanFlipFilesEnter, ScanStuffTop, ScanStuffBottom,
ScanFlipFiles, ScanDescribe, Scanpix,
Scanibmpix,
Scanpaths, Scangraf
);

  TScanForm = class(TForm)
    ScanSpin: TSpinEdit;
    scanall: TButton;
    Levels: TButton;
    CancelButton: TBitBtn;
    forget_Level: TButton;
    NewOnly: TCheckBox;
    Label1: TLabel;
    SysOk: TCheckBox;
    helpbutton: TBitBtn;
    DirectoryName: TLabel;
    Button_ForgetDirectory: TButton;
    GroupBox_Other: TGroupBox;
    Panel_right: TPanel;
    Button_FlipEnter: TButton;
    Button_StuffTop: TButton;
    Button_Clip: TButton;
    Button_ClipDirPix: TButton;
    Panel_Left: TPanel;
    Button_ScanFiles: TButton;
    Button_StuffBottom: TButton;
    Button_FlipFiles: TButton;
    Button_Describe: TButton;
    Button_ClipKind: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ScanSpinChanged(Sender: TObject; NewValue: Integer);
    procedure ScanFilesClick(Sender: TObject);
    procedure scanallClick(Sender: TObject);
    procedure LevelsClick(Sender: TObject);
    procedure forget_LevelClick(Sender: TObject);
    procedure NewOnlyClick(Sender: TObject);
    procedure SysOkClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure helpbuttonClick(Sender: TObject);
    procedure Button_ForgetDirectoryClick(Sender: TObject);
    procedure Button_FlipEnterClick(Sender: TObject);
    procedure Button_StuffTopClick(Sender: TObject);
    procedure Button_StuffBottomClick(Sender: TObject);
    procedure Button_FlipFilesClick(Sender: TObject);
    procedure Button_ClipClick(Sender: TObject);
    procedure Button_DescribeClick(Sender: TObject);
    procedure Button_ClipDirPixClick(Sender: TObject);
    procedure CheckBox_pixClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Button_ClipKindClick(Sender: TObject);
  private
    { Private declarations }
    procedure recaption;
    procedure refo;
    procedure xinit;
    procedure scanhelp;
    procedure fixbuttons;
  public
    { Public declarations }
    directory : string;
    scanr : Tscanresult;
  end;

var
  ScanForm: TScanForm;

implementation
{$R *.xfm}

uses
weirdo
, options, code, qt, sbrs, fontfun, qclipbrd, publics, main;

{****************************************************************************
used short cuts (caps):

  CDE   I  L  oP  RT
aBCDEFGhIjKLmNOPqVRTuvwXyz
****************************************************************************}
procedure TScanForm.FormCreate(Sender: TObject);
begin
  autoscroll := true;
{$ifndef LINUX}
  SysOk.visible := false;
{$endif}
end;


const
pixresults : array[1..4] of Tscanresult = (
  Scanpaths,
  Scanpix,
  Scanibmpix,   //i.e. with little ibm graphics characters.
  Scangraf
);

whichpix : integer = low (pixresults);

procedure TScanForm.recaption;
var
level: integer;
new : string;
begin

  if notinited>0 then
  exit;

  if newonly.checked then
  new := 'new '
  else
  new := '';

  level := scanspin.value;

  Levels.caption :=
  safe_format('scan %s%d &Levels',
  [new,level]);

  Forget_level.caption :=
  safe_format('&Forget level %d',[level]);

  Levels.visible := (level>0);
//  Forget_level.visible := Levels.visible;
// it should ALWAYS be visible; forget level 0 should mean dump all subs....

  scanall.caption := safe_format('scan &Directory %s',[new]);

{how stupid Wednesday, February 19, 2003 11:24 am. Just don't let him
do that....}
{
  if scanspin.value = 0 then begin
    Levels.visible := false;
  end else begin
    Levels.visible := true;
  end;
}

  case pixresults[whichpix] of

    scanpaths: begin
      Button_clipDirPix.caption := 'Clip direct&ories names';
    end;

    scanpix: begin
      Button_clipDirPix.caption := 'Clip direct&ories pix';
    end;

    scanibmpix: begin
      Button_clipDirPix.caption := 'Save direct&ories pix (ibm)';
    end;

    scangraf: begin
      Button_clipDirPix.caption := 'Save direct&ories graphic';
    end;

  end;

end;

procedure TScanForm.xinit;
const
done : boolean = false;

  function showcap(s:string; const k:Tos_key):string;
  begin
    result := s;
    if k.key>0 then
    result := safe_format('%s (%s)',[s,k.show])
    else
    result := s;
  end;



begin
  if done then
  exit;

  done := true;

  ScanSpin.value := Goptions.ScanLevels;
{moved from formshow 1/13/03, so the guy's preferred depth is retained
during os session.}

  Button_stuffBottom.caption :=
  showcap('&Stuff files to bottom ',
  Goptions.stuff);

  Button_stuffTop.caption :=
  showcap('S&tuff files to top',
  Goptions.stufftop);

  Button_FlipFiles.caption :=
  showcap('Fl&ip files',
  Goptions.flip);

{$ifdef LINUX}
  GroupBox_Other.height := GroupBox_Other.height + 4;
  height := height +5;
{$endif}



end;

procedure TScanForm.FormShow(Sender: TObject);
begin
  fixfonts(scanform);
  formguard(scanform);

  xinit;

  caption := 'Scan directory "'+directory+'"';
  DirectoryName.caption := directory;

  NewOnly.checked := false;

{  Button_Clip.caption := safe_format ('clip %s',
  [shortstring(directory,25)]);  }

  recaption;

  scanr := ScanNada;

{$ifdef LINUX}
  SysOk.checked := false;
{$endif}

  refo;

end;

procedure TScanForm.ScanSpinChanged(Sender: TObject; NewValue: Integer);
begin
  recaption;
{  refo; }
end;

procedure TScanForm.refo;
begin
  if levels.visible then
  Levels.setfocus
  else if forget_level.visible then
  forget_level.setfocus else
  scanall.setfocus;
end;

procedure TScanForm.scanallClick(Sender: TObject);
begin
  scanr := Scanscan;
  close;
end;

procedure TScanForm.LevelsClick(Sender: TObject);
begin
  scanr := ScanLevels;
  close;
end;

procedure TScanForm.NewOnlyClick(Sender: TObject);
begin
  recaption;
  refo;

end;

procedure TScanForm.SysOkClick(Sender: TObject);
begin
{$ifdef LINUX}
  if (not SysOk.focused) or (not Sysok.checked) then
  exit;

  if not usuref(
  'Scanning "sys" dirs might be fun, but for instance in the '+
  'dev directories there are thousands of them; Go ahead?') then
  sysok.checked := false;

{$endif}
end;

procedure TScanForm.scanhelp;
begin
  oshelp('The Scan Menu');
  setfocus; {sigh...}
  refo;
end;

procedure TScanForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if (is_key(Goptions.help,key,shift)) or (key=key_F1) then begin
    scanhelp;
    exit;
  end;

//  if key=key_enter then begin
//  end;
// no no can't do that one.

  if (is_key(Goptions.stufftop,key,shift)) then begin
    key := 0;
    Button_stuffTopClick(nil);
  end;

  if (is_key(Goptions.stuff,key,shift)) then begin
    key := 0;
    Button_StuffBottomClick(nil);
  end;

  if (is_key(Goptions.flip,key,shift)) then begin
    key := 0;
    Button_flipFilesClick(nil);
  end;

end;

procedure TScanForm.helpbuttonClick(Sender: TObject);
begin
  scanhelp;
end;

procedure TScanForm.Button_ForgetDirectoryClick(Sender: TObject);
begin
  scanr := ScanForgetDirectory;
  close;
end;

procedure TScanForm.forget_LevelClick(Sender: TObject);
begin
  scanr := ScanForget;
  close;
end;

procedure TScanForm.ScanFilesClick(Sender: TObject);
begin
  scanr := ScanFilesEnter;
  close;
end;

procedure TScanForm.Button_FlipEnterClick(Sender: TObject);
begin
  scanr := ScanFlipFilesEnter;
  close;
end;

procedure TScanForm.Button_StuffTopClick(Sender: TObject);
begin
  scanr := ScanStuffTop;
  close;
end;

procedure TScanForm.Button_StuffBottomClick(Sender: TObject);
begin
  scanr := ScanStuffBottom;
  close;
end;

procedure TScanForm.Button_FlipFilesClick(Sender: TObject);
begin
  scanr := ScanFlipFiles;
  close;
end;

procedure TScanForm.Button_ClipClick(Sender: TObject);
begin
  try
    clipboard.astext := directory;
    scanr := scannada;
    close;
  except
    on exception do;
  end;

end;

procedure TScanForm.Button_DescribeClick(Sender: TObject);
begin
  scanr := ScanDescribe;
  close;
end;

procedure TScanForm.Button_ClipDirPixClick(Sender: TObject);
begin
  scanr := pixresults[whichpix];
  close;
end;

procedure TScanForm.CheckBox_pixClick(Sender: TObject);
begin
  recaption;
end;

procedure TScanForm.fixbuttons;
const
margin = 8;
other_margin = 4;
var
bwidth, nextleft : integer;

  procedure btadj(b:Tbutton);
  begin
    b.left := nextleft;
    b.width := bwidth;
    inc(nextleft,bwidth + margin);
  end;

begin

  Panel_left.left := other_margin;
  Panel_Left.width := (GroupBox_Other.width - other_margin * 3) div 2;
  Panel_Right.left := Panel_left.width+other_margin;
  Panel_Right.width := Panel_left.width;

  bwidth := (width-margin*5) div 4;
  nextleft := margin;
  btadj(Levels);
  btadj(scanall);
  btadj(Button_ForgetDirectory);
  btadj(forget_level);
end;

procedure TScanForm.FormResize(Sender: TObject);
begin
  fixbuttons;
end;

procedure TScanForm.Button_ClipKindClick(Sender: TObject);
begin
  inc(whichpix);
  if whichpix>high(pixresults) then
  whichpix := low(pixresults);
  recaption;
end;

end.
