{weirdo.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit weirdo;
{****************************************************************************
Fri 5/17/02 2:14 pm. What we got to do here is put stuff like GetLongPathName
-- although I haven't figgered out yet what I will do with it. NOTE that in
Windows NT, GetFullPathName DOES NOT return the long path; it does, however,
in W9x. Probably. Maybe on Tuesday....

Anyway much of this was grokked from the windows.pas source in the RTL source.
****************************************************************************}

{.$ALIGN ON}
{.$MINENUMSIZE 4}
{.$WEAKPACKAGEUNIT}
{****************************************************************************
WEAKPACKAGE                                         Fri 2/11/2005 6:37 pm

[Error] weirdo.pas(261): $WEAKPACKAGEUNIT 'weirdo' cannot have initialization
or finalization code

//Fri 2/11/2005 6:36 pm. Which means it can't have globals, see? Of course.
But I can't remember for the life of me why those directive are there at
all.... Maybe I just copied them from windows.pas.... So let's see how we do
without them. // Monday, February 21, 2005 4:56 pm seemed to work fine.

****************************************************************************}


interface

uses Types
,publics
{$ifdef MSWINDOWS}
, windows
//, messages
{$ifdef RECYCLE}
,shellapi
,forms
{$endif}
, sysutils
{$endif}
,osinfo
;

{$ifdef MSWINDOWS}
type

FileSystemKind = (fat_filesystem, ntfs_FileSystem, WhoKnows_FileSystem);
{$endif}


{****************************************************************************
****************************************************************************}

{$ifdef MSWINDOWS}

//function Get_ms:os_ticks;

function GetLabel(Drive: string): string;
function os_isw9x:boolean;
function os_isxp:boolean;
function os_isVista:boolean;
function os_isw7:boolean;

function cw_filesystem:FileSystemKind;
function isbatch(what:string):boolean;


function shortify(src:string; er : boolean = false):string;
function longify(src:string):string;
procedure v_longify(var src:string);
procedure v_shortify(var src:string);

function GetLongPathName(lpszLongPath: PChar; lpszShortPath: PChar;
  cchBuffer: DWORD): DWORD; stdcall;
procedure win_putenv(name,what:string);

{$EXTERNALSYM GetLongPathName}

function dirtime_string(f:Tsearchrec):string;
function if_dirtime_int(is_dir:boolean; f:Tsearchrec):integer;

{$endif}

{$ifdef RECYCLE}
function recycle_file(fname:string):boolean;
{$endif}

procedure oshelp(key:string; heading:boolean = false);
procedure init_help;

{$if defined(MSWINDOWS) and defined(BETTER_READY)}
function IsDriveReady(Root: string): Boolean;

{$ifend}



{****************************************************************************
****************************************************************************}

implementation

{$ifdef LINUX}
uses classes, sbrs, options, exec, sysutils;
{$endif}

{$ifdef MSWINDOWS}

uses options, {publics,} main, sbrs, fileutil, registry, classes, exec;

function GetLongPathName; external kernel32 name 'GetLongPathNameA';

{****************************************************************************
from c:\Program Files\Borland\Delphi7\Source\Rtl\Sys\System.pas

  TWin32FindData = packed record
    dwFileAttributes: Integer;
    ftCreationTime: Int64;
    ftLastAccessTime: Int64;
    ftLastWriteTime: Int64;
    nFileSizeHigh: Integer;
    nFileSizeLow: Integer;
    dwReserved0: Integer;
    dwReserved1: Integer;
    cFileName: array[0..259] of Char;
    cAlternateFileName: array[0..13] of Char;
  end;

from c:\Program Files\Borland\Delphi7\Source\Rtl\Sys\Types.pas

  _FILETIME = packed record
    dwLowDateTime: DWORD;
    dwHighDateTime: DWORD;
  end;
  ...
  TFileTime = _FILETIME;

from "c:\Program Files\Borland\Delphi7\Demos\Virtual Listview\VListView.pas"

  SysTime: TSystemTime;
  ...
  LocalFileTime: TFILETIME;


      //Modified Date
      FillChar(LocalFileTime, SizeOf(TFileTime), #0);
      with FileData do
        if ValidFileTime(ftLastWriteTime)
        and FileTimeToLocalFileTime(ftLastWriteTime, LocalFileTime)
        and FileTimeToSystemTime(LocalFileTime, SysTime) then
        try
          ModDate := DateTimeToStr(SystemTimeToDateTime(SysTime))
        except
          on EConvertError do ModDate := '';
        end
        else
          ModDate := '';


//onward.

So Tdatetime to Filetime: DateTimetoFileDate function.
STring to Tdatetime: StrtoDateTime

****************************************************************************}

function if_dirtime_int(is_dir:boolean; f:Tsearchrec):integer;
begin
  if (is_dir and Goptions.dir_creationtime
//{$ifdef MSWINDOWS}  //whole thing is windows!
//and (Goptions.os=XP)
  and (Gthis_windows_filesystem=ntfs_FileSystem)
//{$endif}
  ) then
  try
    result :=
    DateTimetoFileDate(StrtoDateTime(dirtime_string(f)));
{I have a feeling I may have gone one or two silly conversions too many
here but what the heck.... It *is* XP....}
    exit;
  except
    on exception
    do ;
  end;

  result := f.time;

end;


function dirtime_string(f:Tsearchrec):string;
var
SysTime: TSystemTime;
LocalFileTime: Tfiletime;

 function ValidFileTime(FileTime: TFileTime): Boolean;
 begin
   Result := (FileTime.dwLowDateTime <> 0) or (FileTime.dwHighDateTime <> 0);
 end;

begin

{$WARNINGS OFF}
  with f.FindData do begin
{$WARNINGS ON}
    FillChar(LocalFileTime, SizeOf(TFileTime), #0);
    if ValidFiletime(ftCreationTime) and
    FileTimeToLocalFileTime(ftCreationTime, LocalFileTime) and
    FileTimeToSystemTime(LocalFileTime, SysTime) then
    try
      result := DateTimeToStr(SystemTimeToDateTime(SysTime))
    except
      on exception
      do result := '????';
    end;
  end;
end;

{$endif}    {MSWINDOWS}

{****************************************************************************
****************************************************************************}
{$ifdef MSWINDOWS}
{.$define USE_GLOBAL}
{$ifdef USE_GLOBAL}
function SetGlobalEnvironment(const Name, Value: string;
  const User: Boolean = True): Boolean;
resourcestring
  REG_MACHINE_LOCATION = 'System\CurrentControlSet\Control\Session Manager\Environment';
  REG_USER_LOCATION = 'Environment';
begin

  dbg('SetGlobalEnvironment(%s,%s)',[name,value]);

  with TRegistry.Create do
    try
      if User then { User Environment Variable }
        Result := OpenKey(REG_USER_LOCATION, True)
      else { System Environment Variable }
      begin
        RootKey := HKEY_LOCAL_MACHINE;
        Result  := OpenKey(REG_MACHINE_LOCATION, True);
      end;
      if Result then
      begin
        WriteString(Name, Value); { Write Registry for Global Environment }
        { Update Current Process Environment Variable }
        SetEnvironmentVariable(PChar(Name), PChar(Value));
        { Send Message To All Top Window for Refresh }
        SendMessage(HWND_BROADCAST,
//        WM_INICHANGE
        WM_SETTINGCHANGE
        , 0, Integer(PChar('Environment')));
      end;
    finally
      Free;
    end;
end; { SetGlobalEnvironment }
{$endif}

procedure win_putenv(name,what:string);
begin
//  name := uppercase(name);
// I was trying to get this junk to work in w98. didn't help.
  if not setenvironmentvariable(pchar(name),pchar(what)) then
  dbg('setenvironmentvariable(%s,%s) failed',[name,what]);
{$ifdef USE_GLOBAL}
  if Goptions.os=w9x then
  SetGlobalEnvironment(name,what);
{$endif}
end;




{$endif}
{****************************************************************************
****************************************************************************}
{$ifdef MSWINDOWS}

{****************************************************************************
function GetShortPathName(lpszLongPath: PChar; lpszShortPath: PChar;
  cchBuffer: DWORD): DWORD; stdcall;

function GetFullPathName(lpFileName: PChar; nBufferLength: DWORD;
  lpBuffer: PChar; var lpFilePart: PChar): DWORD; stdcall;

StrPLCopy(Dest: PChar; const Source: string; MaxLen: Cardinal): PChar;

LEAVE THIS HERE! Pascal help hides it fanatically.

Wednesday, July 25, 2007 1:07 pm. These aren't being used today.

****************************************************************************}

procedure v_shortify(var src:string);
var
{s,}d: array[0..MAX_OSPATH+3] of char;
x:DWORD;
begin
{  deslash(src); }
{  StrPLCopy(s,src,MAXPATH); }
  x := getshortpathname({@s} pchar(src),@d,MAX_OSPATH);
{  osinfof('x is %d',[x]);  }
  if x<>0 then
  src := d;
end;


procedure v_longify(var src:string);
var
{s,}d: array[0..MAX_OSPATH+3] of char;
x:DWORD;
begin
{  deslash(src); }
{  StrPLCopy(s,src,MAXPATH); }
  x := getlongpathname({@s} pchar(src),@d,MAX_OSPATH);
{  osinfof('x is %d',[x]);  }
  if x<>0 then
  src := d;
end;

{****************************************************************************
****************************************************************************}
{$define DEBUG_SHORTIFY}    //just leave it on all the time instead
{$define DONT_ERROR_FILE}   //don't substitute error message for name if
                            //failure.
function shortify(src:string; er : boolean = false):string;
var
d: array[0..MAX_OSPATH+3] of char;
x:DWORD;
begin
//           12345678 123
{$ifdef DONT_ERROR_FILE}
  result := src;
{$else}
  result := 'short_fa.il!';
{$endif}

{****************************************************************************
use a more informative name, without colons -- they drove the poor Buerg List
mad.... (it was "::error::") // and then why do error at all stupid!? It's
more likely to succeed even if fail if it returns the original thingoid.
Particularly for longify.
****************************************************************************}

  x := getshortpathname(pchar(src),@d,MAX_OSPATH);
  if x<>0 then
  result := d
{$ifdef DEBUG_SHORTIFY}
{****************************************************************************
Wed 12/12/2007 5:58 pm. So this happened on c:\pagefile.sys -- which is hidden
and all...
****************************************************************************}
  else begin
    dbg('shortify: "%s", "%s"',[src,string(d)]);
    if er then
    result := ''; //note error with empty string.
  end;
{$endif}

  ;

end;

function longify(src:string):string;
var
d: array[0..MAX_OSPATH+3] of char;
x:DWORD;
begin
{$ifdef DONT_ERROR_FILE}
  result := src;
{$else}
  result := 'longify_failure!';
{$endif}
  x := getlongpathname(pchar(src),@d,MAX_OSPATH);
  if x<>0 then
  result := d
{$ifdef DEBUG_SHORTIFY}
  else
  dbg('longify: "%s", "%s"',[src,string(d)]);
{$endif}
  ;
end;

{$endif}

{****************************************************************************
****************************************************************************}

{$ifdef MSWINDOWS}

const
osMajor : integer = -1;
osMinor : integer = -1;

function os_version:boolean;
var
OSVersionInfo: TOSVersionInfo;
begin
  result := true;   //assume success.

  if osMajor > -1 then
  exit;

  result := false;  //assume failure.

  OSVersionInfo.szCSDVersion[0] := chr(0);
  OSVersionInfo.dwOSVersionInfoSize := SizeOf(OSVersionInfo);
  if (not GetVersionEx(OSVersionInfo)) then
  exit;

  osMajor := OSVersionInfo.dwMajorVersion;
  osMinor := OSVersionInfo.dwMinorVersion;

  result := true;

  {
  osinfof('Windows version %d.%d',
  [OSVersionInfo.dwMajorVersion,OSVersionInfo.dwMinorversion]);
  }


end;

function os_isw9x:boolean;
begin
  result := true;   //assumed w9x.

  if not os_version
  then exit;    //it's hopeless; probably w9.

  if osMajor>=5 then
  result := false;
end;

function os_isxp:boolean;
begin
  result := not os_isw9x;
  //in our little world, "xp" means "not w95".
end;


//but others may be curious.
function os_isVista:boolean;
begin
  result := false;
  if not os_version
  then exit;

  result :=
  (osMajor=6)
  and (osMinor=0);
end;

function os_isw7:boolean;
begin
  result := false;
  if not os_version
  then exit;

  result :=
  (osMajor=6)
  and (osMinor=1);
end;


{$ifdef IT_GOT_COMPLICATED}
function os_isw9x:boolean;
var
OSVersionInfo: TOSVersionInfo;
begin
  result := true;   {assume w9x.}

  OSVersionInfo.szCSDVersion[0] := chr(0);
  OSVersionInfo.dwOSVersionInfoSize := SizeOf(OSVersionInfo);
  if (not GetVersionEx(OSVersionInfo)) then
  exit;

  osMajor := OSVersionInfo.dwMajorVersion;
  osMinor := OSVersionInfo.dwMinorVersion;

  {
  osinfof('Windows version %d.%d',
  [OSVersionInfo.dwMajorVersion,OSVersionInfo.dwMinorversion]);
  }

  if OSVersionInfo.dwMajorVersion>=5 then
  result := false;

end;
{$endif}

{****************************************************************************
function GetVolumeInformation(
  lpRootPathName: PChar;

  lpVolumeNameBuffer: PChar;
  nVolumeNameSize: DWORD;
  lpVolumeSerialNumber: PDWORD;

  var
  lpMaximumComponentLength, lpFileSystemFlags: DWORD;
  lpFileSystemNameBuffer: PChar; nFileSystemNameSize: DWORD): BOOL; stdcall;

FileSystemKind = (fat_filesystem, ntfs_FileSystem, WhoKnows_FileSystem);

****************************************************************************}

function cw_filesystem:FileSystemKind;
const
FSNS = 20;
var
FSN : array[0..FSNS] of char; //yes it's 1 larger than FSN but that's
                              //probably corrrect or could be on Tuesday.
dummy: DWORD;

begin
  result := WhoKnows_FileSystem;

  if not
  GetVolumeInformation(
  nil,  //current volume.
  nil,  //don't fill-in with volume name.
  0,    //volume name count.
  nil,  //no volume serial number please.
  dummy,//max path length.
  dummy,//systemflags
  @FSN,
  FSNS) then
  exit;

  if SameText(FSN,'FAT') then
  result := fat_filesystem;

  if SameText(FSN,'NTFS') then
  result := ntfs_FileSystem;

end;


{$endif}

{****************************************************************************
****************************************************************************}
{$ifdef MSWINDOWS}

{****************************************************************************
So "c:\gregor\owenshow" wasn't good-enough; it has to be "c:\".

So I got this from
http://www.greatis.com/delphicb/tips/lib/drives-cdlabel.html
****************************************************************************}

function GetLabel(Drive: string): string;
var
  VolumeName: array[0..255] of Char;
  FileSystemType: array[0..255] of Char;
  SerialNum: DWORD;
  MaxFilenameLength: DWORD;
  Flags: DWORD;
begin
  if (GetVolumeInformation(
  PChar(Drive),
  VolumeName,
  256,
  @SerialNum,
  MaxFilenameLength,
  Flags,
  FileSystemType,
  256)) then
  Result:=VolumeName
  else
  Result:='';
end;

{****************************************************************************
****************************************************************************}

{
function Get_ms:os_ticks;
begin
  result := GetTickCount;
end;
}

{****************************************************************************
****************************************************************************}
{$endif}    //mswindows.

{****************************************************************************
Mon 7/17/2006 2:39 pm.

  PSHFileOpStructA = ^TSHFileOpStructA;
  PSHFileOpStructW = ^TSHFileOpStructW;
  PSHFileOpStruct = PSHFileOpStructA;
  //$EXTERNALSYM _SHFILEOPSTRUCTA
  _SHFILEOPSTRUCTA = packed record
    Wnd: HWND;
    wFunc: UINT;
    pFrom: PAnsiChar;
    pTo: PAnsiChar;
    fFlags: FILEOP_FLAGS;
    fAnyOperationsAborted: BOOL;
    hNameMappings: Pointer;
    lpszProgressTitle: PAnsiChar; // only used if FOF_SIMPLEPROGRESS
  end;
  //$EXTERNALSYM _SHFILEOPSTRUCTW
  _SHFILEOPSTRUCTW = packed record
    Wnd: HWND;
    wFunc: UINT;
    pFrom: PWideChar;
    pTo: PWideChar;
    fFlags: FILEOP_FLAGS;
    fAnyOperationsAborted: BOOL;
    hNameMappings: Pointer;
    lpszProgressTitle: PWideChar; // only used if FOF_SIMPLEPROGRESS
  end;
  //$EXTERNALSYM _SHFILEOPSTRUCT
  _SHFILEOPSTRUCT = _SHFILEOPSTRUCTA;
  TSHFileOpStructA = _SHFILEOPSTRUCTA;
  TSHFileOpStructW = _SHFILEOPSTRUCTW;
  TSHFileOpStruct = TSHFileOpStructA;
  //$EXTERNALSYM SHFILEOPSTRUCTA
  SHFILEOPSTRUCTA = _SHFILEOPSTRUCTA;
  //$EXTERNALSYM SHFILEOPSTRUCTW
  SHFILEOPSTRUCTW = _SHFILEOPSTRUCTW;
  //$EXTERNALSYM SHFILEOPSTRUCT
  SHFILEOPSTRUCT = SHFILEOPSTRUCTA;

function SHFileOperation(const lpFileOp: TSHFileOpStruct): Integer; stdcall;

From Ron Burk's "Recycling Alternative to DeleteFile() 1/01 Windows
Developer's Journal page 51.

But sadly, Ron Burk didn't figure he was supposed to init pto to "" instead of
NIL. As odd-numbered Tuesdays, XP Sp2.... And of course later I discovered he
used "getlongpathname" which is just wrong; supposed to be "getfullpathname".
Tch tch tch....

As per SHFileOP, Copyright (c) 1997 WinWright Consulting Written by Wayne
Niddery.

But sadly, even WinRight consulting couldn't tell me how to make it work in
W98. *I* had to use advanced guessology and do Fix #2. Apparently you're
supposed to be able to pass pfrom as lists of 0-terminated strings, i.e.

  db 'BONGO',0
  db 'BINGO',0
  db 0          ;probably

a common idiom in the neolithic era. I don't do that, but if the OS doesn't
see a double-zero terminator it might get cranky. Or who knows....

And then I did Fix #3, Fix #4, and left Fix #1, all of which seem a good idea.
I should note in w98 deleting files this way takes, as noted by some unhappy
pilgrim on the web, 1/2 second or so for each file.... Oh I get it! See it
took so appalingly long that they had to have the multiple-file list thingey;
right cool....

function GetFullPathName(lpFileName: PChar; nBufferLength: DWORD;
  lpBuffer: PChar; var lpFilePart: PChar): DWORD; stdcall;

****************************************************************************}

{$ifdef RECYCLE}
function recycle_file(fname:string):boolean;
var
info:TSHFileOpStruct;
d: array[0..MAX_OSPATH+3] of char;
fpart : PCHAR;
x:DWORD;
r:integer;
const
empty : array [0..1] of char = ( #0, #0 );  //Fix #4. Have a double
                                            //terminator.
begin
  result := false;    //assume failure.

  fillchar(info,sizeof(info),0); //Fix #3.
  fillchar(d,sizeof(d),0);
  //make it work in w98? Apparently you could past lists with multiple \0
  //terms... //Yes! Fix #2.

//  x := getlongpathname(pchar(fname),@d,MAX_OSPATH);

  x := GetFullPathName(pchar(fname),MAX_OSPATH,@d,fpart);

//  dbg('%s  %s',[fname,d]);

  if x=0 then
  exit;

  info.wnd    := Application.handle;  //make it work in w98? //nope. but might
  //as well leave; I mean it seems like a good plan in general. Fix #1.

  info.wfunc  := FO_DELETE;
  info.pfrom  := @d;
  info.pto    := @empty; //when it was NIL, it crashed.
  info.fflags := FOF_ALLOWUNDO or FOF_NOCONFIRMATION;

  r := SHFileOperation(info);

  result := (r=0);

end;

{$ifdef bad1st_try}
  function recycle_file(fname:string):boolean;
  var
  info:TSHFileOpStruct;
  d: array[0..MAX_OSPATH+3] of char;
  x:DWORD;
  r:integer;
  const
  empty : array [0..1] of char = ( #0, #0 );  //Fix #4. Have a double
                                              //terminator.
  begin
    result := false;    //assume failure.

    fillchar(info,sizeof(info),0); //Fix #3.
    fillchar(d,sizeof(d),0);
    //make it work in w98? Apparently you could past lists with multiple \0
    //terms... //Yes! Fix #2.

    x := getlongpathname(pchar(fname),@d,MAX_OSPATH);

//    dbg('%s  %s',[fname,d]);

    if x=0 then
    exit;

    info.wnd    := Application.handle;  //make it work in w98? //nope. but might
    //as well leave; I mean it seems like a good plan in general. Fix #1.

    info.wfunc  := FO_DELETE;
    info.pfrom  := @d;
    info.pto    := @empty; //when it was NIL, it crashed.
    info.fflags := FOF_ALLOWUNDO or FOF_NOCONFIRMATION;

    r := SHFileOperation(info);

    result := (r=0);

  end;
{$endif}

{$endif}
{****************************************************************************
****************************************************************************}

{$ifdef MSWINDOWS}
function isbatch(what:string):boolean;
var
s:string;
begin

  s := ExtractFileExt(unquote(what));

  result :=
  (SameText(s,'.bat'))
  or
  ((os_isxp) and SameText(s,'.cmd'))
  ;

end;

{$endif}

{****************************************************************************
Trying to start help with ShellExecute(`%s); when that doesn't work, try
viewing the htm file directly, or maybe change the option "helphtm" `%s if
it's wrong. To stop seeing this message, set "helpok=1" in the ini file.
`a,[Goptions.helphtm,ininame]


//     function owenshow() [[[[[
//     window.location='#`%s';
//     ]]]]]
//     `a,[key]

The [[[]]] should be replaced by squiggly junk.


****************************************************************************}

procedure init_help;
begin
  DeleteFile(Goptions.helpjs);
  //so doesn't gook-up non-context help.
end;

//used by both linux/windows
procedure c_h(key:string);
var
h:integer;
begin
  init_help;    //delete the file anyway.

  if key='' then
  exit;         //and leave it disappeared if no help.

  h := StupidNewFile(Goptions.helpjs);
  if h<0 then
  exit;

  hprintf(h,


'function owenshow() {'
+' window.location=''#%s'';'
+' }'
,[key]


  );

  FileClose(h);


end;


{****************************************************************************
function os_exec(exec:string; arguments:TStringList;
modal:boolean = true; chat : boolean = false):
boolean;


Trying to start help with "`%s `%s"; when that doesn't work, try viewing the
htm file directly with a browser, and/or try changing the "helpexecute" and/or
"helphtm" options in `%s. To stop seeing this message, set "helpok=1" in the
ini file.
`a,[Goptions.helpexecute,Goptions.helphtm,ininame]


****************************************************************************}

procedure
{$ifdef LINUX}
oshelp
{$endif}
{$ifdef MSWINDOWS}
x_oshelp
{$endif}
(key:string; heading:boolean = false);
var
slist : TStringList;
begin

  blrize(key);
  c_h(key);

  slist := jgo_slist;
  slist.add(quotate(Goptions.helphtm,true));

{$ifdef NILLIFY}
  execnillify;
{$endif}

  os_exec(Goptions.helpexecute,
  slist,
  false,
  false);

  FreeAndNil(slist);

  if not Goptions.helpok then begin
    Goptions.helpok := true;  //don't do it again.
    osinfof(


'Trying to start help with "%s %s"; when that doesn''t work, try viewing the'
+' htm file directly with a browser, and/or try changing the "helpexecute" and/or'
+' "helphtm" options in %s. To stop seeing this message, set "helpok=1" in the'
+' ini file.'
,[Goptions.helpexecute,Goptions.helphtm,ininame]


    );

  end;

end;

{****************************************************************************
****************************************************************************}

{$ifdef MSWINDOWS}
procedure oshelp(key:string; heading:boolean = false);
{$ifndef PGMDIRIZE_HELPDIR}
const cleared_help : boolean = false;
{$endif}
const execed_done : boolean = false;
begin


  if not execed_done then begin
    execed_done := true;
    if (Goptions.helpexecute='')
    or (not FileExists_unq(Goptions.helpexecute)) then
    Goptions.helpexecute := '';   //flag as hopeless.
  end;

  if execed_done and (Goptions.helpexecute<>'')
  then begin
    x_oshelp(key);
    exit;
  end;

{$ifndef PGMDIRIZE_HELPDIR}
  if Goptions.helpok
  and (not cleared_help) then begin
    cleared_help := true;
    dbg_nolog(
    '!'+
    'probably slowly loading HTML help....');
    clear_debug(15000);
  end;
{$endif}

  blrize(key);
  c_h(key);

  ShellExecute(
    Application.handle,
    'open',
    pchar(Goptions.helphtm),
    nil,
    nil,
    SW_SHOWNORMAL
  );

  if not Goptions.helpok then begin
    Goptions.helpok := true;  //don't do it again.
    osinfof(


'Trying to start help with ShellExecute(%s); when that doesn''t work, try'
+' viewing the htm file directly, or maybe change the option "helphtm" %s if'
+' it''s wrong. To stop seeing this message, set "helpok=1" in the ini file.'
,[Goptions.helphtm,ininame]


    );

  end;

end;
{$endif}



{****************************************************************************
****************************************************************************}
{$if defined(MSWINDOWS) and defined(BETTER_READY)}
function IsDriveReady(Root: string): Boolean;
var
  Oem:      Cardinal;
  Dw1, Dw2: DWORD;
begin
  Oem := SetErrorMode(SEM_FAILCRITICALERRORS);
  if Length(Root) = 1 then Root := Root + ':\';
  try
    Result := GetVolumeInformation(PChar(Root), nil, 0, nil, Dw1, Dw2, nil, 0);
  except
    on exception do
    result := false;
  end;
  SetErrorMode(Oem);
end;

{$ifend}

{****************************************************************************
****************************************************************************}


end.


