{main.pas

See the bottom of main.pas for the BSD-style license.

NOTES.

----------------------------------------
WHY DOESN'T OWENSHOW COMPILE?

LINUX/WINDOWS PROBLEM: [Error] help.pas(502): Left side cannot be assigned to.

Solution: OWENSHOW *LIKES* ASSIGNED CONSTS: check Project / Options / Compiler
/ Assignable Typed Consts. Note that you may have to compile or "Project /
Build os" a few times for the option change to "take".

----------------------------------------
OTHER PROBLEMS

* And oh yes; the main menu on top of the main form continually adds a BLANK
LINE after itself in the IDE. Just resize the form a bit to make the blank go
away (the compiled version doesn't show the blank anyway). And it does it in
both Linux and Windows!

* When moving to and from Windows and Linux, occasionally A FORM IN THE
COMPILED PROGRAM WILL LOOK STRANGE -- too big, little, squashed. The solution
is to resize the form inside the IDE. When I do the famous OwenShow release,
the forms are usually OK in Windows, so I go through every form except main
and splash and resize them a bit -- including resize, which isn't shown as a
form in Linux at least.

* DELPHI EXCEPTIONS: When debugging in the Kylix/Delphi environment, often you
want to turn *off* Delphi exceptions (Tools / Debugger options / Language
exceptions / uncheck "Stop on Delphi exceptions" at bottom of form). Otherwise
Delphi'll break even on caught exceptions which often are a normal part of
program logic, i.e. my directory scanner expects to find a few directories it
can't "chdir" to, and catches these things. See also "SIGSEGV(11)" in
README.SRC for those.

* If you want to create another new Linux/Windows Kylix/Delphi application *in
Windows*, you must use File/New/CLX Application -- i.e. USE THE CLX LIBRARY.

* HOW TO SORT PROJECT MANAGER Tue 8/26/03 12:26 pm. This just in; "View /
Project Manager" is normally the way you get around your giant project. In
Delphi 7/Kylix 3, Borland decided that it would be fun if this list *ceased to
be alphabetized!* Kuel eh? But apparently it follows the order in the DPR,
OS.DPR in this project, and so you *can* sort that to make the list sorted.
Note that rearranging things in the DPR file (1.) must be done with the
correct syntax, commas semicolons etc., (2.) can in some projects make a
difference in compilation/execution. Also occasionally I think the project
manager view occasionally remembers to sort something.

----------------------------------------
OLD FIXED PROBLEMS

* LINUX compile problem: [Fatal Error] File not found:
'/home/gregor/kylix3/bin/QDialogs.pas'

Solution: "rm QDialogs.dcu" Discussion: QDialogs.dcu was distributed with the
OwenShow source so the Windows version compiles a working SaveDialog for
Windows 98. On the other hand, the Kylix Delphi apparently just sweeps-up any
DCU files it finds in the directory, even 'though QDialogs is
conditionaled-out in OS.DPR -- or who knows. So you have to manually delete it
in Linux. Tue 8/23/2005 11:59 am. This will probably not happen in future; I'm
deleting it in the Linux distribution automatically (what a concept, eh?).

LINUX/WINDOWS PDSORT MISSING: At a directory scan, "pdsortx ... missing;
directory sort unavailable": either copy the pdsort program from an existing
OwenShow directory (pdsortx or pdsortx.exe) or see README.SRC for how to
compile it. // But of course we don't *use* pdsortx anymore.

LINUX FAIL AFTER EXEC: When you write an [exec] for OwenShow, and/or copy/use
one from OSEX.INI, if the executable for some reason isn't available -- typo
etc. -- OwenShow dies. Solution: Actually this doesn't happen anymore; it used
to be because you forgot to copy "nop" from an existing OwenShow installation,
or compile it -- but now see RAITER'S TRUE PROGRAM in README.SRC for how
everything fixes itself now....

}
{****************************************************************************
****************************************************************************}
{$I osops.i}

{$define COLOR_FASTER}  //tinker with select coloring.
{.$define IDLE_KEY}      //force keys from os_idle for test.
{****************************************************************************
****************************************************************************}

{.$define KEYUP}
{Tue 11/25/03 4:28 pm While I'm screwing things up, let's use key-up instead
of key-down. // This was supposed to fix a lingering alt problem -- when I
execute something, because I'm executing it *inside* the keyboard thingey,
owenshow never sees the alt key go back-up, so it just leaves it on all the
time. But doing it inside KEYUP won't help, because it *still* won't see the
ALT go up.}

{$if defined(KEYUP)}
  {$Error: keyup and key execution don't play well}
{$ifend}

{****************************************************************************
****************************************************************************}

unit main;

interface

uses
{$ifdef LINUX}
  Libc,
{$endif}
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QExtCtrls, QButtons, QMenus, QTypes, {options,}
  dir, sbrs, scan,
  weirdo, code
  ,publics
  ;

const

howoff = 0;
howclick = 1;
howNoway = 2;
notinited : integer = 1;
os_off : boolean = true;



var
MyKeyQueue : Tlist;

plz_restore_layout : boolean;

Gosidle_will_turn_on,
//a promise that someone else will turn it on, so onactivate doesn't
//have to.

Gosidle_on : boolean;
//Tuesday, June 14, 2005 11:29 am. Moved here so others can see it.

Gthrottling : boolean;
//so file_lxstat can see it. // turned out bad idea but what the heck.

{$ifdef LINUX}
gRE_EXEC_LD_LIBRARY_PATH : string;
//made it public Mon 5/16/2005 3:11 pm. And then closed system blew up
//exploded with @F4.
{$endif}

Gnon_modaldelay : integer;  //set by exec.pas q.v.

keepcumulative : integer;
//Monday, November 15, 2004 6:38 pm. Stop cumulativeStop if >0.

thetree : Ttree;

dbg_count : integer;

{$ifdef MSWINDOWS}
const
Gthis_windows_filesystem : FileSystemKind = WhoKnows_FileSystem;

files_rut : string = '?:'+slashchar;
//someone must init that with options originaldrive

{$endif}

type

{****************************************************************************
This is the heart of the poor thing, as it worked out. Note in particular the

  view: TlistView   displays the files.
  files: farray     dynamic array actually contains the file data.

These are of course redundant, but sorting the TlistView, at least the CLX
version, took forever. A good deal of hocus-pocus is involved in making sure
the appearance of the thing corresponds to the files array.

(These type defintions apparently should appear in the form file where they're
used, at least that's how this one worked-out. Actually there is no way to
do this correctly -- circular refs -- a remaining little flaw of Delphi....)

****************************************************************************}

{File view type}
Tfv = class
  view : TListView;
  status : TLabel;
  panel : TPanel;
  flipbutton : Tbutton;

  sortdir : string;
  old_tree:Ttree;
  old_ns, old_s,

  namesort,       {whatever name is set to; it has more variation.}
  sort : FileSortKind;
  {oh I get it; when he clicks from "size" to "name", we want do the kind
  of name sort he did last. Or something.}

{  files : array of Tos_f; }
  fls : TStringList;
  bytecount : int64;
  dircount,
{****************************************************************************
Thu 1/26/2006 2:17 pm. I added this but didn't use it or test it. Might work.
It's supposed the count of *just* the directories. filecount is still the
count of files *and* directories.
****************************************************************************}

  filecount : integer;
  statinfo, {Tuesday, August 20, 2002 6:32 pm main:fhintoid. }
  selectdir, {apparently it's just the dir name.}
  selectname : string; {not kept current; used for retaining select between an
  occasional scan. }
  selectindex : integer;

  scanonce, scannedonce : boolean; {see files.scanonce }
  needs_sort : boolean; {see files file_oldnew etc.}
  which : whichpanel; {id itself.}
  nonexistent : boolean;  {set for nonexistent directories.}
  file_tree : Ttree;    {was tree}
  dir_index : integer;  {might contain index of files in directory. Just
  used as a hint so we don't search the whole tree every time.}
  sorted,   {set if the sort actually occurred.}
  scanshort: boolean; {set if the scan terminated prematurely.}

  namecaption : string; {keeps the current namecaption value, so we can
  add stuff to it.}

  oldtop : integer;

  checked : integer;
  checklabel : Tlabel;
  check_counted : boolean;

//  dont_fixUpdate : boolean;
  {a little flag to stop end updating.}

  flip : boolean;

  constructor Create;
  destructor Destroy; override;
  procedure emptyfs;

end;


  TForm1 = class(TForm)
    SplitterDirFile: TSplitter;
    BottomPanel: TPanel;
    PageControl1: TPageControl;
    main: TTabSheet;
    SplitterInfo_Visited: TSplitter;
    BottomRightPanel: TPanel;
    FilesPanel: TPanel;
    FilesPanel1: TPanel;
    FilesView1: TListView;
    FilesPanel2: TPanel;
    FilesView2: TListView;
    SplitterFiles: TSplitter;
    DirPanel: TPanel;
    DirStatus: TLabel;
    ProgressTimer: TTimer;
    Files1StatPanel: TPanel;
    FilesLabel1: TLabel;
    Files2StatPanel: TPanel;
    FilesLabel2: TLabel;
    VisitedDirs: TListBox;
    find: TTabSheet;
    DriveList: TListBox;
    SplitterBottom: TSplitter;
    Markall: TMenuItem;
    Unmarkall: TMenuItem;
    Markstars: TMenuItem;
    Unmarkstars: TMenuItem;
    dont: TMenuItem;
    notices: TTabSheet;
    FindButton: TBitBtn;
    Findedit: TEdit;
    Flip1: TBitBtn;
    Flip2: TBitBtn;
    PopupFilesMenu: TPopupMenu;
    Files_1: TMenuItem;
    Files_2: TMenuItem;
    Files_3: TMenuItem;
    Files_4: TMenuItem;
    Files_5: TMenuItem;
    Files_6: TMenuItem;
    MenuUnMark: TMenuItem;
    MenuMark: TMenuItem;
    Debug: TLabel;
    MainMenu1: TMainMenu;
    MenuCopy: TMenuItem;
    MenuDelete: TMenuItem;
    menuCreate: TMenuItem;
    MenuMove: TMenuItem;
    menuRename: TMenuItem;
    MenuScan: TMenuItem;
    MenuDescribe: TMenuItem;
    MenuExec: TMenuItem;
    Mark: TMenuItem;
    MenuEtc: TMenuItem;
    MenuHelp: TMenuItem;
    Files_0: TMenuItem;
    FilesMiscPanel: TPanel;
    FilesMiscSanity: TLabel;
    DirImage: TImage;
    DirVScroll: TScrollBar;
    dirHscroll: TScrollBar;
    FilesM_Label2: TLabel;
    FilesM_stat: TLabel;
    LinuxTimer: TTimer;
    PanelDriveSplit: TPanel;
    {this separates the drive list from the rest of junk on the main
    info panel, which is quite crowded.}
    PanelProgress: TPanel;
    ProgressBar: TProgressBar;
    ProgressStatus: TLabel;
    StopWarning: TLabel;
    StopButton: TButton;
    StatMemo: TMemo;
    SplitterInfo_Drives: TSplitter;
    OnTopTimer: TTimer;
    EndofVisitScan: TMenuItem;
    PopupMenu_etc: TPopupMenu;
    eCopy: TMenuItem;
    eMenuTree: TMenuItem;
    emenuFixTree: TMenuItem;
    eScanTimings: TMenuItem;
    emenuCreateFile: TMenuItem;
    Forgetit: TMenuItem;
    Resize1: TMenuItem;
    cum_advice: TLabel;
    Reconstructtree: TMenuItem;
    FilesM_shift: TLabel;
    restart_os: TMenuItem;
    Fontfun1: TMenuItem;
    Markbottom: TMenuItem;
    Marktop: TMenuItem;
    VisitedDirectories: TMenuItem;
    SaveDialog: TSaveDialog;
    etc_Find: TMenuItem;
    dtimechk: TMenuItem;
    savemainlayoutpreference: TMenuItem;
    restoremainlayoutpreference: TMenuItem;
    osedir: TMenuItem;
    Clips: TMenuItem;
    Numericatts: TMenuItem;
    Label_LXstat: TLabel;
    Label_LXRight: TLabel;
    Label_SearchKind: TLabel;
    Checked1: TLabel;
    Checked2: TLabel;
    Label_blank1: TLabel;
    Label_Blank2: TLabel;
    Sort1: TMenuItem;
    Label_Debug2: TLabel;
    Memo_notices: TMemo;
    PopupMenu_SuperQuick: TPopupMenu;
    quotes: TMenuItem;
    no_quotes: TMenuItem;
    quotes_slash: TMenuItem;
    slash_no_quotes: TMenuItem;
    ESCgoaway1: TMenuItem;
    unsortfiles1: TMenuItem;
    xtra_superquick: TMenuItem;
    xtra21: TMenuItem;
    Shortfilesize: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Positionrecalled: TMenuItem;
    EditOSinitfile: TMenuItem;
    left_select: TMenuItem;
    N3: TMenuItem;
{****************************************************************************
blank1 and blank2 are "spacers"; they're set to "alright", so that
FilesLabel1/2 can be set to "alclient" and checked1/2 can be set to alleft and
everything more or less works. At least once.
****************************************************************************}


    procedure FormCreate(Sender: TObject);
    procedure DriveListDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FindeditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FindButtonClick(Sender: TObject);
    procedure CopyClick(Sender: TObject);
    procedure MenuCheckUncheck(Sender: TObject);
    procedure DirectoriesContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure StopButtonClick(Sender: TObject);
    procedure ProgressTimerTimer(Sender: TObject);
    procedure DirClick(Sender: TObject);
    procedure FindeditEnter(Sender: TObject);
    procedure FindeditExit(Sender: TObject);
    procedure FilesView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure FilesView2ColumnClick(Sender: TObject; Column: TListColumn);
    procedure MenuExecClick(Sender: TObject);

    procedure VisitedDirsClick(Sender: TObject);
    procedure DirectoriesEnter(Sender: TObject);
    procedure FilesView1Enter(Sender: TObject);
    procedure FilesView2Enter(Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuDeleteClick(Sender: TObject);
    procedure menuCreateClick(Sender: TObject);
    procedure MenuMoveClick(Sender: TObject);
    procedure menuRenameClick(Sender: TObject);
    procedure MarkallClick(Sender: TObject);
    procedure UnmarkallClick(Sender: TObject);
    procedure MarkstarsClick(Sender: TObject);
    procedure UnmarkstarsClick(Sender: TObject);
    procedure DirectoriesDblClick(Sender: TObject);
    procedure MenuHelpClick(Sender: TObject);
    procedure MyMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FlipClick(Sender: TObject);
    procedure MarkClick(Sender: TObject);
    procedure VisitedDirsDblClick(Sender: TObject);
    procedure MenuDescribeClick(Sender: TObject);
    procedure plzRefocus_panel;
    procedure FilesView1ColumnResized(Sender: TObject;
      Column: TListColumn);
    procedure MenuScanClick(Sender: TObject);
    procedure FilesLabel1Click(Sender: TObject);
    procedure FilesLabel1DblClick(Sender: TObject);
    procedure FilesLabel2Click(Sender: TObject);
    procedure FilesLabel2DblClick(Sender: TObject);
    procedure Files_1Click(Sender: TObject);
    procedure FilesViewContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure MenuTreeClick(Sender: TObject);
    procedure MenuMarkClick(Sender: TObject);
    procedure MenuUnMarkClick(Sender: TObject);
    procedure FilesPanelResize(Sender: TObject);
    procedure FilesView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure DirVScrollScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure dirHscrollScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure PageControl1Change(Sender: TObject);
    procedure FilesView1ColumnDragged(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure MenuScanKey(Sender: TObject);
    procedure StopButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScanTimingsClick(Sender: TObject);
{    procedure VisitedDirsEnter(Sender: TObject); }
    procedure LinuxTimerTimer(Sender: TObject);
    procedure detree;
    procedure restore_tree;
    procedure save_local;
    procedure menuFixTreeClick(Sender: TObject);
    procedure menuCreateFileClick(Sender: TObject);
    procedure OnTopTimerTimer(Sender: TObject);
    procedure FilesView1DblClick(Sender: TObject);
    procedure MenuEtcClick(Sender: TObject);
    procedure Resize1Click(Sender: TObject);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ReconstructtreeClick(Sender: TObject);
    procedure FilesView1Resize(Sender: TObject);
    procedure FilesView1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FilesView1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
{    procedure FilesView1Click(Sender: TObject);  }
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PopupMenu_etcPopup(Sender: TObject);
    procedure restart_osClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VisitedDirsContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Fontfun1Click(Sender: TObject);
//    procedure Deleteselectedentries1Click(Sender: TObject);
//    procedure changepurgelevel1Click(Sender: TObject);
//    procedure purge1Click(Sender: TObject);
    procedure Files_0Click(Sender: TObject);
    procedure FilesView1Click(Sender: TObject);
    procedure MarktopClick(Sender: TObject);
    procedure MarkbottomClick(Sender: TObject);
    procedure VisitedDirectoriesClick(Sender: TObject);
    procedure FilesM_Label2Click(Sender: TObject);
    procedure DebugClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure etc_FindClick(Sender: TObject);
    procedure dtimechkClick(Sender: TObject);
    procedure DriveListContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure DriveListExit(Sender: TObject);
    procedure save_restore_layoutClick(Sender: TObject);
    procedure restoremainlayoutpreferenceClick(Sender: TObject);
    procedure osedirClick(Sender: TObject);
    procedure ClipsClick(Sender: TObject);
    procedure NumericattsClick(Sender: TObject);
    procedure Label_SearchKindClick(Sender: TObject);
    procedure Sort1Click(Sender: TObject);
    procedure FilesPanel1Resize(Sender: TObject);
    procedure Label_Debug2Click(Sender: TObject);
    procedure unfudgedebug;
    procedure maybesee(what:Texec);
    procedure shiftwhat;
    procedure quotesClick(Sender: TObject);
    procedure no_quotesClick(Sender: TObject);
    procedure quotes_slashClick(Sender: TObject);
    procedure slash_no_quotesClick(Sender: TObject);
    procedure unsortfiles1Click(Sender: TObject);
    procedure ESCgoaway1Click(Sender: TObject);
    procedure File_directory(Sender: TObject);
    procedure ShortfilesizeClick(Sender: TObject);
    procedure PositionrecalledClick(Sender: TObject);
    procedure EditOSinitfileClick(Sender: TObject);
    procedure left_selectClick(Sender: TObject);
//    procedure CalcscandelayClick(Sender: TObject);
    procedure FilesM_Label2ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);

private
    { Private declarations }

    unwarn: string;

    lastlocal : Ttree;

    last_drag_was_select,
    modaling, {supposed to be true while main from is showing a modal
    form.}
    isfindeditpanel,
    plzrefocuspanel,
    plzupdateview
    : boolean;

    selected_dir : string;

    pleaseabort : boolean;

    seekeys : boolean;  {let keys through mainform filter.}

    wasq : boolean; {^Q pressed.}

    original_FilesPanelWidth, original_namewidth: integer;


    dontLinuxKey : boolean;  {see no keys.}
    fclickx, fclicky : integer;

{these used to be used just by the directory, but now general-purpose i.e.
anybody can use the mousedown routine so these values get set somehow
good.}
    mouseshift : Tshiftstate;
    mousex, mousey : integer;
    mousebutton : Tmousebutton;

{    UnFoundCount : integer;  }

    filemousedown : boolean;

    filestart : boolean;

    draglist :TStringList;

    last_shift : TshiftState;

    searchkind : Tsearch_kind;

    last_recalled_layout : string;

    function getos_enabled:boolean;
    procedure setos_enabled(value:boolean);

    procedure os_activate(Sender: TObject);

    procedure jigglemain;
    procedure FilesViewEnter(fv:Tfv);
    procedure xreconstructtree;
    procedure visible_mark(v:boolean);
    procedure
    maybereread_globaldelay(reread:integer
    ; rereadwait:integer
    );

    procedure selectpanel_nocheck(which:whichpanel; anyway:boolean = false;
    refile:boolean = true);

    procedure selectpanel(which:whichpanel; anyway:boolean = false;
    refile:boolean = true);


    procedure xinit;
    function os_find(increment:integer = 0):boolean;
    procedure nextkey_empty;
    function load_n_show(index:integer; quiet_fail:boolean = false):boolean;
    procedure f_s(fv:Tfv; index:integer; cute:boolean = false);
    procedure files_selectoid(index:integer; cute:boolean = false);
    procedure captionoid(const TheFormat: string; const Args:array of const);
    overload;
    procedure captionoid(const TheFormat: string); overload;
    procedure os_idle(Sender: TObject; var Done: Boolean);
    procedure os_scroll(whichway:integer);
    procedure dir_keys(var Key:Word; Shift:TShiftState);
    procedure kill_key;
    procedure unkill_key;
    procedure files_keys(const fv:Tfv; var Key:Word; Shift:TShiftState);
    procedure cumulativecaption;
    function cumulativeSearch(var Key:Word; Shift:TShiftState):boolean;
    procedure cumulativeStop;
    procedure visitedDirectory;
    function dir_find_select(what:string; where:integer=0;
    kind:Tsearch_kind = search_EXACT):
    boolean;
//    procedure scanthefiles;
//    procedure flipoid;
    procedure scanfiles(t:Ttree; scanall:boolean; const panel:Tfv;
    directory:string; casesort:boolean);

    function files_dir:boolean;
    procedure goto_home(currentdir:boolean = false);
    function c_m(what:fileaction):fileaction;
    function fvTop:Tfv;
    function fvBottom:Tfv;
    procedure flip_file_positions;
    procedure update_yield;
    procedure os_keys(var Key: Word; Shift: TShiftState);

    procedure os_modalbegin(Sender: TObject){ of object};
    procedure os_modalend(Sender: TObject){ of object};

    procedure quickcopy;
    procedure super_quickcopy;
    function findvisitdir(dir:string):integer;
    procedure stuffdir(d:string; index : integer; keep:boolean = false;
    atree:Ttree = nil);

    function treeoid(atree:Ttree; quiet_fail : boolean = false):boolean;
    procedure resizename;
    function rootsure(what:string; var rut:boolean; dontask:boolean = false):
    boolean;
    procedure ShowInDriveList;
    procedure fclick(const v:Tfv);
    procedure Fupdate;
    procedure Fcute(fv:Tfv = nil);
    procedure Ffix(fv:Tfv = nil);
    procedure PurgeDirs_FilePanels;
    procedure capdir_file;
    procedure savehome;
    procedure tabselect(forward:boolean);

    function ScanSelectedSubdirs(newonly : boolean; onlyone:string = '';
    levels : integer = 0 ):boolean;

    function ScanSelectedSubdirs0(rootcheck, newonly : boolean;
    onlyone:string = ''; levels : integer = 0 ):boolean;

    function not_cumkey(key:Word; Shift:TshiftState):boolean;

{$ifdef LINUX}
    procedure iconload;
{$endif}

    procedure sortcolor;
    procedure xosidle;
    procedure showscan_start;
    procedure showscan_stop;
    procedure make_main_bump;
    function fudgemenu(s:Tshortcut; p:TMenu {PopupMenu}):boolean;

//    function getposition(LayoutPref:boolean=false; fname : string = ''):boolean;
//    procedure putposition(LayoutPref:boolean=false; fname : string = '');
    function getposition(fname : string = ''):boolean;
    procedure putposition(fname : string = '');

    function killdontscan(section:string):boolean;
    procedure filesviewcolumn(Column:TListColumn);
    procedure doVisitedDC;
    procedure CopyDroppedFiles(alist:TstringList; const dst:Tfv;
    const source:Tobject);
    procedure resizeflip(fileschange:boolean);
    procedure unFilesM_stat;
    procedure DirVScrollsetfocus;
    procedure jgo_seekey(Sender: TObject; var Key: Word;
    Shift: TShiftState);

    procedure fixfilewidths(fv:Tfv);
    procedure filerescan(fv:Tfv=nil; scanall:boolean = true);
    procedure filerescanboth;
    procedure clickscan(fv:Tfv);
{$ifdef MSWINDOWS}
    function mstree(dir:string; var index:integer):Ttree;
    function guesstree(odir:string):boolean;
{$endif}

    procedure getvisited;
    procedure showsearchkind;
    procedure nextsearchkind;
    procedure setsearchkind(what:Tsearch_kind);
    procedure showcount;
    procedure fakeshiftoff;

    procedure noticia;
    procedure show_notices;

    property os_enabled : boolean read getos_enabled write setos_enabled;

    procedure active_color(activate:boolean = true);

    procedure rethinkey;

    procedure layout_checks;

    procedure restore_layout_fiddle(s:string);

    procedure copysort(src,dst:Tfv);

  public
    { Public declarations }
    thepanel:whichpanel;
    fv1, fv2, thisfv, elsefv: Tfv;
    pleaseclose : boolean;
    dontchange_dir_after : boolean;
    captionstuff : string;
    reread : integer;
    rereadwait : integer;

    link_name : string;

    procedure finishexec;
    procedure xfinal;
    procedure inited(clear:boolean = false);
    procedure fixthis;
    procedure calcscroll;
    function visibleview:integer;
    function filepage(view:Tlistview):integer;
    procedure seedirfiles(const fv:Tfv);
    procedure other_stuff;
    procedure seefiles(seetree:boolean = false; seeElse:boolean = true);
    function parentdirectory:boolean;
    procedure progress(howmuch:integer);
    procedure cutefileselect(const v:Tfv);
    procedure fhintoid(const fv:Tfv);
    procedure fileshintoid;
    procedure enterdirectory(fliptrickery:boolean = false);
    function topfv:Tfv;
    function bottomfv:Tfv;
    procedure copymovesuspects(combo:TComboBox; mult:boolean;
    spare:TStringList = nil);
    procedure stopness(how:integer=howoff; hopemsg:string = '');
    function dirpage:integer;
    procedure form1setfocus;
    procedure enterhome(d:string);
    procedure cursoid(curs:TCursor);
    procedure reset_oldtop;
    function FindFind:boolean;
    function files_find_select(what:string; where:integer;
    searchkind:Tsearch_kind):
    boolean;  {made public for clipform Friday, September 5, 2003 12:14 pm.}
    procedure dir_fix(doitnow:boolean = false);
    function os_instructions:boolean;
    procedure copyFwidths(src,dst:Tfv; ccap:boolean = false);
    procedure execute_findkey;
    procedure fixfunfonts;
    procedure VisitedDirsDelete(index:integer);
    function KeepVisitedDirsDelete(index:integer):boolean;
    function iskeep(index:integer):boolean;
//    procedure purgeoid;
    procedure devisited(what:TStrings);
    procedure fixfvcolors;
    procedure flipelsethis;
    function TheMainFv:Tfv;
    function TheOtherFv:Tfv;
    procedure copyselect_ifsame(const fromfv, tofv:Tfv);
    procedure x_stuff;
    procedure x_stufftop;
    procedure x_flip;
    procedure fixvisit;
    procedure ForgetSelectedDir(scanr:TscanResult;
    forgetlevels:integer
    );
    function cum_clk:boolean;
{$ifdef LINUX}
    procedure lxstat;
{$endif}
    procedure fixmainmenu;
    procedure fixmainmenucolor;
    procedure purge_bad_files;
    procedure statmemoid; //for lx_stat can use it.

    procedure visual_complaint;
    procedure driveflash(turn_on:boolean = true);


  end;

var
  Form1: TForm1;

Gstartcumulative,Giscumulative,Gcumulative_stopped : boolean;

{$ifdef WAIT_KEY_CLEAR}
procedure WaitForNoAlt;
{$endif}

//returns what OS thinks is the current directory.
function thisdir_string(slash:boolean = true):string;

//returns what OS thinks is the cwd -- IF it exists; else ''.
function thisdirectory(slash:boolean = true):string;

procedure dbg(const TheFormat: string; const Args:array of const);
overload;
procedure dbg(const TheFormat: string); overload;
procedure dbg_nolog(const TheFormat: string; const Args:array of const);
overload;
procedure dbg_nolog(const TheFormat: string); overload;
procedure clrdbg;
function isdbg:boolean;

procedure leftmain; {calls at least cumulativestop and hoo knows}
//called by cpyfiles at least.

procedure afterDirSelectChange;

procedure plzFview(cute : boolean = false; fv:Tfv = nil);

procedure safestuff(d:string);

function isfilepanel:boolean;

procedure purge_directory(dir:string);

function myKeyQueCount:integer;

procedure throttle(turnon:boolean);

procedure Gidle_on(doit:boolean);
function Gidle_off:boolean;

//the old routine sort-of with a different name.
function Gos_idle_off(doit:boolean=true):boolean;

procedure set_tricky;

function visited_dir(visited_index:integer; box:TlistBox = nil):string;
forward;
//let bigvisit use...

procedure clear_debug(milliseconds:integer);


implementation

{$R *.xfm}

uses
  options,
  qt, files,
  clip, qclipbrd, exec, cpyfiles,
  splash, fasttree, jdisplay, resize
  ,inifiles, fileutil, math, fontfun, chitchat, execp, osinfo,
  bigvisit, log, osedir, clips, layout;

const
unfoundcolor : Tcolor = $00aaaaff;

precall_name = 'position_recall';

const
dir_fix_timer : TICKTIME = ();
dir_fix_missed : integer = 0;

procedure dont_update_for_a_while(inc_missed:integer = 1);
begin
  delay_z(dir_fix_timer,Goptions.dir_fix_time);
  inc(dir_fix_missed,inc_missed);
end;


var
pleaseSFF_flag : boolean;
pleaseSFF_ticks : TICKTIME;

{$ifdef LINUX}
skipshift : TICKTIME;
rootthreat : string;
{$endif}
loadnshowing,
dumpclick : boolean;
dumpclicktime : TICKTIME;

{$ifdef LINUX}
var
got_left, got_top,
fixcount:integer;
{$endif}

{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}

plz_clear_debug : boolean;
clear_debug_time : TICKTIME;

procedure clear_debug(milliseconds:integer);
begin
  delay_z(clear_debug_time,milliseconds);
  plz_clear_debug := true;
end;


{****************************************************************************
general stuff.
****************************************************************************}

function dfind(tv:Tvisited):boolean;
begin

  with form1 do begin

    if tv.index<0 then begin

      stopness(howNoway,'searching');
      result := dir_find_select(tv.directory,tv.index,search_EXACT);
      stopness(howoff);

    end else
    result := dir_find_select(tv.directory,tv.index,search_EXACT);

    if result then
    tv.index := thetree.selected;

  end;

end;

procedure fixVisitIndex(tv:Tvisited);
var
index:integer;
begin

  with form1 do begin

    if tv.index<0 then
    exit;

    index := findvisitdir(tv.directory);
    if index<0 then
    exit;

    (visitedDirs.items.objects[index] as Tvisited).index :=
    tv.index;

  end;

end;

function visited_dir(visited_index:integer; box:TlistBox = nil):string;
begin
  with form1 do begin

    if box=nil then
    box := VisitedDirs;

    result := '';

    if (visited_index)>=box.items.count then
    exit;

    result := box.items[visited_index];

    if (not (box.items.objects[visited_index] is Tvisited))
    then
    exit;

    result :=
    (box.items.objects[visited_index] as Tvisited).directory;

  end;  //with.

end;

procedure TForm1.VisitedDirsDelete(index:integer);
begin
  if VisitedDirs.items.objects[index] is Tvisited then
  Tvisited(VisitedDirs.items.objects[index]).free;
  VisitedDirs.items.delete(index);
end;

function TForm1.iskeep(index:integer):boolean;
begin

{if no Tvisited object, not kept.}
  result := false;

  if (VisitedDirs.items.objects[index] is Tvisited) then
  result := (VisitedDirs.items.objects[index] as Tvisited).keep;

end;

function TForm1.KeepVisitedDirsDelete(index:integer):boolean;
begin

  if iskeep(index) then
  result := true
  else begin
    VisitedDirsDelete(index);
    result := false;
  end;

end;



const

correct_height = 410;
correct_width =
570
;
{because the IDE keeps slopping the size around -- when I fix the
extra line below the menu for instance -- it keeps changing, meaning
that user's "height" and "width" add-on values will require changing,
which is bad. + make the default size fit 480x640 vga; I mean, why
not?}

{$ifdef LINUX}
correct_fileswidth = 369;
{$endif}


{****************************************************************************
****************************************************************************}

var

seeakey_dir_find: boolean;

throttle_time : TICKTIME;

tricky_wait: Ticktime;

no_tricks : boolean;           {turn-off trickery entirely. This is
tempered somewhat by set_tricky turning it back on. Set_tricky, of
course, sets a delay during which selection/scrolling-fixing trickery
should not occur.}

os_scrolled : boolean;        {set true if ^W ^Z scroll, to defeat
                               tricky mechanism.}

{****************************************************************************
Mon 11/06/2006 6:13 pm. This apparently *delays* tricky fixes! It *doesn't*
start them up, dolt! Code apparently calls this when its scrolling or
something to *prevent* the thing from fiddling with stuff....
****************************************************************************}

procedure set_tricky;
begin
  delay_z(tricky_wait,Goptions.tricky_inhibit_timer);

  form1.reset_oldtop;

  no_tricks := false;

end;

procedure Tform1.reset_oldtop;
begin
  if notinited<>0 then
  exit;

{****************************************************************************
this mechanism fixes BUG082803: on a slower W98 machine, I could regularly
set-up a situation where clicking the top flip button would work correctly in
one direction but, in the "wrong" direction, hesitate a bit, and then select
the bottom files panel, apparently as the result of the oldtop mechanism
misfiring. So the fix is, only set oldtop here and in os_idle, and in os_idle,
if oldtop<0, then just set it to the topitem.index q.v. Also of course eye of
newt.
****************************************************************************}

  fv1.oldtop := -1;
  fv2.oldtop := -1;

end;

procedure dir_fixfix;
begin
  if Goptions.dir_fix and (notinited=0) and (thetree<>nil)
  and (thetree.pix.show(true)>0) then
  thetree.resize;
end;

{$ifdef CHECK_TREE_DRIVE}
var
Gcheckcount : integer;
              {tree status drive}
{$endif}

{$ifdef INFO_TREE_DRIVE}
procedure fv1_tsd(const TheFormat: string; const Args:array of
const);
var
stupid:string;
const
didthat : boolean = false;
{only do it once. I've also set-up the dbg thing to only show the message when
the thing appears.}
begin
  if didthat then
  exit;

  with form1 do begin
    if (notinited<>0) or (fv1=nil) or (fv1.tree=nil) then
    exit
    else begin
      stupid := fv1.status.caption[1];

      if fv1.tree.drive <> stupid then begin
        didthat := true;
        stupid := safe_format(TheFormat,Args);
        infof('fv1_tsd: Gcheckcount:%d; %s',
        [Gcheckcount,stupid]);
      end;

    end;
  end;
end;
{$endif}

function isfilepanel:boolean;
begin
  with form1 do
  result :=
  (thepanel = f1) or
  (thepanel = f2);
end;



{note Tue 5/25/04 10:44 am I changed this so if value equals magic number -1,
then it will do the check no matter what, providing a simple way for callers
to make their own choice.}
function main_bump(status:string; value:integer=1):boolean; forward;
{****************************************************************************
that's the forward declaration.
****************************************************************************}

procedure leftmain;
begin
  with form1 do begin
    cumulativestop; {it can see privates here.}
  end;
end;

procedure Tform1.plzrefocus_panel;
begin
  plzrefocuspanel := true;
  plzfview(true);
end;


{****************************************************************************
Sadly disabling a short cut does *not* prevent its short cut key from
short-circuiting my devious mechanisms. Sad, no?
****************************************************************************}

type
K_shortcut = (Save_Shoftcut, Off_Shortcut, On_Shortcut);

T_shortcut = class
  s : Tshortcut;
end;

var

shortcuts : Tstringlist;

procedure emptyshortcuts;
var
i : integer;
short : T_shortcut;

begin

  if shortcuts=nil then
  exit;

  for i := 0 to shortcuts.count-1 do begin
    short := shortcuts.objects[i] as T_shortcut;
//    if short<>nil then
//    short.free;
    FreeAndNil(short);
  end;

//  shortcuts.free;
//  shortcuts := nil;
  FreeAndNil(shortcuts);

end;

procedure fiddleshortcut(kind:K_shortcut; m:TmenuItem);
var
indexof : integer;
short : T_shortcut;

  procedure save;
  begin
    if shortcuts.find(m.caption,indexof) then
    exit; {don't save it if it's already there}

    short := T_Shortcut.create;

    short.s := m.shortcut;

    shortcuts.addobject(m.caption,short);

  end;


begin
  if shortcuts=nil then begin
    shortcuts := TStringlist.create;
    shortcuts.sorted := true;
  end;

  case kind of
    Save_Shoftcut: begin
      save;
    end;

    Off_Shortcut: begin
      save;
      m.shortcut := 0 {none};
    end;

    On_Shortcut: begin
      if not shortcuts.find(m.caption,indexof) then
      exit; {nobody home.}

      short := shortcuts.objects[indexof] as T_shortcut;
      m.shortcut := short.s;

    end;
  end;

end;

{****************************************************************************
****************************************************************************}
procedure Tform1.sortcolor;
begin

  if thisfv.sorted then begin
    thisfv.view.color := SelColor;
    thisfv.view.BorderStyle := bsSunken3d
  end else begin
    thisfv.view.color := UnsortedColor;
    thisfv.view.BorderStyle := bsDouble;
  end;

end;

procedure Tform1.resizeflip(fileschange:boolean);
  procedure dirClient;
  begin
    if DirPanel.align = alClient then
    exit;

    FilesPanel.align := alRight;
    SplitterDirFile.align := alRight;
    DirPanel.align := alClient;

  end;

  procedure filesClient;
  begin

    if FilesPanel.align = alClient then
    exit;

    DirPanel.align := alLeft;
    SplitterDirFile.align := alLeft;
    FilesPanel.align := alClient;

  end;

begin

  if fileschange then
  filesClient
  else
  dirClient;

end;

{****************************************************************************
****************************************************************************}
procedure TForm1.selectpanel(which:whichpanel; anyway:boolean = false;
refile:boolean = true);
begin
  if thetree.isbadnet(true) then
  exit;

  try
    selectpanel_nocheck(which,anyway,refile);
  except
    on e: exception do begin
      errorf('selectpanel error: %s',[e.message]);
    end;
  end;

end;

{****************************************************************************
select the specified. If anyway, select it even if it was already selected.

refile is set to false if you KNOW you don't have to do the file dance. The
only one who uses this would be rescanboth -- which for some reason slows
down in Linux (numeric atts) but not Windows (directory create/written).
****************************************************************************}

procedure TForm1.selectpanel_nocheck (which:whichpanel; anyway:boolean =
false; refile:boolean = true);

const
here : boolean = false;
label
ENDNESS;

  procedure menuyn(what:Tmenuitem; which:boolean=true);
  begin
    what.visible := which;
    what.enabled := which;    {gotta suppress them shortcuts!}
    {but sadly it didn't work. Let's be stern....}
    if which then
    fiddleshortcut(On_Shortcut,what)
    else
    fiddleshortcut(Off_shortcut,what);
  end;

  procedure selectfiles;
  var
  bad_dir_complaint : boolean;
  begin
    if not refile then
    exit;

{$ifdef COLOR_FASTER}
    thetree.dirunselect;   {turn the dir panel color to unselected.}
    Dirstatus.font.color := unSelText;
    sortcolor;
    elsefv.view.color := unSelColor;
{$endif}

    unsortfiles1.visible := true;

    osedir.visible := true;
    bad_dir_complaint := false;
    resizeflip(true);
{    thisfv.view.enabled := true;  }

{do the NOs first so the menu doesn't hop around so much? /Yes... I.e. the
menu was briefly becoming 2-line.... Kinda cute....}
    menuyn(menuCreate,false);
    menuyn(menuScan,false);

    menuyn(menuCopy);
    menuyn(menuMove);
    menuyn(mark);

    {menuCreateFile.visible := true;}
    emenuCreateFile.visible := true;

{$ifdef LINUX}
    Numericatts.Visible := true;
{$endif}
{$ifdef MSWINDOWS}
    dtimechk.visible := true;
{$endif}
    left_select.visible := true;

//{$if (not defined(LATE_MORE)) }
//    calcscandelay.visible := need_speed_fix;
//{$ifend}
//I suspect calcscandelay has passed from this vale of tears Wed 7/15/2009
//3:20 pm.

    Shortfilesize.visible := true;

{$ifndef COLOR_FASTER}
    thetree.dirunselect;   {turn the dir panel color to unselected.}
    Dirstatus.font.color := unSelText;
    sortcolor;
    elsefv.view.color := unSelColor;
{$endif}

    if thisfv.file_tree<>nil then begin
      treeoid(thisfv.file_tree);
      stuffdir(thisfv.status.caption,thisfv.dir_index);
      {moved here from above treeoid thing just above Monday, May 5, 2003 5:37
      pm. The erroneous result was occasionally stuffing the wrong tree,
      and subsequent bizarre visiteddirs double-click behavior. // but it's
      probably better here? // problem wasn't fixed, don't know.}
    end else
    errorf('thisfv.file_tree = nil! (this shouldn''t happen)');
    //see "notinited<>0" below.


    while not
    dir_find_select(thisfv.status.caption,
    {thetree.selected} thisfv.dir_index,search_EXACT) do begin


    {Fri 1/10/03 6:26 pm. This speeds-up entry from tree display; before I was
    starting everytime from zero, which was stupid particularly at the end of
    the tree. Others use select panel, so it may go slow for some of those --
    but probably no worse than before on a random basis.}

{    elsefv.view.enabled := false; }

      {OBSCURE_MISSING_DIRECTORY_BUG}

      if not bad_dir_complaint then
      infof('Ooops; "%s" isn''t in tree; I''m going to keep'+
      ' going up the tree until I find something that does, '+
      'and scan that',[thisfv.status.caption]);

      bad_dir_complaint := true;

      thisfv.status.caption := xfilepath(thisfv.status.caption);
      if slashlevel(thisfv.status.caption)<0 then
      break;  //could happen if corrupt paths file. It's over then.

    end;

    if bad_dir_complaint then
    filerescan(thisfv);

    thisfv.dir_index := thetree.selected;
    //left-out until Monday, August 8, 2005 2:00 pm. This is somewhere
    //where this should happen, no?

    FindButton.caption := 'FIND FILE';

  end;

begin

  if here

//  or (notinited<>0)
{****************************************************************************
missing until Wed 10/25/2006 1:38 pm. The "thisfv.free = nil" error (above)
appears frequently in Mandrake 9.2 for some reason, and one way that could
happen is if someone calls this prematurely. Of course I can't recreate the
problem in the IDE environment. // Thu 10/26/2006 2:38 pm. well that didn't
help.... Let's try just exiting for the nil condition.... Well worked
twice....
****************************************************************************}
  or (thisfv.file_tree=nil)

  then
  exit;

  here := true;
{Fri 8/08/03 10:39 am. maybe this'll stop the occasional confused-trees
problem}

//  dbg('selectpanel');
  FindEditExit(nil);

  wasq := false;

  cumulativestop;

  if (thepanel=which) and (not anyway) then
  goto ENDNESS;

//  visitedmultioff;

  CpyDstOff;

  reset_oldtop;

  filespanel.color := unselcolor; {so it flashes less}
  thepanel := which;
  {I don't think this'll hurt anything. I was doing it below before, and
  that would cause *two* directory searches on some occasions I think.}

{$ifdef LINUX}
  file_lxstat(true);
{$endif}

  case which of
    d: begin
{     throttle(true);  }
{Tue 5/25/04 7:23 pm. Don't know why I did this; maybe before I finessed
throttle so it turns itself on after a short while.}

      unsortfiles1.visible := false;

      osedir.visible := false;
      resizeflip(false);
      menuyn(menuCopy,false);
      menuyn(menuMove,false);
      menuyn(Mark,false);

      menuyn(MenuCreate);

      menuyn(MenuScan);

      {menuCreateFile.visible := false;}  emenuCreatefile.visible := false;

      thetree.dirselect;
      Dirstatus.font.color := selText;
      fv1.view.color := unSelColor;
      fv2.view.color := unSelColor;
      DirVScrollsetfocus;

{      thisfv.view.enabled := false;
      elsefv.view.enabled := false;   }
      FindButton.caption := 'FIND DIR';

      Numericatts.Visible := false;
      dtimechk.visible := false;
      shortfilesize.visible := false;

    end;
    f1: begin
      thisfv := fv1;
      elsefv := fv2;
      selectfiles;
      FilesView1.setfocus;
    end;
    f2: begin
      thisfv := fv2;
      elsefv := fv1;
      selectfiles;
      FilesView2.setfocus;
    end;
  end;

  fixfvcolors;

  set_tricky;

  dir_fixfix;

  capdir_file;

  calcscroll;

  ENDNESS:
  showindrivelist;
  here := false;

end;

procedure Tform1.ShowInDriveList;
var
i:integer;
begin
  if (not DriveList.visible) or loadnshowing then
  exit;

  i := Drivelist.items.indexof(thetree.name);
  if i>=0 then
  Drivelist.itemindex := i;
  Drivelist.makecurrentvisible;
end;

function Tform1.load_n_show(index:integer; quiet_fail:boolean = false):boolean;
var
oldtree,newtree : Ttree;
wason : boolean;
thetime : os_ticks;
label
ENDNESS;
begin

  result := false;

  loadnshowing := true;

  wason := Gidle_off;
    //turn-off os_idle.

  newtree:= Goptions.trees.objects[index] as TTree;

  oldtree := thetree;

  thetime := Get_ms;

  driveflash;

  while true do begin
//    dbg_nolog('load_n_show loop');
    newtree.begoodnet;    //reset the badnet mechanism.

    if (not newtree.isbadnet)
    or quiet_fail
    then
    break;

    if (newtree.retry_wait
//  = -1
    <0
    ) then begin
      if (Get_ms - thetime)<500 then
//only do it if we haven't gone away a while.
      visual_complaint;
      goto ENDNESS;
    end;

    if newtree.retry_wait=0 then begin
      if
      usuref('Can''t access tree "%s"; give up?',
      [newtree.name]) then
      goto ENDNESS
      else
      continue;   //while.
    end;

    if (not Fosinfo.is_showing) then begin
      osinf('Can''t access tree "%s"; click NO (or ESC key) to give up retrying.',
      [newtree.name],
//      osinfo_info
      osinfo_confirm
      );
      Fosinfo.show;
//      Fosinfo.inforesult := osinfo_null;
    end else begin
      Fosinfo.BringToFront;
    end;

    if (Fosinfo.inforesult
//    = osinfo_confirm
    = osinfo_deny
    ) then begin
      Fosinfo.close;
      form1setfocus;
      GOTO ENDNESS;
    end;

//    mswait(abs(newtree.retry_wait));
    mswait(newtree.retry_wait,false);
    Fosinfo.BringToFront;

  end;

  if Fosinfo.is_showing then begin
    Fosinfo.close;
    form1setfocus;
  end;

//  if newtree.retry_wait<-10 then
//  newtree.retry_wait := -1;   //Tue 7/18/2006 12:25 pm. oh read the help.
//too stupid.


  jgodisplay.resethscroll;

  stopness(howNoway,'(switching trees)');

  savehome;

  inc(notinited);


  try

    if newtree<>thetree then begin
{      thetree.olddir := DirStatus.caption; {save the old dir}
      thetree := newtree;
{$ifdef CHECK_TREE_DRIVE}
      inc(Gcheckcount);
{$endif}

    end;

    if Goptions.dir_fix then
    thetree.dont_v_invisible := true;

    if not thetree.load then
    raise EScanFailed.CreateFmt('load of "%s" failed',[newtree.name]);

{    DirVScroll.max := thetree.count;  }
{See BAD DIR SCROLL LOGIC comment in main}

    goto_home;

    thetree.fixscroll;  {See BAD DIR SCROLL LOGIC comment in main}

    result := true;

  except
    on e: exception do begin
      errorf('"%s" tree error: %s',[newtree.name,e.message]);
      thetree := oldtree;
    end;
  end;

  thetree.dont_v_invisible := false;
  thetree.pix.dontshow; {force a redisplay someday if it's on.}

  inited{(true)};

  showInDriveList;

  stopness(howoff);

  dir_fixfix;

  statmemoid;

  save_local;

  ENDNESS:
  driveflash(false);


  Gidle_on(wason);
  //turn it on if it *was* on.

  purge_bad_files;

  loadnshowing := false;


end;


const
debuglx : string = 'debuglx';

{$ifdef LINUX}
iconname : string = 'jgo.ico';

procedure TForm1.iconload;
begin
  pgmdirize(iconname);

  if FileExists_unq(iconname) then
  Application.Icon.LoadFromFile(iconname);
  {it actually worked; not on Kylix project options.
  But didn't work with Red Hat 8 KDE "bluecurve" look and feel. *Did*
  work when I reset it to "KDE1" look 'n' feel. Alzo KDE2. 'Parently
  blue curve doesn't look my icon; sulk....}
end;
{$endif}

procedure TForm1.FormCreate(Sender: TObject);
{$ifdef LINUX}
const
rutname : string = 'OwenShow.Dangerous.BadBad.RootOK';
label
LINUX_BAD, LINUX_OK;
{$endif}
begin

  autoscroll := true;

  visible := false;     {it's designed false, but in XP it keeps creeping
                        on.}
{$ifdef LINUX}
  if (getuid<>0) then
{$endif}
  splashon;             {doesn't work so good in in windows.}

  pgmdirize(debuglx);
  if FileExists_unq(debuglx) then
  mswait(3000);

{$ifdef LINUX}
  if (getuid=0) then begin
{****************************************************************************
You fool! You're running as root! OwenShow is quite capable of destroying
things as an ordinary user.... But unfortunately the file "`%s" exists, so,
regardless, we'll let you incinerate your system. NOTE that AFTER using
OwenShow as root, the OwenShow tree and other files WILL BE CONTAMINATED and
won't work with the non-root software; so it's a really good idea to make a
totally separate directory for the root version of OwenShow; or write some
procedure to restore the right ownership to everything. Or maybe create
/root/owenshow and run OwenShow in a procedure something like "os
-d/root/owenshow"; see the "orut" distribution example procedure for an
example. ... So, want to go ahead with your deranged plan?
`a,[rutname]

You fool! You're running as root! OwenShow is quite capable of destroying
things as an ordinary user.... I'm outta here... (File "`%s" doesn't exist; I
clipped the name)
`a,[rutname]

(ctext -p)

****************************************************************************}
    pgmdirize(rutname);
    rootthreat := 'ROOT!! ';

    if FileExists_unq(rutname) then begin
      if
      (MessageDlg(
      safe_format(


'You fool! You''re running as root! OwenShow is quite capable of destroying'
+' things as an ordinary user.... But unfortunately the file "%s" exists, so,'
+' regardless, we''ll let you incinerate your system. NOTE that AFTER using'
+' OwenShow as root, the OwenShow tree and other files WILL BE CONTAMINATED and'
+' won''t work with the non-root software; so it''s a really good idea to make a'
+' totally separate directory for the root version of OwenShow; or write some'
+' procedure to restore the right ownership to everything. Or maybe create'
+' /root/owenshow and run OwenShow in a procedure something like "os'
+' -d/root/owenshow"; see the "orut" distribution example procedure for an'
+' example. ... So, want to go ahead with your deranged plan?'
,[rutname]

      ),
      mtError,[mbYes,mbNo],0)=mrYES)
      then
      goto LINUX_OK
      else
      goto LINUX_BAD;

    end;

    clipboard.astext := rutname;

    MessageDlg(
    safe_format(


'You fool! You''re running as root! OwenShow is quite capable of destroying'
+' things as an ordinary user.... I''m outta here... (File "%s" doesn''t exist; I'
+' clipped the name)'
,[rutname]

    ),
    mtError,[mbOK],0);

    LINUX_BAD:
    pleaseclose := true;
//    Really_Terminate_Now;
    Application.terminate;
    exit;

    LINUX_OK:

  end;

  iconload;
{$endif}

  width := correct_width;
  height := correct_height;
{$ifdef LINUX}
  filespanel.width := correct_fileswidth;
  {otherwise it wanders I know not why.}
{$endif}


{do some tidying-up here. xinit does the major junk; here I'll just erase
stuff from development environment.}
  FilesView1.Items.Clear;
  FilesView1.Color := unselcolor;

  FilesView2.Items.clear;
  FilesView2.color := unselcolor;


  Application.onActivate := os_activate;

  Application.onModalBegin := os_modalbegin;
  Application.onModalEnd := os_modalend;

  Gos_idle_off(false);
  //shouldn't this be after those?

end;

procedure TForm1.os_activate(Sender: TObject);
begin


  if not Gosidle_will_turn_on then
  begin
{****************************************************************************
turn-on os_idle in here.
****************************************************************************}

    Gos_idle_off(false);

  end;

end;

procedure Tform1.os_modalbegin(Sender: TObject){ of object};
begin
  modaling := true;
end;

procedure Tform1.os_modalend(Sender: TObject){ of object};
begin
  fakeshiftoff;
  modaling := false;
  form1setfocus;

end;

procedure TForm1.DriveListDblClick(Sender: TObject);
begin
  if (notinited<>0) or cum_clk or os_off then
  exit;

  loadnshowing := true;
  selectpanel_nocheck(d);
  load_n_show(drivelist.itemindex);
  showindrivelist;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  xfinal;
//  Really_Terminate_Now; Application.terminate;
// didn't help making it close @ XP shutdown. Oh let's try
  if Goptions.halt then
  Halt(0); // bingo!
end;

{****************************************************************************
****************************************************************************}

procedure Tform1.fclick(const v:Tfv);
const
here : boolean = false;
var
item:Tlistitem;
begin

  if (notinited<>0) or here then
  exit;

  here := true;

  cumulativeStop;

  selectpanel(v.which);

  item := v.view.getitemat(3,fclicky);

{  if item=nil then
  infof('Item=nil!'); }

  if (item<>nil) and (item <> v.view.selected)
  then begin
    files_selectoid(item.index);
    set_tricky;
  end;

  here := false;
end;

{****************************************************************************
So something I did made FilesViewClick event never occur, and clicking a
file wouldn't select it. So I made the mousedown event -- which
could be the culprit I suppose -- do it too.
****************************************************************************}

procedure TForm1.FilesView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if (notinited<>0) or cum_clk then
  exit;

  throttle(false);
  set_tricky;
  filemousedown := true;    {see FixFselect in os_idle}
  fclickx := x;
  fclicky := y;
{  cumulativestop; }
  if Sender=fv1.view then
  fclick(fv1)
  else
  fclick(fv2);
end;

{****************************************************************************
****************************************************************************}

{A general purpose mechanism for changing the form title.}

procedure TForm1.captionoid(const TheFormat: string; const Args:array of const);
begin

{$ifdef LINUX}
  captionstuff := dontcontrol(safe_format(TheFormat,args));
{$else}
  captionstuff := safe_format(TheFormat,args);
{$endif}

  caption :=
{  Goptions.name +' ('+clx_delphi_effheadgetTLA +') '+
  safe_format(TheFormat,args);  }
{$ifdef LINUX}
  rootthreat+
{$endif}
  osversion + ' ' +
  captionstuff;

end;

procedure TForm1.captionoid(const TheFormat: string);
begin
  captionoid(TheFormat,[0]);
end;

procedure Tform1.capdir_file;
const
here: boolean = false;  //might be called by osidle. // isn't 'though
                        //Thursday, March 10, 2005 3:20 pm
label
ENDNESS;
begin
  if here then
  exit;
  here := true;
  if Giscumulative then
  goto ENDNESS;   //isn't this simpler?

  if thepanel=d then
  captionoid('%s',[DirStatus.caption]) else
  captionoid('%s',[file_selected_name]);

  ENDNESS:
  here := false;
end;

{****************************************************************************
Thu 11/17/2005 8:10 pm. So I cunningly moved this out of os_idle, where it had
been wasting time checking the shift state every cycle, to here where it's
called by keydown and keyup. But then when I executed the sacred EDIR
function, it was left with an aberrant little control "^" symbol; somehow a
key snuck in, probably from my text editor which exits with ^K^X -- yes,
probably; if I removed the shiftwhat thing from keyup, *that* didn't happen
anymore -- but of course I didn't get to see the alt keys turn off and
whatnot.... Anyway now there's a skipshift delay which ought to crush the
thing.
****************************************************************************}

procedure TForm1.shiftwhat;
var
s_st : string;
begin

{$ifdef LINUX}
  if not delay_z(skipshift) then
  exit;

  last_shift := Application.keystate;
//windows gets it in keydown/up. Of course Linux doesn't actually
//work all the time.
{$endif}

  s_st := shiftbits(last_shift);

  FilesM_Shift.caption := s_st;

end;


{****************************************************************************
form key down does the cumulative thingey and so much more.

Tue 7/29/03 11:14 am. The Great Queue Mystery. See comments around
"formkeydown(nil,dummyword,[])" above somewhere.

Fri 11/07/03 5:24 pm. But then again, careful experimentation suggests that
the key queue is *never* activated. Ooops.... (later) Oh nonsense.....

****************************************************************************}

type
Tkey = class
  key:word;
  shift:TShiftState;
end;

function myKeyQueCount:integer;
begin
  result := MyKeyQueue.count;
end;

procedure setupMyKeyQue;
begin
  MyKeyQueue := Tlist.create;
//MyKeyQueue.sorted := false; //doesn't do that.
end;

procedure emptyMyKeyQueue;
begin
  if MyKeyQueue<>nil then
  MyKeyQueue.clear;
end;


procedure emptyKeyControls;
var
i:integer;
begin

  if MyKeyQueue=nil then
  exit;

  i := 0;
  while i<MyKeyQueue.count do
  with Tkey(MyKeyQueue[i]) do begin
    if (
    ((shift - [ssShift]) <> [])
    or
    ((key and $FF00) <> 0)
    )
    then begin
      free;
      MyKeyQueue.delete(i);
    end else
    inc(i);
  end;

end;

procedure freeMyKeyQueue;
var
i:integer;
begin
  if MyKeyQueue=nil then
  exit;

  for i := 0 to MyKeyQueue.count-1 do begin
    if MyKeyQueue[i]<>Nil then
    Tkey(MyKeyQueue[i]).free;
//    FreeAndNil(MyKeyQueue[i]);
{"constant object cannot be passed as var parameter"}
  end;

//  MyKeyQueue.free;
//  MyKeyQueue := nil;
  FreeAndNil(MyKeyQueue);

end;

var
akey, killkey:Word;
ashift, killshift:TshiftState;
killkeytick : Ticktime;
procedure TForm1.kill_key;
begin
  if Goptions.dir_fix_scroll>0 then
  delay_z(killkeytick,Goptions.dir_fix_scroll);
  killkey := akey;
  killshift := ashift;
  emptyMyKeyQueue;
end;

procedure Tform1.unkill_key;
begin
  if (killkey = 0)
  or (not delay_z(killkeytick))
  then exit;
  killkey := 0;
  killshift := [];
end;

{called by either formkeydown or formkeyup depending on how I feel that day.}
procedure TForm1.jgo_seekey(Sender: TObject; var Key: Word;
  Shift: TShiftState);
const
here : boolean = false;
leftcount : integer = 0;
var
ThisKey : Tkey;
const
antiskid_count : integer = 0;
antiskid_time : ticktime = ();
lastkey : integer = 0;
lastshift : TShiftState = [];

  procedure putakey;
  var
  ak : Tkey;

    function skidding : boolean;
    begin
      result :=false;

//      if Goptions.antiskid>0 then
//      dbg('skid%s:%x',[shiftbits(shift),key]);

//let him put in ascii chars as fast as he wants...
      if (Goptions.antiskid<1)
      or (
      ((shift - [ssShift]) = [])
      and
      ((key and $ff00)=0)
      )
      then
      exit;

      if delay_z(antiskid_time) then begin
        lastkey := $FFFF;
        delay_z(antiskid_time,Goptions.antiskid_time);
      end;

      result :=
//      (not delay_z(antiskid)) and
      (lastkey = key)
      and (lastshift = shift);

      if result then begin
        inc(antiskid_count);
        if antiskid_count<Goptions.antiskid then
        result := false;
      end else begin
        lastkey := key;
        lastshift := shift;
        antiskid_count := 0;
      end;

    end;

  begin

    if skidding or (MyKeyQueue=nil) or (key=0) then
    exit;

    ak := Tkey.create;
    ak.key := key;
    ak.shift := shift;
    MyKeyQueue.add(ak);
  end;

  function getakey:boolean;
  begin
    result := false;

    if (MyKeyQueue=nil) or (MyKeyQueue.count=0) then
    exit;

    ThisKey := MyKeyQueue[0];

    MyKeyQueue.delete(0);       {remove the thing in the list. It's just
                                a pointer, which is now in ThisKey.}
    result := true;

  end;

begin

  putakey;

  key := 0; //if I don't do that, random controls will get the key also.
//    shift := [];      //that shouldn't make any difference. const.

  if here or os_off
{$ifdef IDLE_KEY}
  or (sender<>nil)
{$endif}
  then begin
    exit;
  end;

  here := true;

  if getakey then begin
    if (thiskey.key <> killkey)
    or (thiskey.shift <> killshift) then begin
      unkill_key;
      akey := ThisKey.key;
      ashift := ThisKey.shift;
      os_keys(ThisKey.key,ThisKey.shift);
    end else begin
//      dbg('killed key');
      emptyMyKeyQueue;
    end;

    ThisKey.free;
    if dumpclick then
    emptyMyKeyQueue;
  end;

//  os_keys(key,shift);

  here := false;
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if notinited<>0 then begin
    key := 0;
    exit;
  end;

{$ifdef MSWINDOWS}
  last_shift := shift;
//linux prefers to do it in shiftwhat.
{$endif}

{$ifdef KEYUP}
  jgo_seekey(Sender,Key,Shift);
{$endif}

  shiftwhat;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if notinited<>0 then begin
    key := 0;
    exit;
  end;

  last_shift := shift;
  shiftwhat;

  throttle(false);

  if (Giscumulative and
  (
  (key=Key_Control) or
//  (key=Key_Shift)   {dolt!}
  (key=Key_Alt) or
  dumpclick
  )
  ) then begin
    emptyMyKeyQueue;
    cumulativestop;
    key := 0;
    exit;
  end;

{$ifndef KEYUP}
  jgo_seekey(Sender,Key,Shift);
{$endif}

end;


{****************************************************************************
****************************************************************************}

procedure Tform1.cursoid(curs:TCursor);

  procedure recurse(c:TwidgetControl; curs:TCursor);
  var
  i:integer;

  begin
    for i := 0 to c.Controlcount-1 do begin

{****************************************************************************

      if (c.controls[i] is Tsplitter)
      and (c.controls[i] is TwidgetControl) then
      infof('%s is a splitter',[(c.controls[i] as Tsplitter).name]);

Wed 8/27/03 1:06 pm. So *that's* why my cursors didn't get "fixed"....
Tsplitter isn't a TwidgetControl. Excellent ... I guess. But note ...

1. If I set the splitter cursors to crDefault in the Delphi IDE, then the
characteristic splitter cursor disappears i.e. you can't find the splitters.
In the IDE, however, you can tell crDefault *isn't* the *correct* cursor,
because it's shown in bold; setting all the splitters to crHSplit appeared to
be the default because they're all in the light-face.

2. But when I recompile or something, some appropriate splitters -- the
vertical ones -- changed to crVSplit -- which is shown in bold, aka "not
default"! / Yeah I think when it reloads the form, i.e. at IDE start-up, or
some other times. Anyway it eventually winds-up with some bold crVbolds for
the appropriate splitters.

So strange....

****************************************************************************}

      if c.controls[i] is TwidgetControl then
      with (c.controls[i] as TwidgetControl) do begin
        cursor := curs;
        recurse(c.controls[i] as TwidgetControl,curs);
        {recurse like wild thing.}
      end;

    end;

  end;

begin

  cursor := curs;
  recurse(form1,curs);

end;


{****************************************************************************
(os_idle)
****************************************************************************}
{$I osidle.pas}
{****************************************************************************
****************************************************************************}

procedure afterDirSelectChange;
begin
  with form1 do begin
    selected_dir := thetree.selectedpath;

    try
      if not dontchange_dir_after then
      chdir(selected_dir);
    {Wed 12/17/03 10:06 am. To stop Linux whining at me about the floppy?}
    except
      on exception do;  {but don't be troublesome.}
    end;

    dirstatus.caption := selected_dir;
    dirstatus.hint := selected_dir;
    capdir_file;
{.$ifdef LINUX}  {don't know why only linux}
{    dirhintoid;   }
{.$endif}
    statmemoid;         {and for that matter... // and then again I just
    stuck dirhintoid into statmemoid and to heck with it. Problem was,
    bytes free wasn't showing up right.}
  end;
end;


{****************************************************************************
****************************************************************************}

procedure TForm1.execute_findkey;
begin
//  PageControl1.setfocus;
  PageControl1.activepage := find;
//  find.setfocus;
//  FindEdit.setfocus;
  PageControl1Change(nil);
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if notinited<>0 then
  exit;

  if PageControl1.ActivePage=find then begin
//    FindEdit.setfocus;
    Findedit.setfocus;
    FindEditEnter(nil);
  end else
  selectpanel(thepanel);
end;

procedure TForm1.FindeditEnter(Sender: TObject);
begin
//  findedit.color := selcolor;

  if (isfindeditpanel) then
  exit;
  {don't do it twice! Monday, June 28, 2004 2:17 pm}

  isfindeditpanel := true;
  Form1.keypreview := false;
//  ExactCheckBox.checked := true;
//  cumulativestop;
//  dumpclick := false;

  findfind;

end;

procedure TForm1.FindeditExit(Sender: TObject);
begin
  if not isfindeditpanel then
  exit;

  isfindeditpanel := false;
  form1.keypreview := true;
  findedit.color := Selcolor;
  PageControl1.activepage :=main;
  plzrefocus_panel;
end;

procedure TForm1.FindeditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  FindEdit.color := selcolor;

  if (thepanel<>d) and (chr(key)=slashchar) then begin
    key := 0;
    exit;
  end;

{$ifdef MSWINDOWS}
  if (thepanel=d) and (chr(key)='/') then begin
    key := ord(slashchar);
    exit;
  end;
{$endif}

  if isreturnkey(key) then begin
    FindButtonClick(nil);
    exit;
  end;

  case key of
    ord('E')-CTL, ord('S')-CTL, ord('D')-CTL, ord('X')-CTL,
    ord('W')-CTL, ord('Z')-CTL: exit;
  end;


{handle tab, escape key so we can return to civilization. // actually
this is sort-of selective, let's do 'em all.}
  if not_cumkey(key,shift) then
  begin
    cumulativestop;
    FindEditExit(nil);

    os_keys(key,shift)
  end;

{
  if (key=key_tab) then begin
    FindeditExit(nil);
    tabselect;
    exit;
  end;

  if is_key(Goptions.gotodir,key,shift) then begin
    FindeditExit(nil);
    selectpanel(d);
    exit;
  end;

}


{  FindEditEnter(nil);  }

end;

function TForm1.FindFind:boolean;
begin
  result := false;

  if (os_find(1)) then begin
    FindEdit.color := selcolor;
    selectpanel(thepanel);
    result := true;
  end else if length(FindEdit.text)>0 then
  FindEdit.color := unfoundcolor
  else
  FindEdit.color := selcolor;

end;

procedure TForm1.FindButtonClick(Sender: TObject);
begin
  if (notinited<>0) or (length(FindEdit.text)<1) then
  exit;

  Giscumulative := true;

  if findfind then
  exit;

  if sender<>nil then
  FindeditEnter(nil);

//  FindEdit.color := unfoundcolor;

end;

{****************************************************************************
****************************************************************************}


procedure Tform1.enterdirectory(fliptrickery:boolean = false);
var
selectplz: Tfv;
auditors:boolean; //should I make silly auditors remark.
wason : boolean;
begin

  if thetree.isbadnet(true) then
  exit;

  wason := Gidle_off;

  auditors := false;

  file_fiddlesort(thisfv);

  cumulativeStop;

  try

{.$define THIS_IS_STUPID}
{$ifdef THIS_IS_STUPID}
{enter_top should be here Mon 6/21/2004 6:03 pm}
    selectplz := thisfv;
    chdir(Dirstatus.caption);

    if (thepanel=d) and Goptions.enter_top then begin
      thisfv := topfv;
      elsefv := bottomfv;
      selectplz := topfv;
    end;
{So if it *isn't* enter_top, then you enter the green one the selected one.
Whatever it is.}

    if fliptrickery
    then
//    flip_file_positions;
    flipelsethis;

    seefiles(true,false);

    if fliptrickery and (not Goptions.control_enter_flip) then
//    flip_file_positions;
    flipelsethis;
{finished flipping.}

{$else}
    chdir(Dirstatus.caption);
    //need this to make exception Fri 12/28/2007 12:59 pm.

    if fliptrickery and Goptions.control_enter_flip
    then begin
      x_flip;
//      flip_file_positions;
//      flipelsethis;
//      seefiles(false,false);
      seefiles(true,false);
//Thursday, July 3, 2008 12:37 pm. Just a bug! There for years!
    end else
    seefiles(true,false);

{enter_top should be here Mon 6/21/2004 6:03 pm}
{no here Wednesday, November 21, 2007 5:27 pm.}
    if (thepanel=d) and Goptions.enter_top then begin
      thisfv := topfv;
      elsefv := bottomfv;
//      selectplz := topfv;
    end;
{So if it *isn't* enter_top, then you enter the lit-up one the selected one.
Whatever it is.}

    selectplz := thisfv;
//    chdir(Dirstatus.caption);

{$endif}


{enter_top should NOT be here!? // or it enters the wrong directory.}
{    if (thepanel=d) and Goptions.enter_top then begin
      thisfv := topfv;
      elsefv := bottomfv;
      selectplz := topfv;
    end;
}


    update;
{****************************************************************************
    mswait(60); //Monday, November 21, 2005 6:35 pm. Don't know why this is
here.... But I hate to dump it; probably fixed something annoying. But it
would wait forever in Linux. Apparently because, unless disciplined, mswait
yields which, in Delphi, can take forever. Of course; that explains the
bizarre behavior I had in Linux during the endless fixit of the osedir
feature; but of course then, I *wanted* it to yield.... Oh well live and
learn....
****************************************************************************}
    mswait(60);

    selectpanel(selectplz.which,true);

    enterhome(Dirstatus.caption);

    plzFview(true);

  except
    on exception do
    auditors := true;
  end;

  if auditors then begin

{****************************************************************************
The OwenShow board of auditors is not entirely certain "'`%s" exists; or it
might be forbidden or something. Click YES if OwenShow should "forget" the
directory: OwenShow removes the entry from its tree, but doesn't change the
actual directory structure in any way. Otherwise, click NO -- and maybe you
should scan (right click) the parent directory....

****************************************************************************}

    if usuref(


'The OwenShow board of auditors is not entirely certain "''%s" exists; or it'
+' might be forbidden or something. Click YES if OwenShow should "forget" the'
+' directory: OwenShow removes the entry from its tree, but doesn''t change the'
+' actual directory structure in any way. Otherwise, click NO -- and maybe you'
+' should scan (right click) the parent directory....'



    ,[Dirstatus.caption])
    then
    forgetSelectedDir(ScanForgetDirectory,0
    )
    ;

  end;

  Gidle_on(wason);

end;

procedure TForm1.DirectoriesDblClick(Sender: TObject);
begin
  if (notinited<>0) or cum_clk then
  exit;
  enterdirectory(ssctrl in mouseshift);
end;

{****************************************************************************
****************************************************************************}
function Tform1.findvisitdir(dir:string):integer;
begin
  result := visitedDirs.Items.IndexOf(dir);
  if result<0 then begin
    result := visitedDirs.Items.IndexOf(favoritemarker+dir);
    if result<0 then
    exit;

//    dbg('%s',[(VisitedDirs.items.objects[result] as Tvisited).directory]);

    if
{$ifdef MSWINDOWS}
    CompareText
{$endif}
{$ifdef LINUX}
    CompareStr
{$endif}
    ((VisitedDirs.items.objects[result] as Tvisited).directory,dir)<>0
    then
    result := -1;
{****************************************************************************
case when idiot has directory with favorite marker. // Wed 5/17/2006 3:42 pm.
Wha? ... Oh I see, there could be a *actual* _directory or something. Oh the
tangled etc....
****************************************************************************}

  end;

end;

{****************************************************************************
stuffdir is in charge of saving visited directories in the visited directories
panel. Some barnacles have affixed themselves over the years however.

//try and find tv in visited dirs, and fix index if.

it is assumed that arguments to stuffdir DO NOT have favoritemarker on them;
stuffdir is in charge of doing that.

The keep arguments means the d argument is a favorites directory we should
stuff, even if it doesn't exist -- and mark with the favorites marker.

On the other hand, occasionally stuffdir will be asked to stuff a directory
that is already a favorites, in which case we want to keep the favorites
version. Hence after finding such a one, we check for the tv.keep attribute.

And today I'm adding the atree argument; I think this will *always* be in
concert with keep = true. So I can specify favorites on other windows drives,
basically. I thought I couldn't but then I noticed I *was* saving such
directories, so what the heck....
****************************************************************************}

procedure TForm1.stuffdir(d:string; index : integer; keep:boolean = false;
atree:Ttree = nil);
const
MAXVISITED = 100;
var
i : integer;
tv : Tvisited;
begin

  if  (not keep)
  and (not DirectoryExists(d))
  then exit;

//  if (Goptions.Visited_Level>0)
//  and (slashlevel(d)>Goptions.Visited_level) then
//  exit;

  if (atree=nil) then
  atree := thetree;

  slash(d);

  i := findvisitdir(d); //finds directories even if kept.

  if i>=0 then begin
    tv := Tvisited(visitedDirs.items.objects[i]);
    VisitedDirs.items.delete(i);
  end else begin
    tv :=
    Tvisited.create(atree,index,d);
    {Note "atree" is just a pointer, so we don't have to worry
    about freeing it or anything. //But now we *do* have to free the
    Tvisited object.}

    if keep then begin
//    tv.tree := nil; //don't know why I'm doing this.
      tv.tree := atree;  //default favorites to this tree.
      tv.keep := true;
    end;

  end;

//here should be the only place where we favoritize the thing
//permanently. So IF tv.keep, THEN it will have the favoritemarker.
//on the other hand, we frequently defavorite things....
  if tv.keep then
  d := tv.favoritize;

  if keep then begin
    visiteddirs.items.add(d);
    i := visiteddirs.items.count-1;
//we want to add initial favorites directories to the end.
  end else begin
    visiteddirs.items.insert(0,d);
    i := 0;
  end;

  tv.index := index;
{****************************************************************************
missing until Thu 12/09/2004 12:04 pm. This was particularly noticeable with
directories from a favorites file list, which start-up with an index of -1 of
course 'cause we don't know where they are. But even normal visited
directories indices should be updated, because the layout may have changed or
something.
****************************************************************************}

  visiteddirs.items.objects[i] := tv;

  if visiteddirs.items.count> MAXVISITED then
  keepvisiteddirsDelete(visiteddirs.items.count-1);

  visiteddirs.topindex := 0;
  visiteddirs.itemindex := 0;

end;



{****************************************************************************
****************************************************************************}
procedure TForm1.visitedDirectory;
var
where, i:integer;
SelectedPath:string;
isshift : boolean;

  procedure moveToEnd;
  begin
    with visiteddirs.items do
    if isshift then
    move(count-1,0)
    else
    move(0,count-1);
  end;

  function checkngo:boolean;
  var
  tv:Tvisited;
  begin
    tv := visiteddirs.items.objects[i] as Tvisited;
{****************************************************************************
I've been assuming it had a valid Tvisited anyways....
****************************************************************************}
    result :=
    (
{$ifdef MSWINDOWS}
    CompareText
{$endif}
{$ifdef LINUX}
    CompareStr
{$endif}
    (SelectedPath,
    visited_dir(i)
//    visiteddirs.items[i]
    )<>0)  {i.e. if it's not this directory}
    or
    (thetree <> tv.tree);
    {or it's the same directory, but not this tree!}

    if result then begin
      visiteddirs.itemindex := i;

      result := treeoid(tv.tree,true);  //might want to change tree.

      if (not result)
      and usuref('Tree visiting no fun; purge non-locals and give up?')
      then begin
        Gpurge_nonlocals := true;  //bigvisit.
        VisitedDirectoriesClick(nil); //that'ull learn 'em.
        result := true;
        exit;
      end;

      if result then begin

  {****************************************************************************
  update index for _directories -- or any directories for that matter.
  ****************************************************************************}
        tv.index := thetree.selected;

  //      if tv.index<0 then
        stopness(HowNoWay);

        result := dir_find_select(
  //      visited_dir(i),
  //      Tvisited(visiteddirs.items.objects[i]).index
        tv.directory,
        tv.index
        ,search_EXACT);

  //      if tv.index<0 then
        stopness(HowOff);

      end;

{****************************************************************************
make ^D in files backtrack through visited directories by moving the top
directory to the bottom. Or if isshift, visa versa. On the other hand,
after the visited dirs is CLICKED, and in the tree display, then for some
reason I decided it should just go down. I don't really konw why. Anyway, when
we do that, the selection disappears off the bottom unless I fiddle with the
topindex in a totally guessology way. The guess is the visiteddirectory is at
least 3 rows high, which I believe is true. "where" is the current itemindex.
****************************************************************************}

      if result then begin

        if (where<>0) then
        with visiteddirs do begin
          if (i-3) > 0 then
          topindex := i-3
          else
          topindex := 0;

          itemindex := i;
          exit;
        end;

        if
        (
  {$ifdef MSWINDOWS}
        CompareText
  {$endif}
  {$ifdef LINUX}
        CompareStr
  {$endif}
        (SelectedPath,
        visited_dir(0)
        )=0
        )
        then
        moveToEnd;

        if thepanel<>d then
        enterdirectory
        else
        visiteddirs.itemindex := 0;
        //stop disappearance?

      end;

    end;

  end;

begin


  isshift :=
  ssshift in
{$ifdef MSWINDOWS}
  last_shift
{$endif}
{$ifdef LINUX}
  Application.KeyState
{$endif}
  ;

  SelectedPath := thetree.selectedpath;
  where := visiteddirs.itemindex;
  if where<0 then
  where := 0;

  if isshift then begin
//    dbg('visited shift');

    for i:= where-1 downto 0 do begin
      if checkngo then
      exit;
    end;

    for i := visiteddirs.items.count-1 downto where do begin
      if checkngo then
      exit;
    end;

  end else begin
//    dbg('visited no');

    for i := where to visiteddirs.items.count-1 {downto 0} do begin
      if checkngo then
      exit;
    end;

    for i:= 0 to where-1 do begin
      if checkngo then
      exit;
    end;
  end;

end;

{****************************************************************************
****************************************************************************}

{on the directory popup context.}

procedure TForm1.DirClick(Sender: TObject);
begin
  if (notinited<>0) or cum_clk then begin
    exit;
  end;

  selectpanel(d);
  thetree.yselect(mousey);
end;

{****************************************************************************
Tue 2/01/2005 6:14 pm. This whole elaborate thing is so we can stop a
cumulative search by clicking on the form. While I was testing, I noticed that
-- presumably for years -- clicking on the form while a scan was going-on
produced bizarre results, so some of the same mechanism is used to stop that.
****************************************************************************}

function TForm1.cum_clk:boolean;
begin
  result := false;

  if (notinited<>0) or (isfindeditpanel) then
  exit;

  result := dumpclick;
  //return state of dumpclick no matter what. Others set it besides this
  //mechanism.

  if (not Giscumulative) then
  exit;

//if cumulative, set-off dontclick mechanism.

  result := true;

  delay_z(dumpclicktime,2000);
//os_idle turns it off.

  throttle(false);

//  if (cstop_count > 4) and (not dumpclick) then
//  infof('hey babe!');

  dumpclick := true;  //inhibit clicks for a while.
//  dbg('dumpclick');



  emptyMyKeyQueue;
  cumulativestop;

end;



procedure TForm1.MyMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  mouseshift := shift;
  mousex := x;
  mousey := y;
  mousebutton := Button;

//  gNon_modaldelay := 0;
end;

{****************************************************************************
****************************************************************************}

const
VISITED_DIR_MIN = 0;

{****************************************************************************
****************************************************************************}
procedure TForm1.ForgetSelectedDir(scanr:TscanResult;
forgetlevels:integer
);
var
reselect,
x:integer;
dirname : string;
label
ENDNESS;
begin
  x := thetree.selected;
  dirname := thetree.selectedpath;
  reselect := thetree.previous_sibling;
//  forgetlevels := ScanSpin.value + 1; //Tuesday, August 31, 2004 2:28 pm.
  //add 1 to make it symmetric with scan.
  if scanr=ScanForgetDirectory then
  forgetlevels := 0;
  if forgetlevels<1 then begin
    if x<1 then
    goto ENDNESS;

    file_oldnew_begin;

    showscan_start;
    thetree.new_deldir(x);
    thetree.cuteselect(x-1);
    showscan_stop;
    thetree.select(reselect);

    file_oldnew(dirname,'');  //make it disappear from any files view.

    file_oldnew_finish;

    goto ENDNESS;
  end;

{Wants to forget a range below current directory.}
  reselect := thetree.selected;   {save the directory}
  showscan_start;
  if thetree.forget_dirs(x,forgetlevels) then
  xreconstructtree;
  showscan_stop;
  thetree.cuteselect(reselect);

  ENDNESS:

end;

{****************************************************************************
when you right click on the directory (context click) then you get to scan
and who knows what else.
****************************************************************************}

procedure TForm1.DirectoriesContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);

label
ENDNESS;

  procedure clipdirs(which:Tscanresult);
  var
  stuff:TStringList;
  h,
  oldselect,
  oldxinfo,
  i:integer;
  name,
  path,
  old:string;
  append : boolean;
  image : Timage;

  const
  FileName : string = 'osdir~.bmp';
  aFileName : string = 'osdir~.a';

{****************************************************************************
. (root)
|-.emacs.d
| `-auto-save-list
|-bundle
| `-works
|-Config.Msi
|-Documents and Settings
| |-Administrator
| | |-Application Data
| | | |-Adobe
| | | | `-Acrobat
| | | |   `-Whapi
| | | `-Microsoft

Ŀ
   
****************************************************************************}
    function ascii_ibm(s:string):string;
    var
    i:integer;
    begin
      result := s;

      for i := 1 to length(result) do begin
        case result[i] of
          '|': begin
            result[i] := '';     //ibm vertical line.
            if es(result,i+1)='-' then
            result[i] := '';     //v line + right.
          end;

          '.': begin
            if es(result,i-1)='' then
            break;                //it's an actual dot.

            if es(result,i+1)=' ' then
            result[i] := ''      // ibm corner down.
            else
            result[i] := '';     // down + right.
          end;

          '-': begin
            if es(result,i-1)='' then
            break;
{****************************************************************************
the for because that must be a leading hyphen. Of course the hyphen looks
exactly like the graphical character.
****************************************************************************}

            result[i] := '';  //ibm horizontal line.
          end;

          '`': begin
            if es(result,i-1)='' then
            break;             //some idiot named a directory with a tick.

            result[i] := '';  //ibm corner top right.
          end;
          ' ': ;
        else
          break;    //exit the for; we don't want to xlate "-" in stuff.
          //of course if the dir starts the way, too bad.
        end;

      end;

    end;

    procedure select_the_saved_file(fv:Tfv);
    begin
      if
{$ifdef LINUX}
      path<>fv.status.caption
{$endif}
{$ifdef MSWINDOWS}
      not SameText(path,fv.status.caption)
{$endif}
      then
      exit;

      selectpanel(fv.which);
      files_find_select(name,0,search_EXACT);
      mswait(Goptions.enabledelay);

    end;


  begin

    if which=scanibmpix then begin

      thetree.screentop(true);
      oldselect := thetree.selected;

      savedialog.filename := afilename;
      if not savedialog.execute then
      exit;

      afilename := savedialog.filename;

      name := ExtractFileName(afilename);

      File_OldNew_Begin;

      append := false;

      if FileExists_unq(afilename) then begin
        old := afilename;
        if usuref('Append to "%s" (YES) or overwrite? (NO)',
        [afilename]) then
        append := true;
      end  else begin
        old := '';
        append := false;
      end;

      if append then begin
        h := FileOpen(afilename,fmOpenReadWrite);
        if (h>=0) then begin
          FileSeek(h,0,2);
          hprintf(h,LNEND); //make a nice line space.
        end;
      end else
      h := StupidNewFile(afilename);

      if h<0 then begin
        errorf('Sorry couldn''t write to %s',[afilename]);
        exit;
      end;

      with thetree do
      for i := screen_top to screen_bottom do begin
        hprintf(h,'%s'+LNEND,[ascii_ibm(getpix(i))]);
      end;

      FileClose(h);

      path := fslash(ExtractFilePath(afilename));
      savedialog.initialdir := path;

      file_oldnew(old,afilename);

      File_OldNew_Finish;

      select_the_saved_file(fv1);
      select_the_saved_file(fv2);

      selectpanel(d);

      thetree.screentop(false);
      thetree.select(oldselect);   //it forgets sometimes.

      exit;

    end;

    if which=scangraf then begin

      thetree.screentop(true);
      oldselect := thetree.selected;

      savedialog.filename := filename;
      if not savedialog.execute then
      exit;

      filename := savedialog.filename;

      name := ExtractFileName(filename);

      oldxinfo := thetree.xinfo;

      if not Goptions.grafinfo then begin
        thetree.xinfo := 0;
        if oldxinfo>0 then
        thetree.resize;
      end;

      if not Goptions.grafselect then
      thetree.showunselect;

      File_OldNew_Begin;

      if FileExists_unq(FileName) then
      old := FileName
      else
      old := '';

{****************************************************************************
Copies part of an image from another canvas into the canvas.

Delphi syntax:

procedure CopyRect(const Dest: TRect; Canvas: TCanvas; const Source: TRect);

Description

Use CopyRect to transfer part of the image on another canvas to the image of
the TCanvas object. Dest specifies the rectangle on the canvas where the
source image will be copied. The Canvas parameter specifies the canvas with
the source image. Source specifies a rectangle bounding the portion of the
source canvas that will be copied.

The portion of the source canvas is copied using the mode specified by
CopyMode.

function Rect(Left, Top, Right, Bottom: Integer): TRect;

//i'm trying to trim the image which for some reason is too big.
****************************************************************************}

      image := Timage.create(self);
      image.height := DirImage.height;
      image.width := Dirimage.width;

      image.canvas.copyrect(
      Rect(0,0,DirImage.width,DirImage.height),
      DirImage.canvas,
      Rect(0,0,DirImage.width,DirImage.height)
      );

      image.picture.savetofile(filename);
      image.free;
//seemed to work!


      file_oldnew(old,filename);

      File_OldNew_Finish;

      path := fslash(ExtractFilePath(filename));
      savedialog.initialdir := path;

      select_the_saved_file(fv1);
      select_the_saved_file(fv2);

      selectpanel(d);

      if not Goptions.grafinfo and (oldxinfo>0) then begin
        thetree.xinfo := oldxinfo;
        thetree.resize;
      end;

      thetree.screentop(false);
      thetree.select(oldselect);   //it forgets sometimes.

//      if not Goptions.grafselect then
//      thetree.select;

      exit;

    end;


    stuff := TStringList.create;
    stuff.sorted := false;

    with thetree do
    for i := screen_top to screen_bottom do begin
      if which=scanpaths then
      stuff.add(getpath(i))
      else
      stuff.add(getpix(i));
    end;

    clipboard.astext := stuff.text;
    freeandnil(stuff);

  end;

begin

  handled := true;

  if (notinited<>0)
  or os_off
  then
  exit;

//  if cum_clk then
//  exit;

  selectpanel(d);

  thetree.yselect(mousey);
  {this makes the selection disappear when dir_fix is true.}
  dir_fix(true);        {so make it show the thing.}

//  scanform.left := left+width - scanform.width;
//  scanform.top := top;

  with scanform do begin
    directory := selected_dir;
    showmodal;
    set_tricky;

//?    form1setfocus;   {did it forget?}

    delphi_yield;
    update;
    case scanr of
      ScanDescribe: begin
        MenuDescribeClick(nil);
      end;

      ScanFilesEnter: begin
        enterdirectory(ssctrl in mouseshift);
      end;

      ScanFlipFilesEnter: enterdirectory(true);

      ScanStuffTop:       x_stufftop;

      ScanStuffBottom:    x_stuff;

      ScanFlipFiles:      x_flip;

      Scanscan: begin
        ScanSelectedSubdirs(newonly.checked);
        thetree.select;
      end;

      ScanLevels: begin
        ScanSelectedSubdirs(newonly.checked, '', ScanSpin.value);
        thetree.cuteselect;
      end;

      ScanForgetDirectory,
      ScanForget:

      ForgetSelectedDir(scanr,ScanSpin.value + 1); //Tuesday, August 31, 2004.
        //add 1 to make it symmetric with scan.

      scanpaths, scanpix,
      scanibmpix,
      scangraf:
      clipdirs(scanr);

    end;

  end;

ENDNESS:
//?  form1setfocus;
  formresize(nil);    //fix tree if he resized....

end;

procedure TForm1.MenuScanClick(Sender: TObject);
var
dummy:boolean;
begin
  if (notinited<>0) or cum_clk then
  exit;

  {call context popup somehow.}
  DirectoriesContextPopup(nil,mouse.CursorPos,dummy);
end;

procedure TForm1.MenuScanKey(Sender: TObject);
var
dummy:boolean;
begin
  if (notinited<>0) then
  exit;

  mousey := thetree.selecty;
  {see to get around CLX weirdness I was saving the mouse click, rather
  than using the strange one that came with the right-click. }
  DirectoriesContextPopup(nil,point(1,mousey),dummy);
end;

{****************************************************************************
****************************************************************************}
procedure TForm1.filesviewcolumn(Column:TListColumn);
begin
  if notinited<>0 then
  exit;

  flipsort(thisfv,column.index);
  sortcolor;

{  fhintoid(thisfv); }
//  statmemoid;
  fhintoid(thisfv);
  plzRefocus_panel;
end;


procedure TForm1.FilesView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if notinited<>0 then
  exit;

{  filesView1click(nil); }
  selectpanel(f1);
  filesviewcolumn(column);

end;


procedure TForm1.FilesView2ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if notinited<>0 then
  exit;

{  FilesView2Click(nil); }
  selectpanel(f2);
  filesviewcolumn(column);
end;


{****************************************************************************
select a tree as per argument. In OwenShow, there is only one tree selected
at a time. In Linux, probably ever; in Windows, they represent different
drives.
****************************************************************************}
function Tform1.treeoid(atree:Ttree; quiet_fail : boolean = false):boolean;
{$ifdef OLD_FASHIONED}
var
i : integer;
{$endif}
begin
  result := true;


  if (atree=nil) or (atree=thetree) then
  exit;   {all is well or hopeless; + skip nils because that's what
  we'll do with the permanent guys.}

  result := load_n_show(atree.option_tree_index,quiet_fail);

{$ifdef OLD_FASHIONED}
  for i := 0 to Goptions.trees.count-1 do begin
    if atree=Goptions.trees.objects[i] as Ttree then begin
      result := load_n_show(i);
      exit;
    end;
  end;
  result := false;
  errorf('Something wrong with tree "%s"; sorry',[atree.name]);
{$endif}
end;

var
VisitedDC, VisitedDDC: boolean;

const
lastVisitedSelect : integer = -1;

procedure TForm1.VisitedDirsClick(Sender: TObject);
var
oldtree: Ttree;
tv:Tvisited;
dir:string;

label
ENDNESS;

  procedure cantfind;
  begin
    errorf('Can''t find directory "%s" (in tree "%s")',
    [dir,thetree.name]);
  end;

  function fixtv:boolean;
{$ifdef MSWINDOWS}
  var
  i:integer;
{$endif}
  begin

//    dir :=
//    defavorite(visiteddirs.items[visiteddirs.itemindex]);


//    dir := defavorite(dir);

//    if (copy(dir,1,length(favoritemarker))=favoritemarker) then
//    dir := copy(dir,length(favoritemarker)+1,5000);

    result := false;

//    if (not (tv is Tvisited)) then
//    exit;
{****************************************************************************
Wed 9/21/2005 10:45 am. So this just shows the advantage of Great Programming
Practices. I was leaving tv uninitialized here for some bizarre reason --
probably it used to be a passed-in argument, right -- and then I was still
executing the code above -- which would *work* for some reason with whatever
random debris was in there.... Tch tch. So then I inited tv to nil and it
*stopped* working. Mon 9/26/2005 6:11 pm. And then it really should fail if
tv.tree=nil in Linux OR Windows, eh?
****************************************************************************}


    tv := Tvisited(visiteddirs.items.objects[visiteddirs.itemindex]);
    dir := tv.defavorite;

    if (tv.tree=nil) then begin
{$ifdef MSWINDOWS}
      tv.tree := mstree(dir,i);
      if tv.tree=nil then
{$endif}
      exit;
    end;

    result := true;

  end;

begin
  if (notinited<>0) or cum_clk then
  exit;

  if (sender <> nil) and
  ((not VisitedDirs.focused) or (mousebutton<>mbLeft)) then
  exit;
{so clx or delphi or whoever apparently sometimes does 'jes for fun, say when
I'm stuffing something into the list or something.... Monday, August 12, 2002
5:58 pm}

  tv := nil;  //missing for quite some time!
              //Wednesday, September 21, 2005 10:43 am
  VisitedDC := true;

  oldtree := thetree;

  if (visiteddirs.itemindex<0) then begin
    if lastVisitedSelect>=0 then
    try
      visiteddirs.itemindex := lastVisitedSelect;
    except
      on exception do;
    end;

  end;


  if (visiteddirs.itemindex<0)
  or (not fixtv)
  or (not treeoid(tv.tree))
  then
  goto ENDNESS;

{so sometimes it just gets a broken dir in there don't know how, so I'm
taking the easy way out.... // well at least disconnected network drives
can do this....}
  if not DirectoryExists(dir)
  then begin
    PurgeDirs_FilePanels;
    treeoid(oldtree);
    cantfind;
    goto ENDNESS;
  end;

  selectpanel(d); //missing until Monday, July 28, 2003 1:57 pm.!?

//  if dir_find_select(dir,tv.index,true) then
//  if dfind(tv) then
//  tv.index := thetree.selected else
{****************************************************************************
Fri 9/24/2004 4:26 pm. the above fixes "keep" visited directories that have -1
for the index -- but it also fixes *other* visited directories that for
whatever reason got the indexes wrong i.e. because of intervening mk/del dir!
// I stuck that code into dfind.
****************************************************************************}
  if not dfind(tv) then
  cantfind;

{this mechanism is if in case somehow the doVisitedDC double click occurs
in the *middle* of this. I'm pretty sure that's not possible but whatever.}
  if VisitedDDC then
  doVisitedDC;
  VisitedDDC := false;

  ENDNESS:
  VisitedDC := false;
end;

procedure TForm1.doVisitedDC;
begin
  if cum_clk then
  exit;

  if (ssctrl in mouseshift) then
  selectpanel(d);

  enterdirectory(ssctrl in mouseshift);
end;

procedure TForm1.VisitedDirsDblClick(Sender: TObject);
begin
  if (notinited<>0) or cum_clk then
  exit;

{  if not VisitedDirs.focused then
  exit;  } {that doesn't make any sense anyway. Unless someone's calling
  VisitedDirsDblClick}

  CpyDstOff;

  if VisitedDC then begin
     VisitedDDC := true;
     exit;
  end;

  doVisitedDC;

end;

{****************************************************************************
progress junk.
****************************************************************************}

procedure Tform1.stopness(how:integer=howoff; hopemsg:string = '');
const
warningtext : string =
'(click, double-click?)';

hopelesstext =
//'You can do nothing. You must wait. '
'Wait; do nothing.'
;

oldhow : integer = -1;

wason : boolean = false;

begin

  if oldhow=how then
  exit;

  if Goptions.keyabort then
  warningtext :=
  '(click, double-click, press a key?)';

  oldhow := how;

  make_main_bump;

  throttle(true);

  case how of
    howclick: begin
      wason := wason or Gidle_off;
      PageControl1.activepageindex := 0; {show the stupid thing.}
      PanelProgress.Visible := true;
      stopbutton.visible := true;
      statmemo.visible := true;
      stopwarning.Caption := warningtext;
      stopwarning.visible := true;
      dontLinuxKey := true;

{To make the stop button work in Linux, you have to press a key. Or I did on
several occasions. This comes and goes; also the mysterious sleep behavior,
where I had to keep the mouse moving in Linux to get it to continue
scanning.... }

    end;

    howNoway: begin
      wason := wason or Gidle_off ;

      PageControl1.activepageindex := 0; {show the stupid thing.}
//      notices.enabled := false;
      PanelProgress.Visible := true;
      statmemo.visible := false;
      stopbutton.visible := false;
      stopwarning.caption := hopelesstext + hopemsg;
      stopwarning.visible := true;

      dontLinuxKey := true;

    end;

  else

    Gidle_on(wason);
    wason := false;
    statmemo.visible := true;
    stopbutton.visible := false;
    stopwarning.visible := false;
    PanelProgress.Visible := false;
    dontLinuxKey := false;

  end;

  update;
  delphi_yield;

end;

{Setup the process bar. Like many modern software products, it is totally
random in owenshow, but does provide a soothing sanity indicator.

howmuch: if 0, finish; if -1, start the progress timer. if >0, start normal
stuff.}

procedure TForm1.progress(howmuch:integer);

const
timing : boolean = false;

begin
  ProgressStatus.caption := '';

  if howmuch<>0 then begin
    stopness(howclick);
    progressbar.Max := abs(howmuch);
    progressbar.position := 0;
  end;

  if howmuch<0 then begin
    progresstimer.enabled := true;
  end;

  if howmuch=0 then begin
    stopness(howoff);
    progresstimer.enabled := false;
//    notices.enabled := true;
  end;


end;

{sometimes the progress bar is so arbitrary we just run it off the timer; see
progress(howmuch) above. }

procedure TForm1.ProgressTimerTimer(Sender: TObject);
begin
  progressbar.stepit;
end;

{nacherly you can abort the process with the stop button. The stuff that does
the work dir/files.pas, calls this to check. // Thu 11/21/02 7:08 pm.
Narcherly indeed. Anyway I tinkered with stupid counting mechanisms for
throttling this thing -- when of course I have this delayed gadget that works
fine.... Oh I see I was originally imagining the progress bar would
indicate something meaningful. But I gave up on that long ago, and if it just
ticks every half second or so -- what's wrong with that? Of course you can't
actually click the stupid button but that's another sorrow..... }

function main_bump(status:string; value:integer = 1):boolean;

const
here : boolean = false;

LABEL
GOAWAY,
STAYHERE;

begin
  result := false;
  if here then
  exit;

  here := true;

  with Form1 do begin

    progressstatus.caption := status;

    ProgressBar.position := ProgressBar.position + value;

    if Progressbar.position >= Progressbar.max then
    Progressbar.position := 0;

    progressstatus.Update;
    update_yield;

    if pleaseabort then begin
      stop_mask_fix := true;
      if usuref('Give-up?') then begin
        result := true;
      end;
    end;

    pleaseabort := false;

  end;

  GOAWAY:
  here := false;
end;


{see main_bump above.}
procedure TForm1.StopButtonClick(Sender: TObject);
begin
//  if notinited<>0 then
//  exit;

  pleaseabort := true;
end;

procedure TForm1.StopButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (notinited<>0) then
  exit;

  throttle(false);
  cumulativestop;
  pleaseabort := true;
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.seedirfiles(const fv:Tfv);
begin

  {see tree from dir.}
  scanfiles(thetree,false,fv,Dirstatus.caption,Goptions.casesort);

  fv.dir_index := thetree.selected;

end;

procedure TForm1.other_stuff;
begin
  if thepanel=d then
  exit;
//just don't call it from there I suppose.

  copysort(thisfv,elsefv);

  scanfiles(thetree,false,elsefv,Dirstatus.caption,Goptions.casesort);

  elsefv.dir_index := thetree.selected;

  copyselect_ifsame(thisfv,elsefv);

end;

{****************************************************************************
seetree means see the directory files in the file panel. seeElse means don't
skip just because it's the other one. I.e., see both.
****************************************************************************}

procedure TForm1.seefiles(seetree:boolean = false; seeElse:boolean = true);

  procedure s(fv:Tfv);
  begin

    if seetree then
    seedirfiles(fv)
    else
    scanfiles(nil,false,fv,fv.status.caption,Goptions.casesort);

  end;

begin

  s(thisfv);
  if seeElse
{  or (notinited > 0) }   {kill the kluje. see seefiles in xinit.}
  then
  s(elsefv);

end;





{****************************************************************************
find stuff. directories.
****************************************************************************}

function TForm1.dir_find_select(what:string; where:integer=0;
kind:Tsearch_kind = search_EXACT):boolean;

var
oldselected,
x:integer;
wason:boolean;

begin
  result := false;

  wason := Gidle_off ;

  oldselected := thetree.selected;

  thetree.pathsFile.fopenR;
  thetree.offsetsFile.fopenR;

  x := thetree.find(what,where,kind);

  if x>=0 then begin
    result := true;
    if oldselected<>x then
    thetree.cuteselect(x);
  end;

  thetree.pathsFile.fclose;
  thetree.offsetsFile.fclose;

  Gidle_on(wason);

end;

{****************************************************************************
find files.
****************************************************************************}
{.$define DEBUG_ph1}

function TForm1.files_find_select(what:string; where:integer;
searchkind:Tsearch_kind):
boolean;
var
j, i:integer;

skipped1,         {we found a match with an extensionless what, but the
                  extension is one of the forbidden.}

skipped2,         {we're going around the second time, so this time we
                  *should* find the forbidden extension version.}

isext,            {what has an extension.}

justtext : boolean; {what is annoying; name with more than one period "a.b.c".
      Basically if sought-after file has more than one period, we give-up on
      all the clever extension matching etc., and just search for the wretch.
      Serves it right. See "if justtext" below.}

name,ext:string;
label
ENDNESS;

const
here : boolean = false;

  procedure checkfile;
  var
  pos, pos2 : integer;
  begin
    if searchkind=search_EXACT then begin
      result :=
{$ifdef MSWINDOWS}
      CompareText
{$endif}
{$ifdef LINUX}
      CompareStr
{$endif}
      (what, Tos_f(thisfv.fls.objects[i]) .name)=0;
    end else if justtext then begin
{$ifdef DEBUG_ph1}
      dbg('justtext j=%d what:%s; name:%s ext:%s',[j,what,name,ext]);
{$endif}

      pos := posi(what, Tos_f(thisfv.fls.objects[i]) .name);

      if searchkind=search_BEGINS_WITH then
      result := pos=1
      else
      result := pos > 0;

    end else if isext then begin
{$ifdef DEBUG_ph1}
      dbg('isext j=%d what:%s; name:%s ext:%s',[j,what,name,ext]);
{$endif}
//      result :=
//      (posi(ext,extractFileext(thisfv.files[i].name))>0) and
//      (posi(name,thisfv.files[i].nameroot)>0);

      pos :=  posi(ext, Tos_f(thisfv.fls.objects[i]) .ext);

      pos2 := posi(name, Tos_f(thisfv.fls.objects[i]) .nameroot);

      if searchkind=search_BEGINS_WITH then
      result := (pos=1) and (pos2=1)
      else
      result := (pos>0) and (pos2>0);

    end else begin
{$ifdef DEBUG_ph1}
      dbg('lastelse j=%d what:%s; name:%s ext:%s',[j,what,name,ext]);
{$endif}

//      result := posi(what,thisfv.files[i].name)>0;
      {do it like dir I say.}

      pos := posi(what, Tos_f(thisfv.fls.objects[i]) .name);

      if searchkind=search_BEGINS_WITH then
      result := pos=1
      else
      result := pos>0;

      if result and (es(what,1)<>'.' {not isext} )
      {we do another different test for extension in this case}
      and (skipextension(system.copy( Tos_f(thisfv.fls.objects[i])
      .ext,2,250)))
      and (not skipped2)
      then begin
        skipped1 := true;
        result := false;
{IF didn't specify an extension, and IF this extension is one of the
forbidden extensions, then don't find.}
      end
    end;

    if result then begin
      files_selectoid(i,true);
    end;
  end;



begin
  result := false;
  if here then
  exit;

  here := true;

  ext := ExtractFileExt(what);

  isext := (length(ext)>0);

  skipped1 := false;
  skipped2 := false;
  justtext := false;

  if isext then begin
    name := extractFname(what);
    if (length(name)<1) or (pos('.',name)>0) then begin
      isext := false;
      {to cover the case where I'm searching just for the extension, please.
      //and now annoying things with two dots.}
      justtext := true;
    end;
  end;

{$ifdef DEBUG_ph1}
//  dbg('what: %s; name: %s; ext: %s',[what,name,ext]);
{$endif}

  for j := 1 to 3 do begin

    if i=3 then
    justtext := true;

    for i := where to thisfv.filecount-1 do begin
      checkfile;
      if result then
      goto ENDNESS;
    end;

    for i := 0 to where-1 do begin
      checkfile;
      if result then
      goto ENDNESS;
    end;


{we got here 'cause we didn't find anything.}

    if justtext then
    break; {that's the last chance.}

    if skipped1 then
{the file had an extension, but it was found in the "skip"
bad extension list. But we didn't find a non-bad extension,
so we'll look again.}
    skipped2 := true
    else
    justtext := true;

{so only the bad extension search gets done twice.}

  end;

  ENDNESS:
  here := false;

end;


{****************************************************************************
use the current entry for next if empty and next key. Like the sainted OV did.
****************************************************************************}

procedure TForm1.nextkey_empty;
begin
  if length(FindEdit.text)>0 then
  exit;

  case thepanel of
    d: begin
      findedit.text := xfilename(thetree.selectedPath);
    end;

    f1,f2: begin
{      if thisfv.view.selected<>nil then  }
//      findedit.text := file_selected_name;
//this is stupid; it'll find only that file! Except MAYBE in Linux.
      findedit.text := file_selected.nameroot;
    end;
  end;
  cumulativecaption;
  Giscumulative := true;


end;

{it might return false if not found.}
function TForm1.os_find(increment:integer = 0):boolean;

label
ENDNESS;

begin

  result := false;  {assume failure}

  if length(FindEdit.text)<1 then begin
    goto ENDNESS;
  end;

  case thepanel of
    d: begin

      thetree.dirupdating;
      seeakey_dir_find := true;
      result :=
      dir_find_select(FindEdit.text,thetree.selected+increment,
      searchkind);
      thetree.dirunupdating;

    end;


    f1,f2: begin
      if thisfv.filecount>0 then begin
        result :=
        files_find_select(FindEdit.Text,
{       thisfv.view.Selected.Index }
        file_selected_index
        +increment,searchkind);

        set_tricky;
      end;
    end;
  end;

  fileshintoid;

  ENDNESS:
end;


{****************************************************************************
copy.
****************************************************************************}
procedure TForm1.quickcopy;
begin
  clipform.plzquick := true;
  CopyClick(nil);
//?  form1setfocus;
end;

{****************************************************************************
Wed 12/03/03 10:55 am. moved the logic from here to clip.pas, where it
belongs.
****************************************************************************}

procedure TForm1.CopyClick(Sender: TObject);
begin
  if notinited<>0 then
  exit;

  if Findedit.focused then begin
    Clipboard.astext := Findedit.text;
    exit;
  end;

  clipform.showmodal;
//?  form1setfocus;

end;


procedure TForm1.MenuCheckUncheck(Sender: TObject);
begin
  with sender as TMenuItem do begin
    checked := not checked
  end;
end;

procedure TForm1.os_scroll(whichway:integer);
var
newtop : integer;
begin
  case thepanel of
    d:begin
      thetree.scroll(whichway);
    end;

    f1,f2:begin
      try
        newtop := thisfv.view.topitem.index+whichway;
        intrange(0,thisfv.view.items.count-1,newtop);

        thisfv.view.topitem :=
        thisfv.view.items[newtop];

      except
        on exception
        do;
      end;

    end;

  end;
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.cumulativeStop;
begin
  if keepcumulative>0 then
  exit;

  Gstartcumulative := false;
  Giscumulative := false;
{$ifdef LINUX}
  if thepanel=d then
{$endif}
  Label_LXstat.caption := '';

  capdir_file;

  if isfindeditpanel then
  exit;

  FindEdit.Text := '';
  setsearchkind(search_CONTAINS);
//  ExactCheckBox.checked := false;
  //reset the search to inexact of course.
end;


procedure Tform1.cumulativecaption;
begin
  captionoid(findedit.text);
end;

{****************************************************************************
****************************************************************************}

function TForm1.not_cumkey(key:Word; Shift:TshiftState):boolean;
var
c:char;
begin

  c := char(key);

  result :=

  (key<>Key_Control) and
  (key<>Key_Shift) and
  (key<>Key_CapsLock) and
  (not is_key(Goptions.literal,key,shift)) and
  (not is_key(Goptions.exact,key,shift)) and

  (

  (Goptions.spacebreak and (c=' ')) or

  (Shift - [ssShift{,ssCtrl}] <> [])
  or (key<32)     {help out pur linux a little; any unused control key
                  will stop search. Backspace of course doesn't work.}
  or (key=127)
  or (key>254)
{  or (c='+')
  or (c='-')
  or (c='='){shouldn't be in file names anyway -- althought - is
  kind of iffy -- and OwenShow defaults to these for file mark/unmark.
  I could fiddle-around and figure if they were actually being used
  but tough. // but now don't care about it in directory.}
  or ( (thepanel<>d) and (c in markset) ) {so I did it.}

  or
  (not (c in
  [' '..'~']

  ))
  )

  ;
end;

{cumumulative search. Returns true if it's a cumulative search key.}
function TForm1.cumulativeSearch(var Key:Word; Shift:TShiftState):boolean;
var
c:char;
lits : string;
{gofind : boolean; }
label
ENDNESS;


  function unfindkey(howmany:integer = 1):boolean;
  var
  i, sl:integer;
  begin

    result := (findedit.text<>'') and (searchkind <> search_EXACT);

    if not result then
    exit;

//    if
//    (searchkind <> search_EXACT)
//    then begin
{just skip it for exact searches; problem is, it might've typed an inexact
search in files and found something, and then typed "/" meaning "be exact" --
and it'd be a lot of work to fix that so we don't.}

      sl := length(findedit.text);

      for i := 1 to howmany do begin
        if sl>0 then
        findedit.text := copy(findedit.text,1,sl-1)
        else
        break;
        dec(sl);
      end;

      cumulativecaption;

//    end;

    emptyMyKeyQueue;
  end;

{****************************************************************************
Wed 8/31/2005 11:08 am. a private version that returns true if user is typing.
I fixed Ttree.find not noticing keypresses -- when it *should* abort, so it
can search with the new cumulative string -- but then this code started
unfindkeying all the new keys, which is wrong. // Tue 9/20/2005 4:43 pm. I'm
not so sure about this. Oh I see what it does is it *doesn't* stop the search
if it was just a keypress. // So Gcumulative_stopped seems to do that just
as well.
****************************************************************************}

  function cum_find(increment:integer = 0):boolean;

    function cumdirfaster:boolean;
    var
    t:TICKTIME;
    begin
      result := false;

      if (thepanel<>d)
      or (Goptions.cumulative_dir_delay < 1) then
      exit;

      delay_z(t,Goptions.cumulative_dir_delay);

      while (not delay_z(t)) do begin
        if not Giscumulative then
        exit;

        if MyKeyQueue.count>0 then begin
          result := true;
          Gcumulative_stopped := true;
          exit;
        end;
        Label_LXstat.caption := 'k';
        Application.ProcessMessages;
        //delphi_yield goes away forever in Linux....
      end;
    end;

  begin
    Gcumulative_stopped := false;
    result := cumdirfaster;
    if not result then begin
      result := os_find(increment);
      if Giscumulative and Gcumulative_stopped then
      result := true;
    end;
  end;

begin
  result := false;

  if not_cumkey(Key,Shift) then begin
    cumulativestop;
    goto ENDNESS;
  end;

  if is_key(Goptions.literal,key,shift) then begin
    lits := inputbox('Enter literal cumulative character(s)','','');
    findedit.text := findedit.Text + lits;
    result := true;
    cumulativecaption;
    if not cum_find
    then unfindkey(length(lits));
    goto ENDNESS;
  end;

  case key of
    key_slash, key_backslash: begin
      key := ord(slashchar);  {xlate slash characters}
    end;
  end;

  if
  is_key(Goptions.exact,key,shift)
{$ifdef SLASH_FILE_EXACT}
  or (
  (key=ord(slashchar)) and
  isfilepanel
  )
{$endif}
  then begin
    nextsearchkind;
    cum_find;
    key := 0;
    result := true;
    goto ENDNESS;
  end;

  c := char(key);

  if is_key(Goptions.nextkey,key,shift) then begin
    key := 0;
    result := true;
    nextkey_empty;
    cum_find(1);
    goto ENDNESS;
  end;

  result := true;
//  key := 0;

  if not (ssShift in Shift) then
  c := sbrs.tolower(c);
  {Ah see in the Linux version, it grabs the Libc version first! (Thu 11/07/02
  10:48 am I was complaining about how I had to do "sbrs.tolower")// So I
  moved LIBC to the *first* in the uses clause, and I gather sbrs overrides
  it. Which is as is it should be.... We can always qualify with "Libc." when
  we should. // but then apparently I moved it around again. // oh it's
  something stupid; sbrs IS ahead of LIBC, but in different clauses.}

  if (length(FindEdit.text)<1) and (sbrs.isspace(c)) then
  goto ENDNESS; {no leading space; he can always literal it.}

  FindEdit.Text:= FindEdit.Text + c;

  cumulativecaption;

//  if not cum_find then
//  unfindkey;

//no this is wrong

{****************************************************************************
Tuesday, May 4, 2010 2:11 pm. Part of the w7a imbroglio. But the way it was
seems logically wrong anyway. I'm not sure what the code does, but it would
still be logically wrong no matter what.... So eff it!
****************************************************************************}
//  while (not cum_find) and Giscumulative
  while Giscumulative and (not cum_find)
  and unfindkey do;

//  do begin
//    unfindkey
//  end;

  key := 0;

  ENDNESS:

end;


{****************************************************************************
****************************************************************************}

procedure TForm1.cutefileselect(const v:Tfv);
var
top, page, select: integer;
s : Tlistitem;
begin

  try
    s :=

{    v.view.selected }
    file_selected_item(v)

    ;

//    directoid(v);
    {re-arrange it so it comes out right, i.e. so it doesn't show a file
    with a bunch of directories on top of it.}

    top := v.view.topitem.index;

//    v.view.selected := s;

    page := filepage(v.view);

    select := s.index;

    if ((select-top) > page) {select is below top}
    or
    (top>select)              {select is above top}
    then
    top := select - (page div 2);

    if top<0 then
    top := 0;

    v.view.topitem := v.view.items[top]
  except
    on exception do
    ;
  end;

end;


{I was having this do an error message -- but then it was annoying and
doesn't happen that often. Oh oh I'll make an infoerror. Look at scan
timings on etc. menu. // Tuesday, December 9, 2003 10:46 am and then it
happened and I didn't know what it was, and who can remember to go look
in etc.? So infoerror now does an error box anyway.}
procedure TForm1.goto_home(currentdir:boolean = false);
var
index:integer;
complaint : boolean;
cd:string;

  function LT2slashes(s:string):boolean;
  var
  count,
  i:integer;
  begin
    result := true;
    count := 0;
    for i := 1 to length(s) do begin
      if s[i]=slashchar then
      inc(count);
      if count>1 then begin
        result := false;
        exit;
      end;
    end;
  end;

begin

  index := 0;
  complaint := true;

  while true do begin
    if length(thetree.homedir)<1 then begin

      thetree.homedir :=
{$ifdef MSWINDOWS}
      thetree.drive + ':' +
{$endif}
      slashchar;

    end;

    index :=
    thetree.find(thetree.homedir,0,search_EXACT);

    if (index<0) or (not DirectoryExists(thetree.homedir)) then begin
      if complaint then begin
        if currentdir then
        cd := 'currentdir or /c option: '
        else
        cd := '';
        cd :=
        infoerror('%shomedir "%s" didn''t exist',
        [cd,thetree.homedir]);

        if currentdir then
        errorf(cd);     {pop-up a box when /c requested.}

      end;
      complaint := false;
      thetree.homedir := xfilepath(thetree.homedir);
      if
{      thetree.homedir=slashchar }
{      length(thetree.homedir)<1  {this never happens. // well at least on
windows....}
      LT2slashes(thetree.homedir)
      then begin
        index := 0;
        break;
      end;
    end else
    break;  {the while.}

  end;

  thetree.cuteselect(index);

  chdir(thetree.homedir);

end;


function TForm1.dirpage:integer;
begin
{  result := (thetree.pix.scrLines * 100) div
  Goptions.dir_page;  }

  result := (thetree.pix.scrLines * Goptions.dir_page) div 100;

//  dec(result, result div Goptions.dir_page);  {i.e. for "cute"}
end;


procedure TForm1.dir_keys(var Key:Word; Shift:TShiftState);
var
screen_top,
page, index : integer;
label
KEY0WASQ_EXIT,
DIRLEVELUP, DIRLEVELDOWN, DIRPARENT, DIRVISITED,
KEYENTER,
UPDATE_SCROLL;

begin

  dir_fix;

{do the wordstar keys}
  index := thetree.selected;
  if Goptions.dir_fix_more then
  screen_top := thetree.screen_top
  else
  screen_top := -1;

  page := dirpage;

  if is_key(Goptions.stuff,key,shift) then begin
    x_stuff;
    goto KEY0WASQ_EXIT;
  end;

  if is_key(Goptions.stufftop,key,shift) then begin
    x_stufftop;
{    infof('pressed stufftop'); }
    KEY0WASQ_EXIT:
    key := 0;
    wasq := false;
    exit;
  end;

  case key of
    ord('A')-CTL: begin
      DIRLEVELUP:
      key := 0;
      thetree.select(thetree.previous_sibling);
    end;

    ord('F')-CTL: begin
      DIRLEVELDOWN:
      key := 0;
      thetree.select(thetree.next_sibling);
    end;

    key_home: begin
      key := 0;
      if ssctrl in shift then
      thetree.homedir := thetree.selectedPath
      else if (ssalt in shift) then
      thetree.select(0)
      else
      goto_home;
    end;

    key_end,
    key_pagedown,
    ord('C')-CTL: begin
      key := 0;

      if wasq or (ssalt in shift) then
      thetree.select(50000)
      else
      thetree.select(index+page);
    end;

    key_right: begin
      if (ssalt in shift) then
      goto DIRLEVELDOWN
      else
      goto DIRVISITED;
    end;

    ord('D')-CTL: begin
      DIRVISITED:
      key := 0;
      visitedDirectory;
    end;

    key_up,
    ord('E')-CTL: begin
      if (ssalt in shift) then
      os_scroll(1)
      else begin
        thetree.select(index-1);
      end;
      key := 0;
    end;

    ord('Q')-CTL: begin
      key := 0;
      wasq := true;
      exit; {avoid wasq clobber}
    end;

    key_pageup,
    ord('R')-CTL: begin
      key := 0;

      if wasq or (ssalt in shift) then
      thetree.select(0)
      else begin
        thetree.select(index-page);
      end;
    end;

{$ifdef KEY_END_DIFFRENT_FROM_FILES}
    key_end: begin
      key := 0;
      thetree.select(thetree.screen_bottom {50000} ) ;
      { changed Fri 5/07/04 8:27 pm so it's like files. //but it
      wasn't... }
    end;
{$endif}

    key_left: begin
      if (ssalt in shift) then
      goto DIRLEVELUP
      else
      goto DIRPARENT;

    end;

    ord('S')-CTL: begin
      DIRPARENT:
      key := 0;
      if thetree.selected>0 then
      thetree.select(thetree.parent);
    end;

    ord('W')-CTL:
    begin
      os_scroll(-1);
      goto UPDATE_SCROLL;
    end;

    key_down,
    ord('X')-CTL: begin
      if (ssalt in shift) then
      os_scroll(-1)
      else begin
        thetree.select(index+1);
      end;
      key := 0;
    end;

    ord('Z')-CTL: begin
      os_scroll(1);
      UPDATE_SCROLL:
{****************************************************************************
//      dont_update_for_a_while(abs(screen_top-thetree.screen_top));
//force unconditional update.
//      dir_fix(true);
nah generally when you're scrolling, you want to see everything; there's no
reason to scroll in a hurry.... So just stop it in its tracks.
****************************************************************************}
      kill_key;
      key := 0;
      dir_fix(true);
//      unkill_key;
      exit;
    end;

    key_Enter, key_return: begin
      KEYENTER:
      key := 0;
      enterdirectory(ssctrl in shift);
    end;

  end;

  if screen_top = thetree.screen_top then begin
    dont_update_for_a_while(0);
//    dbg_nolog('dont_update(0)');
  end else begin
    dont_update_for_a_while(abs(thetree.selected-index));
//    dbg_nolog('dont_update(something)');
  end;

//  dirimage.update;

  wasq := false;

end;



procedure TForm1.files_keys(const fv:Tfv; var Key:Word; Shift:TShiftState);
var
index, page : integer;
//kept : boolean;

tricky : boolean;

olddir:string;

const
here : boolean = false;
lastkey : word = $FFFF;

label
key_was_0EXIT,
key0_EXIT,
justEXIT;

begin

  if here then
  exit;


  here := true;

{  throttle(false);  }
{I'm doing this in key down.}

  tricky := true;

  page := filepage(thisfv.view); {aka page size aka lines on page.}

  dec(page,page div 10);

{$ifdef ISTHISWISE}
  if (key=lastkey) and (plzupdateview) then begin
{see comment at FixFselect; Wed 12/24/03 12:40 pm well I did, and I don't
understand why I should throw-away repeated keystrokes like this. And it of
course showed-up when I was doing repeated keystrokes -- and select still
seemed to work. When it doesn't, just put a plzupdateview trap *in* the key
thingey, and let it stoke the queue until it's over. But for now I'm just
defeating this.}

    goto key0_EXIT;
  end;
{$endif}

  lastkey := key;

{ if thisfv.view.selected=nil then
  index := 0
  else
  index := thisfv.view.selected.index;
}
  index := file_selected_index;

  if fudgemenu(shortcut(key,shift),PopupFilesMenu) then
  goto key0_EXIT;

  if is_key(Goptions.stuff,key,shift) then begin
    other_stuff;
    goto KEY0_EXIT;
  end;

{so apparently if the file_rescan is Insert, it works in the menu. However
I suspect if you change the key, it'll have to come here....}
  if is_key(Goptions.file_rescan,key,shift) then begin
    filerescan(thisfv);
    goto key0_EXIT;
  end;

  if is_key(Goptions.edir_key,key,shift) then begin
    osedirClick(nil);
    goto key0_EXIT;
  end;

  if is_key(Goptions.edit_ini_key,key,shift) then begin
    EditOSinitfileClick(nil);
    goto key0_EXIT;
  end;

  if is_key(Goptions.clips_key,key,shift) then begin
    ClipsClick(nil);
    goto key0_EXIT;
  end;

  if is_key(Goptions.markon,key,shift) then begin
    file_mark(thisfv,index);
    files_selectoid(index+1);
    goto key0_EXIT;
  end;

  if is_key(Goptions.markoff,key,shift) then begin
    file_unmark(thisfv,index);
    files_selectoid(index+1);
    GOTO key0_EXIT;
  end;

  if is_key(Goptions.gotodir,key,shift) {and (not kept)} then begin
    selectpanel(d);
    goto key0_EXIT;
  end;

  if is_key(Goptions.sortName,key,shift) then begin
    sortNamekey;
    goto key0_EXIT;
  end;

  if is_key(Goptions.sortExt,key,shift) then begin
    sortExtKey;
    goto key0_EXIT;
  end;

  if is_key(Goptions.sortSize,key,shift) then begin
    sortSizeKey;
    goto key0_EXIT;
  end;

  if is_key(Goptions.sortDate,key,shift) then begin
    sortDateKey;
    goto key0_EXIT;
  end;

  if is_key(Goptions.sortNot,key,shift) then begin
//    sortUnsort;
    unsortfiles1Click(nil);
    goto key0_EXIT;
  end;

{now your average statutory movement-type keys. Mon 6/02/03 6:17 pm introduced
@home, @end -- goto extremes, @UP/@DOWN -- scroll.}
  case key of

    key_home: begin
      key := 0;
      if (ssctrl in shift) then
      thetree.homedir := thisfv.status.caption
      else if (ssalt in shift) then
      files_selectoid(0,false)
      else begin
        goto_home;
        enterdirectory;
      end;
    end;

    key_end,
    key_pagedown,
    ord('C')-CTL: begin
      if wasq or (ssalt in shift) then
      files_selectoid(50000,false)
      else
      files_selectoid(index+page,false);
      goto key_was_0EXIT;
    end;

{FILES FILES FILES FILES Keys}

    key_up,
    ord('E')-CTL: begin
      if (ssalt in shift) then
      os_scroll(1)
      else
      files_selectoid(index-1,false);
      goto key_was_0EXIT;
    end;

    ord('Q')-CTL: begin
      wasq := true;
      goto key0_EXIT;  {avoid wasq clobber}
    end;

{FILES FILES FILES FILES Keys}

    key_pageup,
    ord('R')-CTL: begin
      if wasq or (ssalt in shift) then
      files_selectoid(0,false)
      else
      files_selectoid(index-page,false);
      goto key_was_0EXIT;
    end;

    key_left,
    ord('S')-CTL: begin

      if ( (thetree.selected>0) and (thetree.parent>=0) )
      then begin
        olddir := xfilename(thisdirectory);
        thetree.select(thetree.parent);
        enterdirectory;
        {note it goes to the top directory of the parent whatever.}
        stuffdir(dirstatus.caption,thetree.selected);
        if left_select.checked then
        files_find_select(olddir,0,search_EXACT);
      end;

      goto key_was_0EXIT;
    end;

    key_right,
    ord('D')-CTL: begin
      visitedDirectory;
//      if kept then
//      enterdirectory;
      goto key_was_0EXIT;
    end;


{FILES FILES FILES FILES Keys}

    ord('W')-CTL:
    begin
      tricky := false;
      os_scrolled := true;
      os_scroll(-1);
      goto key_was_0EXIT;

    end;

    key_down,
    ord('X')-CTL: begin
      if (ssalt in shift) then
      os_scroll(-1)
      else
      files_selectoid(index+1,false);
      goto key_was_0EXIT;
    end;

    ord('Z')-CTL: begin
      tricky := false;
      os_scrolled := true;
      os_scroll(1);
      goto key_was_0EXIT;
    end;

    key_return, key_enter: begin
      files_dir;
    end;

  end;

  goto justEXIT;


  key_was_0EXIT:

  wasq := false;

  key0_EXIT:
  key := 0;

  if tricky then
  set_tricky;

  capdir_file;

  justEXIT:


  here := false;

end;

procedure TForm1.tabselect(forward:boolean);
begin
  if forward then begin
    if thepanel=d then
    selectpanel(fvtop.which)
    else if thepanel=fvtop.which then
    selectpanel(fvbottom.which)
    else selectpanel(d);
  end else begin
    if thepanel=d then
    selectpanel(fvbottom.which)
    else if thepanel=fvtop.which then
    selectpanel(d)
    else selectpanel(fvtop.which);
  end;

{
  case thepanel of
    d: begin
      selectpanel(f1);
    end;

    f1: begin
      selectpanel(f2);
    end;

    f2: begin
      selectpanel(d);
    end;
  end;
}
end;

procedure TForm1.os_keys(var Key: Word; Shift: TShiftState);
{$ifndef COLOR_FASTER}
var
wastopfile : boolean;
{$endif}
const
sizechange = 10;
label
CONTROLSIZE_EXIT;
begin


{Tue 5/25/04 7:24 pm. So the "throttle(false)" s in here should be replaced
by the one I just put in keydown.}

  if (shift=[])
  and (key=key_delete) then begin
    key := 0;
    MenuDeleteClick(nil);
    exit;
  end;

  if dontLinuxKey then begin
    pleaseabort := Goptions.keyabort {true};
    exit;
  end;

//do resize for control arrows.
  if (shift=[ssCtrl]) then
  case key of
    key_right: begin
      width := width + sizechange;

      if Goptions.keepright then begin
        left := left - sizechange;
      end;

      CONTROLSIZE_EXIT:
      key := 0;
      exit;
    end;

    key_left: begin
      width := width - sizechange;
      if Goptions.keepright then begin
        left := left + sizechange;
      end;
      goto CONTROLSIZE_EXIT;
    end;

    key_down: begin
      height := height + sizechange;
      if top+height+50 > screen.height then
//clx too stupid to know how high the form is.
      top := top - sizechange;
      goto CONTROLSIZE_EXIT;
    end;

    key_up: begin
      height := height - sizechange;
      goto CONTROLSIZE_EXIT;
    end;

  end;

  case key of

    0, key_shift: begin
{      throttle(false); }
      exit;
    {ah see it sends a zero now and then just fer fun. And of course I've
    gotten in the habit of using the zero for nothing.}
    end;

    key_alt: begin
{      throttle(false);   }
      if Goptions.alt_stop then begin
        cumulativestop;
      end;
      exit;
    end;

    key_control: begin
{      throttle(false);    }
      if Goptions.control_stop then begin
        cumulativestop; {of course; he *must* mean stop searching}
      end;
      exit;
    end;

  end;

  if seekeys or Findedit.focused then
  exit;

  fix_control(key,shift);

  if cumulativeSearch(key,shift) then begin
    Giscumulative := true;
    Gstartcumulative := true;
    exit;
  end;

  maybe_fix_exec_state;

  if execform.checkexecs(key,shift) then begin
    key := 0;
    finishexec;
    exit;
  end;

  if is_key(Goptions.exec,key,shift) then begin
    key := 0;
    maybe_fix_exec_state;

    execform.shortcut_key := true;
    execform.showmodal;

    finishexec;

    exit;
  end;


  if key=key_tab then begin
    tabselect(shift<>[ssShift]);
    key := 0;
    exit;
  end;

  if is_key(Goptions.flip,key,shift) then begin
    key := 0;

{$ifdef COLOR_FASTER}
    if thepanel=d then
    FlipClick(topfv.flipbutton)
    else
    FlipClick(thisfv.flipbutton);
{$else}

    wastopfile := (topfv = thisfv);

{Fri 1/03/03 2:40 pm. Shouldn't it then goto top panel? If directory?}
{no or something because ^Enter does that.}
//    if thepanel=d then
//    enterdirectory(true)
//    else
//    selectpanel(fvtop.which);
    x_flip;

    if thepanel<>d then begin
      set_tricky;
      if wastopfile then
      selectpanel(topfv.which,true)
      else
      selectpanel(bottomfv.which,true);
    end;
{$endif}

    exit;
  end;

  if is_key(Goptions.quickcopy,key,shift) then begin
    key := 0;
    quickcopy;
//?    form1setfocus;
    exit;
  end;

  if is_key(Goptions.super_quickcopy,key,shift) then begin
    key := 0;
    super_quickcopy;
    exit;
  end;

{$ifdef USEFUDGEINSTEAD}
  if is_key(Goptions.fixfiles,key,shift) then begin
    key := 0;
    detree;
    exit;
  end;
{$endif}

  if is_key(Goptions.cuteify,key,shift) {key=ord('J')-CTL} then begin
    key := 0;
    if thepanel=d then
    thetree.cuteify
    else
    plzFview(true);
    exit;
  end;

{$ifdef ITWASHOPELESS}
  if {fudgemenu(ShortCut(key,shift),MainMenu1) or}
  {apparently isn't helpful for main menu.}
  fudgemenu(ShortCut(key,shift),PopupMenu_etc) then begin
    key := 0;
    exit;
  end;
{****************************************************************************
see rethinkey for troubles making popupmenu_etc short cuts work. It's just too
hairy.
****************************************************************************}
{$endif}

  if is_key(Goptions.TreeKey,key,shift) then begin
    key := 0;
    MenuTreeClick(nil);
    exit;
  end;

  if is_key(Goptions.fixfiles,key,shift) then begin
    key := 0;
    menuFixTreeClick(nil);
    exit;
  end;

  if is_key(Goptions.recall_main_layout,key,shift) then begin
    key := 0;
    restoreMainLayoutPreferenceClick(nil);
    exit;
  end;

  if is_key(Goptions.recall_save_layout,key,shift) then begin
    key := 0;
    save_restore_layoutClick(nil);
    exit;
  end;

{
  if is_key(Goptions.etc,key,shift) then begin
    key := 0;
    MenuEtcClick(nil);
    exit;
  end;  }

  case thepanel of
    d: dir_keys(key,shift);
    f1: files_keys(fv1,key,shift);
    f2: files_keys(fv2,key,shift);
  end;

  unfix_control(key,shift); {?}

end;



{****************************************************************************
****************************************************************************}
procedure Tform1.Fcute(fv:Tfv = nil);
var
top: integer;

begin

  if fv=nil then
  fv := thisfv;

  try
    top :=
    file_selected_index(fv)
    - (round((fv.view.height / files_PixPerLine) / 3.0));

    {don't really know why but what the heck....}

    intrange(0,fv.view.items.count-1,top);

    fv.view.topitem := fv.view.items[top];

  except on
    exception do {nada};
  end;

end;

procedure Tform1.Fupdate;
begin
  if notinited>0 then
  exit;
  thisfv.view.update;
end;


procedure plzFview(cute : boolean = false; fv:Tfv = nil);
begin
  with form1 do begin
    if Thepanel=d then
    exit;
    {shouldn't fix it if it we're not looking at it, eh?}
    if cute then
    Fcute(fv);
    plzupdateview := true;

  end;
end;

procedure TForm1.f_s(fv:Tfv; index:integer; cute:boolean = false);
begin

  try
    if intrange(0,fv.view.items.count-1,index) then begin
      throttle(false);
      set_tricky;
      fv.view.selected := fv.view.Items[index];
      file_showext(fv,index);
    end;
  except
    on exception
    do;
  end;

//  plzFview(cute);
end;

procedure Tform1.files_selectoid(index:integer; cute:boolean = false);
begin
  f_s(thisfv,index,cute);
  plzFview(cute);
  capdir_file;
end;


{****************************************************************************
Mon 8/18/03 11:25 am. safestuff wasn't safe; it was stuffing copy destinations
into the visited-dir list using the current tree  without validating that
the destinations were *in* that tree. This would create the annoying "can't
switch to visited directories" bug, i.e. double-clicking on an entry in the
visited dirs display, and going to the wrong directory -- usually that
directory *on the current drive* i.e. in MSDOS. So I'm going to change it
today to maintain two lists.
****************************************************************************}

var

cpyf_destinations: TStringList;

const
MAXCPYF_DESTINATIONS = 20;

procedure safestuff(d:string);
  function stf(d:string):boolean;
  begin
    result := false;
    if
    (length(d)>0) and
    DirectoryExists(fdeslash(d)) then begin
      if cpyf_destinations.count>=MAXCPYF_DESTINATIONS then
      cpyf_destinations.delete(0);

      adduniquething(cpyf_destinations,d);

//      form1.stuffdir(fslash(d));  //bad bad.
      result := true;

    end;
  end;

begin

  if not stf(d) then
  stf(ExtractFilePath(fdeslash(d)))

end;

{****************************************************************************
this is called by copymove code to get a list of likely targets.
****************************************************************************}
procedure Tform1.copymovesuspects(combo:TComboBox; mult:boolean;
spare:TStringList = nil);
var
i: integer;
begin

  with combo do begin

    items.clear;

    adduniquething(items,thisfv.status.caption);
    {add this -- and then remove it. So the user won't constantly be seeing
    the current directory as a likely destination.}

    adduniquething(items,elsefv.status.caption);

    if not mult then
    adduniquething(items,File_selected_name);

    adduniquething(items,Dirstatus.caption);

    for i := 0 to VisitedDirs.items.count-1 do
    adduniquething(items,
//    Visiteddirs.items[i]
    visited_dir(i)
    );

    for i := 0 to cpyf_destinations.count-1 do
    adduniquething(items,cpyf_destinations[i]);

    if spare<>nil then
    for i := 0 to spare.count-1 do
    adduniquething(items,spare[i]);

    items.delete(0);  {remove this directory.}
  end;

  ComboText0(combo);

end;

{****************************************************************************
****************************************************************************}
function TForm1.topfv:Tfv;
begin
  result := fv1;
  if fv1.panel.top > fv2.panel.top then
  result := fv2;
end;

function TForm1.bottomfv:Tfv;
begin
  if (topfv = fv1) then
  result := fv2
  else
  result := fv1;
end;

procedure Tform1.statmemoid;

var
dirhintinfo : string;
bytes_free:string;
DiskLabel:string;

  procedure dirhintoid;
  const
  basichint = '(rightclick: menu)';
  begin
    dirhintinfo :=
    safe_format('%s dirs, %s bytes free',
    [
    numbercommas(thetree.count),
    bytes_free
    ]);

    dirimage.hint := safe_format('%s %s',
    [
    dirhintinfo,
    basichint]);

  end;

begin

  if (notinited>0)
  or thetree.isbadnet
  then
  exit;

  bytes_free := numbercommas(DiskBytes(dirstatus.caption));

{$ifdef MSWINDOWS}
  disklabel := trim(GetLabel(thetree.drive + ':\'));
{$endif}
{$ifdef LINUX}
  disklabel := trim(getenvironmentvariable('HOSTNAME'));
{$endif}
  if length(disklabel)>0 then
  disklabel := ' ('+disklabel+')';

  dirhintoid;

  StatMemo.Text :=
  safe_format(
  '%s bytes free'+disklabel+LNEND +
  'directory #%s/%s ($%x)' + LNEND +
  '%s' + LNEND +
  '%s',
  [
  bytes_free,
  numbercommas(thetree.selected+1),
  numbercommas(thetree.count),
  thetree.selected,
  topfv.statinfo,
  bottomfv.statinfo
  ]);

  StatMemo.lines[StatMemo.lines.count] :=
  link_name;

end;

procedure Tform1.fhintoid(const fv:Tfv);
var
{ext,}
unscanned,
unsorted : string;
begin

  if fv.sorted then
  unsorted := ''
  else
  unsorted := '(UNSORTED!!) ';

  if fv.scanshort then
  unscanned := '(MISSING FILES!!) '
  else
  unscanned := '';

  if fv.nonexistent then begin

    fv.statinfo :=

    safe_format('%s doesn''t exist; rescan parent?',[fv.selectdir]);

    fv.view.columns[namecolumn].caption := fv.namecaption;

  end else begin

    fv.statinfo :=
    safe_format('%s%s%s files; %s bytes',
    [
    unscanned,
    unsorted,
    numbercommas(fv.filecount),
    numbercommas(fv.bytecount)
    ]);

  end;

  statmemoid;

  fv.view.hint :=
  safe_format('%s (rightclick:menu)',[fv.statinfo]);

end;

procedure TForm1.fileshintoid;
begin
  fhintoid(thisfv);
  fhintoid(elsefv);

  statmemoid;
end;

{****************************************************************************
****************************************************************************}

{****************************************************************************
****************************************************************************}
function TForm1.rootsure(what:string; var rut:boolean;
dontask:boolean = false):boolean;
begin
  result := true;

  rut := thetree.selected=0;

  if rut and thetree.rootwarning
  and
  ( (unwarn='') or (pos(unwarn,thetree.name)<1) )
  then
  result :=
  dontask or
  usuref('%s the root (i.e. everything?); could take a while, '
  +' (5, 10 minutes)'
  ,[what]);
end;

var
showscan_wason : boolean;

procedure TForm1.showscan_start;
begin
  showscan_wason := Gidle_off ;

  dumpclick := true;
  delay_z(dumpclicktime,2000);
  //inhibit dangerous clicks; osidle should get turned-off, and then
  //it'll never get turn-off ... until _stop.

  thetree.dirupdating;
  stopness(howclick);
  progress(10 {0});
  {changed from 100 to 10 in honor of skiptick nonsense just so the
  thing jumps around more. As noted elsewhere in many contradictory ways,
  the progress bar during directory-scanning is without meaning. But it's
  nice if it keeps jumping, and actually I figure if it jumps quickly, it'll
  be obvious it's not tracking total.}

end;

procedure Tform1.showscan_stop;
begin
  delay_z(dumpclicktime,500);
  //inhibit them a bit longer. and turn the thing off.

  thetree.dirunupdating;
  inited(true);
  stopness(howoff);
//?  form1setfocus;

  Gidle_on(showscan_wason);
end;

{****************************************************************************
****************************************************************************}

function TForm1.ScanSelectedSubdirs(newonly : boolean;
onlyone:string = ''; levels : integer = 0 ):boolean;
begin
  result := ScanSelectedSubdirs0(true,newonly,onlyone,levels);
end;

function TForm1.ScanSelectedSubdirs0(rootcheck, newonly : boolean;
onlyone:string = ''; levels : integer = 0 ):boolean;
var
rut:boolean;
p : string;
label
GOAWAY;
begin
  result := false;

  if rootcheck and (not rootsure('scan',rut)) then
  exit;

  p := thetree.selectedPath;
  if not DirectoryExists(p) then begin
    errorf('"%s" doesn''t exist (scan higher up tree?)',[p]);
    exit;
  end;

  result := true;
{  fixlevel(levels); }

{****************************************************************************
****************************************************************************}
{I moved the dir_scan procedure code here Tue 11/05/02 2:02 pm. I.e.
"defactoring".}

  cumulativestop;

  inc(notinited);

{  thetree.select(thetree.selected);  }
{that seems a little redundant. }

  try
    showscan_start;

    chdir(p);

{$ifdef LINUX}
    thetree.LinuxSys := ScanForm.SysOk.checked;
{$endif}

    pleaseSFF_flag := false;
    {*************************************************************************
    Tue 4/22/2008 11:51 am. cancel any requested rereads. It actually managed
    to work once, but probably bad idea. // Well and of course it can't
    happen. But safe/sorry.
    *************************************************************************}

    result := thetree.new_scan(thetree.selected, newonly,levels ,onlyone );

  except
    on E: Exception do begin
      Errorf('dir_scan: %s',[E.Message]);
    end;
  end;

  progress(0);

  dirstatus.caption := p;
  {restore the caption, so seefiles'll work for those who call it
  afterwards. The bizarre unloaddirs/loaddirfile nonsense doubtlessly
  clobbers it.}

  GOAWAY:
  showscan_stop;

end;


{****************************************************************************
****************************************************************************}
procedure Tform1.enterhome(d:string);
begin
  if thetree.enterhome then
  thetree.lastFileselectdir := d;
end;

procedure TForm1.scanfiles(t:Ttree; scanall:boolean; const panel:Tfv;
directory:string; casesort:boolean);
begin

  if thetree.isbadnet(true) then
  exit;

  set_tricky;
  stopness(howclick);
  progress(1000);

  file_scan(t,scanall,panel,directory,casesort);

  progress(0);  { does  stopness(howoff) }

  set_tricky;
end;

procedure TForm1.DirectoriesEnter(Sender: TObject);
begin
  if notinited>0 then
  exit;

  if thepanel<>d then
  selectpanel(d);

end;

procedure TForm1.FilesViewEnter(fv:Tfv);
begin
  if (notinited>0)
//  or cum_clk
  then
  exit;

//  throttle(false);
  if thepanel<>fv.which then
  selectpanel(fv.which);

end;


procedure TForm1.FilesView1Enter(Sender: TObject);
begin
  FilesViewEnter(fv1);
end;


procedure TForm1.FilesView2Enter(Sender: TObject);
begin
  FilesViewEnter(fv2);
end;

{returns true if it was a directory; I gather it changes to the directory or
something, see? Like the double-click either cycle marks or changes to the
directory. Returns true if the current file is a directory, tries to enter the
directory, else returns false.}

function TForm1.files_dir:boolean;

var

plz_scan_name : string;
i, index : integer;

begin
  result := false;

  repeat
  //note that repeat is auto-enclosing, but I won't indent here because I'm
  //trying to be confusing. //oh please...
    plz_scan_name := '';
    index := -1;

    try

      if isdir(file_selected(thisfv))
//      and DirectoryExists(file_selected_name)
      //Wednesday, August 15, 2007 10:32 am.
      //sadly it repeats forever if it doesn't.
      then begin
        if thetree.autodirscan then
        captionoid('searching for "%s"',[file_selected_name]);

        result := true;

        if
        dir_find_select(thisfv.status.caption+
        file_selected_name,thetree.selected)
        then begin
  //          scanfiles(thetree,false,thisfv,dirstatus.caption,Goptions.casesort);
  {it must be this tree, because it's thisfv and a directory *in* thisfv.}
          enterdirectory;
          stuffdir(dirstatus.caption,thetree.selected); {forgot until 1/14/03}
        end else
  {****************************************************************************
  Dir "`%s" isn't known to OwenShow; try and scan it in?
  `a,[file_selected_name]
  ****************************************************************************}
        if
        thetree.autodirscan or
        usuref(


  'Dir "%s" isn''t known to OwenShow; try and scan it in?'
  ,[file_selected_name]


        ) then begin
          if not DirectoryExists(file_selected_name) then begin
{****************************************************************************
 Wed 8/15/2007 9:38 am.
     C:\gregor\OwenShow\junk>[ov] mkdir newdir~
                [rescan files in files panel]
     C:\gregor\OwenShow\junk>[ov] rmdir newdir~
                then try and enter "newdir~"  goes into endless loop.
                Restart'd stop it.
****************************************************************************}
            if usuref('"%s" doesn''t seem to exist; remove from files display?',
            [file_selected_name]) then begin
              file_off(thisfv.status.caption+file_selected_name);
            end;
            exit; //and go away whatever.
          end;

  {****************************************************************************
  Dir "`%s" is excluded (in tree `%s exclude section); OK to override?
  `a,[file_selected_name,thetree.name]

  ****************************************************************************}
          plz_scan_name := file_selected_name;

          if thetree.exclude.find(
          fdedrive(thisdir_string(true)+file_selected_name),
          i)
          and (integer(thetree.exclude.objects[i])=-1)
          then begin
            if usuref(

  'Dir "%s" is excluded (in tree %s exclude section); OK to override?'
  ,[file_selected_name,thetree.name]

            ) then begin
              thetree.exclude.objects[i] := Tobject(1); //whatever.
              index := i;
            end else begin
              plz_scan_name := '';
            end;
          end;
        end;
      end;
    except
      on exception
      do;
    end;

    if ( plz_scan_name<>'' )
    then begin
      ScanSelectedSubdirs0(false,true ,plz_scan_name ,1 );
      if index>-1 then
      thetree.exclude.objects[index] := Tobject(-1);
      //put it back.

  {****************************************************************************
  not new-only....
  Friday, June 10, 2005 7:00 pm YES new directories. I.e. in program files.
  Mon 9/26/2005 6:03 pm. And Linux /mnt! And now not only new directories, but
  *just* this new directory, and just to a single level. (EZONE)
  ****************************************************************************}

    end;

  until
  plz_scan_name='' ;

end;

procedure TForm1.MenuUnMarkClick(Sender: TObject);
begin
  selectedmark(false);
  set_tricky;
end;


procedure TForm1.MenuMarkClick(Sender: TObject);
begin
  selectedmark;
  set_tricky;
end;


procedure TForm1.MarkallClick(Sender: TObject);
var
i:integer;
begin
  for i := 0 to thisfv.filecount-1 do begin
    if not file_isstar( Tos_f(thisfv.fls.objects[i]) )
    then
    file_only_mark(thisfv,i);
  end;
  set_tricky;
end;

procedure TForm1.MarktopClick(Sender: TObject);
var
i:integer;
begin
  for i := 0 to file_selected_index-1 do begin
    if not file_isstar( Tos_f(thisfv.fls.objects[i]) )
    then
    file_only_mark(thisfv,i);
  end;
  set_tricky;
end;

procedure TForm1.MarkbottomClick(Sender: TObject);
var
i:integer;
begin
  for i := file_selected_index+1 to thisfv.filecount-1 do begin
    if not file_isstar( Tos_f(thisfv.fls.objects[i]) )
    then
    file_only_mark(thisfv,i);
  end;
  set_tricky;
end;


procedure TForm1.UnmarkallClick(Sender: TObject);
var
i:integer;
begin
  for i := 0 to thisfv.filecount-1 do begin
    file_unmark(thisfv,i);
  end;
  set_tricky;
end;

procedure TForm1.MarkstarsClick(Sender: TObject);
begin
  file_markchecked;
  set_tricky;
end;

procedure TForm1.UnmarkstarsClick(Sender: TObject);
var
i:integer;
begin
  dbg('unmarkstarsclick');
  for i := 0 to thisfv.filecount-1 do begin
    if file_isstar( Tos_f(thisfv.fls.objects[i]) )
    then
    file_unmark(thisfv,i);
  end;
  set_tricky;
end;

function TForm1.parentdirectory:boolean;
begin
  result := false;


{  if thetree.selected=0 then
  exit;
{the first root directory is the only directory without a parent}

{let's make it bullet proof; I use this for exiting from bad directories, and
it turns out if the parent is a bad directory too -- which often happens with
unmounted Linux directories -- I'm sunk. So....}

  while thetree.selected<>0 do begin
    thetree.select(thetree.parent);
    try
      chdir(thetree.selectedPath);
{      seefiles(true,false);  }
      {this is correct; it is used by cpyfiles to delete dirs etc.}
{      select(d);  }
{I don't know what stuff is. It was leaving the files selected, white,
under some conditions. And wastes time! And is OwenShow inconsistent.
Clicking on a directory in the tree, or moving there *doesn't* select
files unless one double-clicks. Oh I see I was probably double-clicking
on a broken directory. Ah... But it doesn't actually select the files
anway! If it doesn't, it shouldn't show them. I have spoken. I could
fix it with a default "show" argument, but this is more consistent.}
      result := true;
    except on
      exception do {nada};
    end;

    if result then    {it worked.}
    break;
  end;

end;

//returns OS opinion.
function thisdir_string(slash:boolean = true):string;
begin
  result := fslash(getcurrentdir);
  with form1 do
  case thepanel of
    d: result := dirstatus.caption;
    f1,f2: result := thisfv.status.caption;
  end;

  if not slash then
  deslash(result);
end;

//returns OS opinion IF IT exists; else ''.
function thisdirectory(slash:boolean = true):string;
var
dir:string;
begin
  result := '';
  dir := thisdir_string(slash);

  try
    chdir(dir); {probably changes drive too? // has a few times}
    result := dir;
  except
    on exception do begin
    end;
  end;

  if not slash then
  deslash(result);
end;



{****************************************************************************
****************************************************************************}

procedure TForm1.FlipClick(Sender: TObject);
begin

  if (notinited<>0) then
  exit;

  CpyDstOff(true);

{first select the file thing upon which the flip button was clicked. If
it's already selected, that's ok doesn't do anything.}

{$ifdef COLOR_FASTER}
//  thisfv.view.color := unselcolor;
  if sender=Flip1 then begin
    fv1.view.color := unSelColor;
    flip_file_positions;
    selectpanel(f2);
//    fv2.view.color := selColor;
  end else begin
    fv2.view.color := unSelColor;
    flip_file_positions;
    selectpanel(f1);
//    fv1.view.color := selColor;
  end;

//  flip_file_positions;

{$else}
  flip_file_positions;

  if sender=Flip1 then begin
    selectpanel(f2);
  end else begin
    selectpanel(f1);
  end;
{$endif}

  enterhome(dirstatus.caption);
  plzFview;
//  thisfv.view.setfocus;
end;

function TForm1.fvTop:Tfv;
begin
  if filesPanel2.top<5 then
  result := fv2
  else
  result := fv1;
end;

function Tform1.fvBottom:Tfv;
begin
  if filesPanel1.top<5 then
  result := fv2
  else
  result := fv1;
end;



{****************************************************************************
****************************************************************************}
procedure TForm1.flip_file_positions;
var
align1, align2: Talign;
height1,height2 : integer;
//oldthis: Tfv;

begin

  set_tricky;

  align1 := FilesPanel1.align;
  align2 := FilesPanel2.align;

  height1 := FilesPanel1.height;
  height2 := FilesPanel2.height;

  FilesPanel1.Align := align2;
  FilesPanel2.Align := align1;

  FilesPanel1.Height := height2;
  FilesPanel2.Height := height1;

{the order these mysterious things happen at makes a difference.}
  SplitterFiles.top := 0;
  FilesMiscPanel.top := 0;

//  oldthis := thisfv;
//  thisfv  := elsefv;
//  elsefv  := oldthis;

//  case thepanel of
//    f1: selectpanel(f2);
//    f2: selectpanel(F1);
//  end;

{maybe this'll stop the flip wiggle -- when in files panel, after clicking the
flip thing, ESC to dirs always did a little dance.}
  width := width - 1;
  width := width + 1;
{And yes it does! Isn't it amazing!?}

  update;

  set_tricky;

  statmemoid;


end;

{
procedure TForm1.flipoid;
const
here : boolean = false;
begin
  if here then
  exit;

  here := true;

  flip_file_positions;

  statmemoid;

  here := false;

end;
}

{****************************************************************************
****************************************************************************}
procedure dbglog(logit: boolean; const TheFormat: string;
const Args:array of const);
var
dbg : string;
bang : boolean;
begin
  dbg := safe_format(TheFormat,args);

  bang := es(dbg,1) = '!';
  if (bang) then
  dbg := copy(dbg,2,5000);

  if dbg<>'' then
  dbg := safe_format('%d:%s',[dbg_count,dbg]);

  if logit then begin
//blank means erase the stupid thing.
    lg('dbg',dbg,[0]);
  end;

  if (not Goptions.debug)
  and (not bang)
  and (dbg<>'') //Friday, November 23, 2007 4:35 pm. Has to CLEAR dolt....
  then
  exit;
  //i.e. log it if he has log on.

  with form1 do begin
    FilesM_Label2.caption := dbg;
  {between the file panels, to the right of the os_idle sanity blip}
    if isdbg then
    FilesM_Label2.hint := 'click to clear; right-click to copy to clipboard'
    else
    FilesM_Label2.hint := '';
  end;
  inc(dbg_count);     //so do this all the time.
end;

procedure dbg(const TheFormat: string; const Args:array of const);
begin
  dbglog(true,TheFormat,Args);
end;

procedure dbg(const TheFormat: string);
begin
  dbg(TheFormat,[0]);
end;

procedure dbg_nolog(const TheFormat: string; const Args:array of const);
overload;
begin
  dbglog(false,TheFormat,Args);
end;

procedure dbg_nolog(const TheFormat: string); overload;
begin
  dbg_nolog(TheFormat,[0]);
end;

procedure clrdbg;
begin
  dbg('');
end;

function isdbg:boolean;
begin
  with form1 do begin
    result := FilesM_Label2.caption <> '';
//    length(FilesM_Label2.caption)>0;
  {between the file panels, to the right of the os_idle sanity blip}
  //this is the usual one.
  end;
end;

{****************************************************************************
the menus are screwed in some innovative way, so I'm gathering them here
together....
****************************************************************************}
function TForm1.c_m(what:fileaction):fileaction;
begin
  if menuCreate.shortcut = menuMove.shortcut then begin
    if thepanel=d then
    result := xcreate
    else
    result := xmove
  end else
  result := what;
end;

procedure TForm1.MenuExecClick(Sender: TObject);
begin

  maybe_fix_exec_state;
  execform.showmodal;

  finishexec;

end;

procedure TForm1.MenuCopyClick(Sender: TObject);
begin
  no_tricks := true;
  cpyf(xcopy);
  Ffix(elsefv);   {this fixed disappearing select in other files
                  panel.}
  plzFview(true);
end;

procedure TForm1.MenuDeleteClick(Sender: TObject);
var
reselect_index,
baddelete_index : integer;
begin
  if (thepanel=d) then begin
    reselect_index := thetree.previous_sibling;
  {  thetree.parent(thetree.selected);  }
  {Oops it turns-out cpyf does that.... Tch tch....}
    baddelete_index := Thetree.selected;
    thetree.screentop(true);

    cpyf(xdelete);

    thetree.screentop(false); //try and get the old top back...

    if cpyf_didsomething then
    thetree.select(reselect_index)
    else
    thetree.select(baddelete_index); {go back to the undeleted dir}
{****************************************************************************
Thu 7/08/2004 8:55 pm. Changed them both to cuteselect; the failed delete was
leaving the directory at the bottom of the tree display, but actually the
succeeded delete should cute-up too. The problem is, the cpyf code moves the
selected directory to the parent, even if we don't see it, so everything's
bolixed-up anyways. So cuteselect it is.
****************************************************************************}


    PurgeDirs_FilePanels;  {do this after the select, so the files'll scan thel
    right directory.}
  end else begin
    cpyf(xdelete);
  end;

  capdir_file;

  plzFview(true);
end;

procedure TForm1.menuCreateClick(Sender: TObject);
var
s:string;
oldselected : integer;
begin
  oldselected := Thetree.selected;
  s := cpyf(c_m(xcreate));
  plzFview(true);
  if length(s)<1 then
  exit;

  s := dirstatus.caption+s;

  if dir_find_select(s,oldselected {bad bad:0},search_EXACT) then begin
    stuffdir(s,thetree.selected);  {put it on the list.}
  end;

end;

procedure TForm1.MenuMoveClick(Sender: TObject);
begin
  no_tricks := true;
  cpyf(c_m(xmove));
  Ffix(elsefv);
  capdir_file;
  plzFview(true);
end;

procedure TForm1.menuRenameClick(Sender: TObject);
var
name:string;
begin
  name := cpyf(xrename);
//?  form1setfocus;
  if {(thepanel<>d) and} (length(name)>0) then begin
    files_find_select(name,0,search_EXACT);
    cumulativestop;
  end;

  if thepanel=d then begin
    PurgeDirs_FilePanels;
    stuffdir(dirstatus.caption,thetree.selected);
  end;
  form1setfocus;
end;

procedure TForm1.MenuHelpClick(Sender: TObject);
begin
  {$ifdef TESTTHETIMER}
  osinfof('start 2000 wait');
  mswait(2000);
  osinfof('finished 2000 wait');
  {$endif}
  oshelp('The_Three_Main_Panels');
//?  form1setfocus;
end;

procedure TForm1.visible_mark(v:boolean);
var
i:integer;
begin
  for i := 0 to PopupFilesMenu.items.count-1 do begin
    PopupFilesMenu.items[i].visible := v;
    if PopupFilesMenu.items[i].caption = '-' then
    break;
  end;
end;



procedure TForm1.MarkClick(Sender: TObject);
begin
  if cum_clk then
  exit;

{  MarkPopUp.Popup(
  left+FilesPanel.left-40,
  top); }

{Invisible-ize the first part of the menu, up to and including
the separator, a hyphen. Which'd better be there.}
  visible_mark(false);

{  PopupFilesMenu.PopUp(
  left+FilesPanel.left-40,
  top); }

  PopupFilesMenu.popup(Mouse.CursorPos.x,Mouse.CursorPos.y);

end;


procedure TForm1.MenuDescribeClick(Sender: TObject);
begin

  if (thepanel<>d) then begin
    file_show;  //files.pas.
    exit;
  end else if cum_clk then
  exit;

  if
  (thetree.selected=0) and
  (thetree.rootwarning) and
  (not usuref('Describing the root could take a while; go ahead?'))
  then begin
//?    form1setfocus;
// so I fixed this one by sticking form1setfocus into os_modalend.
// and it worked at least once.
    exit;
  end;

  progress(100);    //does stopness.

  dir_describe(thetree.selectedPath,thetree.selected=0);

  progress(0);

  form1setfocus;  //I think sometimes it gets lost.

end;


{****************************************************************************
****************************************************************************}

procedure TForm1.FilesView1ColumnResized(Sender: TObject;
  Column: TListColumn);
const
here : boolean = false;
begin
  if here or (notinited<>0) then
  exit;

  here := true;
  {copyFwidths and what not might set this thing off or at least it should...}

  fixfilewidths(thisfv);
  copyFwidths(thisfv,elsefv);

  set_tricky;

  with (sender as TListview) do begin
    if (tag=1) and (thepanel<>f1) then
    selectpanel(F1)
    else
    if (tag=2) and (thepanel<>f2) then
    selectpanel(f2)
    else
    plzrefocus_panel;
  end;

  fixthis;

  here := false;

end;

procedure TForm1.FilesView1ColumnDragged(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
  plzrefocus_panel;
end;

procedure Tform1.update_yield;
begin
  delphi_yield;
  update;
end;

procedure TForm1.clickscan(fv:Tfv);
var
old_p : whichpanel;
begin
  old_p := thepanel;
  selectpanel(fv.which);
  if Goptions.clickscan and (old_p = fv.which) then
  filerescan(fv);
  {don't rescan if user's just trying to select.}
end;

procedure TForm1.FilesLabel1Click(Sender: TObject);
begin
  if (notinited<>0) then
  exit;

  clickscan(fv1);
end;

{****************************************************************************
Mon 8/08/2005 2:09 pm. This assumes you are already in the files panel, and
*shouldn't* be called unless. Its used by directory creation/written time, and
numeric atts. I.e., to re-do the files display.
****************************************************************************}
procedure TForm1.filerescanboth;
begin
//u can't save/restore topitem. This way jumps around a bit but hey....
  selectpanel(elsefv.which,true,false);
  filerescan;
  selectpanel(elsefv.which,true,false);
  filerescan;
end;


procedure TForm1.filerescan(fv:Tfv=nil; scanall:boolean = true);
begin
  if fv=nil then
  fv := thisfv;
  treeoid(fv.file_tree);
  scanfiles(nil,
//  true,
//shouldn't be true? Supposed to honor scanmax?
//idea is if we rescan, then presumably we want to override scanmax.
  scanall,  //so make it caller's responsibility.
  fv,fv.status.caption,Goptions.casesort);

  set_tricky;
  plzrefocus_panel;
end;

procedure TForm1.FilesLabel1DblClick(Sender: TObject);
begin
  if (notinited<>0) or (not Goptions.clickscan) then
  filerescan(fv1);
{  scanfiles(nil,true,fv1,fv1.status.caption,Goptions.casesort);
  plzrefocus_panel;  }
end;

procedure TForm1.FilesLabel2Click(Sender: TObject);
begin
  clickscan(fv2);
end;

procedure TForm1.FilesLabel2DblClick(Sender: TObject);
begin
  if (notinited<>0) or (not Goptions.clickscan) then
  filerescan(fv2);
{  scanfiles(nil,true,fv2,fv2.status.caption,Goptions.casesort);
  plzrefocus_panel; }
end;

{****************************************************************************
****************************************************************************}
const
ssec = 'os positions';

function TForm1.killdontscan(section:string):boolean;
var
dont_name : string;
begin
  result := false;

  dont_name := dir_inize(section+'.dontsize');

  if FileExists_unq(dont_name) then begin
    DeleteFile(dont_name);
    result := true;
  end;

end;

function Tform1.getposition(fname : string = ''):
boolean;
var
IniFile: Tinifile;
version:string;
dontget:boolean;      //set if different version.
LayoutPref:boolean;
{****************************************************************************
if it's a layout preference, just do main form. Below, layoutpref := fname<>''
that is, if getposition is called with a name, it's a layoutpref, otherwise we
do the default owenshow positions.
****************************************************************************}

  procedure columnfix(column:integer; ininame:string);
  begin
    fv1.view.columns[column].width :=
    IniFile.ReadInteger(ssec,ininame,
    fv1.view.columns[column].width);
  end;

  procedure dosizes(form:Tform; const section:string);
  var
  top:integer;
  begin

    top := IniFile.ReadInteger(section,'top',-200);

//    if top=-200 then
//    exit;

    if (top=-200)
    or killdontscan(section)
    or dontget then
    exit;

//DON'T set it to podesigned if no stuff.

    form.position := poDesigned;
    form.top :=    top
{$ifdef LINUX}
    -Goptions.kylixtop
{$endif}
    ; //IniFile.ReadInteger(section,'top',form.top);
    form.left :=   IniFile.ReadInteger(section,'left',form.left)
{$ifdef LINUX}
    -Goptions.kylixleft
{$endif}
    ;

    form.width :=  IniFile.ReadInteger(section,'width',form.width);
    form.height := IniFile.ReadInteger(section,'height',form.height);

    if section='exec' then begin
      execform.execBox.columns[0].width :=
      IniFile.ReadInteger(section,'exec_name',
      execform.execBox.columns[0].width);

      execform.execBox.columns[1].width :=
      IniFile.ReadInteger(section,'exec_exec',
      execform.execBox.columns[1].width);

    end;

  end;

begin
  dontget := false;
  LayoutPref := fname <> '';

  if not LayoutPref then
  fname := Goptions.ossize;

  datadirize(fname);    //missing until Monday, October 15, 2007 6:15 pm.

  result := FileExists_unq(fname);

//  if not result then
//  helpdialog.position := poMainFormCenter;
  {so the *first* time, it'll goto the center; subsequently, as saved/
  restored.}

  try

    IniFile := Tinifile.Create(fname);

    Positionrecalled.checked :=
    IniFile.ReadBool(ssec,precall_name,true);

    if (not LayoutPref) then begin
      version := IniFile.ReadString(ssec,'version','');
      dontget := version <> sTLA;

{$ifdef SCREENCHECK}
      if (IniFile.ReadInteger(ssec,'ScreenWidth',-1)<>Screen.width)
      or (IniFile.ReadInteger(ssec,'ScreenHeight',-1)<>Screen.Height)
      then
      dontget := true;
{$endif}


    end;

    if (not dontget) or (Goptions.getsizes_anyway) then begin

      BottomPanel.height :=
      IniFile.ReadInteger(ssec,'BottomPanelHeight',BottomPanel.height);

      FilesPanel.width :=
      IniFile.ReadInteger(ssec,'FilesPanelWidth',FilesPanel.width);

      DirPanel.width :=
      IniFile.ReadInteger(ssec,'DirPanelWidth',DirPanel.width);

      width :=
      IniFile.ReadInteger(ssec,'width',width);

      height :=
      IniFile.ReadInteger(ssec,'height',height);

      if
//      (not Layoutpref)
//      or
      (Positionrecalled.checked) then begin

        left :=
        IniFile.ReadInteger(ssec,'left',left);

        top :=
        IniFile.ReadInteger(ssec,'top',top);
{$ifdef LINUX}
        got_left := left;
        got_top := top;
{$endif}

      end;

      filestart :=
      IniFile.ReadBool(ssec,'filestart',false);

      PanelDriveSplit.width :=
      IniFile.ReadInteger(ssec,'PanelDriveSplit',PanelDriveSplit.width);

      PageControl1.width :=
      IniFile.ReadInteger(ssec,'PageControl',PageControl1.width);

      columnfix(namecolumn,'namewidth');
      columnfix(sizecolumn,'sizewidth');
      columnfix(timecolumn,'timewidth');
      columnfix(attscolumn,'attswidth');

  {****************************************************************************
  Mon 6/28/2004 4:56 pm. So no matter how idiotic-looking, this *does* make a
  difference -- setting the size of the panel with align==client doesn't work,
  which happens to be the top panel. Note also that when we *read* the
  positions, we know which panel is which, but when we *write* them below, we
  don't -- so we write the bottom panel height. Writing the height doesn't make
  no difference regarding magical align properties of course.
  Wednesday, August 4, 2004 1:42 pm. Let's do both.
  ****************************************************************************}

      if LayoutPref then begin

        topfv.panel.height :=
        IniFile.ReadInteger(ssec,'file1height',topfv.panel.height);

        bottomfv.panel.height :=
        IniFile.ReadInteger(ssec,'file2height',bottomfv.panel.height);


      end else begin

        FilesPanel1.height :=
        IniFile.ReadInteger(ssec,'file1height',FilesPanel1.height);

        FilesPanel2.height :=
        IniFile.ReadInteger(ssec,'file2height',FilesPanel2.height);

      end;

      Goptions.dir_leftselect :=
      IniFile.ReadBool(ssec,'dir_leftselect',Goptions.dir_leftselect);

{$ifdef MSWINDOWS}
//Goptions.dir_creationtime
      Goptions.dir_creationtime :=
      IniFile.ReadBool(ssec,'dir_creationtime',Goptions.dir_creationtime);
{$endif}
{$ifdef LINUX}
//Goptions.numeric_atts
      Goptions.numeric_atts :=
      IniFile.ReadBool(ssec,'numeric_atts',Goptions.numeric_atts);
{$endif}

      Goptions.short_size :=
      IniFile.ReadBool(ssec,'short_size',Goptions.short_size);

    end;

{****************************************************************************
oh let's do all the little forms.... Note that versioning mechanism is
jiggered so we still delete a dontscan file even if version is different and
we're not reading *any* sizes.
****************************************************************************}

    if not LayoutPref then begin

      dosizes(chit,'chit');
      dosizes(cpmvdel,'cpyfile');
      dosizes(clipform,'clip');
      dosizes(execform,'exec');
      dosizes(execprompt,'execprompt');
      dosizes(fasttreef,'fasttree');
      dosizes(ffontfun,'fontfun');
      dosizes(fosinfo,'info');
      dosizes(fresize,'resize');
      dosizes(scanform,'scan');
      dosizes(fBigVisit,'visited');
      dosizes(fClips,'clips');

    end;

  except
{    on e: exception do
    errorf('Inifile complaint: %s',[e.message]);  }
    on exception do
    result := false;
  end;

  freeAndNil(IniFile);

end;

procedure Tform1.putposition(fname : string = '');
var
IniFile: Tinifile;
LayoutPref : boolean;

  procedure columnfix(column:integer; ininame:string);
  begin
    IniFile.WriteInteger(ssec,ininame,fv1.view.columns[column].width);
  end;

  procedure dosizes(form:Tform; const section:string);
  begin
    IniFile.writeInteger(section,'top',form.top);
    IniFile.writeInteger(section,'left',form.left);

    IniFile.writeInteger(section,'width',form.width);
    IniFile.writeInteger(section,'height',form.height);

    if section='exec' then begin
      IniFile.writeInteger(section,'exec_name',
      execform.execBox.columns[0].width);

      IniFile.writeInteger(section,'exec_exec',
      execform.execBox.columns[1].width);

    end;

  end;

begin
  LayoutPref := fname<>'';



  if not LayoutPref then
  fname := Goptions.ossize;

  datadirize(fname);
  //missing until Monday, October 15, 2007 6:08 pm! Gasp....

  try
    IniFile := Tinifile.Create(fname);

    IniFile.WriteString(ssec,'version',sTLA);

{$ifdef SCREENCHECK}
    IniFile.WriteInteger(ssec,'ScreenWidth',Screen.width);
    IniFile.WriteInteger(ssec,'ScreenHeight',Screen.Height);
{$endif}

    IniFile.WriteInteger(ssec,'BottomPanelHeight',BottomPanel.height);

    IniFile.WriteInteger(ssec,'FilesPanelWidth',FilesPanel.width);

    IniFile.WriteInteger(ssec,'DirPanelWidth',DirPanel.width);

    IniFile.WriteInteger(ssec,'width',width);

    IniFile.WriteInteger(ssec,'height',height);

    IniFile.WriteInteger(ssec,'left',left);

    IniFile.WriteInteger(ssec,'top',top);

    IniFile.WriteInteger(ssec,'PanelDriveSplit',PanelDriveSplit.width);
    IniFile.WriteInteger(ssec,'PageControl',PageControl1.width);

    IniFile.WriteBool(ssec,'filestart',thepanel<>d);

    columnfix(namecolumn,'namewidth');
    columnfix(sizecolumn,'sizewidth');
    columnfix(timecolumn,'timewidth');
    columnfix(attscolumn,'attswidth');

    IniFile.WriteInteger(ssec,'file1height',topfv.panel.height);
    IniFile.WriteInteger(ssec,'file2height',bottomfv.panel.height);

    IniFile.WriteBool(ssec,'dir_leftselect',Goptions.dir_leftselect);

{$ifdef MSWINDOWS}
//Goptions.dir_creationtime
    IniFile.WriteBool(ssec,'dir_creationtime',Goptions.dir_creationtime);
{$endif}

{$ifdef LINUX}
//Goptions.numeric_atts
    IniFile.WriteBool(ssec,'numeric_atts',Goptions.numeric_atts);
{$endif}

    IniFile.WriteBool(ssec,'short_size',Goptions.short_size);

    IniFile.WriteBool(ssec,precall_name,Positionrecalled.checked);

    if not LayoutPref then begin
      dosizes(chit,'chit');
      dosizes(cpmvdel,'cpyfile');
      dosizes(clipform,'clip');
      dosizes(execform,'exec');
      dosizes(execprompt,'execprompt');
      dosizes(fasttreef,'fasttree');
      dosizes(ffontfun,'fontfun');
      dosizes(fosinfo,'info');
      dosizes(fresize,'resize');
      dosizes(scanform,'scan');
      dosizes(fBigVisit,'visited');
      dosizes(fClips,'clips');
    end;

    IniFile.UpdateFile;
    {Mon 12/15/03 7:01 pm. maybe restart'll restart in the right place hmmm.?}

  except
{    on e: exception do
    errorf('Inifile complaint: %s',[e.message]);  }
    on exception do;
  end;

  freeAndNil(IniFile);


end;




{****************************************************************************
****************************************************************************}
{$ifdef LINUX}
const
LINUXROOM = 20 {4 {22};
{$endif}

procedure TForm1.fixfilewidths(fv:Tfv);
begin
  original_FilesPanelWidth := FilesPanel.width;
  {it's NOT fv.view.width; at least that's not what we compare it with
  in resizename.}
  original_namewidth :=  fv.view.columns[NameColumn].width;
end;

procedure TForm1.copyFwidths(src,dst:Tfv; ccap:boolean = false);
var
i:integer;
begin
  for i := 0 to 4 do begin

    dst.view.columns[i].width :=     src.view.columns[i].width;
    dst.view.columns[i].MaxWidth :=  src.view.columns[i].maxwidth;
    dst.view.columns[i].MinWidth :=  src.view.columns[i].minwidth;
//    dst.view.columns[i].alignment := src.view.Columns[i].Alignment;
    if ccap then
    dst.view.columns[i].caption :=   src.view.Columns[i].caption;
    dst.view.columns[i].allowresize:=src.view.Columns[i].allowresize;
    dst.view.columns[i].allowclick :=src.view.Columns[i].allowclick;

  end;
end;

{****************************************************************************
Wednesday, September 4, 2002 7:23 pm

This makes the name column stretch-out when the panel is stretched-out.
This is normally what I want, but
1. Doesn't notice if the name column has been resized by itself
2. Doesn't of course make a distinction between file views, even 'though
one might've been sized differently than the other. // we've fixed that by
forcing them to always be the same.

//Wed 3/24/04 5:39 pm oh it's ok...
****************************************************************************}

procedure Tform1.resizename;
var
newwidth: integer;
begin
  if notinited>0 then
  exit;

  newwidth :=
  (FilesPanel.width-Original_FilesPanelWidth)
  +original_namewidth;

  if newwidth >30 then begin
    fv1.view.columns[NameColumn].width := newwidth;
    fv2.view.columns[NameColumn].width := newwidth;
  end;

end;



{****************************************************************************
****************************************************************************}
{****************************************************************************
well this has apparently worked a few times, so I guess I should document
it....

showcut means *add* the depiction of the shortcut key to the caption.

xshortcut means use the normal Delphi short cut mechanism to specify the
shortcut key; trouble-is, it doesn't work a lot.

Both these parameters default to true.

Thu 8/11/2005 3:39 pm. globalized.
****************************************************************************}

procedure fixmenu(t:TMenuItem; key:Tos_key;
showcut:boolean = true; xshortcut:boolean=true);
begin
  if t.shortcut<>0
  then exit;

  if key.key<>0 then begin
    if xshortcut then
    t.ShortCut := ShortCut(key.key, key.shift);
    {some of the menu items will actually *cause trouble* if they
    get a short cut key they don't like or something.}

  {oh I see some of these stupid menuitems automatically show the shortcut
  and some don't. Of course each like a snow flake.... // Fri 11/29/02 1:40 pm
  do the caption anyway I guess.}
    if showcut then begin
      if Goptions.short_menu then
      t.caption := safe_format('%s %s',[t.caption,LowerCase(key.show)])
      else
      t.caption := safe_format('%s (%s)',[t.caption,key.show])
    end;

  end;
end;

{$define SHORT_LONG}
{Fri 2/13/2009 12:46 pm. Make captions a little shorter with del, ren for
delete rename, even in long version.}

procedure Tform1.fixmainmenu;
//do the caption, and return short to empty state.
  procedure m_oid(t:TMenuItem; short, long:string; key:Tos_key);
  begin
    t.shortcut := 0;  //erase old shortcuts.
    if Goptions.short_menu then
    t.caption := short
    else
    t.caption := long;

    fixmenu(t,key);

  end;
begin
{Fri 2/13/2009 12:46 pm. these are NOT in order}
  m_oid(MenuCopy     , 'cpy',   'copy'    , Goptions.copy     );
  m_oid(MenuCreate   , 'make',  'create'  , Goptions.create   );
  m_oid(MenuMove     , 'mv',    'move'    , Goptions.move     );

{$ifdef SHORT_LONG}
  m_oid(MenuDelete   , 'del',   'del'     , Goptions.delete   );
  m_oid(MenuRename   , 'ren',   'ren'     , Goptions.rename   );
{$else}
  m_oid(MenuDelete   , 'del',   'delete'  , Goptions.delete   );
  m_oid(MenuRename   , 'ren',   'rename'  , Goptions.rename   );
{$endif}

  m_oid(MenuScan     , 'scan',  'scan'    , Goptions.scan     );
  m_oid(MenuDescribe , 'desc',  'describe', Goptions.describe );
  m_oid(MenuExec     , 'x',     'exec'    , Goptions.execform );
  m_oid(menuEtc      , 'etc',   'etc'     , Goptions.etc      );
  m_oid(Mark         , 'mrk',   'mark'    , Goptions.mark     );
  m_oid(MenuHelp     , 'hlp',   'help'    , Goptions.help     );

{$ifdef nuthing__}
  fixmenu(menuCopy,Goptions.copy          {,true,true}  );
  fixmenu(menudelete,Goptions.delete      {,true,true}  );
  fixmenu(menucreate,Goptions.create      {,true,true}  );
  fixmenu(menumove,Goptions.move          {,true,true}  );
  fixmenu(menuRename,Goptions.rename      {,true,true}  );
  fixmenu(menuScan,Goptions.scan          {,true,true}  );
  fixmenu(menuDescribe,Goptions.describe  {,true,true}  );
  fixmenu(menuexec,Goptions.execform      {,true,true}  );
  fixmenu(menuEtc,Goptions.etc            {,true,true}  );
  fixmenu(mark,Goptions.mark              {,true,true}  );
  fixmenu(menuHelp,Goptions.help          {,true,true}  );
{$endif}

end;

procedure TForm1.xinit;
var
i : integer;
s : string;

const
initedalready : boolean = false;


{This does it! I was trying to crush them *just at the top level* foolish
child....}
  procedure crushtabs(c:TwidgetControl);
  var
  i:integer;
  begin
    for i := 0 to c.Controlcount-1 do begin
      if c.controls[i] is TwidgetControl then
      with (c.controls[i] as TwidgetControl) do begin
        tabstop := false;
        crushtabs(c.controls[i] as TwidgetControl);
        {recurse like wild thing.}
      end;

    end;

  end;

begin

{  visible := true; } {this is pointless. Apparently one of the many
things CLX won't honor is visible=false on mainform.}
  if initedalready then
  exit;

  initedalready := true;

  visible := false;
  {stop it jumping around, even if no splash. Ugly, and takes time.}

{  chdir('e:\gregor');   {test}
{testing /c code for windows.}

  label_debug2.caption := '';

{getoptions was done in formcreate, but it's just too annoying there. The
last straw was GPF when "os /?" because the informative prompt used osinfo
-- which it really should, since that clips. So to heck with it. }
  getoptions;

  EditOSinitfile.visible := Goptions.edit_ini <> nil;

  init_help;  //weirdo.pas.

{$ifdef LINUX}
  SplitterFiles.height := 8;
{****************************************************************************
because it likes it; if I don't, then resizing file panel resizes the stupid
misc panel instead of the files.
****************************************************************************}

{  try 'n' kill LD_LIBRARY_PATH somehow in our environment at least. So it
won't drive things we spawn nuts? }
  gRE_EXEC_LD_LIBRARY_PATH := getenvironmentVariable('LD_LIBRARY_PATH');
  {oh but save it first please!}
  putenv(pchar('LD_LIBRARY_PATH')); // this actually worked first try.
{$endif}

{$ifdef LINUX}
  if Goptions.dontfix_kylix_positions then begin
    Goptions.kylixleft := 0;
    Goptions.kylixtop := 0;
  end else
  fixcount := Goptions.kylixcount;
{$endif}

{can't do this in form create}
  if pleaseclose or Gexitnow then begin
    close;
    exit;
  end;

  cursoid(crhourglass); // see comment below at second cursoid.

  if length(Goptions.os_instructions)>0 then
  DeleteFile(Goptions.os_instructions);
  {throw away lingering macro-like instructions.}

  cpyf_destinations := TStringList.Create;


  purge_the_path;

{fix the (*&(*&(& other tab stops}
  crushtabs(form1);

  DirPanel.taborder := 0;
  DirPanel.tabstop := true;

  FilesPanel1.TabOrder := 1;
  FilesPanel1.tabstop := true;

  FilesPanel2.TabOrder := 2;
  FilesPanel2.TabStop := true;

  dirimage.canvas.font.assign(FilesView1.font);
  {just copy it I guess.// u idjit. I was ":=" copying it.}

  {create my display gadget.}
  jgodisplay := Tjgodis.create(DirImage,dirHScroll);

  {*now* I have to assign the pix in the trees.}
  for i := 0 to Goptions.trees.count-1 do
  with (Goptions.trees.objects[i] as Ttree) do begin
    pix := jgodisplay;
    vscroll := DirVscroll;
    onselectchange := AfterDirSelectChange;
  end;

{****************************************************************************
the MainMenu1 items; through careful test and random catastrophes I have
concluded it is unwise to add any but top-level menu items to the main menu. I
really can't remember how many twists I've gone through, but it just seems
happier that way.... Evil symptoms mostly involved non-working shortcuts.
Whatever. // It seems to the topleve *can* deal with @F1. But the lower levels
can't. Or on odd-numbered Tuesdays.
****************************************************************************}
{                                          show   set }
{$ifdef Nuthing}

  fixmenu(menuCopy,Goptions.copy          {,true,true}  );
  fixmenu(menudelete,Goptions.delete      {,true,true}  );
  fixmenu(menucreate,Goptions.create      {,true,true}  );
  fixmenu(menumove,Goptions.move          {,true,true}  );
  fixmenu(menuRename,Goptions.rename      {,true,true}  );
  fixmenu(menuScan,Goptions.scan          {,true,true}  );
  fixmenu(menuDescribe,Goptions.describe  {,true,true}  );
//  fixmenu(menuexec,Goptions.exec           ,true,false  );
    {needs to be seen by code for special treatment. // stupid}
  fixmenu(menuexec,Goptions.execform      {,true,true}  );

  fixmenu(menuEtc,Goptions.etc            {,true,true}  );
  fixmenu(mark,Goptions.mark              {,true,true}  );
  fixmenu(menuHelp,Goptions.help          {,true,true}  );

{$endif}
{****************************************************************************
****************************************************************************}

  fixmenu(menumark,Goptions.markon,true,false);
  fixmenu(menuunmark,Goptions.markoff,true,false);

  fixmenu(markall,Goptions.markall,false);
  fixmenu(unmarkall,Goptions.unmarkall,false);
  fixmenu(markstars,Goptions.markstars,false);
  fixmenu(unmarkstars,Goptions.unmarkstars,false);
  fixmenu(markbottom,Goptions.markbottom,false);
  fixmenu(marktop,Goptions.marktop,false);

  fixmenu(Files_0,Goptions.file_rescan,false);

{****************************************************************************
the etc menu.
****************************************************************************}
  if Goptions.local_trees then begin
    emenuFixTree.caption := 'Fix tree/files to local';
  //'Show &files for restorable trees';
  end;

  fixmenu(emenutree,Goptions.treeKey,                       true,false);
  fixmenu(emenuFixTree,Goptions.fixfiles,                   true,false);

  fixmenu(VisitedDirectories,Goptions.bigvisit,             true,false);
  fixmenu(savemainlayoutpreference,Goptions.recall_save_layout      ,true,false);
  fixmenu(restoremainlayoutpreference,Goptions.recall_main_layout,true,false);
  fixmenu(osedir,Goptions.edir_key                         ,true,false);
  fixmenu(clips,Goptions.clips_key                         ,true,false);
  clips.visible := Goptions.clips.count > 0;


  fixmenu(unsortfiles1,Goptions.sortNot                   ,true,false);

{$ifdef LINUX}
  fixmenu(Numericatts,Goptions.numeric_key                ,true,false);
{$endif}

{****************************************************************************
****************************************************************************}

{  fixmenu(menuEtc,Goptions.etc); }

{$ifdef MSWINDOWS}
  Gthis_windows_filesystem := cw_filesystem;
{$endif}

  fv1 := Tfv.create;
  fv2 := Tfv.create;
  thisfv := fv1;
  elsefv := fv2;
  fixfvcolors;

  drivelist.items := Goptions.trees;
  {I think this just transfer pointers -- but seems to work.}

  if Goptions.whichtreeindex<drivelist.items.count then
  drivelist.itemindex := Goptions.whichtreeindex
  else
  drivelist.itemindex := drivelist.items.count-1;

  thetree := Goptions.trees.objects[drivelist.itemindex] as TTree;

  fv1.view := FilesView1;
  fv1.status := FilesLabel1;
  fv1.panel := FilesPanel1;
  fv1.flipbutton := Flip1;
{  fv1.sort := ext_ascend; }
  fv1.which := f1;
  fv1.checklabel := checked1;

  fv2.view := FilesView2;
  fv2.status := FilesLabel2;
  fv2.panel := FilesPanel2;
  fv2.flipbutton := flip2;
{  fv2.sort := ext_ascend; }
  fv2.which := f2;
  fv2.checklabel := checked2;

  fv2.view.rowselect :=                fv1.view.rowselect;
  fv2.view.Sorted :=                   fv1.view.Sorted;
  fv2.view.ShowColumnSortIndicators := fv1.view.ShowColumnSortIndicators;

  fv2.status.width := fv1.status.width;

  flip2.left := flip1.left;
  flip2.width := flip1.width;
  flip2.top := flip1.top;
  flip2.height := flip1.height;

{$ifdef MSWINDOWS}
  if Goptions.currentdir
  then guesstree(originaldir);
//this just fiddles which tree based on original dir drive.
{$endif}

  if not
  load_n_show(drivelist.itemindex) then begin
    if thetree<>nil then
    s := safe_format('with tree "%s" ',[thetree.name])
    else
    s := '';
    errorf('Sorry; something doesn''t work %s(surprise); bye',
    [s]);
//    Really_Terminate_Now;
    Application.Terminate;
    exit;   {if you don't do this, it just keeps on executing. Kuel eh!?
    of course it turned-out the *caller* kept executing. Hence
    Really_Terminate_now. // but now I think I calmed it down.}
  end;

  if Goptions.currentdir then begin
    thetree.homedir := originaldir;
{the problem with this code here is it *doesn't* select appropriate tree;
hence guesstree, for winders at least.}
    goto_home(true);
  end else

  file_fiddlesort;

{$ifdef LINUX}
  if not getposition then begin {no ossize.ini file}
    fv1.view.columns[namecolumn].width :=
    fv1.view.columns[namecolumn].width -25;
    {we just jigger the Linux version so it looks more-or-less correct
    the first time. That is, I adjust the junk in the IDE screen under
    win32, and then we fix it here for Linux. Fv2 gets copied from
    fv1.}
{$ifdef LINUX}
    fixcount := 0;
{$endif}
  end;
{$endif}

{$ifdef MSWINDOWS}
  getposition;
{$endif}

  layout_checks;

/////////////////////////////////

{*before* reposition! So resizerename'll get it right, after user's
adjustments.}
  fixfilewidths(fv1);   {sets original_width, original_namewidth}

{get stuff from fv1.}
  copyFwidths(fv1,fv2,true);

  jigglemain;
  inited(true);

  resizename;

  formresize(nil);

  fixfunfonts;

//  fixmainmenu;
//  Goptions.short_menu := false;
//  fixmainmenu; //do it in fixfunfonts.

  getvisited;

  showsearchkind;

  visible := true;
  {the form is visible=false in the design -- which doesn't work apparently --
  and set to visible=false at top of .xint -- in a pitiful attempt to
  make the form stop slobbering in public....}

  if Goptions.otherdir
  and DirectoryExists(thetree.otherdir)
  then begin
    enterdirectory;
    scanfiles(thetree,false,elsefv,thetree.otherdir,Goptions.casesort);
  end else begin
    enterdirectory;
    seefiles(true,true);
  end;

  stuffdir(dirstatus.caption,thetree.selected);

  if length(Goptions.TreeKey.show)>0 then
  DriveList.Hint := Goptions.TreeKey.show;
  Drivelist.Hint := Drivelist.Hint + '; right-click for big view';

  capdir_file;

  if Goptions.ontop>0 then begin
    OnTopTimer.interval := Goptions.ontop;
    OnTopTimer.enabled := true;
  end;

  plzFview(true);
  mswait(100);

  if filestart then
  selectpanel(f1)
  else
  selectpanel(d);

//?  form1setfocus;

  application.hinthidepause := Goptions.hintdelay;

  if not Goptions.drivelist then begin
    drivelist.visible := false;
    drivelist.align := alRight;
    PanelDriveSplit.align := alClient;
  end;


  savedialog.initialdir := datadir;

  unsplash;

  cursoid(crDefault);
  {Doing this, and the "cursoid(crHourglass)" above, aside from annoying the
  user about OS starting, seemed to cure numerous odd-cursor symptoms: all I
  think odd splitter cursor, appearing in the main menu and other wrong
  places. It also does something like when inactive -- since the program seems
  to "forget" now and then.}

  checklog_toobig;    //log.

  if plz_restore_layout then begin    // -r
    restoremainlayoutpreferenceClick(nil);
  end;

  os_off := false;

  if Goptions.startup is Texec then begin
    execform.execute(Goptions.startup);
    freeandnil(Goptions.startup); //off the thing what the heck.
  end;

  rethinkey;

//  dbg('hey babe:xinit test message');

end;

procedure Tform1.savehome;
begin
  if notinited>0 then
  exit;

  thetree.savehomedir(elsefv.status.caption) ;
  {we save anyways. But we only use it if alwayshome.}

end;

{****************************************************************************
****************************************************************************}
procedure Tform1.save_local;
begin
  if (thetree is Ttree)
  and thetree.local then
  lastlocal := thetree;
end;

{****************************************************************************
****************************************************************************}
procedure TForm1.MenuTreeClick(Sender: TObject);
begin
  if (notinited<>0) then
  exit;

  CpyDstOff(true);
  with fasttreef do begin
    showmodal;
    if selected>=0 then begin
      Drivelist.itemindex := selected;
      DrivelistDblClick(nil);
    end
    else
    showindrivelist;
    if key_error then
    visual_complaint; // do something for pressing wrong key...

  end;
//?  form1setfocus;
end;

procedure TForm1.DriveListContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
var
index:integer;
begin
  handled := true;

  if (notinited<>0)
  or os_off
  then
  exit;

  index := DriveList.itemAtPos(MousePos,true);

  if index<0 then
  index := DriveList.itemindex;

  DriveList.itemindex := index;

  MenuTreeClick(nil);
end;

{****************************************************************************
****************************************************************************}

procedure Tform1.inited(clear:boolean = false);
begin
  if clear then
  notinited := 0;

  if notinited>0 then
  dec(notinited);
end;


procedure TForm1.FilesPanelResize(Sender: TObject);
begin
  resizename;
end;


procedure TForm1.FormResize(Sender: TObject);
begin
  if notinited<>0 then begin
    exit;
  end;

  throttle(false);

  if (notinited=0) and (DirImage.picture.bitmap <> nil)
  then begin
    DirImage.picture.bitmap.width := DirPanel.width;
    DirImage.picture.bitmap.height := DirPanel.height;
    thetree.resize;
  end;

end;

{****************************************************************************
remove directories that in visiteddirs whose *beginning* matches dir
argument. I.e. so all the subdirs of specified dir are removed.
****************************************************************************}
procedure purge_directory(dir:string);
var
dirlength, i:integer;
stupid:string;
begin
  with form1 do begin

{$ifdef MSWINDOWS}
    dir := fredrive(dir,thetree.drive[1]);
{$endif}

    dirlength := length(dir);

    for i := VisitedDirs.items.count-1 downto 0 do begin
      stupid := copy(
//      visiteddirs.items[i]
      visited_dir(i)
      ,1,dirlength);
      if
{$ifdef MSWINDOWS}
      CompareText
{$endif}
{$ifdef LINUX}
      CompareStr
{$endif}
      (stupid,dir)=0 then
      keepVisitedDirsdelete(i);
    end;

  end;
end;



procedure TForm1.PurgeDirs_FilePanels;
var
i:integer;

  procedure purge_f(fv:Tfv);
  begin
    if
    (fv.file_tree=thetree) and
    (not DirectoryExists(fv.status.caption)) then begin
      scanfiles(thetree,false,fv,dirstatus.caption,Goptions.casesort);
    end;

  end;

begin

  for i := VisitedDirs.items.count-1 downto 0 do begin
    if
    ((visiteddirs.items.objects[i] as Tvisited).tree=thetree)
    and (not DirectoryExists(
//    visiteddirs.items[i]
    visited_dir(i)
    ))
    then
    keepVisiteddirsdelete(i);
  end;

  purge_f(fv1);
  purge_f(fv2);
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.DirVScrollScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  selectpanel(d);

  if thetree.fixingscroll then
  exit;
  case ScrollCode of
    scLineUp: thetree.scroll(-1);
    scLineDown: thetree.scroll(1);
    scPageUp: thetree.scroll(dirpage*-1);
    scPageDown: thetree.scroll(dirpage*+1);
//    scTrack, scPosition: thetree.scroll(scrollPos-thetree.selected);
    {my guess is scTrack doesn't actually work. Oh I take it back, you
    just have to move it slowly-enough.

    Thu 10/16/03 11:28 am. BAD DIR SCROLL LOGIC. See, I thought I was
    scrolling select -- but no, I'm supposed to be scrolling the top of the
    dir presentation there, although select gets adjusted so it appears within
    the dir window. I went through the most amazing convulsions to make the
    files window behave like my directory window -- but files actually works
    correctly, because I don't control the vertical scroll in that gadget!

    Anyway ...

      * Added Ttree.scrollto.

      * Made Ttree.fixscroll public.

      * Added fixscroll call to load_n_show.

      * Removed DirVScroll.max assignment from load_n_show. (So it was
      actually getting assigned in two places.)

      * Added private Ttree.ifscroll -- which calculates vscroll.max
      correctly, and now will make the vertical scroll invisible if it isn't
      needed. // well perhaps not. I'll do that in visible_dir_scroll q.v.

      * Removed vscroll.max assignment from fixscroll.

      * Added fixscroll call to Ttree.resize.

      * And made the xinfo stuff disappear if the screen's too small!

    I think that's it....

      * Tue 10/21/03 4:47 pm. Until I noticed I was occasionally
      DirVScroll.setfocusing; hence DirVscrollsetfocus, q.v.

    }

    scTrack, scPosition: thetree.scrollto(scrollPos);

  end;



  DirImage.update; {that improves things.}

end;

procedure TForm1.dirHscrollScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  selectpanel(d);

  if thetree.fixingscroll then
  exit;

  thetree.skip(ScrollPos);
end;

procedure TForm1.ScanTimingsClick(Sender: TObject);
begin
  infotalk;
//?  form1setfocus;
end;

{I keep getting "cannot focus diabled form; form1" errors. So....}
procedure Tform1.form1setfocus;
begin
{  mswait(300); }

  visible := true;
  os_enabled := true;  {to avoid "can't focus disabled form" errors. I don't care
                    why they happen.}
  statmemoid;

  if {modaling or} issplashing then
  exit;

  setfocus;

end;

procedure TForm1.xosidle;
var
dummy : boolean;
begin
  os_idle(nil,dummy);
end;

procedure TForm1.LinuxTimerTimer(Sender: TObject);
begin
  xosidle;
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.restore_tree;
var
i:integer;
begin
  if (not Goptions.local_trees)
  or thetree.local then
  exit;

//there're local_trees, but this isn't one. Get the first restoreable tree.
  if (lastlocal is Ttree) then begin
    load_n_show(lastlocal.index);
    exit;
  end;

  for i := 0 to Goptions.trees.count-1 do begin
    if (Goptions.trees.objects[i] as Ttree).local then begin
      load_n_show(i);
      exit;
    end;
  end;

end;

{****************************************************************************
make sure all files either correspond to the tree, or a restoreable tree.
****************************************************************************}
procedure Tform1.detree;
var
oldpanel : whichpanel;

  procedure dt(fv:Tfv);
  begin

    if fv.file_tree.local       //if it's local files.
    or (fv.file_tree=thetree)   //or is the current tree.
    then
    exit;

    //so see more files already....
    file_fiddlesort(fv);
    seedirfiles(fv);

  end;

begin
  oldpanel := thepanel;

  restore_tree;   //make tree local or something.

  dt(fv1);
  dt(fv2);

  selectpanel(oldpanel,true);

{Friday, January 2, 2004 4:11 pm. Should remove objectionable tree from
visited list too. Except for keeps?}
//  for i := VisitedDirs.items.count-1 downto 0 do begin
//    if Tvisited(VisitedDirs.items.objects[i]).tree <> thetree then
//    keepVisitedDirsdelete(i);
//  end;
//why? He can delete them if he wants....

end;

procedure TForm1.menuFixTreeClick(Sender: TObject);
begin
  detree;
end;

{****************************************************************************
****************************************************************************}

{function InputQuery(const ACaption, APrompt: string; var Value: string):
Boolean;}
procedure TForm1.menuCreateFileClick(Sender: TObject);
var
dir,
s:string;
h:integer;
begin
  s := 'new~';
  dir := thisfv.status.caption;
  if inputQuery(
  'Create file',
  safe_format('Create file in %s?',[dir]),
  s
  ) then begin

    if badfilename(s,true) then
    exit;

    try
      chdir(dir);

      if FileExists_unq(s) then begin
        errorf('%s exists',[s]);
        exit;
      end;

      h := StupidNewFile(s,true);
      if h>=0 then begin
        FileClose(h);

        file_oldnew_begin;
        file_oldnew('',ExpandFileName(s));
        file_oldnew_finish;

        files_find_select(s,0,search_EXACT);
        set_tricky;
      end else
      errorf('Couldn''t create "%s"',[s]);

    except on
      e: exception do begin
        errorf('Exception creating "%s"; error: %s',
        [s,e.Message]);
      end;
    end;
  end;

end;

procedure TForm1.OnTopTimerTimer(Sender: TObject);
begin
  Application.BringToFront;
//?  form1setfocus;
  OnTopTimer.enabled := false;
end;

procedure TForm1.make_main_bump;
begin
  Gcheck := main_bump;
end;

procedure TForm1.FilesView1DblClick(Sender: TObject);
begin
  if (notinited<>0) or cum_clk or files_dir then
  exit;

  if execform.checkdoubleclick then
  finishexec;

end;

{****************************************************************************
this version does reread OR Gnonmodal_delay.
****************************************************************************}
procedure TForm1.maybereread_globaldelay(reread:integer
; rereadwait:integer
);

begin

  maybe_fix_exec_state;   //doesn't hurt to call it twice?

  if
{$ifdef LINUX}
  (not Gpid_gone)
{$endif}
{$ifdef MSWINDOWS}
  (not exec_failed_aborted)
{$endif}
  then begin
    if
    (thepanel<>d) //shouldn't reread for dir exec!?
    and
    (reread>0)
    and
    (not The_Exec.r.ignore_reread)
    and (
    (reread=1) or
    (reread >= thisfv.filecount)
    )
    then begin

      if rereadwait>0 then
      delay_z(pleaseSFF_ticks,rereadwait)
      else
      pleaseSFF_ticks := dzero;
      pleaseSFF_flag := true;
      FilesM_Stat.caption := 'rr';

    end
    ;
    if Gnon_modaldelay>0 then begin
      Sleep(Gnon_modaldelay);
    end;

  end;

end;

{called after you did one of those exec things.}
procedure TForm1.finishexec;
begin
  emptyMyKeyQueue;

  try

  {    os_activate(nil);  }
      {XP occasionally forgets to get the focus back, apparently with
      16-bit shells on odd-numbered Tuesdays, but I can't figger-out
      how to fake it. }

    if (execform.cancelled or exec_refocus or
    the_exec.r.modal) then begin
//?      form1setfocus;
      plzFview;
    end else if (not the_exec.r.modal) then begin
      plzFview;
  {    mswait(500); {oh why not...}
  {seemed to steal focus back from the executee Mon 3/31/03 1:33 pm. //
  just the opposite Wednesday, April 9, 2003 2:00 pm!}
    end
  {$ifdef LINUX}
    else begin
      Application.restore;
  {      infof('Let''s activate!'); }
  {      caption := 'restoring?';
        osidle(true);
  {      mswait(200);
  {      form1setfocus;
        form1.setfocus;
  {      Application.restore; }
  {      Application.minimize;
        Application.restore;  {of course doesn't actually.}
  {      Application.BringToFront; {let's try this // nope.}
  {      form1.WindowState := wsNormal;
        form1.caption := 'restoring .......';
  {      osidleon;
  {      form1.enabled := false;  }

  {    form1setfocus;  {Linux wanted this.}
  {lotta water under this bridge; see exec:Linux_exec for same thing.}
    end;
  {$endif}
    ;

  except
    on e: exception do
    Errorf('%s finishexec: %s',[OwenShowID,e.message]);
    {on 7/29/03, I double-clicked on a batch file, got a GPF, and then
    @g wouldn't work; only the shadow knows.... // that was on HP760 which
    *has* no doubleclicks defined. Which means it wouldn't've got here
    anyway. So I put one out there at exec checkdoubleclick.}
  end;

  maybe_fix_exec_state; //doesn't hurt to do it twice.

  if not the_exec.r.modal then begin
    os_enabled := false;
    maybereread_globaldelay(reread
    ,rereadwait
    );
  end;

end;

procedure TForm1.MenuEtcClick(Sender: TObject);
begin
  if cum_clk then
  exit;

  PopupMenu_etc.popup(Mouse.CursorPos.x,Mouse.CursorPos.y);
end;

procedure TForm1.Resize1Click(Sender: TObject);
begin
  fresize.showmodal;
//?  form1setfocus;
//  copyFwidths(fv1,fv2);
end;

{****************************************************************************
it checks the keys in the specified menu, and if one of them is s, then
executes the associated routine. I'm not entirely sure why I do this, but I'm
sure it's very useful now and then.... //Because the menus don't do it,
probably; on odd-numbered Tuesdays....
****************************************************************************}

function Tform1.fudgemenu(s:Tshortcut; p:TMenu {TPopupMenu} ):boolean;
var
i:integer;
begin

  for i := 0 to p.items.count-1 do begin
    if (p.items[i].shortcut=s)
    and p.items[i].visible
    then begin
      p.items[i].OnClick(p.items[i]);
      result := true;
      exit;
    end;
  end;

  result := false;

end;



procedure Tform1.xreconstructtree;
begin
  selectpanel(d);
  thetree.delete_aux;
  load_n_show(thetree.option_tree_index);
end;

{****************************************************************************
If cumulative search stubbornly fails, or entering a directory shows the wrong
directory, reconstructing the auxiliary files from the path file might help.
Go ahead?
****************************************************************************}

procedure TForm1.ReconstructtreeClick(Sender: TObject);
begin
  if usuref(


'If cumulative search stubbornly fails, or entering a directory shows the wrong'
+' directory, reconstructing the auxiliary files from the path file might help.'
+' Go ahead?'

  ) then begin
    xreconstructtree;
//?    form1setfocus;
  end;

end;



procedure TForm1.FilesView1Resize(Sender: TObject);
begin
  if (notinited<>0) then
  exit;

//  if (sender=fv1.view) then
//  Ffix(fv2)
//  else
//  Ffix(fv1);
  Ffix(fv1);
  Ffix(fv2);
  set_tricky;
end;

procedure TForm1.FilesView1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
const
oldx : integer = -1;
oldy : integer = -1;
//here : boolean = false;
begin
//  if cum_clk then
//  exit;

//  if here then exit;

//  here := true;

  if
{well it helps. If you wave the mouse around, it'll reselect. Otherwise if
you're in the vicinity it may notice something's not properly selected. If
you're not waving the mouse around you probably don't care anyway.}
  (oldx<>x) or (oldy<>y) then begin
    oldx := x;
    oldy := y;
    set_tricky;
  end;

end;

{****************************************************************************
FormDragDrop is where it comes when a thing is *dropped* on this program.

FilesView1StartDrag is where things get dragged *from* this program.

procedure TForm2.SharedDragOver(Sender, Source: TObject; X, Y: Integer;
State: TDragState; var Accept: Boolean);
var
Formats: TStrings;
begin
  try
    Accept :=
    (Formats.IndexOf('text/plain') <> -1) or
    (Formats.IndexOf('image/bmp') <> -1)
  finally
    Formats.Free
  end;
end;


procedure TForm2.SharedDragDrop(Sender, Source: TObject; X, Y: Integer);
var
MS: TMemoryStream;
begin

  MS := TMemoryStream.Create;

  try

    //Display supported MIME formats in listbox
    ListBox1.Clear;

    SupportedDragFormats(ListBox1.Items);
    if SaveDragDataToStream(MS, 'text/plain') then
    begin
      MS.Position := 0;
      Memo1.Lines.LoadFromStream(MS);
    end;

    //Reset memory stream
    MS.SetSize(0);

    if SaveDragDataToStream(MS, 'image/bmp') then
    begin
      MS.Position := 0;
      Image1.Picture.Bitmap.LoadFromStream(MS);
    end;
  finally
    MS.Free;
  end;
end;

****************************************************************************}

{procedure TForm1.FilesView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source=nil then
  infof('nil')
  else
  infof('%s',[Source.classname]);
end;}

procedure TForm1.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
var
v:Tfv;
MS:TMemoryStream;
{formats,}
alist:TStringList;

const
here : boolean = false;

  {given a list of these uri, make them files names, discarding
  the confused.
  So they look like
   'file:///C%7c/gregor/OwenShow/_a%20space'
    12345678
    but I expect this to change like the wind....
  }

  procedure fileoid(urilist:TStringList);
  var
  index,x :integer;
  s:string;
  const
  {$ifdef MSWINDOWS}
  FILETAG = 'file:///';
  {$endif}
  {$ifdef LINUX}
  FILETAG = 'file:';
  {$endif}
  begin
    index := 0;
    while(index<urilist.count) do begin
      if copy(urilist[index],1,length(FILETAG))<>FILETAG then begin
        urilist.delete(index);
        continue;
      end else begin
        s := copy(urilist[index],length(FILETAG)+1,50000);
        {dump the file tag}
        while true do begin
          x := pos('%',s);
          if x<1 then
          break;

          s :=
          copy(s,1,x-1)+
          chr(HexToInt(copy(s,x+1,2)))+
          copy(s,x+3,50000);

          if s[x]='|' then
          s[x] := ':';  {I only work here}
        end;

{$ifdef MSWINDOWS}
        while true do begin
          x := pos('/',s);
          if x<1 then
          break;

          s[x] := slashchar;
        end;
{$endif}

        urilist[index] := s;

        {ok now we've tidied that up}
        inc(index);

      end;

    end;
  end;

begin

  if here
  or (not (Sender is TListView))
  then
  exit;

  here := true;


{  if (source=nil) then
  infof('nil');   }
  {source apparently is always nil; helpful.... oh oh apparently
  it's nil when it's from some other program! Helpful indicator. Oh I see;
  if it's from *this* program it'll be the object what did the drag i.e. a
  TlistView.
  }

  MS := TMemoryStream.Create;
  alist := TStringList.create;

  try

{    Formats := TStringList.Create;
    SupportedDragFormats(Formats);  }
{I used to to discover only format was test/uri-list. In winders.
}
{//Display supported MIME formats in listbox B. Long's comment. The stuff he
had was totally bogus, but still I wouldn't've gotten this far so whatever. }

    if SaveDragDataToStream(MS, 'text/uri-list' {'text/plain'}) then
    begin
      MS.Position := 0;
      alist.LoadFromStream(MS);
    end;

    fileoid(alist);

    if (sender as TListView)=FilesView1 {.name='FilesView1'} then
    v := fv1
    else
    v := fv2;

    os_enabled := true;
    selectpanel(v.which);

    CopyDroppedFiles(alist,v,source);

  finally
    MS.Free;
    alist.free;
{    formats.free; }
  end;

  unFilesM_stat;

  here := false;

end;



{****************************************************************************
This really should be somewhere else, but the tangled web of dependencies
which the often-useful Delphi scheme requires, makes it impossible.
****************************************************************************}

procedure TForm1.CopyDroppedFiles(alist:TstringList; const dst:Tfv;
const source:Tobject);
var
i:integer;
first,                  {used to select after drop}
s,d:string;
r : ResultAction;
dirwarn,
giveup,
wreckon : boolean;
label
ENDNESS;

  procedure fixchecks;
  var
  srcfv : Tfv;
  begin
    if  (source is TListview)
    and (not last_drag_was_select)
    then begin
      if (source as Tlistview)=fv1.view then
      srcfv := fv1
      else
      srcfv := fv2;
      file_markchecked(srcfv,alist);
    end;

  end;

begin
  if alist.count<1 then
  exit;

{So let's try and have OS grab the focus when you drop files on it. It's this
kind of intense intellectual work that drew me to programming....}

{$ifdef LINUX}
  for i := 1 to 2
  do begin
    Application.bringtofront;
//?    form1setfocus;
    selectpanel(dst.which);
    xosidle;
    mswait(300);
  end;

  thisfv.view.color := selColor;
  mswait(300);
  {look I just work here....}

{$endif}

{$ifdef MSWINDOWS}
//?  form1setfocus;
  Application.bringtofront;
  selectpanel(dst.which);
  xosidle;
{  mswait(300);  }

  thisfv.view.color := selColor;
{  mswait(300); }

{$endif}

  if cantdelete(OSCopyFile) then
  exit;

  file_oldnew_begin;

  wreckon := false;
  giveup := false;

  stopness(howclick);

  first := '';
  dirwarn := false;

  for i := 0 to alist.count-1 do begin

    if (i=0) and (

{$ifdef MSWINDOWS}
    CompareText
{$endif}
{$ifdef LINUX}
    CompareStr
{$endif}
    (extractFilePath(alist[0]),dst.status.caption)=0) then begin
      FilesM_stat.caption := 'drop to same directory; skipped';
      update_yield;

      fixchecks;

      mswait(500);
      goto ENDNESS;
    end;

    s := alist[i];
    d := dst.status.caption + extractFileName(s);

    if DirectoryExists(s) then begin
      if not dirwarn then
      errorf('Can''t drop directories! (%s)',[s]);
      dirwarn := true;
      continue;
    end;

    captionoid('copying %s',[s]);

    update_yield;
    if pleaseabort and usuref('Give up drop copy?') then
    break
    else
    pleaseabort := false;

    if not wreckon then begin

      r := overwriteOK(s,d);

      if r=raABORT then
      break;

      if r=raWRECK then
      wreckon := true
      else if (r<>raOK) and (r<>raNA) then
      continue;     {the for}

    end;

    ProgressBar.position := 0;
    ProgressBar.max := os_fSize(s);

    try
      os_fCopy(s,d);
      file_oldnew('',d);
      if length(first)<1 then
      first := extractFileName(d);
    except
      on e: exception do begin
        errorf('Error copying "%s" to "%s" (%s); giving-up',[s,d,e.message]);
        giveup := true;
      end;
    end;

    if giveup then
    break;

  end;

  ENDNESS:
  stopness(howoff);

  file_oldnew_finish;

  if length(first)>0 then
  files_find_select(first,0,search_EXACT);

//?  form1setfocus;
  selectpanel(dst.which,true);
  Application.bringtofront;
  {... but then again it still takes a little effort, and doesn't
  always work....}

end;

{****************************************************************************
Listing 24: Starting a MIME-based drag operation

procedure TForm1.SharedStartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  MS: TMemoryStream;
begin
  MS := TMemoryStream.Create;
  try
    Memo1.Lines.SaveToStream(MS);
    MS.Position := 0;
    if not AddDragFormat('text/plain', MS) then
      raise Exception.Create('Failed to add text drag format');
    //Reset memory stream so it can be re-used
    MS.SetSize(0);
    Image1.Picture.Bitmap.SaveToStream(MS);
    MS.Position := 0;
    if not AddDragFormat('image/bmp', MS) then
      raise Exception.Create('Failed to add bitmap drag format');
  finally
    MS.Free;
  end;
end;

This, and the unattributed stuff above, is from the estimable Brian Long, who
writes about Delphi Kylix Builder with unusual usefulness at your favorite web
browser (might be www.blong.com, or google him).

****************************************************************************}

{$define FIX_DRAG}
{****************************************************************************
Tue 2/17/2009 3:11 pm. I accidentally dragged something to the desktop!
****************************************************************************}

procedure TForm1.FilesView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
MS: TMemoryStream;
alist : TStringList;
fv : Tfv;
f : Tos_f;
filecount,
i : integer;
label
ENDNESS;
const
here : boolean = false;

  function uri_ize(s:string):string;
  var
  i:integer;
  label
  RELOOP;
  begin
    for i:=1 to length(s) do
    if s[i]=':' then
    s[i]:='|';

    RELOOP:   {that'ull learn them}
    for i := 1 to length(s) do begin
      if s[i]<=' ' then begin
        s :=
        copy(s,1,i-1) +
        safe_format('%%%s',[formathex(ord(s[i]),2)])+
        copy(s,i+1,50000);
        goto RELOOP;
      end;
    end;

    result := s;
  end;

{I thought I could somehow fool the manadatory move into being a copy, but
no.}
  procedure logdraglist(s,n:string);
  begin
    if (length(n)<1) then
    exit;       {sometimes the name is zilch in our wonderful
    OS world.}

    s := s+n;

    draglist.add(s);
{but then again I can do this in here...}
    alist.add(
{$ifdef MSWINDOWS}
    'file:///'+
{$endif}
{$ifdef LINUX}
    'file:'+
{$endif}
    uri_ize(s) );
  end;

begin
  if here then
  exit;

  here := true;

{$ifdef FIX_DRAG}
  if (notinited<>0)
  or (not Application.active)
  or (os_off) //let's try hard....
  then
  goto ENDNESS;
{$endif}

  MS := TMemoryStream.Create;
  alist := TStringList.create;
  draglist := TStringList.create;

  filecount := 0;

  last_drag_was_select := true;

  try
    if fv1.view=sender then
    fv := fv1
    else
    fv := fv2;

    FilesM_stat.caption :=
    'Drag may *DELETE* source files on odd-numbered Tuesdays';
    FilesM_stat.font.color := clRed;

    for i := 0 to fv.filecount-1 do begin
      if file_ismarked( Tos_f(fv.fls.objects[i]) )
      and
      (not isdir( Tos_f(fv.fls.objects[i]) ))
      then begin
        file_check(fv,i);
        logdraglist(fv.status.caption, Tos_f(fv.fls.objects[i]) .name);
        inc(filecount);
      end;

    end;

    if filecount<1 then begin
      f := file_selected(fv);
      if not f.dir then
      logdraglist(fv.status.caption,f.name);
    end else
    last_drag_was_select := false;

    if alist.count<1 then begin
//      draglist.free;
//      draglist := nil;
      FreeAndNil(draglist);
      {the exception was just annoying.}
    end else begin

      alist.SaveToStream(MS);
      MS.Position := 0;

      if not AddDragFormat( 'text/uri-list' {'text/plain'} , MS) then
      raise Exception.Create('Failed to add text drag format');
    end;

  finally
    MS.Free;
    alist.Free;

  end;

  ENDNESS:
  here := false;

end;



{****************************************************************************
****************************************************************************}

procedure TForm1.unFilesM_stat;
begin
  FilesM_stat.caption := '';
  FilesM_stat.font.color := clBlack;
end;

procedure TForm1.PopupMenu_etcPopup(Sender: TObject);
begin
  FindeditExit(nil);
end;

procedure TForm1.DirVScrollsetfocus;
begin
  if DirVScroll.enabled and DirVScroll.visible then
  DirVScroll.setfocus
  else
  dirHscroll.setfocus;

{the point here is we want to set the focus somewhere other than the file
panels, but sometimes dirvscroll is invisible.}

end;



{****************************************************************************
****************************************************************************}
procedure TForm1.restart_osClick(Sender: TObject);
{$ifdef LINUX}
var
s:string;
{$endif}
begin
  chdir(originaldir);

{$ifdef LINUX}
{replace the LD_LIBRARY_PATH we thoughtfully got rid of.}
  if length(gRE_EXEC_LD_LIBRARY_PATH)>0 then begin
{but only if it was actually there.}
    //gRE_EXEC_LD_LIBRARY_PATH //shouldn't assign this. bad luck.
    s := safe_format('LD_LIBRARY_PATH=%s',
    [gRE_EXEC_LD_LIBRARY_PATH]);
//    putenv(pchar(gRE_EXEC_LD_LIBRARY_PATH));
    putenv(pchar(s));
  end;
{$endif}

  replace_oldpath;  //mebbee...

  os_exec(ParamStr(0),Gos_args,false,true);
  close;
end;

procedure TForm1.dir_fix(doitnow:boolean = false);

const
here : boolean = false;

begin
  if (not Goptions.dir_fix) or here then
  exit;

  here := true;

  unkill_key;

  if delay_z(dir_fix_timer)
  or (dir_fix_missed > (thetree.pix.scrLines div 3))
  or doitnow then begin
    if (thetree.pix.show(true)>0) then begin
//      dbg_nolog('dir_fix_missed:%d; scrLines:%d; scrLinesdiv 3: %d',
//      [dir_fix_missed,thetree.pix.scrLines,thetree.pix.scrLines div 3]);
      dir_fix_missed := 0;
      thetree.resize;
      thetree.pix.killshowcount;
      {off the count so we don't keep doing this!}
      Dirimage.Update;

      emptyKeyControls;

    end;
    dont_update_for_a_while(0);
    thetree.pix.show(false);
  end
//  else
//  inc(dir_fix_missed)
  ;

  here := false;

end;

procedure throttle(turnon:boolean);
begin
  if turnon then begin
    delay_z(throttle_time,Goptions.throttle_wait);
    Gthrottling := true;
  end else begin
{    if throttling then
    infof('was throttled');  }
    Gthrottling := false;
    delay_z(throttle_time,1000);
  end;
end;

{****************************************************************************
Tue 12/23/03 11:13 am. A pathetic little bit of automation here. If os_idle
notices the file Goptions.os_instructions existing, it attempts to read
instructions from it, and then destroys it. I'll try to document it in the
help I guess. Although the general idea is keyword [optional args] executes
some OS function, basically the ones I want to do.
****************************************************************************}

function Tform1.os_instructions:boolean;
var
h : integer;
s : string;
plzrestart,
plzclose : boolean;

label
ENDNESS;

begin
  result := false;

  if (length(Goptions.os_instructions)<1) or
  (not FileExists_unq(Goptions.os_instructions))
  then exit;

//some instructions about.
  result := true;

  plzclose := false;
  plzrestart := false;

  h := FileOpen(Goptions.os_instructions,fmOpenRead);

  if h<0 then goto
  ENDNESS;

  while hgets(h,s) do begin
    tokenate(s);
    if tokens < 1 then
    continue;

    if tokenarray[1]='notice' then begin
      noticia;  //he knows about tokenarray. put notice on tab.
    end

    else if tokenarray[1]='unwarn' then
    unwarn := tokenarray[2]               //diddle rut scan warning.
    else if tokenarray[1]='tree' then begin   //change tree?
      ft_what := tokenarray[2];
      MenuTreeclick(nil);
    end

    else if tokenarray[1]='files_match' then begin
      detree;                       //set to local drives.
    end

    else if tokenarray[1]='close' then
    plzclose := true

    else if tokenarray[1]='files_scan' then begin
      if thepanel<>d then begin
//        thisfv.dont_fixUpdate := true;
//        thisfv.view.items.BeginUpdate;
//this seemed to have absolutely no effect; the display still jumps around

        file_top(true);
        filerescan(thisfv);
        file_top(false);  //here is where the display jumps around.

//        thisfv.view.items.EndUpdate;
//        thisfv.dont_fixUpdate := false;
      end;
    end

    else if tokenarray[1]='restart' then
    plzrestart := true;

{****************************************************************************
Not terribly useful, since the batch file that would do it has the focus, so
this doesn't happen until after the batch file exits.
****************************************************************************}

  end;

  ENDNESS:
  if h>=0 then
  FileClose(h);

  DeleteFile(Goptions.os_instructions);

{do it *after* the file delete.}
  if plzclose then
  close;

  if plzrestart then begin
    restart_osClick(nil);
  end;

end;

{****************************************************************************
select a tree based on the drive letter of odir.
****************************************************************************}
{$ifdef MSWINDOWS}
function TForm1.mstree(dir:string; var index:integer):Ttree;
var
i:integer;
t:TTree;
drive:char;


  function drivetree(x:Ttree):boolean;
  var
  i : integer;
  begin
    result := x.drive=drive;
{****************************************************************************
this is truly stupid. When we guess what tree a directory comes-from, we
should *start* by guessing the current tree. But when we do that, guesstree
below wants to know the index of the tree in the tree list, so we have to find
it every time. So we basically go thru the list twice in mstree. So I'm
stupid.....
****************************************************************************}
    if result then begin
      for i := 0 to Goptions.trees.count-1 do begin
        if Goptions.trees.objects[i]=x then begin
          index := i;
          t := x;
          exit;
        end;
      end;
    end;
    result := false;  //something disappeared.
  end;

begin
  result := nil;
  drive := tolower(es(dir,1));

//try *this* tree first, dumpfkopf.
  if drivetree(thetree) then begin
    result := t;
    exit;
  end;

  for i := 0 to Goptions.trees.count-1 do begin
//    t := Goptions.trees.objects[i] as TTree;
//    if t.drive=drive then begin
    if drivetree(Goptions.trees.objects[i] as TTree) then begin
      result := t;
      index := i;
      exit;
    end;
  end;

end;


function TForm1.guesstree
(odir:string):boolean;
var
i:integer;
t:TTree;
begin
  result := false;

  t := mstree(odir,i);
  if t=nil then
  errorf('Couldn''t find a windows tree that might contain "%s"',[odir])
  else begin
    result := true;
    thetree := t;
    DriveList.itemindex := i;
  end;

end;
{$endif}


{.$define DEBUG_Ffix}

procedure Tform1.Ffix(fv:Tfv = nil);
var
fpage, top, selected: integer;
{$ifdef DEBUG_Ffix}
const
count:integer = 0;
{$endif}
begin

  if fv=nil then
  fv := thisfv;


  try

    selected := file_selected_index(fv);

    if fv.view.topitem=nil then
    exit;

    top := fv.view.topitem.index;
    fpage := filepage(fv.view);

    if selected<top then
    fv.view.topitem := fv.view.items[selected]
    else if selected>(top+fpage-2) {i.e. bottom} then
    fv.view.topitem := fv.view.items[selected-(fpage-2)];

    {these #s are just stupid guesses.... The next time I'll do the file panel
    with my own graphics and to heck with these stupid lists. It is
    *undoubtedly* true that, by now, I've spent far more time fixing this junk
    than it would've taken to write in my own graphics to start with. Of
    course (1.) I didn't know that then, and (2.) I didn't know enough to do
    that then.... Ah well....}

//    fv.view.update;

//    infof('hey babe');

{$ifdef DEBUG_Ffix}
    inc(count);
    dbg('Ffix %d',[count]);
{$endif}

  except on
    exception do {nada};
  end;

end;


const
oldshowcount : integer = -1;

procedure TForm1.unfudgedebug;
begin
  Label_Debug2.caption := '';
  oldshowcount := -1;
end;

procedure TForm1.Fontfun1Click(Sender: TObject);
var
mr: TModalResult;
begin
  mr := fFontfun.showmodal;
//?  form1setfocus;

  unfudgedebug;

  if show_line_count then begin
    filepage(nil);
    filepage(thisfv.view);
  end;

  case mr of

    mrOK: begin
      fixfunfonts;
    end;

    mrRetry: restart_osClick(nil);
  end;



end;

procedure TForm1.fixfunfonts;
var
oldpanel : whichpanel;

const
o_FilesMiscPanel =
{$ifdef LINUX}
10
{$endif}
{$ifdef MSWINDOWS}
8
{$endif}
;
{$ifdef LINUX}
lx_stat_fudge=3;
{$endif}
o_dirstatus = 11;
o_filespanel = 13;
o_tabheight = 12;

  procedure refonttree;
  begin
    thetree.pix.refont;
    thetree.resize;
    selectpanel(oldpanel,true);
  end;

begin
  oldpanel := thepanel;

{****************************************************************************
Oh see this is the result of the routine which changes fonts; if it changed a
font, it returns true. All the other stuff has to occur *all* the time, since
we don't know if anything changed on the font fun form. That is, "fixfonts"
*will* call the mechanism that reads osfonts.ini if it hasn't been already,
and we must honor anything read in. Or we might be responding to an mrOK
above, in which case we should do everything again. Or something.
****************************************************************************}

  if fixfonts(form1) then begin
//some *fonts* on form1 need attending.
    dirimage.canvas.font.assign(FilesView1.font);
    notices.font.assign(FilesView1.font);
//    refonttree;
  end else begin
    if needlineadjust then
//    refonttree;
  end;

  fixmainmenu;

  refonttree;
{****************************************************************************
Wed 7/25/2007 3:22 pm. do this always; it makes the F8 key work again after
changing abbreviation who knows why....
****************************************************************************}

  PageControl1.tabheight := o_tabheight + Gtabdif;

  Files1StatPanel.height := o_filespanel + Gtabdif;
  Files2StatPanel.height := o_filespanel + Gtabdif;

  DirStatus.height       := o_dirstatus + Gtabdif;

  FilesMiscPanel.height  := o_FilesMiscPanel + Gtabdif;
{$ifdef LINUX}
  if (FilesView1.font.height+lx_stat_fudge) > FilesMiscPanel.height then
  FilesMiscPanel.height := FilesVIew1.font.height+lx_stat_fudge;
{$endif}



end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}

const
Files_Max = 6;

var
Files_List : TStringList;

Files_menus : array[1..Files_max] of TMenuItem;


procedure TForm1.FilesViewContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);

var
files_clicked,
other:Tfv;
i: integer;
tv:Tvisited;


const
filesinited : boolean = false;
{$ifdef LINUX}
files_rut : string = slashchar;
{****************************************************************************
Fri 3/04/2005 3:07 pm. Moved to Windows version to public so options can whack
it.
****************************************************************************}

{$endif}


  procedure init;
  var
  i:integer;
  begin
    if filesinited then
    exit;

    filesinited := true;

    Files_menus[1] := Files_1;
    Files_menus[2] := Files_2;
    Files_menus[3] := Files_3;
    Files_menus[4] := Files_4;
    Files_menus[5] := Files_5;
    Files_menus[6] := Files_6;

    for i:= 1 to 6 do
    Files_menus[i].tag := i;

    if Files_list=nil then begin
      Files_list := TStringList.create;

      Files_list.sorted := false;
    end;

  end;

begin

  if (notinited<>0) or cum_clk or os_off then
  exit;

  {this was totally bogus. The various offered choices aren't associated with
  the proper trees, so who knows what will be... // ok I'm fixing it Tuesday,
  October 1, 2002 11:50 am; we'll just stick some objects on the list with the
  trees in 'em.}

  init;

  visible_mark(true);

  devisited(files_list);
  files_list.clear;

  if (sender as TlistView) = FilesView1 then begin
    files_clicked := fv1;
    other := fv2;
  end else begin
    files_clicked := fv2;
    other := fv1;
  end;

  sort1.visible := not files_clicked.sorted;

  Files_list.addobject(files_clicked.status.caption,

  {thetree} Tvisited.create(thetree,files_clicked.dir_index,
  files_clicked.status.caption
  )

  );
  {start with *this* directory at [0]; that shouldn't be on list.// oh I see
  he's doing it so the unique thing mechanism'll work. But then again we might
  want to do this for rescan....}

{$ifdef MSWINDOWS}
  files_rut[1] := thetree.drive[1];
{$endif}

  adduniquething(Files_list,files_rut,
  {thetree}
  Tvisited.create(thetree,0,files_rut));

  adduniquething(Files_list,Dirstatus.caption,
  {thetree}
  Tvisited.create(thetree,thetree.selected,Dirstatus.caption));

  adduniquething(Files_list,other.status.caption,
  {other.file_tree}
  Tvisited.create(other.file_tree,other.dir_index,other.status.caption));

  for i := 0 to VisitedDirs.items.count-1 do begin

    if files_list.count>FILES_MAX then
    break; {for}
    {the count includes the [0] item which we won't actually show.}

    tv := visitedDirs.items.objects[i] as Tvisited;

    adduniquething(Files_list,
//    visitedDirs.items[i]
    visited_dir(i)
    ,
//    visitedDirs.items.objects[i]
    {that should be adding those cute little Tvisited in there.}

{ oops! See this is just a pointer, I want to add a new object, so I can
delete it later without tears....}
    Tvisited.create(
    Tvisited(visitedDirs.items.objects[i]).tree,
    Tvisited(visitedDirs.items.objects[i]).index,
    tv.directory
    )

    );

  end;

{the first entry in this silly menu is going to be "rescan" so we can
rescan.... Files_menus is a 1-based thingey. file_list is 0-based, but the
zeroth one is the current files.}

  files_0.caption := safe_format('rescan "%s" files',
  [shortstring(files_list[0],20)]);

  for i := low(Files_menus) to high(Files_Menus) do begin
    files_Menus[i].visible := i<files_list.count;
    if files_menus[i].visible then
    Files_menus[i].caption := shortstring(files_list[i],50);
    {it's not zero-ized because we have one extra at [0] }
  end;

  MousePos := mouse.CursorPos; {to make it work on screen.}

  no_tricks := true;

  PopUpFilesMenu.PopUp(MousePos.x,MousePos.y+10);

end;


{$ifdef __NOTHIN}
  procedure TForm1.Files_1Click(Sender: TObject);
  {$ifdef I_dont_know_why_this_didnt_work}
  var
  s : string;
  atree: Ttree;
  {$endif}
  begin
    filerescan(thisfv);

  {$ifdef I_dont_know_why_this_doesnt_work}
    with Sender as Tmenuitem do begin
      try
        s := Files_list[tag];
        atree := Files_list.objects[tag] as Ttree;
        if treeoid(atree) then begin
          scanfiles(atree,tag=0,thisfv,Files_list[tag],Goptions.casesort);
          {scanall if rescan.}

          dir_find_select(thisfv.status.caption,0,true);
  {added Friday, January 2, 2004 4:03 pm.}

        end;
      except
        on exception do;
      end;
    end;
  {$endif}
    set_tricky;
  end;
{$endif}

procedure TForm1.Files_1Click(Sender: TObject);
var
s : string;
avisit : Tvisited;
begin
  if (notinited<>0) or cum_clk then
  exit;

  with Sender as Tmenuitem do begin
    try
//      s := Files_list[tag];
      avisit := Files_list.objects[tag] as Tvisited;
      s := avisit.directory;
      if treeoid(avisit.tree)
      and dfind(avisit)
      then begin
        fixVisitIndex(avisit);
        //this is probably a copy, so we'll search for the thing and
        //try to fix it.
        scanfiles(avisit.tree,tag=0,thisfv,
//        Files_list[tag],
        avisit.directory,
        Goptions.casesort);
        {scanall if rescan.}

//        dir_find_select(thisfv.status.caption,avisit.index,true);
{added Friday, January 2, 2004 4:03 pm.}
{but wrong place! ha ha. dfind should be part of the if.}

      end;
    except
      on exception do;
    end;
  end;
  set_tricky;
end;

procedure Tform1.xfinal;
//var
//i:integer;
//var
//save_r:string;
begin

  Gos_idle_off;

  unsplash;

  if Gexitnow then
  exit;

//  save_r := save_restore_filename(Goptions.layout_main);

//  if not FileExists_unq(save_r) then
//no we should always do this; that's what main is.
{$ifdef Not_like_this}
  if last_recalled_layout<>'' then
  //only do it if the user didn't recall some other layout.
  putposition(last_recalled_layout);

//or this.
  if (last_recalled_layout=Goptions.layout_main)
  and (not FileExists()) then
  putposition(Goptions.layout_main);

{$endif}

  if not FileExists(fdatadirize(save_restore_filename(Goptions.layout_main)))
  then
  putposition(save_restore_filename(Goptions.layout_main));

//  for i := VisitedDirs.items.count-1 downto 0 do
//  VisitedDirsDelete(i);
  devisited(VisitedDirs.items);
  {to free my cunning Tvisiteds in there.}
  freeMyKeyQueue;

  cpyf_destinations.free;

  savehome;

  putposition;

  stopness(howNoway,'(going away)');

  thetree.dirupdating;

  inc(notinited);


  FreeAndNil(fv1);
  FreeAndNil(fv2);

  if Files_list<>nil then begin
    devisited(Files_list);
    FreeAndNil(Files_list);
  end;

  emptyshortcuts;


end;

{get rid of the visited objects that might be in the stringlist.}
procedure TForm1.devisited(what:TStrings);
var
i:integer;
begin
  for i := 0 to what.count-1 do
  if what.objects[i] is Tvisited then begin
    Tvisited(what.objects[i]).free;
    what.objects[i] := nil;
  end;

end;

{the files popup menu first entry.}
procedure TForm1.Files_0Click(Sender: TObject);
begin
  filerescan(thisfv);
end;

procedure TForm1.fixfvcolors;
begin
  if (notinited>0) or (Goptions.enter_top) then
  exit;

  elsefv.flipbutton.color := clButton;
  thisfv.flipbutton.color := clLime;
end;

procedure Tform1.flipelsethis;
var
extra : Tfv;
begin
  extra := elsefv;
  elsefv := thisfv;
  thisfv := extra;
end;

function TForm1.TheMainFv:Tfv;
begin
  if Goptions.enter_top then
  result := topfv
  else
  result := thisfv;
end;


function Tform1.TheOtherFv:Tfv;
begin
  if Goptions.enter_top then
  result := bottomfv
  else
  result := elsefv;
end;

procedure TForm1.copyselect_ifsame(const fromfv, tofv:Tfv);
var
index:integer;
begin
  if fromfv.status.caption<> tofv.status.caption then
  exit;

//  f_s(tofv, file_selected_index(fromfv), true);
// stupid; only works if same sort.

  index := file_findname(tofv,file_selected_name(fromfv));

  if index<0 then
  exit;

  f_s(tofv,index,true);

  Fcute(tofv);      //needed to show selection in tofv.


end;

procedure TForm1.x_stuff;
begin

  stuffdir(dirstatus.caption,thetree.selected);

  copysort(TheMainFv,TheOtherFv);
//nah not here.//Tuesday, March 11, 2008 4:24 pm why not?!

  seedirfiles(TheOtherFv);
//    selectpanel(topfv.which);
    {Friday, August 8, 2003 1:52 pm. Change behavior.}
    {Wednesday, June 16, 2004 5:01 pm. Change it again. DON'T enter
    a directory. So @- and ^- are the same except top/bottom.}
  copyselect_ifsame(TheMainFv,TheOtherFv);
  cpydstoff(true);
end;

procedure TForm1.x_stufftop;
begin
  stuffdir(dirstatus.caption,thetree.selected);
  seedirfiles(TheMainFv);
  copyselect_ifsame(TheOtherFv,TheMainFv);
end;

procedure TForm1.x_flip;
begin
  flip_file_positions;
  flipelsethis;
end;


{****************************************************************************
I added this to files click because I wasn't selecting the right files
occasionally, probably because tricky scroll thingey was selecting the other
due to endless panel jitter.
****************************************************************************}

procedure TForm1.FilesView1Click(Sender: TObject);
begin
  if (notinited<>0) or cum_clk then
  exit;
  set_tricky;
end;

{.$define RIGHT_CLICK_SELECT}
//do I really want to select with right-click? I don't think so...
procedure TForm1.VisitedDirsContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
{$ifdef RIGHT_CLICK_SELECT}
var
index:integer;
{$endif}
begin

  handled := true;

  if (notinited<>0) or cum_clk or os_off then
  exit;

  if VisitedDirs.items.count<1 then begin
//    handled := true;
    exit;
//no one at home.
  end;

{$ifdef RIGHT_CLICK_SELECT}
//fix the index.
  index := VisitedDirs.itemAtPos(MousePos,true);

  if index<0 then
  index := VisitedDirs.itemindex;

  VisitedDirs.itemindex := index;
{$endif}

  VisitedDirectoriesClick(nil);

end;


{****************************************************************************
Thu 3/03/2005 2:18 pm. this is still clicked from the etc menu. Today I'm
calling it directly from visited right-click and discarding the intermediate
menu; it had two entries, both of which are duplicated in the big view.
****************************************************************************}

procedure TForm1.VisitedDirectoriesClick(Sender: TObject);
var
index : integer;
r : integer;

 procedure clickclick;
 begin
   VisitedDirsClick(nil);
   VisitedDirsDblClick(nil);
 end;

begin

  if (notinited<>0) or cum_clk then
  exit;

//gotta jigger multiselect so the select from the form works.

  r := fBigVisit.showmodal;

//?  form1setfocus;

  if r = mrCancel then
  exit;

  VisitedDirs.items.assign(fBigVisit.ListBox_Visit.items);
//Wednesday, May 31, 2006 12:58 pm. I never dealt with the Tvisited objects!
//going to try and do it now in bigvisit....

  index := fBigVisit.ListBox_Visit.itemindex;

  VisitedDirs.itemindex := index;

  fixvisit;   //deal with itemindex or something.

  if index<0 then
  exit;

  mouseshift:= [];

  case bigvisit_result of

    bigvisit_dir: VisitedDirsClick(nil);

    bigvisit_enter: clickclick;

    bigvisit_control_enter: begin
      mouseshift := [ssctrl];
      clickclick;
    end;

  end;
end;

{$define GET_TREE}
{.$define GET_DEBUG}
procedure TForm1.getvisited;
  procedure rvfile(name:string);
  var
  h:integer;
  s:string;
  c:char;
{$ifdef GET_TREE}
  x:integer;
  treename:string;
  atree:Ttree;
{$endif}
  begin
    h := FileOpen(name,fmOpenRead);
    if h<0 then begin
//    errorf
      dbg('Couldn''t open favorites file "%s"',[name]);
      exit;
    end;

    while hgets(h,s) do begin
      atree := thetree;
      s := unquote(s);
      c := es(s,1);

{$ifdef GET_DEBUG}
      dbglog(true,'getvisited %s %s %s',
      [atree.name,s,c]);
{$endif}

      if (c=';')
      or (ord(c)<=32)
      then
      continue;

{$ifdef GET_TREE}
      x := pos('|',s);
      if x>0 then begin
        treename := copy(s,x+1,5000);
        s := copy(s,1,x-1);
        for x := 0 to Goptions.trees.count-1 do begin
          if SameText(treename,Ttree(Goptions.trees.objects[x]).name)
          then begin
            atree := Ttree(Goptions.trees.objects[x]);
            break;  //the for.
          end;
        end;
//if it isn't there, just leave it thetree I suppose.
      end
{$ifdef MSWINDOWS}
      else begin    //oops gotta check if drive and then tree.
        atree := mstree(s,x);
      end
{$endif}
      ;
{$endif}


{$ifdef MSWINDOWS}
{$ifdef GET_TREE}
      if es(s,2)<>':' then
      //Thursday, December 7, 2006 2:12 pm. Don't clobber it if it HAS a drive.
      s := fredrive(s,atree.drive[1]);
      //if windows, it *should* have a drive.
{$else}
      if es(s,2)=':' then begin
        if tolower(s[1])<>thetree.drive then
        continue;
      end else
      s := fredrive(s,thetree.drive[1]);
      //if windows, it *should* have a drive.
{$endif}
{$endif}

      stuffdir(s,-1,true,atree);

    end;

    FileClose(h);

  end;

var
i:integer;

begin

  for i := 0 to Goptions.visitdirs.count-1 do begin
    rvfile(Goptions.visitdirs[i]);
  end;

end;



procedure TForm1.FormShow(Sender: TObject);
begin
//  activated_flag := true;
  if notinited<>0 then begin
    exit;
  end;

  formguard(form1);
end;

procedure TForm1.fixvisit;
begin
  if (VisitedDirs.itemindex<0)
  and (VisitedDirs.items.count>0) then
  VisitedDirs.itemindex := 0;

end;

procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  if notinited<>0 then begin
    exit;
  end;

  if cum_clk then
  exit;

  case thepanel of
    d: begin
      if WheelDelta > 0 then
      os_scroll(-1)
      else
      os_scroll(1);
    end;

{$ifdef TLISTVIEW_STEALS_MOUSE_WHEEL}
    f1, f2: begin
    //os_scroll(0);   //?
    //      set_tricky;
      set_tricky(1000);
      dbg('formmousewheel f1, f2');
    end;
{$endif}

  end;
end;

procedure TForm1.etc_FindClick(Sender: TObject);
begin
  execute_findkey;
end;

{****************************************************************************
Let user choose whether directories show creation time or write time. See
weirdo.pas if_dirtime_int. I think the user has to rescan after changing this.
****************************************************************************}
procedure TForm1.dtimechkClick(Sender: TObject);
begin
{$ifdef MSWINDOWS}
  if thepanel=d then
  exit;
  Goptions.dir_creationtime := not Goptions.dir_creationtime;
  layout_checks;
{$endif}
end;

procedure TForm1.DriveListExit(Sender: TObject);
begin
  showindrivelist;
end;

procedure TForm1.save_restore_layoutClick(Sender: TObject);
var
s:string;
begin
  case save_recall(false,s) of
    s_r_save:   putposition(s);
    s_r_recall: restore_layout_fiddle(s);
  end;

end;

procedure TForm1.restore_layout_fiddle(s:string);
begin
  undebugfudge;
  getposition(s);
  fixfilewidths(fv1);
  copyFwidths(fv1,fv2,true);
  delphi_yield;
  fixmainmenucolor;
  jigglemain;

  layout_checks;

  last_recalled_layout := s;
end;

procedure TForm1.restoremainlayoutpreferenceClick(Sender: TObject);
var
s:string;
begin
  if save_recall(true,s)=s_r_recall then //save_restore(false,sender=nil);
  restore_layout_fiddle(s);
end;

procedure Tform1.jigglemain;
var
howmuch : integer;
begin
  if height<250 then
  howmuch := 20
  else
  howmuch := -20;

  height := height + howmuch;
  height := height - howmuch;
{on odd Tuesdays, the extra-line in the menu that appears frequently in
the IDE design view appears in executing program. This stops it.}
end;


//if the exec is right, see the files.
procedure Tform1.maybesee(what:Texec);
var
thereread:integer;
begin
  if (what=nil) then
  exit;

  with what do begin
    thereread := get_reread;
    if (thereread>0)
    and (
    (thereread=1) or
    (thereread >= thisfv.filecount)
    )
    then
    seefiles;
  end;
end;

{$define NOT_OSEDIR_STUPID}

procedure TForm1.osedirClick(Sender: TObject);
{$ifndef NOT_OSEDIR_STUPID}
var
edir_index:integer;
{$endif}

begin
  if (thepanel=d) then
  exit;

{$ifdef NOT_OSEDIR_STUPID}
  if (Goptions.edir_scan=edir_scan_both)
  or (Goptions.edir_scan=edir_scan_before)
  or (thisfv.fls.count <= Goptions.edir_scan) then
  filerescan(thisfv);
{$else}
//see if the thing exists already.
  edir_index := thisfv.fls.indexof(Goptions.edir_name);

  thisdirectory;
//don't do the maybesee here; use the function, have to do the scan.

//so IF it exists, show the current copy.
  if edir_index>=0 then
  filerescan(thisfv);   //so it sees an *updated* version plz.
{$endif}

  if edir(thisfv) then begin
    reread := 0;
{****************************************************************************
Thu 2/16/2006 12:02 pm. We use an exec for the edir editor, but we want to
ignore any rereadwait in there. So we have to do this, whereupon it should get
the non_modaldelay....
****************************************************************************}
    finishexec;
  end;

//if it DIDN'T exist, show it now. It's annoying otherwise.
{$ifdef NOT_OSEDIR_STUPID}
  if (Goptions.edir_scan=edir_scan_both)
  or (Goptions.edir_scan=edir_scan_after)
  or (thisfv.fls.count <= Goptions.edir_scan) then
{$else}
  if edir_index<0 then
{$endif}
  filerescan(thisfv);

  if Goptions.edir_selectanyway then
  files_find_select(Goptions.edir_name,0,search_EXACT);
//we *can't* see the files now; it's deferred.oh to hoo with it.
//?

end;

procedure TForm1.ClipsClick(Sender: TObject);
begin
  fclips.showmodal;
end;

{$ifdef LINUX}
procedure Tform1.lxstat;
begin
  file_lxstat(thepanel=d);
end;
{$endif}

procedure TForm1.showsearchkind;
begin
  case searchkind of
    search_CONTAINS:        Label_searchKind.caption := 'contains';
    search_EXACT:           Label_SearchKind.caption := 'EXACT';
    search_BEGINS_WITH:     Label_searchKind.caption := 'BEGINS WITH';
  end;

//  dbg('%s',[Label_searchKind.caption]);
  if Giscumulative then
  Label_LXstat.caption := Label_SearchKind.caption;
end;

procedure TForm1.nextsearchkind;
begin
  case searchkind of
    search_CONTAINS:        searchkind := search_EXACT;
    search_EXACT:           searchkind := search_BEGINS_WITH;
    search_BEGINS_WITH:     searchkind := search_CONTAINS;
  end;
  showsearchkind;
end;

procedure TForm1.Label_SearchKindClick(Sender: TObject);
begin
  nextsearchkind;
  findbuttonclick(nil);
end;

procedure TForm1.setsearchkind(what:Tsearch_kind);
begin
  searchkind := what;
  showsearchkind;
end;

procedure TForm1.Sort1Click(Sender: TObject);
begin
//fake a click on the left-most little box.
  filesviewcolumn(thisfv.view.columns[nadacolumn]);
end;

{****************************************************************************
****************************************************************************}
//get rid of the objects in the fls.
procedure Tfv.emptyfs;
var
i:integer;
begin
  fls.sorted := false;

  for i := 0 to fls.count-1 do begin
    fls.objects[i].free
  end;

  fls.clear;

end;

constructor Tfv.Create;
begin
  inherited Create;
  {code}
//  fls := TStringList.create;
//  fls.sorted := false;
  fls := jgo_slist;
  fls.casesensitive := Goptions.casesort;
end;

destructor Tfv.Destroy;
begin
  {code}
  emptyfs;
  FreeAndNil(fls);

  inherited destroy;

end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}

var
integer_height_timer : TICKTIME;
scrollheight : integer;

procedure TForm1.calcscroll;
var
width_total,
i:integer;
const
{$ifdef MSWINDOWS}
fudge1 = 0;
fudge2 = 4;
//scrollfudge = 8;
{$endif}
{$ifdef LINUX}
fudge1 = 0;
fudge2 = 4;
//scrollfudge = 8;
{$endif}
begin
  scrollheight := 0;
  if notinited<>0 then
  exit;

  width_total := fudge1;
  with thisfv.view do
  for i := 0 to columns.count-1 do begin
    inc(width_total,columns[i].width+fudge2);
  end;

  if width_total > thisfv.view.width then
  scrollheight := files_scroll;

end;

function TForm1.visibleview:integer;
begin
  result :=
  thisfv.view.height - (files_header + scrollheight);
end;

procedure TForm1.fixthis;
var
heightfix,
remainder : integer;
begin
  if (notinited<>0)
  or (not delay_z(integer_height_timer))
  then
  exit;


  remainder :=
  visibleview
  mod files_PixPerLine;

  if remainder=0 then
  exit;

{****************************************************************************
Fri 10/14/2005 8:24 pm. we adjust the view so it has an integer number of
lines, or at least what we think is an integer number of lines. We have to
adjust the *panel*, and sometimes we have to adjust *this* panel, sometimes
the *other*, depending on the vagaries of Delphi magical -- very powerful to
be sure -- alignment mysteries.
****************************************************************************}
  if (thisfv.view.height < 10)
  or thisfv.flip
  then
  heightfix := files_PixPerLine - remainder
  else
  heightfix := - remainder;

  thisfv.flip := not thisfv.flip;

//this is supposed to make the screen an integer # of lines.
  if thisfv.panel.align = alClient then
  elsefv.panel.height := elsefv.panel.height - heightfix
  else
  thisfv.panel.height := thisfv.panel.height + heightfix;

end;

{This is a pitiful hack designed to help me keep the file view cute; and
sometimes it sort-of works.}

procedure TForm1.showcount;
var
count : integer;
begin
  if not show_line_count then
  exit;

  count :=
  visibleview
  div
  files_PixPerLine;

  if (count <> oldshowcount) then begin
    oldshowcount := count;
    Label_Debug2.caption :=
    safe_format('   %d lines (H:%d;L:%d;S:%d (%d))   ',
    [count,
    files_Header,
    files_PixPerLine,
    files_Scroll,
    scrollheight]);
  end;
end;

function Tform1.filepage(view:Tlistview):integer;

{$ifdef OLDFINALFONT}
const
oldresult : integer = -1;
  procedure showcount;
{$ifdef OLDFINALFONT}
  var
  pixstart,
  pixheight:integer;
{$endif}
  begin
    if show_line_count and
    (result <> oldresult) then begin
{$ifdef OLDFINALFONT}
      pixheight := 0;
      pixstart := 0;
      try
        pixstart := view.items[0].DisplayRect.Top;
        pixheight :=
        view.items[1].DisplayRect.Top -
        view.items[0].DisplayRect.Top
      except
        on exception do;
      end;

      oldresult := result;
      Label_Debug2.caption :=
      safe_format('  %d lines (%d) (h:%d t:%d) (%d)   ',
      [result,view.font.height,pixheight,pixstart,
      files_PixPerLine*2 - Goptions.linefudge
      ]);
  //    dbg('%d',[result]);
{$else}
      Label_Debug2.caption :=
      safe_format('   %d lines (H:%d;L:%d;S:%d (%d))   ',
      [result,
      files_Header,
      files_PixPerLine,
      files_Scroll,
      scrollheight]);
{$endif}
    end;
  end;
{$endif}

begin

  result :=
//  (view.height - figgered_file_header)
  visibleview
  div
  files_PixPerLine;

  if result<0 then
  result := 0;
//  dbg('filepage:%d',[result]);  //
end;

procedure TForm1.FilesPanel1Resize(Sender: TObject);
begin
  if notinited <>0 then
  exit;
  delay_z(integer_height_timer,200);
  calcscroll;
end;

procedure TForm1.Label_Debug2Click(Sender: TObject);
begin
  Clipboard.astext := Label_Debug2.caption;
end;

procedure TForm1.fakeshiftoff;
begin
{$ifdef LINUX}
  delay_z(skipshift,1000);
{$endif}
{$ifdef MSWINDOWS}
  last_shift := [];   //let's just pretend.
{$endif}
  FilesM_Shift.caption := '';
end;

{****************************************************************************
****************************************************************************}

{****************************************************************************
Gosi_off RETURNS the state of osidle BEFORE it changes anything. Thu
10/06/2005 6:10 pm. So you should ALWAYS use it like

    wason :=
    Gosi_off;  //turn-off os_idle.

paired with

    if wason then   //turn it on if it *was* on.
    Gosi_off(false);

so the stupid thing works right. Or now
    Gosi_on(wason);

****************************************************************************}

function Gos_idle_off(doit:boolean=true):boolean;

  procedure osidle(yes:boolean);
  begin
    with form1 do begin
      result := Gosidle_on;

      if yes then begin //turn it on.
//        os_enabled := true;
        throttle(false);    //shouldn't we?
        if not assigned(Application.OnIdle) then
        Application.OnIdle := os_idle;
        if Goptions.linux_time then begin
          linuxtimer.interval := Goptions.linux_timer;
          linuxtimer.enabled := true;
        end;
        Gosidle_on := true;

      end else begin    //turn it of.
        Linuxtimer.enabled := false;
        Application.OnIdle := nil;
        Gosidle_on := false;
      end;
//      os_off := not Gosidle_on;
//nah; os_off means something different, not sure what.
    end;
  end;

begin
  osidle(not doit);
end;

{****************************************************************************
these should be called in pairs. I.e. anyone who calls Gidle_off must call
Gidle_on subsequently.
****************************************************************************}

function Gidle_off:boolean;
begin
  result := false;          //assume it's already off.

  if Gosidle_on then begin  //but it's on!
    Gos_idle_off(true);
    Gosidle_will_turn_on := true;   //this is the promise.
    result := true;
  end;

end;

procedure Gidle_on(doit:boolean);
begin
  if doit then begin
    Gosidle_will_turn_on := false;
    Gos_idle_off(false);
  end;
end;


{****************************************************************************
****************************************************************************}

{$ifdef WAIT_KEY_CLEAR}
procedure WaitForNoAlt;
var
t:TICKTIME;
begin
  delay_z(t,1000); //basically, don't. this is a kluj fix.
  with form1 do
  while true do begin
    delphi_yield;

//    shiftwhat;    //update little display. maybe get lx opinion.
    if (last_shift = [])
    or delay_z(t)
    then
    break;

  end;
end;
{$endif}


{****************************************************************************
****************************************************************************}
const
imaginary_enabled : boolean = true;

function Tform1.getos_enabled:boolean;
begin
  if Goptions.disablenot then begin
    result := imaginary_enabled;
    enabled := true;
  end else
  result := enabled;
end;

var
Disabled_Main_Menu : TMainMenu;

procedure Tform1.setos_enabled(value:boolean);
begin
  if value=imaginary_enabled then
  exit;

  imaginary_enabled := value;

  if Goptions.disablenot then begin
    enabled := true;  //form1 is *always* enabled in this scheme.

    dirImage.enabled := value;
    FilesPanel.enabled := value;
    bottomPanel.enabled := value;
    if value then begin
      form1.menu := MainMenu1
    end else begin
      form1.menu := Disabled_Main_Menu;
    end;
  end else begin
    enabled := value;
  end;

  active_color(value);

  if value then
  MainMenu1.color := clButton
  else
//  MainMenu1.color := $600000; //clBlue; //clBlack;
  //dark blue -- so it doesn't look like a DOS box.
  MainMenu1.color := $000050;
  //a dark red?

end;

{****************************************************************************
****************************************************************************}

procedure TForm1.fixmainmenucolor;
begin
  MainMenu1.color := clWhite;
  update;
  delphi_yield;
  MainMenu1.color := clButton
end;

{****************************************************************************
****************************************************************************}
{$ifdef MSWINDOWS}
procedure TForm1.active_color(activate:boolean = true);
//const
//apanel : whichpanel = none;

  procedure uncolor(fv:TListView);
  begin
    if Goptions.dont_uncolor then
    exit;

//    dbg_nolog('Uncoloring');
    fv.color := unselcolor;
    fv.update;
  end;

begin
  if activate then begin
    if thepanel=d then
    thetree.dirselect;

  end else begin
    case thepanel of
      d: begin
        thetree.dirunselect;
        dir_fix(true);
      end;

      f1: uncolor(fv1.view);
      f2: uncolor(fv2.view);
    end;

  end;
end;
{$endif}


{****************************************************************************
****************************************************************************}

{$if defined(LINUX)}
procedure TForm1.active_color(activate:boolean = true);
const     {   bbggrr}
LXUNSEL = $000404040;     {a darkish gray; the letters turn white}
{actually they turn a lightish gray; the panel captions apparently turn
*bright* white. If I put that in front of black it just gets uglier. /
Then again, maybe it's the same color, but just smaller.... whatever.}
begin
  if activate then begin
    filesview1.color := unselcolor;
    filesview2.color := unselcolor;
    DirStatus.color  := clBackground;
    FilesLabel1.color := clBackground;
    FilesLabel2.color := clBackground;
    FilesMiscPanel.color := clBackground;
  end else begin
    filesview1.color := LXUNSEL;
    filesLabel1.color := clWhite;
    filesview2.color := LXUNSEL;
    filesLabel2.color := clWhite;
    DirStatus.color := clWhite;
    FilesMiscPanel.color := clWhite;
  end;
end;
{$ifend}

{****************************************************************************
****************************************************************************}
//stolen from detree.
procedure TForm1.purge_bad_files;
//var
//oldpanel : whichpanel;
{****************************************************************************
Fri 2/24/2006 1:55 pm. Returning to the panel screwed-up the logic somehow, so
not knowing any reason why I *wanted* to do that, I don't....
****************************************************************************}

  procedure dt(fv:Tfv);
  begin

    if (not fv.file_tree.isbadnet) then
    exit;

    //so see more files already....
    file_fiddlesort(fv);
    seedirfiles(fv);

  end;

begin
  if notinited<>0 then
  exit;

//  oldpanel := thepanel;

  dt(fv1);
  dt(fv2);

//  selectpanel(oldpanel,true);

end;

{****************************************************************************
****************************************************************************}
var
noticias : Tkey_string;

{****************************************************************************
arrives the tokenarray containing
[2] key
[3] ... string
****************************************************************************}

procedure Tform1.noticia;
var
space, s:string;
i:integer;
begin
  if tokens<2 then
  exit;

//tokens[2] is the key.

//construct the string.
  s := '';
  space := '';
  for i := 3 to tokens do begin
    s := s + space + tokenarray[i];
    space := ' ';
  end;

//set it -- replacing anything already there.
  noticias.set_keystring(tokenarray[2],s);

  show_notices;

end;

procedure Tform1.show_notices;
var
s:string;
begin
  memo_notices.clear;
  noticias.next(true);      //init it.
  while true do begin
    s := noticias.next;
    if s='' then
    break;    //the exit.

    memo_notices.lines.add(s);
  end;
//we are finished adding strings.

  if memo_notices.lines.count<1 then begin
    if PageControl1.ActivePage = notices then
    PageControl1.ActivePage := main;
    notices.tabvisible := false;
  end else begin
    notices.tabvisible := true;
    if memo_notices.lines.count = 1 then begin
      notices.caption := UpperCase(memo_notices.lines[0]);
    end
    else
    notices.caption := Goptions.alert; //'alert';
  end;

end;

{****************************************************************************
****************************************************************************}
{$define DIR_NAME}

const
superquick_dirtag = 0;
superquick_filetag = -1;

procedure TForm1.super_quickcopy;

const
dirstuff : array[0..3] of string = (
  '&3. quotes,slash',
  '&4. slash, no quotes',
{$ifdef DIR_NAME}
  '&5. just the name',
{$endif}
  'ESC: go away'
);

filestuff : array[0..4] of string = (
  '&3. name, quotes',
  '&4. name, no quotes',
  '&5. cute',
  '&6. directory',
  'ESC: go away'
);

var
clearwhat, index, i:integer;

begin
  index := 2; //where they begin to diverge.

  with popupmenu_superquick do
  if thepanel = d then begin
    clearwhat := index + high(dirstuff) + 1;
    for i := low(dirstuff) to high(dirstuff) do begin
      items[index+i].caption := dirstuff[i];
      items[index+i].tag := superquick_dirtag;
      items[index+i].visible := true;
    end;
  end else begin
    clearwhat := index + high(filestuff) + 1;
    for i := low(filestuff) to high(filestuff) do begin
      items[index+i].caption := filestuff[i];
      items[index+i].tag := superquick_filetag;
      items[index+i].visible := true;
    end;
  end;

  with popupmenu_superquick do
  for i := clearwhat to items.count -1 do
  items[i].visible := false;

  clipform.plzquick := true;
  PopupMenu_superQuick.popup(max(0,left),max(0,top));

  fakeshiftoff; //if I pick out esc with the mouse, it leaves the @ on.
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.quotesClick(Sender: TObject);
begin
  clipform.plzsuper := [quick_valid,quick_quotes];
  CopyClick(nil);
end;

procedure TForm1.no_quotesClick(Sender: TObject);
begin
  clipform.plzsuper := [quick_valid];
  CopyClick(nil);
end;

procedure TForm1.quotes_slashClick(Sender: TObject);
begin
  if (sender as TmenuItem).tag = superquick_dirtag then begin
    clipform.plzsuper := [quick_valid,quick_quotes,quick_slash];
  end else begin
    clipform.plzsuper := [quick_valid,quick_quotes,quick_name];
  end;
  CopyClick(nil);
end;

procedure TForm1.slash_no_quotesClick(Sender: TObject);
begin
  if (sender as TmenuItem).tag = superquick_dirtag then begin
    clipform.plzsuper := [quick_valid,quick_slash];
  end else begin
    clipform.plzsuper := [quick_valid,quick_name];
  end;
  CopyClick(nil);
end;

procedure TForm1.ESCgoaway1Click(Sender: TObject);
begin
  if (sender as TmenuItem).tag = superquick_filetag then begin
    clipform.plzsuper := [quick_valid,quick_cute];
    CopyClick(nil);
  end;

{$ifdef DIR_NAME}
//do just the directory name part.
  if (sender as TmenuItem).tag = superquick_dirtag then begin
    if (thetree.selected=0) then
    clipboard.astext := slashchar  //oh why not....
    else
    clipboard.astext := quotate(xfilename(dirstatus.caption),true);
  end;
{$endif}

end;

procedure TForm1.File_directory(Sender: TObject);
begin
  if (sender as TmenuItem).tag = superquick_filetag then begin
    clipboard.astext := quotate(dirstatus.caption,true);
//it's just easier than the rigamarole.
  end;
end;

{****************************************************************************
****************************************************************************}


procedure TForm1.unsortfiles1Click(Sender: TObject);
begin
  if thepanel=d then
  exit;

  thisfv.sort := all_unsorted;
  thisfv.old_s := nada_sort;
  filerescan(nil,false);
//  sortUnsort;
  sortcolor;

end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
Wed 3/29/2006 10:28 am. So this is mumbo-jumbo to make the "automatic"
shortcuts in the etc menu actually appear. Note that *this* mumbo-jumbo, as
opposed to the atrocities in "else WHAT_WORKED" produces *different* automatic
shortcuts. Note also of course the automatic shortcuts have *nothing* to do
with the shortcut keys for a few functions installed by owenshow -- as one can
tell by examining the menu; I display the OwenShow shortcut keys also.

I'm hoping this version will work even as I change and fix the menu. But note
I might have to call it again if I do something dynamic. That's why it's in a
subroutine -- also so I can add other menus etc if necessary.
****************************************************************************}

procedure TForm1.rethinkey;
var
i:integer;

begin

  for i := 0 to PopupMenu_etc.items.count-1 do begin

    PopupMenu_etc.items[i].visible :=
    not PopupMenu_etc.items[i].visible;

    PopupMenu_etc.items[i].visible :=
    not PopupMenu_etc.items[i].visible;

  end;

end;

{****************************************************************************
****************************************************************************}

procedure Tform1.visual_complaint;
var
mm:Tcolor;
i:integer;
const
colorwait = 50;

begin
  mm := MainMenu1.color;

  for i := 1 to 2 do begin
    MainMenu1.color := clBlack;
    mswait(colorwait,false);

    MainMenu1.color := clRed;
    mswait(colorwait,false);
  end;

  mswait(colorwait,false); //and 1 extra!?
  MainMenu1.color := mm;

end;

procedure Tform1.driveflash(turn_on:boolean = true);
begin
  if turn_on then
  MainMenu1.color := clBlack
  else
  MainMenu1.color := clButton
end;




{****************************************************************************
****************************************************************************}

procedure TForm1.ShortfilesizeClick(Sender: TObject);
begin
  Goptions.short_size := not Goptions.short_size;
  layout_checks;
end;

procedure TForm1.NumericattsClick(Sender: TObject);
begin
{$ifdef LINUX}
  Goptions.numeric_atts := not Goptions.numeric_atts;
  layout_checks;
{$else}
  Numericatts.visible := false;
{$endif}
end;

procedure TForm1.layout_checks;
var
wasdir,
rescan : boolean;

  procedure rsc(one,two:boolean);
  begin
    rescan := rescan
    or (one <> two);
  end;

begin
  rescan := false;
  wasdir := thepanel=d;

  rsc(left_select.checked,Goptions.dir_leftselect);
  left_select.checked := Goptions.dir_leftselect;

{$ifdef MSWINDOWS}
  if (Gthis_windows_filesystem=ntfs_FileSystem) then begin
    rsc(dtimechk.checked,Goptions.dir_creationtime);
    dtimechk.checked := Goptions.dir_creationtime;
  end else
{$endif}
  dtimechk.visible := false;

{$ifdef LINUX}
  rsc(Numericatts.checked,Goptions.numeric_atts);
  Numericatts.checked := Goptions.numeric_atts;
{$else}
  Numericatts.visible := false;
{$endif}

  rsc(Shortfilesize.checked,Goptions.short_size);
  Shortfilesize.checked := Goptions.short_size;

  if notinited<>0 then
  exit;

  if rescan then begin
    filerescanboth;

    if wasdir then
    selectpanel(d);
  end;

end;

procedure TForm1.PositionrecalledClick(Sender: TObject);
begin
  Positionrecalled.checked := not Positionrecalled.checked;
end;

procedure TForm1.EditOSinitfileClick(Sender: TObject);
begin
  if Goptions.edir_exec=nil then
  exit;

  maybe_fix_exec_state;
  execform.execute(Goptions.edit_ini);
end;


procedure TForm1.copysort(src,dst:Tfv);
begin
  dst.old_ns := nada_sort;
  dst.old_s := nada_sort;

  dst.namesort := src.namesort;
  dst.sort     := src.sort;
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.left_selectClick(Sender: TObject);
begin
  Goptions.dir_leftselect := not Goptions.dir_leftselect;
  layout_checks;
end;

//procedure TForm1.CalcscandelayClick(Sender: TObject);
//begin
//  Sleep(500);     //wait a bit?
//  refix_again(true);
//end;

{****************************************************************************
****************************************************************************}

//this is the usually invisible debug box on the main screen.
procedure TForm1.DebugClick(Sender: TObject);
begin
  if (notinited<>0) then
  exit;
  Clipboard.astext := Debug.caption;
end;

//debug label click, clears it.
procedure TForm1.FilesM_Label2Click(Sender: TObject);
begin
{$ifdef MAKE_IT_CLEAR_now_instead_of_copy}
  if (notinited<>0) then
  exit;
  Clipboard.astext := FilesM_Label2.caption;
{$endif}
  if (notinited<>0) then
  exit;
  clrdbg;
  dbg_count := 0;
end;

//debug label right click.
procedure TForm1.FilesM_Label2ContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  if (notinited<>0) then
  exit;
  Clipboard.astext := FilesM_Label2.caption;
end;

//and I changed the hint thingey up there somewhere.

{****************************************************************************
****************************************************************************}

initialization

//I had this in .xinit, which just means I have to check keyque.
setupMyKeyQue;
{****************************************************************************
Mon 1/23/2006 5:58 pm. So I don't dare disable the main form, because OwenShow
occasionally pines away for sorrow or something or we shall see. So I disable
various things instead (in setos_enabled above), but I couldn't disable the
main menu -- so I replace it with this Disabled_Main_Menu I create.
****************************************************************************}

Disabled_Main_Menu := TMainMenu.create(form1);
Disabled_Main_Menu.items.add(TMenuItem.create(form1));
Disabled_Main_Menu.items[0].caption := '(disabled)';

noticias := Tkey_string.create;

finalization

freeandnil(noticias);

{****************************************************************************

Copyright (c) 2002-2007, James Gregor Owen
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the author nor the names of any associates may be used
to endorse or promote products derived from this software without specific
prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

****************************************************************************}


end.


